
///  <license>
///
///  Copyright 2021 ChapmanWorld LLC ( https://chapmanworld.com )
///
///  Redistribution and use in source and binary forms, with or without modification,
///  are permitted provided that the following conditions are met:
///
///  1. Redistributions of source code must retain the above copyright notice,
///     this list of conditions and the following disclaimer.
///
///  2. Redistributions in binary form must reproduce the above copyright notice,
///     this list of conditions and the following disclaimer in the documentation and/or
///     other materials provided with the distribution.
///
///  3. Neither the name of the copyright holder nor the names of its contributors may be
///     used to endorse or promote products derived from this software without specific prior
///     written permission.
///
///  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
///  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
///  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
///  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
///  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
///  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
///  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
///  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
///
///  </license>
unit cwWin32;
{$ifdef fpc}{$mode delphiunicode}{$endif}

interface
{$ifdef MSWINDOWS}

const
  cLibName        = 'user32.dll';
  cLibNameAdvApi  = 'advapi32.dll';
  cLibNameKernel  = 'kernel32.dll';
  cLibNameGDI     = 'gdi32.dll';
  cLibNameWinsock = 'ws2_32.dll';
  cLibNameOle     = 'ole32.dll';


const
  ACM_OPENA                                                     = $0459;
  ACM_OPENW                                                     = $0459;
  ACM_PLAY                                                      = $0459;
  ACM_STOP                                                      = $0459;
  ANYSIZE_ARRAY                                                 = 1;
  BFFM_ENABLEOK                                                 = $0459;
  BFFM_SETSELECTIONA                                            = $0459;
  BFFM_SETSELECTIONW                                            = $0459;
  BFFM_SETSTATUSTEXTA                                           = $0459;
  BFFM_SETSTATUSTEXTW                                           = $0459;
  BM_CLICK                                                      = $00d2;
  BM_GETCHECK                                                   = $00d2;
  BM_GETIMAGE                                                   = $00d2;
  BM_GETSTATE                                                   = $00d2;
  BM_SETCHECK                                                   = $00d2;
  BM_SETDONTCLICK                                               = $00d2;
  BM_SETIMAGE                                                   = $00d2;
  BM_SETSTATE                                                   = $00d2;
  BM_SETSTYLE                                                   = $00d2;
  CBEM_GETCOMBOCONTROL                                          = $00d2;
  CBEM_GETEDITCONTROL                                           = $00d2;
  CBEM_GETEXSTYLE                                               = $00d2;
  CBEM_GETEXTENDEDSTYLE                                         = $00d2;
  CBEM_GETIMAGELIST                                             = $00d2;
  CBEM_GETITEMA                                                 = $00d2;
  CBEM_GETITEMW                                                 = $00d2;
  CBEM_HASEDITCHANGED                                           = $00d2;
  CBEM_INSERTITEMA                                              = $00d2;
  CBEM_INSERTITEMW                                              = $00d2;
  CBEM_SETEXSTYLE                                               = $00d2;
  CBEM_SETEXTENDEDSTYLE                                         = $00d2;
  CBEM_SETIMAGELIST                                             = $00d2;
  CBEM_SETITEMA                                                 = $00d2;
  CBEM_SETITEMW                                                 = $00d2;
  CCHDEVICENAME                                                 = 32;
  CCHFORMNAME                                                   = 32;
  CCHILDREN_SCROLLBAR                                           = 5;
  CDM_FIRST                                                     = $0459;
  CDM_GETFILEPATH                                               = $0459;
  CDM_GETFOLDERIDLIST                                           = $0459;
  CDM_GETFOLDERPATH                                             = $0459;
  CDM_GETSPEC                                                   = $0459;
  CDM_HIDECONTROL                                               = $0459;
  CDM_LAST                                                      = $0459;
  CDM_SETCONTROLTEXT                                            = $0459;
  CDM_SETDEFEXT                                                 = $0459;
  CDS_FULLSCREEN                                                = 4;
  CDS_GLOBAL                                                    = 8;
  CDS_NORESET                                                   = $10000000;
  CDS_RESET                                                     = $40000000;
  CDS_SETRECT                                                   = $20000000;
  CDS_SET_PRIMARY                                               = $10;
  CDS_TEST                                                      = 2;
  CDS_UPDATEREGISTRY                                            = 1;
  COLOR_3DDKSHADOW                                              = 21;
  COLOR_3DFACE                                                  = 15;
  COLOR_3DHIGHLIGHT                                             = 20;
  COLOR_3DHILIGHT                                               = 20;
  COLOR_3DLIGHT                                                 = 22;
  COLOR_3DSHADOW                                                = 16;
  COLOR_ACTIVEBORDER                                            = 10;
  COLOR_ACTIVECAPTION                                           = 2;
  COLOR_APPWORKSPACE                                            = 12;
  COLOR_BACKGROUND                                              = 1;
  COLOR_BTNFACE                                                 = 15;
  COLOR_BTNHIGHLIGHT                                            = 20;
  COLOR_BTNHILIGHT                                              = 20;
  COLOR_BTNSHADOW                                               = 16;
  COLOR_BTNTEXT                                                 = 18;
  COLOR_CAPTIONTEXT                                             = 9;
  COLOR_DESKTOP                                                 = 1;
  COLOR_GRADIENTACTIVECAPTION                                   = 27;
  COLOR_GRADIENTINACTIVECAPTION                                 = 28;
  COLOR_GRAYTEXT                                                = 17;
  COLOR_HIGHLIGHT                                               = 13;
  COLOR_HIGHLIGHTTEXT                                           = 14;
  COLOR_HOTLIGHT                                                = 26;
  COLOR_INACTIVEBORDER                                          = 11;
  COLOR_INACTIVECAPTION                                         = 3;
  COLOR_INACTIVECAPTIONTEXT                                     = 19;
  COLOR_INFOBK                                                  = 24;
  COLOR_INFOTEXT                                                = 23;
  COLOR_MENU                                                    = 4;
  COLOR_MENUBAR                                                 = 30;
  COLOR_MENUHILIGHT                                             = 29;
  COLOR_MENUTEXT                                                = 7;
  COLOR_SCROLLBAR                                               = 0;
  COLOR_WINDOW                                                  = 5;
  COLOR_WINDOWFRAME                                             = 6;
  COLOR_WINDOWTEXT                                              = 8;
  CS_BYTEALIGNCLIENT                                            = $1000;
  CS_BYTEALIGNWINDOW                                            = $2000;
  CS_CLASSDC                                                    = $0040;
  CS_DBLCLKS                                                    = $0008;
  CS_DROPSHADOW                                                 = $00020000;
  CS_GLOBALCLASS                                                = $4000;
  CS_HREDRAW                                                    = $0002;
  CS_NOCLOSE                                                    = $0200;
  CS_OWNDC                                                      = $0020;
  CS_PARENTDC                                                   = $0080;
  CS_SAVEBITS                                                   = $0800;
  CS_VREDRAW                                                    = $0001;
  DC_APPSTARTING                                                = 32650;
  DDM_BEGIN                                                     = $00d2;
  DDM_CLOSE                                                     = $00d2;
  DDM_DRAW                                                      = $00d2;
  DDM_END                                                       = $00d2;
  DDM_SETFMT                                                    = $00d2;
  DISP_CHANGE_BADDUALVIEW                                       = -6;
  DISP_CHANGE_BADFLAGS                                          = -4;
  DISP_CHANGE_BADMODE                                           = -2;
  DISP_CHANGE_BADPARAM                                          = -5;
  DISP_CHANGE_FAILED                                            = -1;
  DISP_CHANGE_NOTUPDATED                                        = -3;
  DISP_CHANGE_RESTART                                           = 1;
  DISP_CHANGE_SUCCESSFUL                                        = 0;
  DL_BEGINDRAG                                                  = $0459;
  DL_CANCELDRAG                                                 = $0459;
  DL_DRAGGING                                                   = $0459;
  DL_DROPPED                                                    = $0459;
  DM_BITSPERPEL                                                 = $40000;
  DM_DISPLAYFIXEDOUTPUT: uint32                                 = $20000000;
  DM_DISPLAYFLAGS                                               = $200000;
  DM_DISPLAYFREQUENCY                                           = $400000;
  DM_DISPLAYORIENTATION: uint32                                 = $80;
  DM_DISPLAYQUERYORIENTATION: uint32                            = $01000000;
  DM_GETDEFID                                                   = $00d2;
  DM_PELSHEIGHT                                                 = $100000;
  DM_PELSWIDTH                                                  = $80000;
  DM_REPOSITION                                                 = $00d2;
  DM_SETDEFID                                                   = $00d2;
  EM_AUTOURLDETECT                                              = $0459;
  EM_CANPASTE                                                   = $00d2;
  EM_CANREDO                                                    = $043f;
  EM_CANUNDO                                                    = $00b5;
  EM_CHARFROMPOS                                                = $00d2;
  EM_CONVPOSITION                                               = $0459;
  EM_DISPLAYBAND                                                = $00d2;
  EM_EMPTYUNDOBUFFER                                            = $00cd;
  EM_EXGETSEL                                                   = $00d2;
  EM_EXLIMITTEXT                                                = $00d2;
  EM_EXLINEFROMCHAR                                             = $00d2;
  EM_EXSETSEL                                                   = $00d2;
  EM_FINDTEXT                                                   = $00d2;
  EM_FINDTEXTEX                                                 = $043f;
  EM_FINDTEXTEXW                                                = $0459;
  EM_FINDTEXTW                                                  = $0459;
  EM_FINDWORDBREAK                                              = $043f;
  EM_FMTLINES                                                   = $00b5;
  EM_FORMATRANGE                                                = $00d2;
  EM_GETAUTOURLDETECT                                           = $0459;
  EM_GETBIDIOPTIONS                                             = $0459;
  EM_GETCHARFORMAT                                              = $00d2;
  EM_GETCTFMODEBIAS                                             = $0459;
  EM_GETCTFOPENSTATUS                                           = $0459;
  EM_GETEDITSTYLE                                               = $0459;
  EM_GETEVENTMASK                                               = $00d2;
  EM_GETFIRSTVISIBLELINE                                        = $00ce;
  EM_GETHANDLE                                                  = $00b5;
  EM_GETHYPHENATEINFO                                           = $0459;
  EM_GETIMECOLOR                                                = $0459;
  EM_GETIMECOMPMODE                                             = $0459;
  EM_GETIMECOMPTEXT                                             = $0459;
  EM_GETIMEMODEBIAS                                             = $0459;
  EM_GETIMEOPTIONS                                              = $0459;
  EM_GETIMEPROPERTY                                             = $0459;
  EM_GETIMESTATUS                                               = $00d2;
  EM_GETLANGOPTIONS                                             = $0459;
  EM_GETLIMITTEXT                                               = $00d2;
  EM_GETLINE                                                    = $00b5;
  EM_GETLINECOUNT                                               = $00b5;
  EM_GETMARGINS                                                 = $00d2;
  EM_GETMODIFY                                                  = $00b5;
  EM_GETOLEINTERFACE                                            = $00d2;
  EM_GETOPTIONS                                                 = $043f;
  EM_GETPAGE                                                    = $0459;
  EM_GETPAGEROTATE                                              = $0459;
  EM_GETPARAFORMAT                                              = $00d2;
  EM_GETPASSWORDCHAR                                            = $00d2;
  EM_GETPUNCTUATION                                             = $0459;
  EM_GETQUERYRTFOBJ                                             = $0459;
  EM_GETRECT                                                    = $00b2;
  EM_GETREDONAME                                                = $0457;
  EM_GETSCROLLPOS                                               = $0459;
  EM_GETSEL                                                     = $00b0;
  EM_GETSELTEXT                                                 = $043e;
  EM_GETTEXTEX                                                  = $0459;
  EM_GETTEXTLENGTHEX                                            = $0459;
  EM_GETTEXTMODE                                                = $0459;
  EM_GETTEXTRANGE                                               = $043f;
  EM_GETTHUMB                                                   = $00b5;
  EM_GETTYPOGRAPHYOPTIONS                                       = $0459;
  EM_GETUNDONAME                                                = $043f;
  EM_GETVIEWKIND                                                = $0459;
  EM_GETWORDBREAKPROC                                           = $00d1;
  EM_GETWORDBREAKPROCEX                                         = $043f;
  EM_GETWORDWRAPMODE                                            = $0459;
  EM_GETZOOM                                                    = $0459;
  EM_HIDESELECTION                                              = $043f;
  EM_ISIME                                                      = $0459;
  EM_LIMITTEXT                                                  = $00b5;
  EM_LINEFROMCHAR                                               = $00b5;
  EM_LINEINDEX                                                  = $00b5;
  EM_LINELENGTH                                                 = $00b5;
  EM_LINESCROLL                                                 = $00b5;
  EM_OUTLINE                                                    = $0459;
  EM_PASTESPECIAL                                               = $043f;
  EM_POSFROMCHAR                                                = $00d2;
  EM_RECONVERSION                                               = $0459;
  EM_REDO                                                       = $043f;
  EM_REPLACESEL                                                 = $00b5;
  EM_REQUESTRESIZE                                              = $043f;
  EM_SCROLL                                                     = $00b5;
  EM_SCROLLCARET                                                = $00b5;
  EM_SELECTIONTYPE                                              = $043f;
  EM_SETBIDIOPTIONS                                             = $0459;
  EM_SETBKGNDCOLOR                                              = $043f;
  EM_SETCHARFORMAT                                              = $043f;
  EM_SETCTFMODEBIAS                                             = $0459;
  EM_SETCTFOPENSTATUS                                           = $0459;
  EM_SETEDITSTYLE                                               = $0459;
  EM_SETEVENTMASK                                               = $043f;
  EM_SETFONT                                                    = $00b5;
  EM_SETFONTSIZE                                                = $0459;
  EM_SETHANDLE                                                  = $00b5;
  EM_SETHYPHENATEINFO                                           = $0459;
  EM_SETIMECOLOR                                                = $0459;
  EM_SETIMEMODEBIAS                                             = $0459;
  EM_SETIMEOPTIONS                                              = $0459;
  EM_SETIMESTATUS                                               = $00d2;
  EM_SETLANGOPTIONS                                             = $0459;
  EM_SETLIMITTEXT                                               = $00b5;
  EM_SETMARGINS                                                 = $00d2;
  EM_SETMODIFY                                                  = $00b5;
  EM_SETOLECALLBACK                                             = $043f;
  EM_SETOPTIONS                                                 = $043f;
  EM_SETPAGE                                                    = $0459;
  EM_SETPAGEROTATE                                              = $0459;
  EM_SETPALETTE                                                 = $0459;
  EM_SETPARAFORMAT                                              = $043f;
  EM_SETPASSWORDCHAR                                            = $00b5;
  EM_SETPUNCTUATION                                             = $0459;
  EM_SETQUERYRTFOBJ                                             = $0459;
  EM_SETREADONLY                                                = $00cf;
  EM_SETRECT                                                    = $00b3;
  EM_SETRECTNP                                                  = $00b4;
  EM_SETSCROLLPOS                                               = $0459;
  EM_SETSEL                                                     = $00b1;
  EM_SETTABSTOPS                                                = $00b5;
  EM_SETTARGETDEVICE                                            = $043f;
  EM_SETTEXTEX                                                  = $0459;
  EM_SETTEXTMODE                                                = $0459;
  EM_SETTYPOGRAPHYOPTIONS                                       = $0459;
  EM_SETUNDOLIMIT                                               = $043f;
  EM_SETVIEWKIND                                                = $0459;
  EM_SETWORDBREAK                                               = $00b5;
  EM_SETWORDBREAKPROC                                           = $00d0;
  EM_SETWORDBREAKPROCEX                                         = $043f;
  EM_SETWORDWRAPMODE                                            = $0459;
  EM_SETZOOM                                                    = $0459;
  EM_SHOWSCROLLBAR                                              = $0459;
  EM_STOPGROUPTYPING                                            = $0458;
  EM_STREAMIN                                                   = $043f;
  EM_STREAMOUT                                                  = $043f;
  EM_UNDO                                                       = $00b5;
  ERROR_ACCESS_DENIED                                           = $5;
  ERROR_ACCOUNT_DISABLED                                        = $533;
  ERROR_ACCOUNT_RESTRICTION                                     = $52F;
  ERROR_ADAP_HDW_ERR                                            = $39;
  ERROR_ALIAS_EXISTS                                            = $563;
  ERROR_ALLOTTED_SPACE_EXCEEDED                                 = $540;
  ERROR_ALREADY_ASSIGNED                                        = $55;
  ERROR_ALREADY_EXISTS                                          = $B7;
  ERROR_ARENA_TRASHED                                           = $7;
  ERROR_ATOMIC_LOCKS_NOT_SUPPORTED                              = $AE;
  ERROR_AUTHIP_FAILURE                                          = $5BD;
  ERROR_AUTODATASEG_EXCEEDS_64k                                 = $C7;
  ERROR_BAD_ARGUMENTS                                           = $A0;
  ERROR_BAD_COMMAND                                             = $16;
  ERROR_BAD_CONFIGURATION                                       = $64A;
  ERROR_BAD_DESCRIPTOR_FORMAT                                   = $551;
  ERROR_BAD_DEVICE_PATH                                         = $14A;
  ERROR_BAD_DEV_TYPE                                            = $42;
  ERROR_BAD_DRIVER_LEVEL                                        = $77;
  ERROR_BAD_ENVIRONMENT                                         = $A;
  ERROR_BAD_EXE_FORMAT                                          = $C1;
  ERROR_BAD_FILE_TYPE                                           = $DE;
  ERROR_BAD_FORMAT                                              = $B;
  ERROR_BAD_IMPERSONATION_LEVEL                                 = $542;
  ERROR_BAD_INHERITANCE_ACL                                     = $53C;
  ERROR_BAD_LENGTH                                              = $18;
  ERROR_BAD_LOGON_SESSION_STATE                                 = $555;
  ERROR_BAD_NETPATH                                             = $35;
  ERROR_BAD_NET_NAME                                            = $43;
  ERROR_BAD_NET_RESP                                            = $3A;
  ERROR_BAD_PATHNAME                                            = $A1;
  ERROR_BAD_PIPE                                                = $E6;
  ERROR_BAD_QUERY_SYNTAX                                        = $64F;
  ERROR_BAD_REM_ADAP                                            = $3C;
  ERROR_BAD_THREADID_ADDR                                       = $9F;
  ERROR_BAD_TOKEN_TYPE                                          = $545;
  ERROR_BAD_UNIT                                                = $14;
  ERROR_BAD_VALIDATION_CLASS                                    = $544;
  ERROR_BROKEN_PIPE                                             = $6D;
  ERROR_BUFFER_OVERFLOW                                         = $6F;
  ERROR_BUSY                                                    = $AA;
  ERROR_BUSY_DRIVE                                              = $8E;
  ERROR_CALL_NOT_IMPLEMENTED                                    = $78;
  ERROR_CANCEL_VIOLATION                                        = $AD;
  ERROR_CANNOT_COPY                                             = $10A;
  ERROR_CANNOT_FIND_WND_CLASS                                   = $57F;
  ERROR_CANNOT_IMPERSONATE                                      = $558;
  ERROR_CANNOT_MAKE                                             = $52;
  ERROR_CANT_ACCESS_DOMAIN_INFO                                 = $547;
  ERROR_CANT_DISABLE_MANDATORY                                  = $51E;
  ERROR_CANT_OPEN_ANONYMOUS                                     = $543;
  ERROR_CHECKOUT_REQUIRED                                       = $DD;
  ERROR_CHILD_NOT_COMPLETE                                      = $81;
  ERROR_CHILD_WINDOW_MENU                                       = $59C;
  ERROR_CLASS_ALREADY_EXISTS                                    = $582;
  ERROR_CLASS_DOES_NOT_EXIST                                    = $583;
  ERROR_CLASS_HAS_WINDOWS                                       = $584;
  ERROR_CLIPBOARD_NOT_OPEN                                      = $58A;
  ERROR_COMMITMENT_LIMIT                                        = $5AF;
  ERROR_COMPRESSED_FILE_NOT_SUPPORTED                           = $14F;
  ERROR_CONTROL_ID_NOT_FOUND                                    = $58D;
  ERROR_CRC                                                     = $17;
  ERROR_CREATE_FAILED                                           = $65F;
  ERROR_CURRENT_DIRECTORY                                       = $10;
  ERROR_CURRENT_DOMAIN_NOT_ALLOWED                              = $577;
  ERROR_DATATYPE_MISMATCH                                       = $65D;
  ERROR_DATA_CHECKSUM_ERROR                                     = $143;
  ERROR_DC_NOT_FOUND                                            = $591;
  ERROR_DELETE_PENDING                                          = $12F;
  ERROR_DESTROY_OBJECT_OF_OTHER_THREAD                          = $59B;
  ERROR_DEVICE_FEATURE_NOT_SUPPORTED                            = $13C;
  ERROR_DEVICE_NO_RESOURCES                                     = $142;
  ERROR_DEVICE_REMOVED                                          = $651;
  ERROR_DEVICE_SUPPORT_IN_PROGRESS                              = $AB;
  ERROR_DEVICE_UNREACHABLE                                      = $141;
  ERROR_DEV_NOT_EXIST                                           = $37;
  ERROR_DIRECTORY                                               = $10B;
  ERROR_DIRECTORY_NOT_SUPPORTED                                 = $150;
  ERROR_DIRECT_ACCESS_HANDLE                                    = $82;
  ERROR_DIR_NOT_EMPTY                                           = $91;
  ERROR_DIR_NOT_ROOT                                            = $90;
  ERROR_DISCARDED                                               = $9D;
  ERROR_DISK_CHANGE                                             = $6B;
  ERROR_DISK_CORRUPT                                            = $571;
  ERROR_DISK_FULL                                               = $70;
  ERROR_DISK_RESOURCES_EXHAUSTED                                = $13A;
  ERROR_DISK_TOO_FRAGMENTED                                     = $12E;
  ERROR_DOMAIN_EXISTS                                           = $54C;
  ERROR_DOMAIN_LIMIT_EXCEEDED                                   = $54D;
  ERROR_DRIVE_LOCKED                                            = $6C;
  ERROR_DUPLICATE_PRIVILEGES                                    = $137;
  ERROR_DUP_NAME                                                = $34;
  ERROR_DYNLINK_FROM_INVALID_RING                               = $C4;
  ERROR_EAS_DIDNT_FIT                                           = $113;
  ERROR_EAS_NOT_SUPPORTED                                       = $11A;
  ERROR_EA_FILE_CORRUPT                                         = $114;
  ERROR_EA_LIST_INCONSISTENT                                    = $FF;
  ERROR_EA_TABLE_FULL                                           = $115;
  ERROR_ENVVAR_NOT_FOUND                                        = $CB;
  ERROR_EVENTLOG_CANT_START                                     = $5DD;
  ERROR_EVENTLOG_FILE_CHANGED                                   = $5DF;
  ERROR_EVENTLOG_FILE_CORRUPT                                   = $5DC;
  ERROR_EXCL_SEM_ALREADY_OWNED                                  = $65;
  ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY                         = $D9;
  ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY                  = $DA;
  ERROR_EXE_MACHINE_TYPE_MISMATCH                               = $D8;
  ERROR_EXE_MARKED_INVALID                                      = $C0;
  ERROR_FAIL_FAST_EXCEPTION                                     = $675;
  ERROR_FAIL_I24                                                = $53;
  ERROR_FAIL_NOACTION_REBOOT                                    = $15E;
  ERROR_FAIL_RESTART                                            = $160;
  ERROR_FAIL_SHUTDOWN                                           = $15F;
  ERROR_FILENAME_EXCED_RANGE                                    = $CE;
  ERROR_FILE_CHECKED_OUT                                        = $DC;
  ERROR_FILE_CORRUPT                                            = $570;
  ERROR_FILE_EXISTS                                             = $50;
  ERROR_FILE_LEVEL_TRIM_NOT_SUPPORTED                           = $146;
  ERROR_FILE_NOT_FOUND                                          = $2;
  ERROR_FILE_TOO_LARGE                                          = $DF;
  ERROR_FORMS_AUTH_REQUIRED                                     = $E0;
  ERROR_FUNCTION_FAILED                                         = $65B;
  ERROR_FUNCTION_NOT_CALLED                                     = $65A;
  ERROR_GENERIC_NOT_MAPPED                                      = $550;
  ERROR_GEN_FAILURE                                             = $1F;
  ERROR_GLOBAL_ONLY_HOOK                                        = $595;
  ERROR_GROUP_EXISTS                                            = $526;
  ERROR_HANDLE_DISK_FULL                                        = $27;
  ERROR_HANDLE_EOF                                              = $26;
  ERROR_HOOK_NEEDS_HMOD                                         = $594;
  ERROR_HOOK_NOT_INSTALLED                                      = $597;
  ERROR_HOOK_TYPE_NOT_ALLOWED                                   = $5B2;
  ERROR_HOTKEY_ALREADY_REGISTERED                               = $581;
  ERROR_HOTKEY_NOT_REGISTERED                                   = $58B;
  ERROR_HWNDS_HAVE_DIFF_PARENT                                  = $5A1;
  ERROR_ILL_FORMED_PASSWORD                                     = $52C;
  ERROR_IMAGE_SUBSYSTEM_NOT_PRESENT                             = $134;
  ERROR_INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING    = $130;
  ERROR_INCORRECT_SIZE                                          = $5B6;
  ERROR_INDEX_ABSENT                                            = $64B;
  ERROR_INFLOOP_IN_RELOC_CHAIN                                  = $CA;
  ERROR_INSTALL_ALREADY_RUNNING                                 = $652;
  ERROR_INSTALL_FAILURE                                         = $643;
  ERROR_INSTALL_LANGUAGE_UNSUPPORTED                            = $657;
  ERROR_INSTALL_LOG_FAILURE                                     = $656;
  ERROR_INSTALL_NOTUSED                                         = $662;
  ERROR_INSTALL_PACKAGE_INVALID                                 = $654;
  ERROR_INSTALL_PACKAGE_OPEN_FAILED                             = $653;
  ERROR_INSTALL_PACKAGE_REJECTED                                = $659;
  ERROR_INSTALL_PACKAGE_VERSION                                 = $64D;
  ERROR_INSTALL_PLATFORM_UNSUPPORTED                            = $661;
  ERROR_INSTALL_REJECTED                                        = $676;
  ERROR_INSTALL_REMOTE_DISALLOWED                               = $668;
  ERROR_INSTALL_REMOTE_PROHIBITED                               = $66D;
  ERROR_INSTALL_SERVICE_FAILURE                                 = $641;
  ERROR_INSTALL_SERVICE_SAFEBOOT                                = $674;
  ERROR_INSTALL_SOURCE_ABSENT                                   = $64C;
  ERROR_INSTALL_SUSPEND                                         = $644;
  ERROR_INSTALL_TEMP_UNWRITABLE                                 = $660;
  ERROR_INSTALL_TRANSFORM_FAILURE                               = $658;
  ERROR_INSTALL_TRANSFORM_REJECTED                              = $66C;
  ERROR_INSTALL_UI_FAILURE                                      = $655;
  ERROR_INSTALL_USEREXIT                                        = $642;
  ERROR_INSUFFICIENT_BUFFER                                     = $7A;
  ERROR_INTERMIXED_KERNEL_EA_OPERATION                          = $144;
  ERROR_INTERNAL_DB_CORRUPTION                                  = $54E;
  ERROR_INTERNAL_DB_ERROR                                       = $567;
  ERROR_INTERNAL_ERROR                                          = $54F;
  ERROR_INVALID_ACCEL_HANDLE                                    = $57B;
  ERROR_INVALID_ACCESS                                          = $C;
  ERROR_INVALID_ACCOUNT_NAME                                    = $523;
  ERROR_INVALID_ACL                                             = $538;
  ERROR_INVALID_ADDRESS                                         = $1E7;
  ERROR_INVALID_AT_INTERRUPT_TIME                               = $68;
  ERROR_INVALID_BLOCK                                           = $9;
  ERROR_INVALID_CAP                                             = $140;
  ERROR_INVALID_CATEGORY                                        = $75;
  ERROR_INVALID_COMBOBOX_MESSAGE                                = $58E;
  ERROR_INVALID_COMMAND_LINE                                    = $667;
  ERROR_INVALID_CURSOR_HANDLE                                   = $57A;
  ERROR_INVALID_DATA                                            = $D;
  ERROR_INVALID_DOMAIN_ROLE                                     = $54A;
  ERROR_INVALID_DOMAIN_STATE                                    = $549;
  ERROR_INVALID_DRIVE                                           = $F;
  ERROR_INVALID_DWP_HANDLE                                      = $57D;
  ERROR_INVALID_EA_HANDLE                                       = $116;
  ERROR_INVALID_EA_NAME                                         = $FE;
  ERROR_INVALID_EDIT_HEIGHT                                     = $590;
  ERROR_INVALID_EVENT_COUNT                                     = $97;
  ERROR_INVALID_EXCEPTION_HANDLER                               = $136;
  ERROR_INVALID_EXE_SIGNATURE                                   = $BF;
  ERROR_INVALID_FIELD                                           = $650;
  ERROR_INVALID_FIELD_IN_PARAMETER_LIST                         = $148;
  ERROR_INVALID_FILTER_PROC                                     = $593;
  ERROR_INVALID_FLAG_NUMBER                                     = $BA;
  ERROR_INVALID_FUNCTION                                        = $1;
  ERROR_INVALID_GROUP_ATTRIBUTES                                = $541;
  ERROR_INVALID_GW_COMMAND                                      = $5A3;
  ERROR_INVALID_HANDLE                                          = $6;
  ERROR_INVALID_HANDLE_STATE                                    = $649;
  ERROR_INVALID_HOOK_FILTER                                     = $592;
  ERROR_INVALID_HOOK_HANDLE                                     = $57C;
  ERROR_INVALID_ICON_HANDLE                                     = $586;
  ERROR_INVALID_ID_AUTHORITY                                    = $53F;
  ERROR_INVALID_INDEX                                           = $585;
  ERROR_INVALID_KEYBOARD_HANDLE                                 = $5B1;
  ERROR_INVALID_LB_MESSAGE                                      = $598;
  ERROR_INVALID_LEVEL                                           = $7C;
  ERROR_INVALID_LIST_FORMAT                                     = $99;
  ERROR_INVALID_LOCK_RANGE                                      = $133;
  ERROR_INVALID_LOGON_HOURS                                     = $530;
  ERROR_INVALID_LOGON_TYPE                                      = $557;
  ERROR_INVALID_MEMBER                                          = $56C;
  ERROR_INVALID_MENU_HANDLE                                     = $579;
  ERROR_INVALID_MINALLOCSIZE                                    = $C3;
  ERROR_INVALID_MODULETYPE                                      = $BE;
  ERROR_INVALID_MONITOR_HANDLE                                  = $5B5;
  ERROR_INVALID_MSGBOX_STYLE                                    = $59E;
  ERROR_INVALID_NAME                                            = $7B;
  ERROR_INVALID_OPLOCK_PROTOCOL                                 = $12D;
  ERROR_INVALID_ORDINAL                                         = $B6;
  ERROR_INVALID_OWNER                                           = $51B;
  ERROR_INVALID_PARAMETER                                       = $57;
  ERROR_INVALID_PASSWORD                                        = $56;
  ERROR_INVALID_PATCH_XML                                       = $672;
  ERROR_INVALID_PRIMARY_GROUP                                   = $51C;
  ERROR_INVALID_SCROLLBAR_RANGE                                 = $5A8;
  ERROR_INVALID_SECURITY_DESCR                                  = $53A;
  ERROR_INVALID_SEGDPL                                          = $C6;
  ERROR_INVALID_SEGMENT_NUMBER                                  = $B4;
  ERROR_INVALID_SERVER_STATE                                    = $548;
  ERROR_INVALID_SHOWWIN_COMMAND                                 = $5A9;
  ERROR_INVALID_SID                                             = $539;
  ERROR_INVALID_SIGNAL_NUMBER                                   = $D1;
  ERROR_INVALID_SPI_VALUE                                       = $59F;
  ERROR_INVALID_STACKSEG                                        = $BD;
  ERROR_INVALID_STARTING_CODESEG                                = $BC;
  ERROR_INVALID_SUB_AUTHORITY                                   = $537;
  ERROR_INVALID_TABLE                                           = $65C;
  ERROR_INVALID_TARGET_HANDLE                                   = $72;
  ERROR_INVALID_TASK_INDEX                                      = $60F;
  ERROR_INVALID_TASK_NAME                                       = $60E;
  ERROR_INVALID_THREAD_ID                                       = $5A4;
  ERROR_INVALID_TOKEN                                           = $13B;
  ERROR_INVALID_VERIFY_SWITCH                                   = $76;
  ERROR_INVALID_WINDOW_HANDLE                                   = $578;
  ERROR_INVALID_WORKSTATION                                     = $531;
  ERROR_IOPL_NOT_ENABLED                                        = $C5;
  ERROR_IS_JOINED                                               = $86;
  ERROR_IS_JOIN_PATH                                            = $93;
  ERROR_IS_JOIN_TARGET                                          = $85;
  ERROR_IS_SUBSTED                                              = $87;
  ERROR_IS_SUBST_PATH                                           = $92;
  ERROR_IS_SUBST_TARGET                                         = $95;
  ERROR_ITERATED_DATA_EXCEEDS_64k                               = $C2;
  ERROR_JOIN_TO_JOIN                                            = $8A;
  ERROR_JOIN_TO_SUBST                                           = $8C;
  ERROR_JOURNAL_HOOK_SET                                        = $596;
  ERROR_LABEL_TOO_LONG                                          = $9A;
  ERROR_LAST_ADMIN                                              = $52A;
  ERROR_LB_WITHOUT_TABSTOPS                                     = $59A;
  ERROR_LICENSE_QUOTA_EXCEEDED                                  = $573;
  ERROR_LISTBOX_ID_NOT_FOUND                                    = $588;
  ERROR_LM_CROSS_ENCRYPTION_REQUIRED                            = $56E;
  ERROR_LOCAL_USER_SESSION_KEY                                  = $517;
  ERROR_LOCKED                                                  = $D4;
  ERROR_LOCK_FAILED                                             = $A7;
  ERROR_LOCK_VIOLATION                                          = $21;
  ERROR_LOGON_FAILURE                                           = $52E;
  ERROR_LOGON_NOT_GRANTED                                       = $564;
  ERROR_LOGON_SESSION_COLLISION                                 = $556;
  ERROR_LOGON_SESSION_EXISTS                                    = $553;
  ERROR_LOGON_TYPE_NOT_GRANTED                                  = $569;
  ERROR_LOG_FILE_FULL                                           = $5DE;
  ERROR_LUIDS_EXHAUSTED                                         = $536;
  ERROR_MAX_SESSIONS_REACHED                                    = $161;
  ERROR_MAX_THRDS_REACHED                                       = $A4;
  ERROR_MEMBERS_PRIMARY_GROUP                                   = $55E;
  ERROR_MEMBER_IN_ALIAS                                         = $562;
  ERROR_MEMBER_IN_GROUP                                         = $528;
  ERROR_MEMBER_NOT_IN_ALIAS                                     = $561;
  ERROR_MEMBER_NOT_IN_GROUP                                     = $529;
  ERROR_MENU_ITEM_NOT_FOUND                                     = $5B0;
  ERROR_META_EXPANSION_TOO_LONG                                 = $D0;
  ERROR_MOD_NOT_FOUND                                           = $7E;
  ERROR_MORE_DATA                                               = $EA;
  ERROR_MR_MID_NOT_FOUND                                        = $13D;
  ERROR_MUTUAL_AUTH_FAILED                                      = $575;
  ERROR_NEGATIVE_SEEK                                           = $83;
  ERROR_NESTING_NOT_ALLOWED                                     = $D7;
  ERROR_NETNAME_DELETED                                         = $40;
  ERROR_NETWORK_ACCESS_DENIED                                   = $41;
  ERROR_NETWORK_BUSY                                            = $36;
  ERROR_NET_WRITE_FAULT                                         = $58;
  ERROR_NONE_MAPPED                                             = $534;
  ERROR_NONPAGED_SYSTEM_RESOURCES                               = $5AB;
  ERROR_NON_MDICHILD_WINDOW                                     = $5A5;
  ERROR_NOTIFICATION_GUID_ALREADY_DEFINED                       = $135;
  ERROR_NOT_ALLOWED_ON_SYSTEM_FILE                              = $139;
  ERROR_NOT_ALL_ASSIGNED                                        = $514;
  ERROR_NOT_CHILD_WINDOW                                        = $5A2;
  ERROR_NOT_DOS_DISK                                            = $1A;
  ERROR_NOT_ENOUGH_MEMORY                                       = $8;
  ERROR_NOT_GUI_PROCESS                                         = $5BF;
  ERROR_NOT_JOINED                                              = $88;
  ERROR_NOT_LOCKED                                              = $9E;
  ERROR_NOT_LOGON_PROCESS                                       = $552;
  ERROR_NOT_OWNER                                               = $120;
  ERROR_NOT_READY                                               = $15;
  ERROR_NOT_READ_FROM_COPY                                      = $151;
  ERROR_NOT_REDUNDANT_STORAGE                                   = $14D;
  ERROR_NOT_SAME_DEVICE                                         = $11;
  ERROR_NOT_SUBSTED                                             = $89;
  ERROR_NOT_SUPPORTED                                           = $32;
  ERROR_NO_DATA                                                 = $E8;
  ERROR_NO_IMPERSONATION_TOKEN                                  = $51D;
  ERROR_NO_INHERITANCE                                          = $56F;
  ERROR_NO_LOGON_SERVERS                                        = $51F;
  ERROR_NO_MORE_FILES                                           = $12;
  ERROR_NO_MORE_ITEMS                                           = $103;
  ERROR_NO_MORE_SEARCH_HANDLES                                  = $71;
  ERROR_NO_NVRAM_RESOURCES                                      = $5BE;
  ERROR_NO_PROC_SLOTS                                           = $59;
  ERROR_NO_QUOTAS_FOR_ACCOUNT                                   = $516;
  ERROR_NO_RANGES_PROCESSED                                     = $138;
  ERROR_NO_SCROLLBARS                                           = $5A7;
  ERROR_NO_SECURITY_ON_OBJECT                                   = $546;
  ERROR_NO_SIGNAL_SENT                                          = $CD;
  ERROR_NO_SPOOL_SPACE                                          = $3E;
  ERROR_NO_SUCH_ALIAS                                           = $560;
  ERROR_NO_SUCH_DOMAIN                                          = $54B;
  ERROR_NO_SUCH_GROUP                                           = $527;
  ERROR_NO_SUCH_LOGON_SESSION                                   = $520;
  ERROR_NO_SUCH_MEMBER                                          = $56B;
  ERROR_NO_SUCH_PACKAGE                                         = $554;
  ERROR_NO_SUCH_PRIVILEGE                                       = $521;
  ERROR_NO_SUCH_USER                                            = $525;
  ERROR_NO_SYSTEM_MENU                                          = $59D;
  ERROR_NO_SYSTEM_RESOURCES                                     = $5AA;
  ERROR_NO_USER_SESSION_KEY                                     = $572;
  ERROR_NO_VOLUME_LABEL                                         = $7D;
  ERROR_NO_WILDCARD_CHARACTERS                                  = $589;
  ERROR_NT_CROSS_ENCRYPTION_REQUIRED                            = $56A;
  ERROR_NULL_LM_PASSWORD                                        = $518;
  ERROR_OFFSET_ALIGNMENT_VIOLATION                              = $147;
  ERROR_OPEN_FAILED                                             = $6E;
  ERROR_OPERATION_IN_PROGRESS                                   = $149;
  ERROR_OPLOCK_NOT_GRANTED                                      = $12C;
  ERROR_OUTOFMEMORY                                             = $E;
  ERROR_OUT_OF_PAPER                                            = $1C;
  ERROR_OUT_OF_STRUCTURES                                       = $54;
  ERROR_PAGED_SYSTEM_RESOURCES                                  = $5AC;
  ERROR_PAGEFILE_QUOTA                                          = $5AE;
  ERROR_PARTIAL_COPY                                            = $12B;
  ERROR_PASSWORD_EXPIRED                                        = $532;
  ERROR_PASSWORD_RESTRICTION                                    = $52D;
  ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT                        = $673;
  ERROR_PATCH_NO_SEQUENCE                                       = $670;
  ERROR_PATCH_PACKAGE_INVALID                                   = $664;
  ERROR_PATCH_PACKAGE_OPEN_FAILED                               = $663;
  ERROR_PATCH_PACKAGE_REJECTED                                  = $66B;
  ERROR_PATCH_PACKAGE_UNSUPPORTED                               = $665;
  ERROR_PATCH_REMOVAL_DISALLOWED                                = $671;
  ERROR_PATCH_REMOVAL_UNSUPPORTED                               = $66E;
  ERROR_PATCH_TARGET_NOT_FOUND                                  = $66A;
  ERROR_PATH_BUSY                                               = $94;
  ERROR_PATH_NOT_FOUND                                          = $3;
  ERROR_PIPE_BUSY                                               = $E7;
  ERROR_PIPE_LOCAL                                              = $E5;
  ERROR_PIPE_NOT_CONNECTED                                      = $E9;
  ERROR_POPUP_ALREADY_ACTIVE                                    = $5A6;
  ERROR_PRINTQ_FULL                                             = $3D;
  ERROR_PRINT_CANCELLED                                         = $3F;
  ERROR_PRIVATE_DIALOG_INDEX                                    = $587;
  ERROR_PRIVILEGE_NOT_HELD                                      = $522;
  ERROR_PROCESS_MODE_ALREADY_BACKGROUND                         = $192;
  ERROR_PROCESS_MODE_NOT_BACKGROUND                             = $193;
  ERROR_PROC_NOT_FOUND                                          = $7F;
  ERROR_PRODUCT_UNINSTALLED                                     = $64E;
  ERROR_PRODUCT_VERSION                                         = $666;
  ERROR_READ_FAULT                                              = $1E;
  ERROR_REDIR_PAUSED                                            = $48;
  ERROR_RELOC_CHAIN_XEEDS_SEGLIM                                = $C9;
  ERROR_REM_NOT_LIST                                            = $33;
  ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION                      = $5B3;
  ERROR_REQ_NOT_ACCEP                                           = $47;
  ERROR_RESIDENT_FILE_NOT_SUPPORTED                             = $14E;
  ERROR_RESTART_APPLICATION                                     = $5BB;
  ERROR_REVISION_MISMATCH                                       = $51A;
  ERROR_RING2SEG_MUST_BE_MOVABLE                                = $C8;
  ERROR_RING2_STACK_IN_USE                                      = $CF;
  ERROR_RXACT_COMMIT_FAILURE                                    = $55A;
  ERROR_RXACT_INVALID_STATE                                     = $559;
  ERROR_SAME_DRIVE                                              = $8F;
  ERROR_SCOPE_NOT_FOUND                                         = $13E;
  ERROR_SCREEN_ALREADY_LOCKED                                   = $5A0;
  ERROR_SCRUB_DATA_DISABLED                                     = $14C;
  ERROR_SECRET_TOO_LONG                                         = $566;
  ERROR_SECTOR_NOT_FOUND                                        = $1B;
  ERROR_SECURITY_STREAM_IS_INCONSISTENT                         = $132;
  ERROR_SEEK                                                    = $19;
  ERROR_SEEK_ON_DEVICE                                          = $84;
  ERROR_SEM_IS_SET                                              = $66;
  ERROR_SEM_NOT_FOUND                                           = $BB;
  ERROR_SEM_OWNER_DIED                                          = $69;
  ERROR_SEM_TIMEOUT                                             = $79;
  ERROR_SEM_USER_LIMIT                                          = $6A;
  ERROR_SERVER_DISABLED                                         = $53D;
  ERROR_SERVER_NOT_DISABLED                                     = $53E;
  ERROR_SETCOUNT_ON_BAD_LB                                      = $599;
  ERROR_SHARING_BUFFER_EXCEEDED                                 = $24;
  ERROR_SHARING_PAUSED                                          = $46;
  ERROR_SHARING_VIOLATION                                       = $20;
  ERROR_SHORT_NAMES_NOT_ENABLED_ON_VOLUME                       = $131;
  ERROR_SIGNAL_PENDING                                          = $A2;
  ERROR_SIGNAL_REFUSED                                          = $9C;
  ERROR_SOME_NOT_MAPPED                                         = $515;
  ERROR_SPECIAL_ACCOUNT                                         = $55B;
  ERROR_SPECIAL_GROUP                                           = $55C;
  ERROR_SPECIAL_USER                                            = $55D;
  ERROR_SUBST_TO_JOIN                                           = $8D;
  ERROR_SUBST_TO_SUBST                                          = $8B;
  ERROR_SUCCESS                                                 = $0;
  ERROR_SUCCESS_REBOOT_INITIATED                                = $669;
  ERROR_SYMLINK_CLASS_DISABLED                                  = $5B7;
  ERROR_SYMLINK_NOT_SUPPORTED                                   = $5B8;
  ERROR_SYSTEM_TRACE                                            = $96;
  ERROR_THREAD_1_INACTIVE                                       = $D2;
  ERROR_THREAD_ALREADY_IN_TASK                                  = $610;
  ERROR_THREAD_MODE_ALREADY_BACKGROUND                          = $190;
  ERROR_THREAD_MODE_NOT_BACKGROUND                              = $191;
  ERROR_TIMEOUT                                                 = $5B4;
  ERROR_TIME_SKEW                                               = $576;
  ERROR_TLW_WITH_WSCHILD                                        = $57E;
  ERROR_TOKEN_ALREADY_IN_USE                                    = $55F;
  ERROR_TOO_MANY_CMDS                                           = $38;
  ERROR_TOO_MANY_CONTEXT_IDS                                    = $568;
  ERROR_TOO_MANY_DESCRIPTORS                                    = $14B;
  ERROR_TOO_MANY_LUIDS_REQUESTED                                = $535;
  ERROR_TOO_MANY_MODULES                                        = $D6;
  ERROR_TOO_MANY_MUXWAITERS                                     = $98;
  ERROR_TOO_MANY_NAMES                                          = $44;
  ERROR_TOO_MANY_OPEN_FILES                                     = $4;
  ERROR_TOO_MANY_POSTS                                          = $12A;
  ERROR_TOO_MANY_SECRETS                                        = $565;
  ERROR_TOO_MANY_SEMAPHORES                                     = $64;
  ERROR_TOO_MANY_SEM_REQUESTS                                   = $67;
  ERROR_TOO_MANY_SESS                                           = $45;
  ERROR_TOO_MANY_SIDS                                           = $56D;
  ERROR_TOO_MANY_TCBS                                           = $9B;
  ERROR_UNDEFINED_SCOPE                                         = $13F;
  ERROR_UNEXP_NET_ERR                                           = $3B;
  ERROR_UNKNOWN_COMPONENT                                       = $647;
  ERROR_UNKNOWN_FEATURE                                         = $646;
  ERROR_UNKNOWN_PATCH                                           = $66F;
  ERROR_UNKNOWN_PRODUCT                                         = $645;
  ERROR_UNKNOWN_PROPERTY                                        = $648;
  ERROR_UNKNOWN_REVISION                                        = $519;
  ERROR_UNSUPPORTED_TYPE                                        = $65E;
  ERROR_USER_EXISTS                                             = $524;
  ERROR_VC_DISCONNECTED                                         = $F0;
  ERROR_VIRUS_DELETED                                           = $E2;
  ERROR_VIRUS_INFECTED                                          = $E1;
  ERROR_WAIT_NO_CHILDREN                                        = $80;
  ERROR_WINDOW_NOT_COMBOBOX                                     = $58F;
  ERROR_WINDOW_NOT_DIALOG                                       = $58C;
  ERROR_WINDOW_OF_OTHER_THREAD                                  = $580;
  ERROR_WORKING_SET_QUOTA                                       = $5AD;
  ERROR_WRITE_FAULT                                             = $1D;
  ERROR_WRITE_PROTECT                                           = $13;
  ERROR_WRONG_COMPARTMENT                                       = $5BC;
  ERROR_WRONG_DISK                                              = $22;
  ERROR_WRONG_PASSWORD                                          = $52B;
  ERROR_WRONG_TARGET_NAME                                       = $574;
  ERROR_XMLDSIG_ERROR                                           = $5BA;
  ERROR_XML_PARSE_ERROR                                         = $5B9;
  EXCEPTION_MAXIMUM_PARAMETERS                                  = 15;
  FILE_128_BYTE_ALIGNMENT                                       = $0000007F;
  FILE_256_BYTE_ALIGNMENT                                       = $000000FF;
  FILE_32_BYTE_ALIGNMENT                                        = $0000001F;
  FILE_512_BYTE_ALIGNMENT                                       = $000001FF;
  FILE_64_BYTE_ALIGNMENT                                        = $0000003F;
  FILE_ANY_ACCESS                                               = 0;
  FILE_ATTRIBUTE_ARCHIVE                                        = $00000020;
  FILE_ATTRIBUTE_COMPRESSED                                     = $00000800;
  FILE_ATTRIBUTE_DEVICE                                         = $00000040;
  FILE_ATTRIBUTE_DIRECTORY                                      = $00000010;
  FILE_ATTRIBUTE_ENCRYPTED                                      = $00004000;
  FILE_ATTRIBUTE_HIDDEN                                         = $00000002;
  FILE_ATTRIBUTE_NORMAL                                         = $00000080;
  FILE_ATTRIBUTE_NOT_CONTENT_INDEXED                            = $00002000;
  FILE_ATTRIBUTE_OFFLINE                                        = $00001000;
  FILE_ATTRIBUTE_READONLY                                       = $00000001;
  FILE_ATTRIBUTE_REPARSE_POINT                                  = $00000400;
  FILE_ATTRIBUTE_SPARSE_FILE                                    = $00000200;
  FILE_ATTRIBUTE_SYSTEM                                         = $00000004;
  FILE_ATTRIBUTE_TEMPORARY                                      = $00000100;
  FILE_ATTRIBUTE_VALID_FLAGS                                    = $00007FB7;
  FILE_ATTRIBUTE_VALID_SET_FLAGS                                = $000031A7;
  FILE_AUTOGENERATED_DEVICE_NAME                                = $00000080;
  FILE_BYTE_ALIGNMENT                                           = $00000000;
  FILE_COMPLETE_IF_OPLOCKED                                     = $00000100;
  FILE_COPY_STRUCTURED_STORAGE                                  = $00000041;
  FILE_CREATE                                                   = $00000002;
  FILE_CREATED                                                  = $00000002;
  FILE_CREATE_TREE_CONNECTION                                   = $00000080;
  FILE_DELETE_ON_CLOSE                                          = $00001000;
  FILE_DEVICE_IS_MOUNTED                                        = $00000020;
  FILE_DEVICE_SECURE_OPEN                                       = $00000100;
  FILE_DIRECTORY_FILE                                           = $00000001;
  FILE_DOES_NOT_EXIST                                           = $00000005;
  FILE_EXISTS                                                   = $00000004;
  FILE_FLOPPY_DISKETTE                                          = $00000004;
  FILE_LONG_ALIGNMENT                                           = $00000003;
  FILE_MAXIMUM_DISPOSITION                                      = $00000005;
  FILE_NON_DIRECTORY_FILE                                       = $00000040;
  FILE_NO_COMPRESSION                                           = $00008000;
  FILE_NO_EA_KNOWLEDGE                                          = $00000200;
  FILE_NO_INTERMEDIATE_BUFFERING                                = $00000008;
  FILE_OCTA_ALIGNMENT                                           = $0000000F;
  FILE_OPEN                                                     = $00000001;
  FILE_OPENED                                                   = $00000001;
  FILE_OPEN_BY_FILE_ID                                          = $00002000;
  FILE_OPEN_FOR_BACKUP_INTENT                                   = $00004000;
  FILE_OPEN_FOR_FREE_SPACE_QUERY                                = $00800000;
  FILE_OPEN_FOR_RECOVERY                                        = $00000400;
  FILE_OPEN_IF                                                  = $00000003;
  FILE_OPEN_NO_RECALL                                           = $00400000;
  FILE_OPEN_REPARSE_POINT                                       = $00200000;
  FILE_OVERWRITE                                                = $00000004;
  FILE_OVERWRITE_IF                                             = $00000005;
  FILE_OVERWRITTEN                                              = $00000003;
  FILE_QUAD_ALIGNMENT                                           = $00000007;
  FILE_RANDOM_ACCESS                                            = $00000800;
  FILE_READ_ACCESS                                              = $0001;
  FILE_READ_ONLY_DEVICE                                         = $00000002;
  FILE_REMOTE_DEVICE                                            = $00000010;
  FILE_REMOVABLE_MEDIA                                          = $00000001;
  FILE_RESERVE_OPFILTER                                         = $00100000;
  FILE_SEQUENTIAL_ONLY                                          = $00000004;
  FILE_SHARE_DELETE                                             = $00000004;
  FILE_SHARE_READ                                               = $00000001;
  FILE_SHARE_VALID_FLAGS                                        = $00000007;
  FILE_SHARE_WRITE                                              = $00000002;
  FILE_SPECIAL_ACCESS                                           = FILE_ANY_ACCESS;
  FILE_STRUCTURED_STORAGE                                       = $00000441;
  FILE_SUPERSEDE                                                = $00000000;
  FILE_SUPERSEDED                                               = $00000000;
  FILE_SYNCHRONOUS_IO_ALERT                                     = $00000010;
  FILE_SYNCHRONOUS_IO_NONALERT                                  = $00000020;
  FILE_USE_FILE_POINTER_POSITION                                = $FFFFFFFE;
  FILE_VALID_MAILSLOT_OPTION_FLAGS                              = $00000032;
  FILE_VALID_OPTION_FLAGS                                       = $00FFFFFF;
  FILE_VALID_PIPE_OPTION_FLAGS                                  = $00000032;
  FILE_VALID_SET_FLAGS                                          = $00000036;
  FILE_VIRTUAL_VOLUME                                           = $00000040;
  FILE_WORD_ALIGNMENT                                           = $00000001;
  FILE_WRITE_ACCESS                                             = $0002;
  FILE_WRITE_ONCE_MEDIA                                         = $00000008;
  FILE_WRITE_THROUGH                                            = $00000002;
  FILE_WRITE_TO_END_OF_FILE                                     = $FFFFFFFF;
  FM_GETDRIVEINFOA                                              = $0459;
  FM_GETDRIVEINFOW                                              = $0459;
  FM_GETFILESELA                                                = $0459;
  FM_GETFILESELLFNA                                             = $0459;
  FM_GETFILESELLFNW                                             = $0459;
  FM_GETFILESELW                                                = $0459;
  FM_GETFOCUS                                                   = $0459;
  FM_GETSELCOUNT                                                = $0459;
  FM_GETSELCOUNTLFN                                             = $0459;
  FM_REFRESH_WINDOWS                                            = $0459;
  FM_RELOAD_EXTENSIONS                                          = $0459;
  GWL_EXSTYLE                                                   = -20;
  GWL_HINSTANCE                                                 = -6;
  GWL_HWNDPARENT                                                = -8;
  GWL_ID                                                        = -12;
  GWL_STYLE                                                     = -16;
  GWL_USERDATA                                                  = -21;
  GWL_WNDPROC                                                   = -4;
  HEAP_GENERATE_EXCEPTIONS                                      = $00000004;
  HEAP_NO_SERIALIZE                                             = $00000001;
  HEAP_ZERO_MEMORY                                              = $00000008;
  HKEY_CLASSES_ROOT                                             = nativeuint($80000000);
  HKEY_CURRENT_CONFIG                                           = nativeuint($80000005);
  HKEY_CURRENT_USER                                             = nativeuint($80000001);
  HKEY_DYN_DATA                                                 = nativeuint($80000006);
  HKEY_LOCAL_MACHINE                                            = nativeuint($80000002);
  HKEY_PERFORMANCE_DATA                                         = nativeuint($80000004);
  HKEY_USERS                                                    = nativeuint($80000003);
  HKM_GETHOTKEY                                                 = $00d2;
  HKM_SETHOTKEY                                                 = $00d2;
  HKM_SETRULES                                                  = $00d2;
  HW_PROFILE_GUIDLEN                                            = 39;                 { 36 + Z Z Z }
  IDC_ARROW                                                     = 32512;
  IDC_CROSS                                                     = 32515;
  IDC_HAND                                                      = 32649;
  IDC_HELP                                                      = 32651;
  IDC_IBEAM                                                     = 32513;
  IDC_ICON                                                      = 32641;
  IDC_NO                                                        = 32648;
  IDC_SIZE                                                      = 32640;
  IDC_SIZEALL                                                   = 32646;
  IDC_SIZENESW                                                  = 32643;
  IDC_SIZENS                                                    = 32645;
  IDC_SIZENWSE                                                  = 32642;
  IDC_SIZEWE                                                    = 32644;
  IDC_UPARROW                                                   = 32516;
  IDC_WAIT                                                      = 32514;
  IDI_APPLICATION                                               = 32512;
  IDI_ASTERISK                                                  = 32516;
  IDI_ERROR                                                     = 32513;
  IDI_EXCLAMATION                                               = 32515;
  IDI_HAND                                                      = 32513;
  IDI_INFORMATION                                               = 32516;
  IDI_QUESTION                                                  = 32514;
  IDI_SHIELD                                                    = 32518;
  IDI_WARNING                                                   = 32515;
  IDI_WINLOGO                                                   = 32517;
  IE_DOCOMMAND                                                  = $0459;
  IE_GETAPPDATA                                                 = $0459;
  IE_GETBKGND                                                   = $0459;
  IE_GETCOMMAND                                                 = $0459;
  IE_GETCOUNT                                                   = $0459;
  IE_GETDRAWOPTS                                                = $0459;
  IE_GETERASERTIP                                               = $0459;
  IE_GETFORMAT                                                  = $0459;
  IE_GETGESTURE                                                 = $0459;
  IE_GETGRIDORIGIN                                              = $0459;
  IE_GETGRIDPEN                                                 = $0459;
  IE_GETGRIDSIZE                                                = $0459;
  IE_GETINK                                                     = $0459;
  IE_GETINKINPUT                                                = $0459;
  IE_GETINKRECT                                                 = $0459;
  IE_GETMENU                                                    = $0459;
  IE_GETMODE                                                    = $0459;
  IE_GETNOTIFY                                                  = $0459;
  IE_GETPAINTDC                                                 = $0459;
  IE_GETPDEVENT                                                 = $0459;
  IE_GETPENTIP                                                  = $0459;
  IE_GETRECOG                                                   = $0459;
  IE_GETSECURITY                                                = $0459;
  IE_GETSEL                                                     = $0459;
  IE_GETSELCOUNT                                                = $0459;
  IE_GETSELITEMS                                                = $0459;
  IE_GETSTYLE                                                   = $0459;
  IE_MSGFIRST                                                   = $0459;
  IE_SETAPPDATA                                                 = $0459;
  IE_SETBKGND                                                   = $0459;
  IE_SETDRAWOPTS                                                = $0459;
  IE_SETERASERTIP                                               = $0459;
  IE_SETFORMAT                                                  = $0459;
  IE_SETGRIDORIGIN                                              = $0459;
  IE_SETGRIDPEN                                                 = $0459;
  IE_SETGRIDSIZE                                                = $0459;
  IE_SETINK                                                     = $0459;
  IE_SETINKINPUT                                                = $0459;
  IE_SETMODE                                                    = $0459;
  IE_SETNOTIFY                                                  = $0459;
  IE_SETPENTIP                                                  = $0459;
  IE_SETRECOG                                                   = $0459;
  IE_SETSECURITY                                                = $0459;
  IE_SETSEL                                                     = $0459;
  INFINITE                                                      = Cardinal($FFFFFFFF);
  INVALID_HANDLE                                                = -1;
  IPM_CLEARADDRESS                                              = $0459;
  IPM_GETADDRESS                                                = $0459;
  IPM_ISBLANK                                                   = $0459;
  IPM_SETADDRESS                                                = $0459;
  IPM_SETFOCUS                                                  = $0459;
  IPM_SETRANGE                                                  = $0459;
  KEY_ALL_ACCESS                                                = $f003f;
  KEY_CREATE_LINK                                               = 32;
  KEY_CREATE_SUB_KEY                                            = 4;
  KEY_ENUMERATE_SUB_KEYS                                        = 8;
  KEY_EXECUTE                                                   = $20019;
  KEY_NOTIFY                                                    = 16;
  KEY_QUERY_VALUE                                               = 1;
  KEY_READ                                                      = $20019;
  KEY_SET_VALUE                                                 = 2;
  KEY_WOW64_32KEY                                               = $0200;
  KEY_WOW64_64KEY                                               = $0100;
  KEY_WRITE                                                     = $20006;
  LF_FACESIZE                                                   = 32;
  LF_FULLFACESIZE                                               = 64;
  LVM_APPROXIMATEVIEWRECT                                       = $0459;
  LVM_ARRANGE                                                   = $0459;
  LVM_CANCELEDITLABEL                                           = $0459;
  LVM_CREATEDRAGIMAGE                                           = $0459;
  LVM_DELETEALLITEMS                                            = $0459;
  LVM_DELETECOLUMN                                              = $0459;
  LVM_DELETEITEM                                                = $0459;
  LVM_EDITLABELA                                                = $0459;
  LVM_EDITLABELW                                                = $0459;
  LVM_ENABLEGROUPVIEW                                           = $0459;
  LVM_ENSUREVISIBLE                                             = $0459;
  LVM_FINDITEMA                                                 = $0459;
  LVM_FINDITEMW                                                 = $0459;
  LVM_FIRST                                                     = $0459;
  LVM_GETBKCOLOR                                                = $0459;
  LVM_GETBKIMAGEA                                               = $0459;
  LVM_GETBKIMAGEW                                               = $0459;
  LVM_GETCALLBACKMASK                                           = $0459;
  LVM_GETCOLUMNA                                                = $0459;
  LVM_GETCOLUMNORDERARRAY                                       = $0459;
  LVM_GETCOLUMNW                                                = $0459;
  LVM_GETCOLUMNWIDTH                                            = $0459;
  LVM_GETCOUNTPERPAGE                                           = $0459;
  LVM_GETEDITCONTROL                                            = $0459;
  LVM_GETEXTENDEDLISTVIEWSTYLE                                  = $0459;
  LVM_GETGROUPINFO                                              = $0459;
  LVM_GETGROUPMETRICS                                           = $0459;
  LVM_GETHEADER                                                 = $0459;
  LVM_GETHOTCURSOR                                              = $0459;
  LVM_GETHOTITEM                                                = $0459;
  LVM_GETHOVERTIME                                              = $0459;
  LVM_GETIMAGELIST                                              = $0459;
  LVM_GETINSERTMARK                                             = $0459;
  LVM_GETINSERTMARKCOLOR                                        = $0459;
  LVM_GETINSERTMARKRECT                                         = $0459;
  LVM_GETISEARCHSTRINGA                                         = $0459;
  LVM_GETISEARCHSTRINGW                                         = $0459;
  LVM_GETITEMA                                                  = $0459;
  LVM_GETITEMCOUNT                                              = $0459;
  LVM_GETITEMPOSITION                                           = $0459;
  LVM_GETITEMRECT                                               = $0459;
  LVM_GETITEMSPACING                                            = $0459;
  LVM_GETITEMSTATE                                              = $0459;
  LVM_GETITEMTEXTA                                              = $0459;
  LVM_GETITEMTEXTW                                              = $0459;
  LVM_GETITEMW                                                  = $0459;
  LVM_GETNEXTITEM                                               = $0459;
  LVM_GETNUMBEROFWORKAREAS                                      = $0459;
  LVM_GETORIGIN                                                 = $0459;
  LVM_GETOUTLINECOLOR                                           = $0459;
  LVM_GETSELECTEDCOLUMN                                         = $0459;
  LVM_GETSELECTEDCOUNT                                          = $0459;
  LVM_GETSELECTIONMARK                                          = $0459;
  LVM_GETSTRINGWIDTHA                                           = $0459;
  LVM_GETSTRINGWIDTHW                                           = $0459;
  LVM_GETSUBITEMRECT                                            = $0459;
  LVM_GETTEXTBKCOLOR                                            = $0459;
  LVM_GETTEXTCOLOR                                              = $0459;
  LVM_GETTILEINFO                                               = $0459;
  LVM_GETTILEVIEWINFO                                           = $0459;
  LVM_GETTOOLTIPS                                               = $0459;
  LVM_GETTOPINDEX                                               = $0459;
  LVM_GETUNICODEFORMAT                                          = $0459;
  LVM_GETVIEW                                                   = $0459;
  LVM_GETVIEWRECT                                               = $0459;
  LVM_GETWORKAREAS                                              = $0459;
  LVM_HASGROUP                                                  = $0459;
  LVM_HITTEST                                                   = $0459;
  LVM_INSERTCOLUMNA                                             = $0459;
  LVM_INSERTCOLUMNW                                             = $0459;
  LVM_INSERTGROUP                                               = $0459;
  LVM_INSERTGROUPSORTED                                         = $0459;
  LVM_INSERTITEMA                                               = $0459;
  LVM_INSERTITEMW                                               = $0459;
  LVM_INSERTMARKHITTEST                                         = $0459;
  LVM_ISGROUPVIEWENABLED                                        = $0459;
  LVM_ISITEMVISIBLE                                             = $0459;
  LVM_MAPIDTOINDEX                                              = $0459;
  LVM_MAPINDEXTOID                                              = $0459;
  LVM_MOVEGROUP                                                 = $0459;
  LVM_MOVEITEMTOGROUP                                           = $0459;
  LVM_REDRAWITEMS                                               = $0459;
  LVM_REMOVEALLGROUPS                                           = $0459;
  LVM_REMOVEGROUP                                               = $0459;
  LVM_SCROLL                                                    = $0459;
  LVM_SETBKCOLOR                                                = $0459;
  LVM_SETBKIMAGEA                                               = $0459;
  LVM_SETCALLBACKMASK                                           = $0459;
  LVM_SETCOLUMNA                                                = $0459;
  LVM_SETCOLUMNORDERARRAY                                       = $0459;
  LVM_SETCOLUMNW                                                = $0459;
  LVM_SETCOLUMNWIDTH                                            = $0459;
  LVM_SETEXTENDEDLISTVIEWSTYLE                                  = $0459;
  LVM_SETGROUPINFO                                              = $0459;
  LVM_SETGROUPMETRICS                                           = $0459;
  LVM_SETHOTCURSOR                                              = $0459;
  LVM_SETHOTITEM                                                = $0459;
  LVM_SETHOVERTIME                                              = $0459;
  LVM_SETICONSPACING                                            = $0459;
  LVM_SETIMAGELIST                                              = $0459;
  LVM_SETINFOTIP                                                = $0459;
  LVM_SETINSERTMARK                                             = $0459;
  LVM_SETINSERTMARKCOLOR                                        = $0459;
  LVM_SETITEMA                                                  = $0459;
  LVM_SETITEMCOUNT                                              = $0459;
  LVM_SETITEMPOSITION                                           = $0459;
  LVM_SETITEMPOSITION32                                         = $0459;
  LVM_SETITEMSTATE                                              = $0459;
  LVM_SETITEMTEXTA                                              = $0459;
  LVM_SETITEMTEXTW                                              = $0459;
  LVM_SETITEMW                                                  = $0459;
  LVM_SETOUTLINECOLOR                                           = $0459;
  LVM_SETSELECTEDCOLUMN                                         = $0459;
  LVM_SETSELECTIONMARK                                          = $0459;
  LVM_SETTEXTBKCOLOR                                            = $0459;
  LVM_SETTEXTCOLOR                                              = $0459;
  LVM_SETTILEINFO                                               = $0459;
  LVM_SETTILEVIEWINFO                                           = $0459;
  LVM_SETTILEWIDTH                                              = $0459;
  LVM_SETTOOLTIPS                                               = $0459;
  LVM_SETUNICODEFORMAT                                          = $0459;
  LVM_SETVIEW                                                   = $0459;
  LVM_SETWORKAREAS                                              = $0459;
  LVM_SORTGROUPS                                                = $0459;
  LVM_SORTITEMS                                                 = $0459;
  LVM_SUBITEMHITTEST                                            = $0459;
  LVM_UPDATE                                                    = $0459;
  MAXIMUM_FILENAME_LENGTH                                       = 256;
  MAXIMUM_SUPPORTED_EXTENSION                                   = 512;
  MAX_DEFAULTCHAR                                               = 2;
  MAX_LEADBYTES                                                 = 12;
  MAX_MODULE_NAME32                                             = 255;
  MAX_PATH                                                      = 260;
  MAX_PROFILE_LEN                                               = 80;
  MCIWNDM_CAN_CONFIG                                            = $0459;
  MCIWNDM_CAN_EJECT                                             = $0459;
  MCIWNDM_CAN_PLAY                                              = $0459;
  MCIWNDM_CAN_RECORD                                            = $0459;
  MCIWNDM_CAN_SAVE                                              = $0459;
  MCIWNDM_CAN_WINDOW                                            = $0459;
  MCIWNDM_GETDEVICEA                                            = $0459;
  MCIWNDM_GETDEVICEW                                            = $0459;
  MCIWNDM_GETERRORA                                             = $0459;
  MCIWNDM_GETERRORW                                             = $0459;
  MCIWNDM_GETFILENAMEA                                          = $0459;
  MCIWNDM_GETFILENAMEW                                          = $0459;
  MCIWNDM_GETINACTIVETIMER                                      = $0459;
  MCIWNDM_GETPALETTE                                            = $0459;
  MCIWNDM_GETTIMEFORMATA                                        = $0459;
  MCIWNDM_GETTIMEFORMATW                                        = $0459;
  MCIWNDM_GETZOOM                                               = $0459;
  MCIWNDM_GET_DEST                                              = $0459;
  MCIWNDM_GET_SOURCE                                            = $0459;
  MCIWNDM_NOTIFYERROR                                           = $0459;
  MCIWNDM_NOTIFYMEDIA                                           = $0459;
  MCIWNDM_NOTIFYMODE                                            = $0459;
  MCIWNDM_PALETTEKICK                                           = $0459;
  MCIWNDM_PLAYTO                                                = $0459;
  MCIWNDM_PUT_DEST                                              = $0459;
  MCIWNDM_PUT_SOURCE                                            = $0459;
  MCIWNDM_REALIZE                                               = $0459;
  MCIWNDM_SETINACTIVETIMER                                      = $0459;
  MCIWNDM_SETPALETTE                                            = $0459;
  MCIWNDM_SETTIMEFORMATA                                        = $0459;
  MCIWNDM_SETTIMEFORMATW                                        = $0459;
  MCIWNDM_VALIDATEMEDIA                                         = $0459;
  MM_MAX_NUMAXES                                                = 16;
  MN_GETHMENU                                                   = $01E1;
  MSG_FTS_JUMP_QWORD                                            = $00d2;
  MSG_FTS_JUMP_VA                                               = $00d2;
  MSG_FTS_WHERE_IS_IT                                           = $00d2;
  MSG_GET_DEFFONT                                               = $00d2;
  MSG_REINDEX_REQUEST                                           = $00d2;
  NIN_SELECT                                                    = $00d2;
  OCM_CHARTOITEM                                                = $0459;
  OCM_COMMAND                                                   = $0459;
  OCM_COMPAREITEM                                               = $0459;
  OCM_CTLCOLOR                                                  = $0459;
  OCM_CTLCOLORBTN                                               = $0459;
  OCM_CTLCOLORDLG                                               = $0459;
  OCM_CTLCOLOREDIT                                              = $0459;
  OCM_CTLCOLORLISTBOX                                           = $0459;
  OCM_CTLCOLORMSGBOX                                            = $0459;
  OCM_CTLCOLORSCROLLBAR                                         = $0459;
  OCM_CTLCOLORSTATIC                                            = $0459;
  OCM_DELETEITEM                                                = $0459;
  OCM_DRAWITEM                                                  = $0459;
  OCM_HSCROLL                                                   = $0459;
  OCM_MEASUREITEM                                               = $0459;
  OCM_NOTIFY                                                    = $0459;
  OCM_PARENTNOTIFY                                              = $0459;
  OCM_VKEYTOITEM                                                = $0459;
  OCM_VSCROLL                                                   = $0459;
  OCM__BASE                                                     = $0459;
  OFS_MAXPATHNAME                                               = 128;
  PBM_DELTAPOS                                                  = $00d2;
  PBM_GETPOS                                                    = $00d2;
  PBM_GETRANGE                                                  = $00d2;
  PBM_SETBARCOLOR                                               = $00d2;
  PBM_SETPOS                                                    = $00d2;
  PBM_SETRANGE                                                  = $00d2;
  PBM_SETRANGE32                                                = $00d2;
  PBM_SETSTEP                                                   = $00d2;
  PBM_STEPIT                                                    = $00d2;
  PFD_DEPTH_DONTCARE                                            = $20000000;
  PFD_DOUBLEBUFFER                                              = $1;
  PFD_DOUBLEBUFFER_DONTCARE                                     = $40000000;
  PFD_DRAW_TO_BITMAP                                            = $8;
  PFD_DRAW_TO_WINDOW                                            = $4;
  PFD_GENERIC_ACCELERATED                                       = $1000;
  PFD_GENERIC_FORMAT                                            = $40;
  PFD_MAIN_PLANE                                                = $0;
  PFD_NEED_PALETTE                                              = $80;
  PFD_NEED_SYSTEM_PALETTE                                       = $100;
  PFD_STEREO                                                    = $2;
  PFD_STEREO_DONTCARE                                           = $80000000;
  PFD_SUPPORT_GDI                                               = $10;
  PFD_SUPPORT_OPENGL                                            = $20;
  PFD_SWAP_COPY                                                 = $400;
  PFD_SWAP_EXCHANGE                                             = $200;
  PFD_SWAP_LAYER_BUFFERS                                        = $800;
  PFD_TYPE_COLORINDEX                                           = $1;
  PFD_TYPE_RGBA                                                 = $0;
  PM_NOREMOVE                                                   = $00;
  PM_NOYIELD                                                    = $02;
  PM_REMOVE                                                     = $01;
  PSM_ADDPAGE                                                   = $0459;
  PSM_APPLY                                                     = $0459;
  PSM_CANCELTOCLOSE                                             = $0459;
  PSM_CHANGED                                                   = $0459;
  PSM_GETCURRENTPAGEHWND                                        = $0459;
  PSM_GETRESULT                                                 = $0459;
  PSM_GETTABCONTROL                                             = $0459;
  PSM_HWNDTOINDEX                                               = $0459;
  PSM_IDTOINDEX                                                 = $0459;
  PSM_INDEXTOHWND                                               = $0459;
  PSM_INDEXTOID                                                 = $0459;
  PSM_INDEXTOPAGE                                               = $0459;
  PSM_INSERTPAGE                                                = $0459;
  PSM_ISDIALOGMESSAGE                                           = $0459;
  PSM_PAGETOINDEX                                               = $0459;
  PSM_PRESSBUTTON                                               = $0459;
  PSM_QUERYSIBLINGS                                             = $0459;
  PSM_REBOOTSYSTEM                                              = $0459;
  PSM_RECALCPAGESIZES                                           = $0459;
  PSM_REMOVEPAGE                                                = $0459;
  PSM_RESTARTWINDOWS                                            = $0459;
  PSM_SETCURSEL                                                 = $0459;
  PSM_SETCURSELID                                               = $0459;
  PSM_SETFINISHTEXTA                                            = $0459;
  PSM_SETFINISHTEXTW                                            = $0459;
  PSM_SETHEADERSUBTITLEA                                        = $0459;
  PSM_SETHEADERSUBTITLEW                                        = $0459;
  PSM_SETHEADERTITLEA                                           = $0459;
  PSM_SETHEADERTITLEW                                           = $0459;
  PSM_SETTITLEA                                                 = $0459;
  PSM_SETTITLEW                                                 = $0459;
  PSM_SETWIZBUTTONS                                             = $0459;
  PSM_UNCHANGED                                                 = $0459;
  RB_BEGINDRAG                                                  = $00d2;
  RB_DELETEBAND                                                 = $00d2;
  RB_DRAGMOVE                                                   = $00d2;
  RB_ENDDRAG                                                    = $00d2;
  RB_GETBANDBORDERS                                             = $00d2;
  RB_GETBANDCOUNT                                               = $00d2;
  RB_GETBANDINFOA                                               = $00d2;
  RB_GETBANDINFOW                                               = $00d2;
  RB_GETBARHEIGHT                                               = $00d2;
  RB_GETBARINFO                                                 = $00d2;
  RB_GETBKCOLOR                                                 = $00d2;
  RB_GETPALETTE                                                 = $00d2;
  RB_GETRECT                                                    = $00d2;
  RB_GETROWCOUNT                                                = $00d2;
  RB_GETROWHEIGHT                                               = $00d2;
  RB_GETTEXTCOLOR                                               = $00d2;
  RB_GETTOOLTIPS                                                = $00d2;
  RB_HITTEST                                                    = $00d2;
  RB_IDTOINDEX                                                  = $00d2;
  RB_INSERTBANDA                                                = $00d2;
  RB_INSERTBANDW                                                = $00d2;
  RB_MAXIMIZEBAND                                               = $00d2;
  RB_MINIMIZEBAND                                               = $00d2;
  RB_MOVEBAND                                                   = $00d2;
  RB_PUSHCHEVRON                                                = $00d2;
  RB_SETBANDINFOA                                               = $00d2;
  RB_SETBANDINFOW                                               = $00d2;
  RB_SETBARINFO                                                 = $00d2;
  RB_SETBKCOLOR                                                 = $00d2;
  RB_SETPALETTE                                                 = $00d2;
  RB_SETPARENT                                                  = $00d2;
  RB_SETTEXTCOLOR                                               = $00d2;
  RB_SETTOOLTIPS                                                = $00d2;
  RB_SHOWBAND                                                   = $00d2;
  RB_SIZETORECT                                                 = $00d2;
  SBM_ENABLE_ARROWS                                             = $00d2;
  SBM_GETPOS                                                    = $00d2;
  SBM_GETRANGE                                                  = $00d2;
  SBM_GETSCROLLBARINFO                                          = $00d2;
  SBM_GETSCROLLINFO                                             = $00d2;
  SBM_SETPOS                                                    = $00d2;
  SBM_SETRANGE                                                  = $00d2;
  SBM_SETRANGEREDRAW                                            = $00d2;
  SBM_SETSCROLLINFO                                             = $00d2;
  SB_GETBORDERS                                                 = $00d2;
  SB_GETICON                                                    = $00d2;
  SB_GETPARTS                                                   = $00d2;
  SB_GETRECT                                                    = $00d2;
  SB_GETTEXTA                                                   = $00d2;
  SB_GETTEXTLENGTHA                                             = $00d2;
  SB_GETTEXTLENGTHW                                             = $00d2;
  SB_GETTEXTW                                                   = $00d2;
  SB_GETTIPTEXTA                                                = $00d2;
  SB_GETTIPTEXTW                                                = $00d2;
  SB_ISSIMPLE                                                   = $00d2;
  SB_SETICON                                                    = $00d2;
  SB_SETMINHEIGHT                                               = $00d2;
  SB_SETPARTS                                                   = $00d2;
  SB_SETTEXTA                                                   = $00d2;
  SB_SETTEXTW                                                   = $00d2;
  SB_SETTIPTEXTA                                                = $00d2;
  SB_SETTIPTEXTW                                                = $00d2;
  SB_SIMPLE                                                     = $00d2;
  SERVICE_ACCEPT_HARDWAREPROFILECHANGE                          = $00000020;
  SERVICE_ACCEPT_NETBINDCHANGE                                  = $00000010;
  SERVICE_ACCEPT_PARAMCHANGE                                    = $00000008;
  SERVICE_ACCEPT_PAUSE_CONTINUE                                 = $00000002;
  SERVICE_ACCEPT_POWEREVENT                                     = $00000040;
  SERVICE_ACCEPT_PRESHUTDOWN                                    = $00000100;
  SERVICE_ACCEPT_SESSIONCHANGE                                  = $00000080;
  SERVICE_ACCEPT_SHUTDOWN                                       = $00000004;
  SERVICE_ACCEPT_STOP                                           = $00000001;
  SERVICE_ACCEPT_TIMECHANGE                                     = $00000200;
  SERVICE_ACCEPT_TRIGGEREVENT                                   = $00000400;
  SERVICE_ACCEPT_USERMODEREBOOT                                 = $00000800;
  SERVICE_CONTINUE_PENDING                                      = $00000005;
  SERVICE_CONTROL_CONTINUE                                      = $00000003;
  SERVICE_CONTROL_DEVICEEVENT                                   = $0000000B;
  SERVICE_CONTROL_HARDWAREPROFILECHANGE                         = $0000000C;
  SERVICE_CONTROL_INTERROGATE                                   = $00000004;
  SERVICE_CONTROL_NETBINDADD                                    = $00000007;
  SERVICE_CONTROL_NETBINDDISABLE                                = $0000000A;
  SERVICE_CONTROL_NETBINDENABLE                                 = $00000009;
  SERVICE_CONTROL_NETBINDREMOVE                                 = $00000008;
  SERVICE_CONTROL_NzETBINDENABLE                                = $00000009;
  SERVICE_CONTROL_PARAMCHANGE                                   = $00000006;
  SERVICE_CONTROL_PAUSE                                         = $00000002;
  SERVICE_CONTROL_POWEREVENT                                    = $0000000D;
  SERVICE_CONTROL_PRESHUTDOWN                                   = $0000000F;
  SERVICE_CONTROL_SESSIONCHANGE                                 = $0000000E;
  SERVICE_CONTROL_SHUTDOWN                                      = $00000005;
  SERVICE_CONTROL_STOP                                          = $00000001;
  SERVICE_CONTROL_TIMECHANGE                                    = $00000010;
  SERVICE_CONTROL_TRIGGEREVENT                                  = $00000020;
  SERVICE_CONTROL_USERMODEREBOOT                                = $00000040;
  SERVICE_FILE_SYSTEM_DRIVER                                    = $00000002;
  SERVICE_INTERACTIVE_PROCESS                                   = $00000100;
  SERVICE_KERNEL_DRIVER                                         = $00000001;
  SERVICE_PAUSED                                                = $00000007;
  SERVICE_PAUSE_PENDING                                         = $00000006;
  SERVICE_RUNNING                                               = $00000004;
  SERVICE_START_PENDING                                         = $00000002;
  SERVICE_STOPPED                                               = $00000001;
  SERVICE_STOP_PENDING                                          = $00000003;
  SERVICE_WIN32_OWN_PROCESS                                     = $00000010;
  SERVICE_WIN32_SHARE_PROCESS                                   = $00000020;
  SIZE_OF_80387_REGISTERS                                       = 80;
  SM_GETCURFOCUSA                                               = $0459;
  SM_GETCURFOCUSW                                               = $0459;
  SM_GETOPTIONS                                                 = $0459;
  SM_GETSELCOUNT                                                = $0459;
  SM_GETSERVERSELA                                              = $0459;
  SM_GETSERVERSELW                                              = $0459;
  SW_FORCEMINIMIZE                                              = 11;
  SW_HIDE                                                       = 0;
  SW_MAXIMIZE                                                   = 3;
  SW_MINIMIZE                                                   = 6;
  SW_RESTORE                                                    = 9;
  SW_SHOW                                                       = 5;
  SW_SHOWDEFAULT                                                = 10;
  SW_SHOWMAXIMIZED                                              = 3;
  SW_SHOWMINIMIZED                                              = 2;
  SW_SHOWMINNOACTIVE                                            = 7;
  SW_SHOWNA                                                     = 8;
  SW_SHOWNOACTIVATE                                             = 4;
  SW_SHOWNORMAL                                                 = 1;
  TAPI_REPLY                                                    = $0459;
  TBM_CLEARSEL                                                  = $00d2;
  TBM_CLEARTICS                                                 = $00d2;
  TBM_GETBUDDY                                                  = $00d2;
  TBM_GETCHANNELRECT                                            = $00d2;
  TBM_GETLINESIZE                                               = $00d2;
  TBM_GETNUMTICS                                                = $00d2;
  TBM_GETPAGESIZE                                               = $00d2;
  TBM_GETPOS                                                    = $00d2;
  TBM_GETPTICS                                                  = $00d2;
  TBM_GETRANGEMAX                                               = $00d2;
  TBM_GETRANGEMIN                                               = $00d2;
  TBM_GETSELEND                                                 = $00d2;
  TBM_GETSELSTART                                               = $00d2;
  TBM_GETTHUMBLENGTH                                            = $00d2;
  TBM_GETTHUMBRECT                                              = $00d2;
  TBM_GETTIC                                                    = $00d2;
  TBM_GETTICPOS                                                 = $00d2;
  TBM_GETTOOLTIPS                                               = $00d2;
  TBM_SETBUDDY                                                  = $00d2;
  TBM_SETLINESIZE                                               = $00d2;
  TBM_SETPAGESIZE                                               = $00d2;
  TBM_SETPOS                                                    = $00d2;
  TBM_SETRANGE                                                  = $00d2;
  TBM_SETRANGEMAX                                               = $00d2;
  TBM_SETRANGEMIN                                               = $00d2;
  TBM_SETSEL                                                    = $00d2;
  TBM_SETSELEND                                                 = $00d2;
  TBM_SETSELSTART                                               = $00d2;
  TBM_SETTHUMBLENGTH                                            = $00d2;
  TBM_SETTIC                                                    = $00d2;
  TBM_SETTICFREQ                                                = $00d2;
  TBM_SETTIPSIDE                                                = $00d2;
  TBM_SETTOOLTIPS                                               = $00d2;
  TB_ADDBITMAP                                                  = $00d2;
  TB_ADDBUTTONSA                                                = $00d2;
  TB_ADDBUTTONSW                                                = $043f;
  TB_ADDSTRINGA                                                 = $00d2;
  TB_ADDSTRINGW                                                 = $043f;
  TB_AUTOSIZE                                                   = $00d2;
  TB_BUTTONCOUNT                                                = $00d2;
  TB_BUTTONSTRUCTSIZE                                           = $00d2;
  TB_CHANGEBITMAP                                               = $00d2;
  TB_CHECKBUTTON                                                = $00d2;
  TB_COMMANDTOINDEX                                             = $00d2;
  TB_CUSTOMIZE                                                  = $00d2;
  TB_DELETEBUTTON                                               = $00d2;
  TB_ENABLEBUTTON                                               = $00d2;
  TB_GETANCHORHIGHLIGHT                                         = $043f;
  TB_GETBITMAP                                                  = $00d2;
  TB_GETBITMAPFLAGS                                             = $00d2;
  TB_GETBUTTON                                                  = $00d2;
  TB_GETBUTTONINFOA                                             = $043f;
  TB_GETBUTTONINFOW                                             = $043f;
  TB_GETBUTTONSIZE                                              = $00d2;
  TB_GETBUTTONTEXTA                                             = $00d2;
  TB_GETBUTTONTEXTW                                             = $043f;
  TB_GETDISABLEDIMAGELIST                                       = $00d2;
  TB_GETEXTENDEDSTYLE                                           = $043f;
  TB_GETHOTIMAGELIST                                            = $00d2;
  TB_GETHOTITEM                                                 = $043f;
  TB_GETIMAGELIST                                               = $00d2;
  TB_GETINSERTMARK                                              = $043f;
  TB_GETINSERTMARKCOLOR                                         = $0459;
  TB_GETITEMRECT                                                = $00d2;
  TB_GETMAXSIZE                                                 = $043f;
  TB_GETOBJECT                                                  = $043e;
  TB_GETPADDING                                                 = $043f;
  TB_GETRECT                                                    = $00d2;
  TB_GETROWS                                                    = $00d2;
  TB_GETSTATE                                                   = $00d2;
  TB_GETSTRINGA                                                 = $0459;
  TB_GETSTRINGW                                                 = $0459;
  TB_GETSTYLE                                                   = $00d2;
  TB_GETTEXTROWS                                                = $043d;
  TB_GETTOOLTIPS                                                = $00d2;
  TB_HIDEBUTTON                                                 = $00d2;
  TB_HITTEST                                                    = $043f;
  TB_INDETERMINATE                                              = $00d2;
  TB_INSERTBUTTONA                                              = $00d2;
  TB_INSERTBUTTONW                                              = $043f;
  TB_INSERTMARKHITTEST                                          = $043f;
  TB_ISBUTTONCHECKED                                            = $00d2;
  TB_ISBUTTONENABLED                                            = $00d2;
  TB_ISBUTTONHIDDEN                                             = $00d2;
  TB_ISBUTTONHIGHLIGHTED                                        = $00d2;
  TB_ISBUTTONINDETERMINATE                                      = $00d2;
  TB_ISBUTTONPRESSED                                            = $00d2;
  TB_LOADIMAGES                                                 = $00d2;
  TB_MAPACCELERATORA                                            = $043f;
  TB_MAPACCELERATORW                                            = $0459;
  TB_MARKBUTTON                                                 = $00d2;
  TB_MOVEBUTTON                                                 = $043f;
  TB_PRESSBUTTON                                                = $00d2;
  TB_REPLACEBITMAP                                              = $00d2;
  TB_SAVERESTOREA                                               = $00d2;
  TB_SAVERESTOREW                                               = $043f;
  TB_SETANCHORHIGHLIGHT                                         = $043f;
  TB_SETBITMAPSIZE                                              = $00d2;
  TB_SETBUTTONINFOA                                             = $043f;
  TB_SETBUTTONINFOW                                             = $043f;
  TB_SETBUTTONSIZE                                              = $00d2;
  TB_SETBUTTONWIDTH                                             = $00d2;
  TB_SETCMDID                                                   = $00d2;
  TB_SETDISABLEDIMAGELIST                                       = $00d2;
  TB_SETDRAWTEXTFLAGS                                           = $043f;
  TB_SETEXTENDEDSTYLE                                           = $043f;
  TB_SETHOTIMAGELIST                                            = $00d2;
  TB_SETHOTITEM                                                 = $043f;
  TB_SETIMAGELIST                                               = $00d2;
  TB_SETINDENT                                                  = $00d2;
  TB_SETINSERTMARK                                              = $043f;
  TB_SETINSERTMARKCOLOR                                         = $0458;
  TB_SETMAXTEXTROWS                                             = $00d2;
  TB_SETPADDING                                                 = $0457;
  TB_SETPARENT                                                  = $00d2;
  TB_SETROWS                                                    = $00d2;
  TB_SETSTATE                                                   = $00d2;
  TB_SETSTYLE                                                   = $00d2;
  TB_SETTOOLTIPS                                                = $00d2;
  TTM_ACTIVATE                                                  = $00d2;
  TTM_ADDTOOLA                                                  = $00d2;
  TTM_ADDTOOLW                                                  = $00d2;
  TTM_ADJUSTRECT                                                = $00d2;
  TTM_DELTOOLA                                                  = $00d2;
  TTM_DELTOOLW                                                  = $00d2;
  TTM_ENUMTOOLSA                                                = $00d2;
  TTM_ENUMTOOLSW                                                = $00d2;
  TTM_GETBUBBLESIZE                                             = $00d2;
  TTM_GETCURRENTTOOLA                                           = $00d2;
  TTM_GETCURRENTTOOLW                                           = $00d2;
  TTM_GETDELAYTIME                                              = $00d2;
  TTM_GETMARGIN                                                 = $00d2;
  TTM_GETMAXTIPWIDTH                                            = $00d2;
  TTM_GETTEXTA                                                  = $00d2;
  TTM_GETTEXTW                                                  = $00d2;
  TTM_GETTIPBKCOLOR                                             = $00d2;
  TTM_GETTIPTEXTCOLOR                                           = $00d2;
  TTM_GETTOOLCOUNT                                              = $00d2;
  TTM_GETTOOLINFOA                                              = $00d2;
  TTM_GETTOOLINFOW                                              = $00d2;
  TTM_HITTESTA                                                  = $00d2;
  TTM_HITTESTW                                                  = $00d2;
  TTM_NEWTOOLRECTA                                              = $00d2;
  TTM_NEWTOOLRECTW                                              = $00d2;
  TTM_POP                                                       = $00d2;
  TTM_RELAYEVENT                                                = $00d2;
  TTM_SETDELAYTIME                                              = $00d2;
  TTM_SETMARGIN                                                 = $00d2;
  TTM_SETMAXTIPWIDTH                                            = $00d2;
  TTM_SETTIPBKCOLOR                                             = $00d2;
  TTM_SETTIPTEXTCOLOR                                           = $00d2;
  TTM_SETTITLEA                                                 = $00d2;
  TTM_SETTITLEW                                                 = $00d2;
  TTM_SETTOOLINFOA                                              = $00d2;
  TTM_SETTOOLINFOW                                              = $00d2;
  TTM_TRACKACTIVATE                                             = $00d2;
  TTM_TRACKPOSITION                                             = $00d2;
  TTM_UPDATE                                                    = $00d2;
  TTM_UPDATETIPTEXTA                                            = $00d2;
  TTM_UPDATETIPTEXTW                                            = $00d2;
  TTM_WINDOWFROMPOINT                                           = $00d2;
  UDM_GETACCEL                                                  = $0459;
  UDM_GETBASE                                                   = $0459;
  UDM_GETBUDDY                                                  = $0459;
  UDM_GETPOS                                                    = $0459;
  UDM_GETPOS32                                                  = $0459;
  UDM_GETRANGE                                                  = $0459;
  UDM_GETRANGE32                                                = $0459;
  UDM_SETACCEL                                                  = $0459;
  UDM_SETBASE                                                   = $0459;
  UDM_SETBUDDY                                                  = $0459;
  UDM_SETPOS                                                    = $0459;
  UDM_SETPOS32                                                  = $0459;
  UDM_SETRANGE                                                  = $0459;
  UDM_SETRANGE32                                                = $0459;
  UM_GETCURFOCUSA                                               = $0459;
  UM_GETCURFOCUSW                                               = $0459;
  UM_GETGROUPSELA                                               = $0459;
  UM_GETGROUPSELW                                               = $0459;
  UM_GETOPTIONS                                                 = $0459;
  UM_GETOPTIONS2                                                = $0459;
  UM_GETSELCOUNT                                                = $0459;
  UM_GETUSERSELA                                                = $0459;
  UM_GETUSERSELW                                                = $0459;
  WAIT_TIMEOUT                                                  = $102;
  WIZ_NEXT                                                      = $00d2;
  WIZ_PREV                                                      = $00d2;
  WIZ_QUERYNUMPAGES                                             = $00d2;
  WLX_WM_SAS                                                    = $0459;
  DISPLAY_DEVICE_ATTACHED_TO_DESKTOP                            = $00000001;
  DISPLAY_DEVICE_MULTI_DRIVER                                   = $00000002;
  DISPLAY_DEVICE_PRIMARY_DEVICE                                 = $00000004;
  DISPLAY_DEVICE_MIRRORING_DRIVER                               = $00000008;
  DISPLAY_DEVICE_VGA_COMPATIBLE                                 = $00000010;
  WM_ACTIVATE                                                   = $0006;
  WM_ACTIVATEAPP                                                = $001C;
  WM_AFXFIRST                                                   = $00d2;
  WM_AFXLAST                                                    = $00d2;
  WM_APP                                                        = $8000;
  WM_APPCOMMAND                                                 = $00d2;
  WM_ASKCBFORMATNAME                                            = $00d2;
  WM_CANCELJOURNAL                                              = $0015;
  WM_CANCELMODE                                                 = $001F;
  WM_CAPTURECHANGED                                             = $00d2;
  WM_CAP_DRIVER_GET_NAMEW                                       = $0459;
  WM_CAP_DRIVER_GET_VERSIONW                                    = $0459;
  WM_CAP_FILE_GET_CAPTURE_FILEW                                 = $0459;
  WM_CAP_FILE_SAVEASW                                           = $0459;
  WM_CAP_FILE_SAVEDIBW                                          = $0459;
  WM_CAP_FILE_SET_CAPTURE_FILEW                                 = $0459;
  WM_CAP_GET_MCI_DEVICEW                                        = $0459;
  WM_CAP_PAL_OPENW                                              = $0459;
  WM_CAP_PAL_SAVEW                                              = $0459;
  WM_CAP_SET_CALLBACK_ERRORW                                    = $0459;
  WM_CAP_SET_CALLBACK_STATUSW                                   = $0459;
  WM_CAP_SET_MCI_DEVICEW                                        = $0459;
  WM_CAP_UNICODE_START                                          = $0459;
  WM_CHANGECBCHAIN                                              = $00d2;
  WM_CHANGEUISTATE                                              = $00d2;
  WM_CHAR                                                       = $00d2;
  WM_CHARTOITEM                                                 = $0015;
  WM_CHILDACTIVATE                                              = $0022;
  WM_CHOOSEFONT_GETLOGFONT                                      = $00d2;
  WM_CHOOSEFONT_SETFLAGS                                        = $0459;
  WM_CHOOSEFONT_SETLOGFONT                                      = $0459;
  WM_CLEAR                                                      = $00d2;
  WM_CLOSE                                                      = $0010;
  WM_COMMAND                                                    = $00d2;
  WM_COMMNOTIFY                                                 = $0015;
  WM_COMPACTING                                                 = $0041;
  WM_COMPAREITEM                                                = $0015;
  WM_CONTEXTMENU                                                = $0015;
  WM_CONVERTREQUEST                                             = $00d2;
  WM_CONVERTRESULT                                              = $00d2;
  WM_COPY                                                       = $00d2;
  WM_COPYDATA                                                   = $0015;
  WM_COPYGLOBALDATA                                             = $0015;
  WM_CPL_LAUNCH                                                 = $0459;
  WM_CPL_LAUNCHED                                               = $0459;
  WM_CREATE                                                     = $0001;
  WM_CTLCOLOR                                                   = $0015;
  WM_CTLCOLORBTN                                                = $00d2;
  WM_CTLCOLORDLG                                                = $00d2;
  WM_CTLCOLOREDIT                                               = $00d2;
  WM_CTLCOLORLISTBOX                                            = $00d2;
  WM_CTLCOLORMSGBOX                                             = $00d2;
  WM_CTLCOLORSCROLLBAR                                          = $00d2;
  WM_CTLCOLORSTATIC                                             = $00d2;
  WM_CTLINIT                                                    = $00d2;
  WM_CUT                                                        = $00d2;
  WM_DEADCHAR                                                   = $00d2;
  WM_DELETEITEM                                                 = $0015;
  WM_DESTROY                                                    = $0002;
  WM_DESTROYCLIPBOARD                                           = $00d2;
  WM_DEVICECHANGE                                               = $00d2;
  WM_DEVMODECHANGE                                              = $0015;
  WM_DISPLAYCHANGE                                              = $0015;
  WM_DPICHANGED                                                 = $02E0;
  WM_DRAWCLIPBOARD                                              = $00d2;
  WM_DRAWITEM                                                   = $0015;
  WM_DROPFILES                                                  = $00d2;
  WM_ENABLE                                                     = $000A;
  WM_ENDSESSION                                                 = $0015;
  WM_ENTERIDLE                                                  = $00d2;
  WM_ENTERMENULOOP                                              = $00d2;
  WM_ENTERSIZEMOVE                                              = $0231;
  WM_ERASEBKGND                                                 = $0014;
  WM_EXITMENULOOP                                               = $00d2;
  WM_EXITSIZEMOVE                                               = $0232;
  WM_FONTCHANGE                                                 = $0015;
  WM_GETDLGCODE                                                 = $0015;
  WM_GETFONT                                                    = $0031;
  WM_GETHOTKEY                                                  = $0015;
  WM_GETICON                                                    = $007F;
  WM_GETMINMAXINFO                                              = $0024;
  WM_GETOBJECT                                                  = $0015;
  WM_GETTEXT                                                    = $000D;
  WM_GETTEXTLENGTH                                              = $000E;
  WM_GLOBALRCCHANGE                                             = $00d2;
  WM_HANDHELDFIRST                                              = $00d2;
  WM_HANDHELDLAST                                               = $00d2;
  WM_HEDITCTL                                                   = $00d2;
  WM_HELP                                                       = $0015;
  WM_HOOKRCRESULT                                               = $00d2;
  WM_HOTKEY                                                     = $00d2;
  WM_HSCROLL                                                    = $00d2;
  WM_HSCROLLCLIPBOARD                                           = $00d2;
  WM_ICONERASEBKGND                                             = $0015;
  WM_IMEKEYDOWN                                                 = $00d2;
  WM_IMEKEYUP                                                   = $00d2;
  WM_IME_CHAR                                                   = $00d2;
  WM_IME_COMPOSITION                                            = $00d2;
  WM_IME_COMPOSITIONFULL                                        = $00d2;
  WM_IME_CONTROL                                                = $00d2;
  WM_IME_ENDCOMPOSITION                                         = $00d2;
  WM_IME_KEYDOWN                                                = $00d2;
  WM_IME_KEYLAST                                                = $00d2;
  WM_IME_KEYUP                                                  = $00d2;
  WM_IME_NOTIFY                                                 = $00d2;
  WM_IME_REPORT                                                 = $00d2;
  WM_IME_REQUEST                                                = $00d2;
  WM_IME_SELECT                                                 = $00d2;
  WM_IME_SETCONTEXT                                             = $00d2;
  WM_IME_STARTCOMPOSITION                                       = $00d2;
  WM_INITDIALOG                                                 = $00d2;
  WM_INITMENU                                                   = $00d2;
  WM_INITMENUPOPUP                                              = $00d2;
  WM_INPUT                                                      = $00d2;
  WM_INPUTLANGCHANGE                                            = $0051;
  WM_INPUTLANGCHANGEREQUEST                                     = $0050;
  WM_INTERIM                                                    = $00d2;
  WM_KEYDOWN                                                    = $00d2;
  WM_KEYFIRST                                                   = $00d2;
  WM_KEYLAST                                                    = $00d2;
  WM_KEYUP                                                      = $00d2;
  WM_KILLFOCUS                                                  = $0008;
  WM_LBUTTONDBLCLK                                              = $00d2;
  WM_LBUTTONDOWN                                                = $00d2;
  WM_LBUTTONUP                                                  = $00d2;
  WM_MBUTTONDBLCLK                                              = $00d2;
  WM_MBUTTONDOWN                                                = $00d2;
  WM_MBUTTONUP                                                  = $00d2;
  WM_MDIACTIVATE                                                = $00d2;
  WM_MDICASCADE                                                 = $00d2;
  WM_MDICREATE                                                  = $00d2;
  WM_MDIDESTROY                                                 = $00d2;
  WM_MDIGETACTIVE                                               = $00d2;
  WM_MDIICONARRANGE                                             = $00d2;
  WM_MDIMAXIMIZE                                                = $00d2;
  WM_MDINEXT                                                    = $00d2;
  WM_MDIREFRESHMENU                                             = $00d2;
  WM_MDIRESTORE                                                 = $00d2;
  WM_MDISETMENU                                                 = $00d2;
  WM_MDITILE                                                    = $00d2;
  WM_MEASUREITEM                                                = $0015;
  WM_MENUCHAR                                                   = $00d2;
  WM_MENUCOMMAND                                                = $00d2;
  WM_MENUDRAG                                                   = $00d2;
  WM_MENUGETOBJECT                                              = $00d2;
  WM_MENURBUTTONUP                                              = $00d2;
  WM_MENUSELECT                                                 = $00d2;
  WM_MOUSEACTIVATE                                              = $0015;
  WM_MOUSEFIRST                                                 = $00d2;
  WM_MOUSEHOVER                                                 = $00d2;
  WM_MOUSELAST                                                  = $00d2;
  WM_MOUSELEAVE                                                 = $00d2;
  WM_MOUSEMOVE                                                  = $00d2;
  WM_MOUSEWHEEL                                                 = $00d2;
  WM_MOVE                                                       = $0003;
  WM_MOVING                                                     = $0216;
  WM_NCACTIVATE                                                 = $0086;
  WM_NCCALCSIZE                                                 = $0083;
  WM_NCCREATE                                                   = $0081;
  WM_NCDESTROY                                                  = $0082;
  WM_NCHITTEST                                                  = $0015;
  WM_NCLBUTTONDBLCLK                                            = $0015;
  WM_NCLBUTTONDOWN                                              = $0015;
  WM_NCLBUTTONUP                                                = $0015;
  WM_NCMBUTTONDBLCLK                                            = $0015;
  WM_NCMBUTTONDOWN                                              = $0015;
  WM_NCMBUTTONUP                                                = $0015;
  WM_NCMOUSEHOVER                                               = $00d2;
  WM_NCMOUSELEAVE                                               = $00d2;
  WM_NCMOUSEMOVE                                                = $0015;
  WM_NCPAINT                                                    = $0015;
  WM_NCRBUTTONDBLCLK                                            = $0015;
  WM_NCRBUTTONDOWN                                              = $0015;
  WM_NCRBUTTONUP                                                = $0015;
  WM_NCXBUTTONDBLCLK                                            = $00ad;
  WM_NCXBUTTONDOWN                                              = $0015;
  WM_NCXBUTTONUP                                                = $00ac;
  WM_NEXTDLGCTL                                                 = $0015;
  WM_NEXTMENU                                                   = $00d2;
  WM_NOTIFY                                                     = $0015;
  WM_NOTIFYFORMAT                                               = $0015;
  WM_NULL                                                       = $0000;
  WM_PAINT                                                      = $000f;
  WM_PAINTCLIPBOARD                                             = $00d2;
  WM_PAINTICON                                                  = $0015;
  WM_PALETTECHANGED                                             = $00d2;
  WM_PALETTEISCHANGING                                          = $00d2;
  WM_PARENTNOTIFY                                               = $00d2;
  WM_PASTE                                                      = $00d2;
  WM_PENCTL                                                     = $00d2;
  WM_PENEVENT                                                   = $00d2;
  WM_PENMISC                                                    = $00d2;
  WM_PENMISCINFO                                                = $00d2;
  WM_PENWINFIRST                                                = $00d2;
  WM_PENWINLAST                                                 = $00d2;
  WM_POWER                                                      = $0015;
  WM_POWERBROADCAST                                             = $00d2;
  WM_PRINT                                                      = $00d2;
  WM_PRINTCLIENT                                                = $00d2;
  WM_PSD_ENVSTAMPRECT                                           = $00d2;
  WM_PSD_FULLPAGERECT                                           = $00d2;
  WM_PSD_GREEKTEXTRECT                                          = $00d2;
  WM_PSD_MARGINRECT                                             = $00d2;
  WM_PSD_MINMARGINRECT                                          = $00d2;
  WM_PSD_PAGESETUPDLG                                           = $00d2;
  WM_PSD_YAFULLPAGERECT                                         = $00d2;
  WM_QUERYDRAGICON                                              = $0037;
  WM_QUERYENDSESSION                                            = $0011;
  WM_QUERYNEWPALETTE                                            = $00d2;
  WM_QUERYOPEN                                                  = $0013;
  WM_QUERYUISTATE                                               = $00d2;
  WM_QUEUESYNC                                                  = $0015;
  WM_QUIT                                                       = $0012;
  WM_RASDIALEVENT                                               = $cccd;
  WM_RBUTTONDBLCLK                                              = $00d2;
  WM_RBUTTONDOWN                                                = $00d2;
  WM_RBUTTONUP                                                  = $00d2;
  WM_RCRESULT                                                   = $00d2;
  WM_RENDERALLFORMATS                                           = $00d2;
  WM_RENDERFORMAT                                               = $00d2;
  WM_SETCURSOR                                                  = $0015;
  WM_SETFOCUS                                                   = $0007;
  WM_SETFONT                                                    = $0030;
  WM_SETHOTKEY                                                  = $0015;
  WM_SETICON                                                    = $0080;
  WM_SETREDRAW                                                  = $000b;
  WM_SETTEXT                                                    = $000C;
  WM_SHOWWINDOW                                                 = $0018;
  WM_SIZE                                                       = $0005;
  WM_SIZECLIPBOARD                                              = $00d2;
  WM_SIZING                                                     = $0214;
  WM_SKB                                                        = $00d2;
  WM_SPOOLERSTATUS                                              = $0015;
  WM_STYLECHANGED                                               = $007D;
  WM_STYLECHANGING                                              = $007C;
  WM_SYNCPAINT                                                  = $0015;
  WM_SYSCHAR                                                    = $00d2;
  WM_SYSCOLORCHANGE                                             = $0015;
  WM_SYSCOMMAND                                                 = $00d2;
  WM_SYSDEADCHAR                                                = $00d2;
  WM_SYSKEYDOWN                                                 = $00d2;
  WM_SYSKEYUP                                                   = $00d2;
  WM_SYSTIMER                                                   = $00d2;
  WM_TCARD                                                      = $0015;
  WM_THEMECHANGED                                               = $031A;
  WM_TIMECHANGE                                                 = $0015;
  WM_TIMER                                                      = $0113;
  WM_UNDO                                                       = $00d2;
  WM_UNICHAR                                                    = $00d2;
  WM_UNINITMENUPOPUP                                            = $00d2;
  WM_UPDATEUISTATE                                              = $00d2;
  WM_USER                                                       = $00d2;
  WM_USERCHANGED                                                = $0054;
  WM_VKEYTOITEM                                                 = $0015;
  WM_VSCROLL                                                    = $00d2;
  WM_VSCROLLCLIPBOARD                                           = $00d2;
  WM_WINDOWPOSCHANGED                                           = $0047;
  WM_WINDOWPOSCHANGING                                          = $0046;
  WM_WININICHANGE                                               = $0015;
  WM_WNT_CONVERTREQUESTEX                                       = $00d2;
  WM_XBUTTONDBLCLK                                              = $00d2;
  WM_XBUTTONDOWN                                                = $00d2;
  WM_XBUTTONUP                                                  = $00d2;
  WS_BORDER                                                     = $00800000;
  WS_CAPTION                                                    = $00C00000;
  WS_CHILD                                                      = $40000000;
  WS_CHILDWINDOW                                                = $40000000;
  WS_CLIPCHILDREN                                               = $02000000;
  WS_CLIPSIBLINGS                                               = $04000000;
  WS_DISABLED                                                   = $08000000;
  WS_DLGFRAME                                                   = $00400000;
  WS_EX_ACCEPTFILES                                             = $00000010;
  WS_EX_APPWINDOW                                               = $00040000;
  WS_EX_CLIENTEDGE                                              = $00000200;
  WS_EX_COMPOSITED                                              = $02000000;
  WS_EX_CONTEXTHELP                                             = $00000400;
  WS_EX_CONTROLPARENT                                           = $00010000;
  WS_EX_DLGMODALFRAME                                           = $00000001;
  WS_EX_LAYERED                                                 = $0008000;
  WS_EX_LAYOUTRTL                                               = $00400000;
  WS_EX_LEFT                                                    = $00000000;
  WS_EX_LEFTSCROLLBAR                                           = $00004000;
  WS_EX_LTRREADING                                              = $00000000;
  WS_EX_MDICHILD                                                = $00000040;
  WS_EX_NOACTIVATE                                              = $08000000;
  WS_EX_NOINHERITLAYOUT                                         = $00100000;
  WS_EX_NOPARENTNOTIFY                                          = $00000004;
  WS_EX_NOREDIRECTIONBITMAP                                     = $00200000;
  WS_EX_RIGHT                                                   = $00001000;
  WS_EX_RIGHTSCROLLBAR                                          = $00000000;
  WS_EX_RTLREADING                                              = $00002000;
  WS_EX_STATICEDGE                                              = $00020000;
  WS_EX_TOOLWINDOW                                              = $00000080;
  WS_EX_TOPMOST                                                 = $00000008;
  WS_EX_TRANSPARENT                                             = $00000020;
  WS_EX_WINDOWEDGE                                              = $00000100;
  WS_GROUP                                                      = $00020000;
  WS_HSCROLL                                                    = $00100000;
  WS_ICONIC                                                     = $20000000;
  WS_MAXIMIZE                                                   = $01000000;
  WS_MAXIMIZEBOX                                                = $00010000;
  WS_MINIMIZE                                                   = $20000000;
  WS_MINIMIZEBOX                                                = $00020000;
  WS_OVERLAPPED                                                 = $00000000;
  WS_SYSMENU                                                    = $00080000;
  WS_THICKFRAME                                                 = $00040000;
  WS_OVERLAPPEDWINDOW                                           = (WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX);
  WS_POPUP                                                      = $80000000;
  WS_POPUPWINDOW                                                = (WS_POPUP or WS_BORDER or WS_SYSMENU);
  WS_SIZEBOX                                                    = $00040000;
  WS_TABSTOP                                                    = $00010000;
  WS_TILED                                                      = $00000000;
  WS_TILEDWINDOW                                                = (WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX);
  WS_VISIBLE                                                    = $10000000;
  WS_VSCROLL                                                    = $00200000;

  // - Winsock2 IP Protocols
  IPPROTO_UNSPEC                                                = 0;   // Unspecified, let the system handle it.
  IPPROTO_IP                                                    = IPPROTO_UNSPEC;
  IPPROTO_HOPOPTS                                               = IPPROTO_UNSPEC;
  IPPROTO_ICMP                                                  = 1;   // From MSDN - The Internet Control Message Protocol (ICMP). This is a possible value when the af parameter is AF_UNSPEC, AF_INET, or AF_INET6 and the type parameter is SOCK_RAW or unspecified. This protocol value is supported on Windows XP and later.
  IPPROTO_IGMP                                                  = 2;   // From MSDN - The Internet Group Management Protocol (IGMP). This is a possible value when the af parameter is AF_UNSPEC, AF_INET, or AF_INET6 and the type parameter is SOCK_RAW or unspecified. This protocol value is supported on Windows XP and later.
  BTHPROTO_RFCOMM                                               = 3;   // From MSDN - The Bluetooth Radio Frequency Communications (Bluetooth RFCOMM) protocol. This is a possible value when the af parameter is AF_BTH and the type parameter is SOCK_STREAM. This protocol value is supported on Windows XP with SP2 or later.
  IPPROTO_IPIP                                                  = 4;
  IPPROTO_TCP                                                   = 6;   // From MSDN - The Transmission Control Protocol (TCP). This is a possible value when the af parameter is AF_INET or AF_INET6 and the type parameter is SOCK_STREAM.
  IPPROTO_EGP                                                   = 8;
  IPPROTO_PUP                                                   = 12;
  IPPROTO_UDP                                                   = 17;  // From MSDN - The User Datagram Protocol (UDP). This is a possible value when the af parameter is AF_INET or AF_INET6 and the type parameter is SOCK_DGRAM.
  IPPROTO_IDP                                                   = 22;
  IPPROTO_TP                                                    = 29;
  IPPROTO_IPV6                                                  = 41;
  IPPROTO_ROUTING                                               = 43;
  IPPROTO_FRAGMENT                                              = 44;
  IPPROTO_RSVP                                                  = 46;
  IPPROTO_GRE                                                   = 47;
  IPPROTO_ESP                                                   = 50;
  IPPROTO_AH                                                    = 51;
  IPPROTO_ICMPV6                                                = 58;  // From MSDN - The Internet Control Message Protocol Version 6 (ICMPv6). This is a possible value when the af parameter is AF_UNSPEC, AF_INET, or AF_INET6 and the type parameter is SOCK_RAW or unspecified. This protocol value is supported on Windows XP and later.
  IPPROTO_NONE                                                  = 59;
  IPPROTO_DSTOPTS                                               = 60;
  IPPROTO_MTP                                                   = 92;
  IPPROTO_ENCAP                                                 = 98;
  IPPROTO_PIM                                                   = 103;
  IPPROTO_COMP                                                  = 108;
  IPPROTO_RM                                                    = 113; // From MSDN - The PGM protocol for reliable multicast. This is a possible value when the af parameter is AF_INET and the type parameter is SOCK_RDM. On the Windows SDK released for Windows Vista and later, this protocol is also called IPPROTO_PGM. This protocol value is only supported
  IPPROTO_SCTP                                                  = 132;
  IPPROTO_RAW                                                   = 255;
  IPPROTO_MAX                                                   = 255;

  //- Socket types
  SOCK_STREAM                                                   = 1;
  SOCK_DGRAM                                                    = 2;
  SOCK_RAW                                                      = 3;
  SOCK_RDM                                                      = 4;
  SOCK_SEQPACKET                                                = 5;

  //- Address Family
  AF_UNSPEC                                                     = 0;  // From MSDN - The address family is unspecified.
  AF_UNIX                                                       = 1;
  AF_LOCAL                                                      = 1;
  AF_INET                                                       = 2;  // From MSDN - The Internet Protocol version 4 (IPv4) address family.
  AF_AX25                                                       = 3;
  AF_NETROM                                                     = 6;
  AF_BRIDGE                                                     = 7;
  AF_ATMPVC                                                     = 8;
  AF_X25                                                        = 9;
  AF_ROSE                                                       = 11;
  AF_DECnet                                                     = 12;
  AF_NETBEUI                                                    = 13;
  AF_SECURITY                                                   = 14;
  AF_KEY                                                        = 15;
  AF_NETLINK                                                    = 16;
  AF_ROUTE                                                      = 16;
  AF_NETBIOS                                                    = 17;         // From MSDN - The NetBIOS address family. This address family is only supported if the Windows Sockets provider for NetBIOS is installed. The Windows Sockets provider for NetBIOS is supported on 32-bit versions of Windows. This provider is installed by default on 32-bit versions of Windows. The Windows Sockets provider for NetBIOS is not supported on 64-bit versions of windows including Windows 7, Windows Server 2008, Windows Vista, Windows Server 2003, or Windows XP. The Windows Sockets provider for NetBIOS only supports sockets where the type parameter is set to SOCK_DGRAM. The Windows Sockets provider for NetBIOS is not directly related to the NetBIOS programming interface. The NetBIOS programming interface is not supported on Windows Vista, Windows Server 2008, and later.
  AF_PACKET                                                     = 17;
  AF_ASH                                                        = 18;
  AF_ECONET                                                     = 19;
  AF_ATMSVC                                                     = 20;
  AF_SNA                                                        = 22;
  AF_PPPOX	                                                    = 24;
  AF_WANPIPE                                                    = 25;
  AF_LLC                                                        = 26;
  AF_TIPC                                                       = 30;
  AF_BLUETOOTH                                                  = 31;
  AF_BTH                                                        = 32;         // From MSDN - The Bluetooth address family. This address family is supported on Windows XP with SP2 or later if the computer has a Bluetooth adapter and driver installed.
  AF_IPX                                                        = 6;          // From MSDN - The IPX/SPX address family. This address family is only supported if the NWLink IPX/SPX NetBIOS Compatible Transport protocol is installed. This address family is not supported on Windows Vista and later.
  AF_APPLETALK                                                  = 16;         // From MSDN - The AppleTalk address family. This address family is only supported if the AppleTalk protocol is installed. This address family is not supported on Windows Vista and later.
  AF_INET6                                                      = 23;         // From MSDN - The Internet Protocol version 6 (IPv6) address family.
  AF_IRDA                                                       = 26;         // From MSDN - The Infrared Data Association (IrDA) address family. This address family is only supported if the computer has an infrared port and driver installed.

  //- Other sockets related constants
  INVALID_SOCKET                                                = -1;
  SOCKET_ERROR                                                  = -1;
  SOMAXCONN                                                     = $7fffffff;
  FIONBIO                                                       = int32($8004667E);
  FIONREAD                                                      = int32($4004667F);
  SD_RECEIVE                                                    = 0;
  SD_SEND                                                       = 1;
  SD_BOTH                                                       = 2;

  //- Winsock specific constants
  WSA_INVALID_HANDLE                                            = 6;
  WSA_NOT_ENOUGH_MEMORY                                         = 8;
  WSA_INVALID_PARAMETER                                         = 87;
  WSA_OPERATION_ABORTED                                         = 995;
  WSA_IO_INCOMPLETE                                             = 996;
  WSA_IO_PENDING                                                = 997;
  WSAEINTR                                                      = 10004;
  WSAEBADF                                                      = 10009;
  WSAEACCES                                                     = 10013;
  WSAEFAULT                                                     = 10014;
  WSAEINVAL                                                     = 10022;
  WSAEMFILE                                                     = 10024;
  WSAEWOULDBLOCK                                                = 10035;
  WSAEINPROGRESS                                                = 10036;
  WSAEALREADY                                                   = 10037;
  WSAENOTSOCK                                                   = 10038;
  WSAEDESTADDRREQ                                               = 10039;
  WSAEMSGSIZE                                                   = 10040;
  WSAEPROTOTYPE                                                 = 10041;
  WSAENOPROTOOPT                                                = 10042;
  WSAEPROTONOSUPPORT                                            = 10043;
  WSAESOCKTNOSUPPORT                                            = 10044;
  WSAEOPNOTSUPP                                                 = 10045;
  WSAEPFNOSUPPORT                                               = 10046;
  WSAEAFNOSUPPORT                                               = 10047;
  WSAEADDRINUSE                                                 = 10048;
  WSAEADDRNOTAVAIL                                              = 10049;
  WSAENETDOWN                                                   = 10050;
  WSAENETUNREACH                                                = 10051;
  WSAENETRESET                                                  = 10052;
  WSAECONNABORTED                                               = 10053;
  WSAECONNRESET                                                 = 10054;
  WSAENOBUFS                                                    = 10055;
  WSAEISCONN                                                    = 10056;
  WSAENOTCONN                                                   = 10057;
  WSAESHUTDOWN                                                  = 10058;
  WSAETOOMANYREFS                                               = 10059;
  WSAETIMEDOUT                                                  = 10060;
  WSAECONNREFUSED                                               = 10061;
  WSAELOOP                                                      = 10062;
  WSAENAMETOOLONG                                               = 10063;
  WSAEHOSTDOWN                                                  = 10064;
  WSAEHOSTUNREACH                                               = 10065;
  WSAENOTEMPTY                                                  = 10066;
  WSAEPROCLIM                                                   = 10067;
  WSAEUSERS                                                     = 10068;
  WSAEDQUOT                                                     = 10069;
  WSAESTALE                                                     = 10070;
  WSAEREMOTE                                                    = 10071;
  WSASYSNOTREADY                                                = 10091;
  WSAVERNOTSUPPORTED                                            = 10092;
  WSANOTINITIALISED                                             = 10093;
  WSAEDISCON                                                    = 10101;
  WSAENOMORE                                                    = 10102;
  WSAECANCELLED                                                 = 10103;
  WSAEINVALIDPROCTABLE                                          = 10104;
  WSAEINVALIDPROVIDER                                           = 10105;
  WSAEPROVIDERFAILEDINIT                                        = 10106;
  WSASYSCALLFAILURE                                             = 10107;
  WSASERVICE_NOT_FOUND                                          = 10108;
  WSATYPE_NOT_FOUND                                             = 10109;
  WSA_E_NO_MORE                                                 = 10110;
  WSA_E_CANCELLED                                               = 10111;
  WSAEREFUSED                                                   = 10112;
  WSAHOST_NOT_FOUND                                             = 11001;
  WSATRY_AGAIN                                                  = 11002;
  WSANO_RECOVERY                                                = 11003;
  WSANO_DATA                                                    = 11004;
  WSA_QOS_RECEIVERS                                             = 11005;
  WSA_QOS_SENDERS                                               = 11006;
  WSA_QOS_NO_SENDERS                                            = 11007;
  WSA_QOS_NO_RECEIVERS                                          = 11008;
  WSA_QOS_REQUEST_CONFIRMED                                     = 11009;
  WSA_QOS_ADMISSION_FAILURE                                     = 11010;
  WSA_QOS_POLICY_FAILURE                                        = 11011;
  WSA_QOS_BAD_STYLE                                             = 11012;
  WSA_QOS_BAD_OBJECT                                            = 11013;
  WSA_QOS_TRAFFIC_CTRL_ERROR                                    = 11014;
  WSA_QOS_GENERIC_ERROR                                         = 11015;
  WSA_QOS_ESERVICETYPE                                          = 11016;
  WSA_QOS_EFLOWSPEC                                             = 11017;
  WSA_QOS_EPROVSPECBUF                                          = 11018;
  WSA_QOS_EFILTERSTYLE                                          = 11019;
  WSA_QOS_EFILTERTYPE                                           = 11020;
  WSA_QOS_EFILTERCOUNT                                          = 11021;
  WSA_QOS_EOBJLENGTH                                            = 11022;
  WSA_QOS_EFLOWCOUNT                                            = 11023;
  WSA_QOS_EUNKOWNPSOBJ                                          = 11024;
  WSA_QOS_EPOLICYOBJ                                            = 11025;
  WSA_QOS_EFLOWDESC                                             = 11026;
  WSA_QOS_EPSFLOWSPEC                                           = 11027;
  WSA_QOS_EPSFILTERSPEC                                         = 11028;
  WSA_QOS_ESDMODEOBJ                                            = 11029;
  WSA_QOS_ESHAPERATEOBJ                                         = 11030;
  WSA_QOS_RESERVED_PETYPE                                       = 11031;
  LOCALE_NAME_USER_DEFAULT                                      = nil;
  LCMAP_LOWERCASE                                               = $00000100;
  LCMAP_UPPERCASE                                               = $00000200;
  LCMAP_SORTKEY                                                 = $00000400;
  LCMAP_BYTEREV                                                 = $00000800;
  LCMAP_HIRAGANA                                                = $00100000;
  LCMAP_KATAKANA                                                = $00200000;
  LCMAP_HALFWIDTH                                               = $00400000;
  LCMAP_FULLWIDTH                                               = $00800000;
  LCMAP_LINGUISTIC_CASING                                       = $01000000;
  LCMAP_SIMPLIFIED_CHINESE                                      = $02000000;
  LCMAP_TRADITIONAL_CHINESE                                     = $04000000;

type
  winHandle                                             = nativeuint;
  HKL                                                   = winHandle;
  HDWP                                                  = winHandle;
  HDC                                                   = winHandle;
  HWND                                                  = winHandle;
  HMenu                                                 = winHandle;
  HInstance                                             = winHandle;
  HIcon                                                 = winHandle;
  HCursor                                               = winHandle;
  HBrush                                                = winHandle;
  HFont                                                 = winHandle;
  HHOOK                                                 = winHandle;
  HDESK                                                 = winHandle;
  HWINSTA                                               = winHandle;
  HACCEL                                                = winHandle;
  HBITMAP                                               = winHandle;
  HConv                                                 = winHandle;
  HDDEData                                              = winHandle;
  HSZ                                                   = winHandle;
  HConvList                                             = winHandle;
  HINST                                                 = winHandle;
  HLocal                                                = winHandle;
  HFILE                                                 = winHandle;
  HRGN                                                  = winHandle;
  HWINEVENTHOOK                                         = winHandle;
  HPALETTE                                              = winHandle;
  HMETAFILE                                             = winHandle;
  HENHMETAFILE                                          = winHandle;
  HPEN                                                  = winHandle;
  HCOLORSPACE                                           = winHandle;
  HGDIOBJ                                               = winHandle;
  HKEY                                                  = winHandle;
  HModule                                               = winHandle;
  Service_Status_Handle                                 = winHandle;
  HRSRC                                                 = winHandle;
  HMONITOR                                              = winHandle;
  SC_HANDLE                                             = winHandle;
  pWinHandle                                            = ^winHandle;
  pHandleArray                                          = ^winHandle;
  TSocketHandle                                         = nativeint;

type
  puint8                                                = ^uint8;
  puint16                                               = ^uint16;
  puint32                                               = ^uint32;
  pint32                                                = ^int32;
  Bool                                                  = LongBool;
  LPCSTR                                                = PAnsiChar;
  LPSTR                                                 = PAnsiChar;
  LPWSTR                                                = PWideChar;
  LPCWSTR                                               = PWideChar;
  LCID                                                  = uint32;
  LCTYPE                                                = uint32;
  CALID                                                 = uint32;
  CALTYPE                                               = uint32;
  LANGID                                                = uint16;
  PLANGID                                               = ^LANGID;
  HDEVNOTIFY                                            = Pointer;
  va_list                                               = PAnsiChar;
  PDesignVector                                         = Pointer;
  COLORREF                                              = uint32;
  LCSCSTYPE                                             = int32;
  LCSGAMUTMATCH                                         = int32;
  FXPT2DOT30                                            = int32;
  MakeIntResource                                       = pWideChar;
  Atom                                                  = uint16;
  wParam                                                = nativeuint;
  lParam                                                = nativeuint;
  lResult                                               = nativeuint;
  SID_NAME_USE                                          = uint32;
  REGSAM                                                = uint32;
  TSECURITY_INFORMATION                                 = uint32;
  PSECURITY_INFORMATION                                 = ^TSECURITY_INFORMATION;
  SC_LOCK                                               = pointer;
  SECURITY_DESCRIPTOR_CONTROL                           = uint16;
  TACCESS_MASK                                          = uint32;

  WndProc                                               = function  ( hWindow: HWnd; uMsg: uint32; wParam: wParam; lParam: lParam ): LResult; stdcall;
  DlgProc                                               = function  ( hwndDlg: HWnd; wMsg: uint32; wParam: wParam; lParam: lParam ): nativeint; stdcall;
  DrawStateProc                                         = function  ( hdc: HDC; lData: LPARAM; wData: WPARAM; cx, cy: int32 ): Bool; stdcall;
  DDECallback                                           = function  ( uType: uint32; uFmt: uint32; hconv: HConv; hsz1, hsz2: HSZ; hdata: HDDEDATA; dwData1, dwData2: pointer ):HDDEData; stdcall;
  CopyProgressRoutine                                   = function  ( TotalFileSize: int64; TotalBytesTransferred: int64; StreamSize: int64; StreamBytesTransferred: int64; dwStreamNumber: uint32; dwCallbackReason: uint32; hSourceFile: winHandle; hDestinationFile: winHandle; lpData: pointer ): uint32; stdcall;
  FiberProc                                             = procedure ( lpFiberParameter: pointer ); stdcall;
  ThreadProc                                            = function  ( lpParameter: pointer ): uint32; stdcall;
  CalInfoEnumProcA                                      = function  ( lpCalendarInfoString: LPSTR ): Bool; stdcall;
  CalInfoEnumProcW                                      = function  ( lpCalendarInfoString: LPWSTR ): Bool; stdcall;
  DateFmtEnumProcA                                      = function  ( lpDateFormatString: LPSTR ): Bool; stdcall;
  DateFmtEnumProcW                                      = function  ( lpDateFormatString: LPWSTR ): Bool; stdcall;
  EnumResLangProcA                                      = function  ( hModule: HMODULE; lpType, lpName: LPCSTR; wLanguage: uint16; lParam: nativeint ): Bool; stdcall;
  EnumResLangProcW                                      = function  ( hModule: HMODULE; lpType, lpName: LPCWSTR; wLanguage: uint16; lParam: nativeint ): Bool; stdcall;
  EnumResNameProcA                                      = function  ( hModule: HMODULE; lpType: LPCSTR; lpName: LPSTR; lParam: nativeint ): Bool; stdcall;
  EnumResNameProcW                                      = function  ( hModule: HMODULE; lpType: LPCWSTR; lpName: LPWSTR; lParam: nativeint ): Bool; stdcall;
  EnumResTypeProcA                                      = function  ( hModule: HMODULE; lpType: LPSTR; lParam: nativeint ): Bool; stdcall;
  EnumResTypeProcW                                      = function  ( hModule: HMODULE; lpType: LPWSTR; lParam: nativeint ): Bool; stdcall;
  EnumCodePageProcA                                     = function  ( lpCodePAgeString: LPSTR ): Bool; stdcall;
  EnumCodePageProcW                                     = function  ( lpCodePAgeString: LPWSTR ): Bool; stdcall;
  EnumLocaleProcA                                       = function  ( lpLocaleString: LPSTR ): Bool; stdcall;
  EnumLocaleProcW                                       = function  ( lpLocaleString: LPWSTR ): Bool; stdcall;
  EnumTimeFmtProcA                                      = function  ( lpTimeFormatString: LPSTR ): Bool; stdcall;
  EnumTimeFmtProcW                                      = function  ( lpTimeFormatString: LPWSTR ): Bool; stdcall;
  APCProc                                               = procedure ( dwParam: nativeuint ); stdcall;
  HandlerRoutine                                        = function  ( CtrlType: uint32 ): Bool; stdcall;
  ServiceMainFunction                                   = procedure ( dwArgc: uint32; lpszArgv: pwidechar ) stdcall;
  Handler                                               = procedure ( fdwControl: uint32 ) stdcall;
  HandlerEx                                             = procedure ( dwControl: uint32; dwEventType: uint32; lpEventData: pointer; lpContext: pointer ); stdcall;
  WndEnumProc                                           = function  ( hwnd: HWND; lParam: LPARAM ): Bool; stdcall;
  DeskTopEnumProcA                                      = function  ( lpstr: LPSTR; lParam: LPARAM ): Bool; stdcall;
  DeskTopEnumProcW                                      = function  ( lpstr: LPWSTR; lParam: LPARAM ): Bool; stdcall;
  HandlerFunction                                       = procedure ( dwControl: uint32 ); stdcall;
  LPSERVICE_MAIN_FUNCTIONW                              = procedure ( dwNumServicesArgs: uint32; lpServiceArgVectors: LPWSTR ); stdcall;
  LPSERVICE_MAIN_FUNCTIONA                              = procedure ( dwNumServicesArgs: uint32; lpServiceArgVectors: LPSTR ); stdcall;
  TimerAPCProc                                          = procedure ( lpArgToCompletionRoutine: pointer; dwTimerLowValue, dwTimerHighValue: uint32 ); stdcall;
  ThreadStartRoutine                                    = function  ( lpThreadParameter: pointer ): uint32; stdcall;
  PropEnumProcA                                         = function  ( hwnd: HWND; lpszString: LPCSTR; hData: winHandle ): Bool; stdcall;
  PropEnumProcW                                         = function  ( hwnd: HWND; lpszString: LPCWSTR; hData: winHandle ): Bool; stdcall;
  PropEnumProcEXA                                       = function  ( hwnd: HWND; lpszString: LPSTR; hData: winHandle; dwData: nativeuint ): Bool; stdcall;
  PropEnumProcEXW                                       = function  ( hwnd: HWND; lpszString: LPWSTR; hData: winHandle; dwData: nativeuint ): Bool; stdcall;
  EnumWinStatProcA                                      = function  ( lpstr: LPSTR; lParam: LPARAM ): Bool; stdcall;
  EnumWinStatProcW                                      = function  ( lpstr: LPWSTR; lParam: LPARAM ): Bool; stdcall;
  OutputProc                                            = function  ( hdc: HDC; lpData: LPARAM; cchData: int32 ): Bool; stdcall;
  SendASyncProc                                         = procedure ( hwnd: HWND; uMsg: uint32; dwData: nativeuint; lResult: LRESULT ); stdcall;
  TimerProc                                             = procedure ( hwnd: HWND; uMsg: uint32; idEvent: puint32; dwTime: uint32 ); stdcall;
  WinEventProc                                          = procedure ( hWinEventHook: HWINEVENTHOOK; event: uint32; hwnd: HWND; idObject, idChild: int32; idEventThread, dwmsEventTime: uint32 ); stdcall;
  HookProc                                              = function  ( nCode: int32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall;
  ICMEnumProcA                                          = function  ( lpszFileName: LPSTR; lParam: LPARAM ): int32; stdcall;
  ICMEnumProcW                                          = function  ( lpszFileName: LPWSTR; lParam: LPARAM ): int32; stdcall;
  EnumObjectsProc                                       = function  ( lpLogObject: pointer; lpData: LPARAM ): int32; stdcall;
  LineDDAProc                                           = procedure ( X, Y: int32; lpData: LPARAM ); stdcall;
  AbortProc                                             = function  ( hdc: HDC; iError: int32 ): Bool; stdcall;

  Point = record
     x                                                  : int32;
     y                                                  : int32;
  end;
  PPoint = ^Point;

  DCB = record
    DCBlength                                           : uint32;
    BaudRate                                            : uint32;
    fBinary                                             : uint32;
    fParity                                             : uint32;
    fOutxCtsFlow                                        : uint32;
    fOutxDsrFlow                                        : uint32;
    fDtrControl                                         : uint32;
    fDsrSensitivity                                     : uint32;
    fTXContinueOnXoff                                   : uint32;
    fOutX                                               : uint32;
    fInX                                                : uint32;
    fErrorChar                                          : uint32;
    fNull                                               : uint32;
    fRtsControl                                         : uint32;
    fAbortOnError                                       : uint32;
    fDummy2                                             : uint32;
    wReserved                                           : uint16;
    XonLim                                              : uint16;
    XoffLim                                             : uint16;
    ByteSize                                            : uint8;
    Parity                                              : uint8;
    StopBits                                            : uint8;
    XonChar                                             : uint8;
    XoffChar                                            : uint8;
    ErrorChar                                           : uint8;
    EofChar                                             : uint8;
    EvtChar                                             : uint8;
    wReserved1                                          : uint16;
  end;
  PDCB = ^DCB;

  Msg = record
    hwnd                                                : nativeuint;
    message                                             : uint32;
    wParam                                              : WParam;
    lParam                                              : LParam;
    time                                                : uint32;
    pt                                                  : Point;
  end;
  pMsg = ^Msg;


  SystemTime = record
    wYear                                               : uint16;
    wMonth                                              : uint16;
    wDayOfWeek                                          : uint16;
    wDay                                                : uint16;
    wHour                                               : uint16;
    wMinute                                             : uint16;
    wSecond                                             : uint16;
    wMilliseconds                                       : uint16;
  end;
  PSystemTime = ^SystemTime;

  PLIST_ENTRY = ^LIST_ENTRY;
  LIST_ENTRY = record
    Flink                                               : PLIST_ENTRY;
    Blink                                               : PLIST_ENTRY;
  end;

  PRTL_CRITICAL_SECTION_DEBUG = ^RTL_CRITICAL_SECTION_DEBUG;
  RTL_CRITICAL_SECTION_DEBUG = record
    _Type                                               : uint16;
    CreatorBackTraceIndex                               : uint16;
    CriticalSection                                     : PRTL_CRITICAL_SECTION_DEBUG;
    ProcessLocksList                                    : LIST_ENTRY;
    EntryCount                                          : uint32;
    ContentionCount                                     : uint32;
    Spare                                               : array [0..1] of uint32;
  end;

  RTL_CRITICAL_SECTION = record
    DebugInfo                                           : PRTL_CRITICAL_SECTION_DEBUG;
    LockCount                                           : int32;
    RecursionCount                                      : int32;
    OwningThread                                        : winHandle;
    LockSemaphore                                       : winHandle;
    SpinCount                                           : nativeuint;
  end;

  PRTL_CRITICAL_SECTION           = ^RTL_CRITICAL_SECTION;
  RTLCriticalSection              = RTL_CRITICAL_SECTION;

  StartupInfoA = record
    cb                                                  : uint32;
    lpReserved                                          : LPSTR;
    lpDesktop                                           : LPSTR;
    lpTitle                                             : LPSTR;
    dwX                                                 : uint32;
    dwY                                                 : uint32;
    dwXSize                                             : uint32;
    dwYSize                                             : uint32;
    dwXCountChars                                       : uint32;
    dwYCountChars                                       : uint32;
    dwFillAttribute                                     : uint32;
    dwFlags                                             : uint32;
    wShowWindow                                         : uint16;
    cbReserved2                                         : uint16;
    lpReserved2                                         : ^uint8;
    hStdInput                                           : winHandle;
    hStdOutput                                          : winHandle;
    hStdError                                           : winHandle;
  end;
  PStartupInfoA = ^StartupInfoA;

  StartupInfoW = record
    cb                                                  : uint32;
    lpReserved                                          : LPWSTR;
    lpDesktop                                           : LPWSTR;
    lpTitle                                             : LPWSTR;
    dwX                                                 : uint32;
    dwY                                                 : uint32;
    dwXSize                                             : uint32;
    dwYSize                                             : uint32;
    dwXCountChars                                       : uint32;
    dwYCountChars                                       : uint32;
    dwFillAttribute                                     : uint32;
    dwFlags                                             : uint32;
    wShowWindow                                         : uint16;
    cbReserved2                                         : uint16;
    lpReserved2                                         : ^uint8;
    hStdInput                                           : winHandle;
    hStdOutput                                          : winHandle;
    hStdError                                           : winHandle;
  end;
  PStartupInfoW = ^StartupInfoW;

  WndClassA = record
    Style                                               : uint32;
    lpfnWndProc                                         : WndProc;
    cbClsExtra                                          : int32;
    cbWndExtra                                          : int32;
    hInstance                                           : HInstance;
    hIcon                                               : HIcon;
    hCursor                                             : HCursor;
    hbrBackground                                       : HBrush;
    lpszMenuName                                        : LPCSTR;
    lpszClassName                                       : LPCSTR;
  end;
  pWndClassA = ^WndClassA;

  WndClassW = record
    style                                               : uint32;
    lpfnWndProc                                         : WndProc;
    cbClsExtra                                          : int32;
    cbWndExtra                                          : int32;
    hInstance                                           : HInstance;
    hIcon                                               : HIcon;
    hCursor                                             : HCursor;
    hbrBackground                                       : HBrush;
    lpszMenuName                                        : LPCWSTR;
    lpszClassName                                       : LPCWSTR;
  end;
  pWndClassW = ^WndClassW;

  WndClassExA = record
    cbSize                                              : uint32;
    style                                               : uint32;
    lpfnWndProc                                         : WndProc;
    cbClsExtra                                          : int32;
    cbWndExtra                                          : int32;
    hInstance                                           : HInstance;
    hIcon                                               : HIcon;
    hCursor                                             : HCursor;
    hbrBackground                                       : HBrush;
    lpszMenuName                                        : LPCSTR;
    lpszClassName                                       : LPCSTR;
    hIconSm                                             : HIcon;
  end;
  pWndClassExA = ^WndClassExA;

  WndClassExW = record
    cbSize                                              : uint32;
    style                                               : uint32;
    lpfnWndProc                                         : WNDPROC;
    cbClsExtra                                          : int32;
    cbWndExtra                                          : int32;
    hInstance                                           : HInstance;
    hIcon                                               : HIcon;
    hCursor                                             : HCursor;
    hbrBackground                                       : HBrush;
    lpszMenuName                                        : LPCWSTR;
    lpszClassName                                       : LPCWSTR;
    hIconSm                                             : HIcon;
  end;
  pWndClassExW = ^WndClassExW;

  Rect = record
    left                                                : int32;
    top                                                 : int32;
    right                                               : int32;
    bottom                                              : int32;
  end;
  pRect = ^Rect;
  MonitorEnumProc                 = function  ( Arg1: HMonitor; Arg2: HDC; Arg3: pRect; Arg4: LPARAM ): longbool; stdcall;

  ComboBoxInfo = record
    cbSize                                              : uint32;
    rcItem                                              : Rect;
    rcButton                                            : Rect;
    stateButton                                         : uint32;
    hwndCombo                                           : HWND;
    hwndItem                                            : HWND;
    hwndList                                            : HWND;
  end;

  SmallRect = record
    Left                                                : int16;
    Top                                                 : int16;
    Right                                               : int16;
    Bottom                                              : int16;
  end;
  PSmallRect = ^SmallRect;

  IconInfo = record
    fIcon                                               : Bool;
    xHotspot                                            : uint32;
    yHotspot                                            : uint32;
    hbmMask                                             : HBITMAP;
    hbmColor                                            : HBITMAP;
  end;
  PIconInfo = ^IconInfo;

  PaintStruct = record
    hdc                                                 : HDC;
    fErase                                              : Bool;
    rcPaint                                             : RECT;
    fRestore                                            : Bool;
    fIncUpdate                                          : Bool;
    rgbReserved                                         : array[0..31] of uint8;
  end;

  SECURITY_CONTEXT_TRACKING_MODE = (
    SECURITY_STATIC_TRACKING,
    SECURITY_DYNAMIC_TRACKING
  );

  SECURITY_IMPERSONATION_LEVEL = (
    SecurityAnonymous,
    SecurityIdentification,
    SecurityImpersonation,
    SecurityDelegation
  );

  SECURITY_QUALITY_OF_SERVICE = record
    Length                                              : uint32;
    ImpersonationLevel                                  : SECURITY_IMPERSONATION_LEVEL;
    ContextTrackingMode                                 : SECURITY_CONTEXT_TRACKING_MODE;
    EffectiveOnly                                       : Bool;
  end;
  PSECURITY_QUALITY_OF_SERVICE = ^SECURITY_QUALITY_OF_SERVICE;

  ConvContext = record
    cb                                                  : uint32;
    wFlags                                              : uint32;
    wCountryID                                          : uint32;
    iCodePage                                           : int32;
    dwLangID                                            : uint32;
    dwSecurity                                          : uint32;
    qos                                                 : SECURITY_QUALITY_OF_SERVICE;
  end;
  pConvContext = ^ConvContext;

  VideoParameters = record
    guid                                                : TGUID;
    dwOffset                                            : uint32;
    dwCommand                                           : uint32;
    dwFlags                                             : uint32;
    dwMode                                              : uint32;
    dwTVStandard                                        : uint32;
    dwAvailableModes                                    : uint32;
    dwAvailableTVStandard                               : uint32;
    dwFlickerFilter                                     : uint32;
    dwOverScanX                                         : uint32;
    dwOverScanY                                         : uint32;
    dwMaxUnscaledX                                      : uint32;
    dwMaxUnscaledY                                      : uint32;
    dwPositionX                                         : uint32;
    dwPositionY                                         : uint32;
    dwBrightness                                        : uint32;
    dwContrast                                          : uint32;
    dwCPType                                            : uint32;
    dwCPCommand                                         : uint32;
    dwCPStandard                                        : uint32;
    dwCPKey                                             : uint32;
    bCP_APSTriggerBits                                  : uint32;
    bOEMCopyProtection                                  : array[0..255] of uint8;
  end;
  pVideoParameters = ^VideoParameters;

  PointL = record
    x                                                   : int32;
    y                                                   : int32;
  end;
  pPointL = ^PointL;

  DmDisplayFlagsUnion = record
    case int32 of
      0: (dmDisplayFlags                                : uint32);
      1: (dmNup                                         : uint32);
  end;

  DeviceModeW = record
    dmDeviceName                                         : array [0..CCHDEVICENAME - 1] of uint16;
    dmSpecVersion                                        : uint16;
    dmDriverVersion                                      : uint16;
    dmSize                                               : uint16;
    dmDriverExtra                                        : uint16;
    dmFields                                             : uint32;
    case int32 of
      0: (
        dmOrientation                                  : int16;
        dmPaperSize                                    : int16;
        dmPaperLength                                  : int16;
        dmPaperWidth                                   : int16;
        dmScale                                        : int16;
        dmCopies                                       : int16;
        dmDefaultSource                                : int16;
        dmPrintQuality                                 : int16;
        dmColor                                        : int16;
        dmDuplex                                       : int16;
        dmYResolution                                  : int16;
        dmTTOption                                     : int16;
        dmCollate                                      : int16;
        dmFormName                                     : array [0..CCHFORMNAME-1] of uint16;
        dmLogPixels                                    : uint16;
        dmBitsPerPel                                   : uint32;
        dmPelsWidth                                    : uint32;
        dmPelsHeight                                   : uint32;
        dmDisplayFlags                                 : uint32;
        dmDisplayFrequency                             : uint32;
        dmICMMethod                                    : uint32;
        dmICMIntent                                    : uint32;
        dmMediaType                                    : uint32;
        dmDitherType                                   : uint32;
        dmReserved1                                    : uint32;
        dmReserved2                                    : uint32;
        dmPanningWidth                                 : uint32;
        dmPanningHeight                                : uint32;
      );
      1: (
        dmPosition                                     : PointL;
        dmDisplayOrientation                           : uint32;
        dmDisplayFixedOutput                           : uint32
      );
  end;
  PDeviceModeW = ^DeviceModeW;

  DeviceModeA = record
    dmDeviceName                                         : array [0..CCHDEVICENAME - 1] of uint8;
    dmSpecVersion                                        : uint16;
    dmDriverVersion                                      : uint16;
    dmSize                                               : uint16;
    dmDriverExtra                                        : uint16;
    dmFields                                             : uint32;
    union1                                               : record
    case int32 of

      0: (
        dmOrientation                                    : int16;
        dmPaperSize                                      : int16;
        dmPaperLength                                    : int16;
        dmPaperWidth                                     : int16;
        dmScale                                          : int16;
        dmCopies                                         : int16;
        dmDefaultSource                                  : int16;
        dmPrintQuality                                   : int16
      );

      1: (
        dmPosition                                       : PointL;
        dmDisplayOrientation                             : uint32;
        dmDisplayFixedOutput                             : uint32
      );

    end;
    dmColor                                              : int8;
    dmDuplex                                             : int8;
    dmYResolution                                        : int8;
    dmTTOption                                           : int8;
    dmCollate                                            : int8;
    dmFormName                                           : array [0..CCHFORMNAME - 1] of uint8;
    dmLogPixels                                          : uint16;
    dmBitsPerPel                                         : uint32;
    dmPelsWidth                                          : uint32;
    dmPelsHeight                                         : uint32;
    dmDisplayFlags                                       : DmDisplayFlagsUnion;
    dmDisplayFrequency                                   : uint32;
    dmICMMethod                                          : uint32;
    dmICMIntent                                          : uint32;
    dmMediaType                                          : uint32;
    dmDitherType                                         : uint32;
    dmReserved1                                          : uint32;
    dmReserved2                                          : uint32;
    dmPanningWidth                                       : uint32;
    dmPanningHeight                                      : uint32;
  end;
  PDeviceModeA = ^DeviceModeA;


  DLGTEMPLATE = packed record
    style                                                : uint32;
    dwExtendedStyle                                      : uint32;
    cdit                                                 : uint16;
    x                                                    : int16;
    y                                                    : int16;
    cx                                                   : int16;
    cy                                                   : int16;
  end;

  PixelFormatDescriptor = record
    nSize                                                : uint16;
    nVersion                                             : uint16;
    dwFlags                                              : uint32;
    iPixelType                                           : uint8;
    cColorBits                                           : uint8;
    cRedBits                                             : uint8;
    cRedShift                                            : uint8;
    cGreenBits                                           : uint8;
    cGreenShift                                          : uint8;
    cBlueBits                                            : uint8;
    cBlueShift                                           : uint8;
    cAlphaBits                                           : uint8;
    cAlphaShift                                          : uint8;
    cAccumBits                                           : uint8;
    cAccumRedBits                                        : uint8;
    cAccumGreenBits                                      : uint8;
    cAccumBlueBits                                       : uint8;
    cAccumAlphaBits                                      : uint8;
    cDepthBits                                           : uint8;
    cStencilBits                                         : uint8;
    cAuxBuffers                                          : uint8;
    iLayerType                                           : uint8;
    bReserved                                            : uint8;
    dwLayerMask                                          : uint32;
    dwVisibleMask                                        : uint32;
    dwDamageMask                                         : uint32;
  end;
  pPixelFormatDescriptor = ^PixelFormatDescriptor;

  SERVICE_STATUS = record
    dwServiceType                                        : uint32;
    dwCurrentState                                       : uint32;
    dwControlsAccepted                                   : uint32;
    dwWin32ExitCode                                      : uint32;
    dwServiceSpecificExitCode                            : uint32;
    dwCheckPoint                                         : uint32;
    dwWaitHint                                           : uint32;
  end;
  pSERVICE_STATUS = ^SERVICE_STATUS;

  SIDIdentifierAuthority = record
    value                                                : array [0..5] of uint8;
  end;
  PSIDIdentifierAuthority = ^SIDIdentifierAuthority;

  SID = record
    Revision                                             : uint8;
    SubAuthorityCount                                    : uint8;
    IdentifierAuthority                                  : SIDIdentifierAuthority;
    SubAuthority                                         : array [0..ANYSIZE_ARRAY-1] of uint32;
  end;
  PSID = ^SID;

  ACL = record
    AclRevision                                          : uint8;
    Sbz1                                                 : uint8;
    AclSize                                              : uint16;
    AceCount                                             : uint16;
    Sbz2                                                 : uint16;
  end;
  pACL = ^ACL;

  SecurityDescriptor = record
    Revision                                             : uint8;
    Sbz1                                                 : uint8;
    Control                                              : SECURITY_DESCRIPTOR_CONTROL;
    Owner                                                : PSID;
    Group                                                : PSID;
    Sacl                                                 : PACL;
    Dacl                                                 : PACL;
  end;
  PSecurityDescriptor = ^SecurityDescriptor;

  TGenericMapping = record
    GenericRead                                          : TACCESS_MASK;
    GenericWrite                                         : TACCESS_MASK;
    GenericExecute                                       : TACCESS_MASK;
    GenericAll                                           : TACCESS_MASK;
  end;

  LUID = record
    LowPart                                              : uint32;
    HighPart                                             : int32;
  end;

  LUID_AND_ATTRIBUTES = record
    Luid                                                 : LUID;
    Attributes                                           : uint32;
  end;

  PrivilegeSet = record
    PrivilegeCount                                       : uint32;
    Control                                              : uint32;
    Privilege                                            : array [0..ANYSIZE_ARRAY - 1] of LUID_AND_ATTRIBUTES;
  end;
  pPrivilegeSet = ^PrivilegeSet;

  GUID = record
    D1                                                   : int32;
    D2                                                   : uint16;
    D3                                                   : uint16;
    D4                                                   : array[0..7] of uint8;
  end;
  PGUID = ^GUID;

  ObjectTypeList = record
    Level                                                : uint16;
    Sbz                                                  : uint16;
    ObjectType                                           : PGUID;
  end;
  PObjectTypeList = ^ObjectTypeList;

  AUDIT_EVENT_TYPE = (
    AuditEventObjectAccess,
    AuditEventDirectoryServiceAccess
  );

  SID_AND_ATTRIBUTES = record
    Sid                                                  : PSID;
    Attributes                                           : uint32;
  end;

  Token_Groups = record
    GroupCount                                           : uint32;
    Groups                                               : array [0..ANYSIZE_ARRAY - 1] of SID_AND_ATTRIBUTES;
  end;
  PToken_Groups = ^Token_Groups;

  Token_Privileges = record
    PrivilegeCount                                       : uint32;
    Privileges                                           : array [0..ANYSIZE_ARRAY - 1] of LUID_AND_ATTRIBUTES;
  end;
  PToken_Privileges = ^Token_Privileges;

  ServiceStatus = record
    dwServiceType                                        : uint32;
    dwCurrentState                                       : uint32;
    dwControlsAccepted                                   : uint32;
    dwWin32ExitCode                                      : uint32;
    dwServiceSpecificExitCode                            : uint32;
    dwCheckPoint                                         : uint32;
    dwWaitHint                                           : uint32;
  end;
  PServiceStatus = ^ServiceStatus;

  SecurityAttributes = record
    nLength                                              : uint32;
    lpSecurityDescriptor                                 : PSecurityDescriptor;
    bInheriHandle                                        : Bool;
  end;
  PSecurityAttributes = ^SecurityAttributes;

  ProcessInformation = record
    hProcess                                             : winHandle;
    hThread                                              : winHandle;
    dwProcessId                                          : uint32;
    dwThreadId                                           : uint32;
  end;
  PProcessInformation = ^ProcessInformation;

  Token_Type = (
    TokenTPad,
    TokenPrimary,
    TokenImpersonation
  );

  EnumServiceStatusA = record
    lpServiceName                                        : LPSTR;
    lpDisplayName                                        : LPSTR;
    ServiceStatus                                        : ServiceStatus;
  end;

  EnumServiceStatusW = record
    lpServiceName                                        : LPWStr;
    lpDisplayName                                        : LPWStr;
    ServiceStatus                                        : ServiceStatus;
  end;

  AclInformationClass = (
    AclInfoPad,
    AclRevisionInformation,
    AclSizeInformation
  );

  HWProfileInfoA = record
    dwDockInfo                                           : uint32;
    szHwProfileGuid                                      : packed array[0..HW_PROFILE_GUIDLEN-1] of AnsiChar;
    szHwProfileName                                      : packed array[0..MAX_PROFILE_LEN-1] of AnsiChar;
  end;
  pHWPProfileInfoA = ^HWProfileInfoA;

  HWProfileInfoW = record
    dwDockInfo                                           : uint32;
    szHwProfileGuid                                      : packed array[0..HW_PROFILE_GUIDLEN-1] of WideChar;
    szHwProfileName                                      : packed array[0..MAX_PROFILE_LEN-1] of WideChar;
  end;
  pHWPProfileInfoW = ^HWProfileInfoW;

  Token_Information_Class = (
    TokenUser = 1,
    TokenGroups,
    TokenPrivileges,
    TokenOwner,
    TokenPrimaryGroup,
    TokenDefaultDacl,
    TokenSource,
    TokenType,
    TokenImpersonationLevel,
    TokenStatistics,
    TokenRestrictedSids,
    TokenSessionId,
    TokenGroupsAndPrivileges,
    TokenSessionReference,
    TokenSandBoxInert,
    TokenAuditPolicy,
    TokenOrigin,
    TokenElevationType,
    TokenLinkedToken,
    TokenElevation,
    TokenHasRestrictions,
    TokenAccessInformation,
    TokenVirtualizationAllowed,
    TokenVirtualizationEnabled,
    TokenIntegrityLevel,
    TokenUIAccess,
    TokenMandatoryPolicy,
    TokenLogonSid,
    vMaxTokenInfoClass
  );

  Query_Service_ConfigA = record
    dwServiceType                                        : uint32;
    dwStartType                                          : uint32;
    dwErrorControl                                       : uint32;
    lpBinaryPathName                                     : LPSTR;
    lpLoadOrderGroup                                     : LPSTR;
    dwTagId                                              : uint32;
    lpDependencies                                       : LPSTR;
    lpServiceStartName                                   : LPSTR;
    lpDisplayName                                        : LPSTR;
  end;
  PQuery_Service_ConfigA = ^Query_Service_ConfigA;

  Query_Service_ConfigW = record
    dwServiceType                                        : uint32;
    dwStartType                                          : uint32;
    dwErrorControl                                       : uint32;
    lpBinaryPathName                                     : LPWSTR;
    lpLoadOrderGroup                                     : LPWSTR;
    dwTagId                                              : uint32;
    lpDependencies                                       : LPWSTR;
    lpServiceStartName                                   : LPWSTR;
    lpDisplayName                                        : LPWSTR;
  end;
  PQuery_Service_ConfigW = ^Query_Service_ConfigW;

  Query_Service_Lock_StatusA = record
    fIsLocked                                            : uint32;
    lpLockOwner                                          : LPSTR;
    dwLockDuration                                       : uint32
  end;
  pQuery_Service_Lock_StatusA = ^Query_Service_Lock_StatusA;

  Query_Service_Lock_StatusW = record
    fIsLocked                                            : uint32;
    lpLockOwner                                          : LPWSTR;
    dwLockDuration                                       : uint32;
  end;
  PQuery_Service_Lock_StatusW  = ^Query_Service_Lock_StatusW;

  SECURITY_DESCRIPTOR = record
    Revision                                             : uint8;
    Sbz1                                                 : uint8;
    Control                                              : SECURITY_DESCRIPTOR_CONTROL;
    Owner                                                : PSID;
    Group                                                : PSID;
    Sacl                                                 : PACL;
    Dacl                                                 : PACL;
  end;
  PSECURITY_DESCRIPTOR = ^SECURITY_DESCRIPTOR;

  FileTime = record
    dwLowDateTime                                        : uint32;
    dwHighDateTime                                       : uint32;
  end;
  PFileTime = ^FileTime;

  Service_Table_EntryA = record
    lpServiceName                                        : LPSTR;
    lpServiceProc                                        : LPSERVICE_MAIN_FUNCTIONA;
  end;
  PService_Table_EntryA = ^Service_Table_EntryA;

  Service_Table_EntryW = record
    lpServiceName                                        : LPWSTR;
    lpServiceProc                                        : LPSERVICE_MAIN_FUNCTIONW;
  end;
  PService_Table_EntryW = ^Service_Table_EntryW;

  SERVICE_TABLE_ENTRY = record
    lpServiceName                                        : pWideChar;
    lpServiceProc                                        : ServiceMainFunction;
  end;
  pSERVICE_TABLE_ENTRY = ^SERVICE_TABLE_ENTRY;

  ConvInfo = record
    cb                                                   : uint32;
    hUser                                                : ^uint32;
    hConvPartner                                         : HCONV;
    hszSvcPartner                                        : HSZ;
    hszServiceReq                                        : HSZ;
    hszTopic                                             : HSZ;
    hszItem                                              : HSZ;
    wFmt                                                 : uint32;
    wType                                                : uint32;
    wStatus                                              : uint32;
    wConvst                                              : uint32;
    wLastError                                           : uint32;
    hConvList                                            : HConvList;
    ConvCtxt                                             : ConvContext;
    hwnd                                                 : HWND;
    hwndPartner                                          : HWND;
  end;
  PConvInfo = ^ConvInfo;

  DrawTextParams = record
    cbSize                                               : uint32;
    iTabLength                                           : int32;
    iLeftMargin                                          : int32;
    iRightMargin                                         : int32;
    uiLengthDrawn                                        : uint32;
  end;
  PDrawTextParams = ^DrawTextParams;

  COMMTIMEOUTS = record
    ReadIntervalTimeout                                  : uint32;
    ReadTotalTimeoutMultiplier                           : uint32;
    ReadTotalTimeoutConstant                             : uint32;
    WriteTotalTimeoutMultiplier                          : uint32;
    WriteTotalTimeoutConstant                            : uint32;
  end;
  PCOMMTIMEOUTS = ^COMMTIMEOUTS;

  ComStat = record
    Flags                                                : uint32;
    cbInQue                                              : uint32;
    cbOutQue                                             : uint32;
  end;
  PCOMSTAT = ^ComStat;

  CommConfig = record
    dwSize                                               : uint32;
    wVersion                                             : uint16;
    wReserved                                            : uint16;
    dcb                                                  : DCB;
    dwProviderSubType                                    : uint32;
    dwProviderOffset                                     : uint32;
    dwProviderSize                                       : uint32;
    wcProviderData                                       : array [0..0] of uint16;
  end;

  Overlapped = record
    Internal                                             : nativeuint;
    InternalHigh                                         : nativeuint;
    Union                                                : record
      case int32 of

        0  : (
          Offset                                         : uint32;
          OffsetHigh                                     : uint32
        );

        1: (
          ptr                                            : pointer
        );

      end;
    hEvent: winHandle;
  end;
  POverlapped = ^Overlapped;
  FileIOCompletionRoutine                                = procedure ( dwErrorCode: uint32; dwNumberOfBytesTransfered: uint32; lpOverlapped: POverlapped ); stdcall;

  Coord = record
    X                                                    : int16;
    Y                                                    : int16;
  end;
  PCoord = ^Coord;

  WIN32FindDataA = record
    dwFileAttributes                                     : uint32;
    ftCreationTime                                       : FileTime;
    ftLastAccessTime                                     : FileTime;
    ftLastWriteTime                                      : FileTime;
    nFileSizeHigh                                        : uint32;
    nFileSizeLow                                         : uint32;
    dwReserved0                                          : uint32;
    dwReserved1                                          : uint32;
    cFileName                                            : array [0..MAX_PATH - 1] of AnsiChar;
    cAlternateFileName                                   : array [0..13] of AnsiChar;
  end;
  PWIN32FindDataA = ^WIN32FindDataA;


  WIN32FindDataW = record
    dwFileAttributes                                     : uint32;
    ftCreationTime                                       : FileTime;
    ftLastAccessTime                                     : FileTime;
    ftLastWriteTime                                      : FileTime;
    nFileSizeHigh                                        : uint32;
    nFileSizeLow                                         : uint32;
    dwReserved0                                          : uint32;
    dwReserved1                                          : uint32;
    cFileName                                            : array [0..MAX_PATH - 1] of WideChar;
    cAlternateFileName                                   : array [0..13] of WideChar;
  end;
  PWIN32FindDataW = ^WIN32FindDataw;

  FindexInfoLevels = (
    FindExInfoStandard,
    FindExInfoBasic,
    FindExInfoMaxInfoLevel
  );

  FindexSearchOps = (
    FindExSearchNameMatch,
    FindExSearchLimitToDirectories,
    FindExSearchLimitToDevices
  );

  CPInfo = record
    MaxCharSize                                          : uint32;
    DefaultChar                                          : array [0..MAX_DEFAULTCHAR - 1] of uint8;
    LeadByte                                             : array [0..MAX_LEADBYTES - 1] of uint8;
  end;
  PCPInfo = ^CPInfo;

  COMMPROP = record
    wPacketLength                                        : uint16;
    wPacketVersion                                       : uint16;
    dwServiceMask                                        : uint32;
    dwReserved1                                          : uint32;
    dwMaxTxQueue                                         : uint32;
    dwMaxRxQueue                                         : uint32;
    dwMaxBaud                                            : uint32;
    dwProvSubType                                        : uint32;
    dwProvCapabilities                                   : uint32;
    dwSettableParams                                     : uint32;
    dwSettableBaud                                       : uint32;
    wSettableData                                        : uint16;
    wSettableStopParity                                  : uint16;
    dwCurrentTxQueue                                     : uint32;
    dwCurrentRxQueue                                     : uint32;
    dwProvSpec1                                          : uint32;
    dwProvSpec2                                          : uint32;
    wcProvChar                                           : array [0..0] of WideChar;
  end;

  ConsoleCursorInfo = record
    dwSize                                               : uint32;
    bVisible                                             : Bool;
  end;

  ConsoleScreenBufferInfo = record
    dwSize                                               : Coord;
    dwCursorPosition                                     : Coord;
    wAttributes                                          : uint16;
    srWindow                                             : SmallRect;
    dwMaximumWindowSize                                  : Coord;
  end;

  CurrencyFmtA = record
    NumDigits                                            : uint32;
    LeadingZero                                          : uint32;
    Grouping                                             : uint32;
    lpDecimalSep                                         : LPSTR;
    lpThousandSep                                        : LPSTR;
    NegativeOrder                                        : uint32;
    PositiveOrder                                        : uint32;
    lpCurrencySymbol                                     : LPSTR;
  end;
  PCurrencyFmtA = ^CurrencyFmtA;

  CurrencyFmtW = record
    NumDigits                                            : uint32;
    LeadingZero                                          : uint32;
    Grouping                                             : uint32;
    lpDecimalSep                                         : LPWSTR;
    lpThousandSep                                        : LPWSTR;
    NegativeOrder                                        : uint32;
    PositiveOrder                                        : uint32;
    lpCurrencySymbol                                     : LPWSTR;
  end;
  PCurrencyFmtW = ^CurrencyFmtW;

  GetFileEXInfoLevels = (
    GetFileExInfoStandard,
    GetFileExMaxInfoLevel
  );

  ByHandleFileInformation = record
    dwFileAttributes                                     : uint32;
    ftCreationTime                                       : FileTime;
    ftLastAccessTime                                     : FileTime;
    ftLastWriteTime                                      : FileTime;
    dwVolumeSerialNumber                                 : uint32;
    nFileSizeHigh                                        : uint32;
    nFileSizeLow                                         : uint32;
    nNumberOfLinks                                       : uint32;
    nFileIndexHigh                                       : uint32;
    nFileIndexLow                                        : uint32;
  end;

  NumberFmtA = record
    NumDigits                                            : uint32;
    LeadingZero                                          : uint32;
    Grouping                                             : uint32;
    lpDecimalSep                                         : LPSTR;
    lpThousandSep                                        : LPSTR;
    NegativeOrder                                        : uint32;
  end;
  PNumberFmtA = ^NumberFmtA;

  NumberFmtW = record
    NumDigits                                            : uint32;
    LeadingZero                                          : uint32;
    Grouping                                             : uint32;
    lpDecimalSep                                         : LPWSTR;
    lpThousandSep                                        : LPWSTR;
    NegativeOrder                                        : uint32;
  end;
  PNumberFmtW = ^NumberFmtW;

  SystemInfo = record
    case int32 of

    0: (
      dwOemId                                            : uint32
    );

    1: (
      wProcessorArchitecture                             : uint16;
      wReserved                                          : uint16;
      dwPageSize                                         : uint32;
      lpMinimumApplicationAddress                        : pointer;
      lpMaximumApplicationAddress                        : pointer;
      dwActiveProcessorMask                              : nativeuint;
      dwNumberOfProcessors                               : uint32;
      dwProcessorType                                    : uint32;
      dwAllocationGranularity                            : uint32;
      wProcessorLevel                                    : uint16;
      wProcessorRevision                                 : uint16
    );
  end;

  SystemPowerStatus = record
    ACLineStatus                                         : uint8;
    BatteryFlag                                          : uint8;
    BatteryLifePercent                                   : uint8;
    Reserved1                                            : uint8;
    BatteryLifeTime                                      : uint32;
    BatteryFullLifeTime                                  : uint32;
  end;

  FloatingSaveArea = record
    ControlWord                                          : uint32;
    StatusWord                                           : uint32;
    TagWord                                              : uint32;
    ErrorOffset                                          : uint32;
    ErrorSelector                                        : uint32;
    DataOffset                                           : uint32;
    DataSelector                                         : uint32;
    RegisterArea                                         : array [0..SIZE_OF_80387_REGISTERS - 1] of uint8;
    Cr0NpxState                                          : uint32;
  end;

  Context  = record
    ContextFlags                                         : uint32;
    Dr0                                                  : uint32;
    Dr1                                                  : uint32;
    Dr2                                                  : uint32;
    Dr3                                                  : uint32;
    Dr6                                                  : uint32;
    Dr7                                                  : uint32;
    FloatSave                                            : FloatingSaveArea;
    SegGs                                                : uint32;
    SegFs                                                : uint32;
    SegEs                                                : uint32;
    SegDs                                                : uint32;
    Edi                                                  : uint32;
    Esi                                                  : uint32;
    Ebx                                                  : uint32;
    Edx                                                  : uint32;
    Ecx                                                  : uint32;
    Eax                                                  : uint32;
    Ebp                                                  : uint32;
    Eip                                                  : uint32;
    SegCs                                                : uint32;
    EFlags                                               : uint32;
    Esp                                                  : uint32;
    SegSs                                                : uint32;
    ExtendedRegisters                                    : array [0..MAXIMUM_SUPPORTED_EXTENSION - 1] of uint8;
  end;
  PContext = ^Context;

  LDTEntry = record
    LimitLow                                             : uint16;
    BaseLow                                              : uint16;
    BaseMid                                              : uint8;
    Flags1                                               : uint8;
    Flags2                                               : uint8;
    BaseHi                                               : uint8;
  end;

  TimeZoneInformation = record
    Bias                                                 : int32;
    StandardName                                         : array [0..31] of WideChar;
    StandardDate                                         : SystemTime;
    StandardBias                                         : int32;
    DaylightName                                         : array [0..31] of WideChar;
    DaylightDate                                         : SystemTime;
    DaylightBias                                         : int32;
  end;
  PTimeZoneInformation = ^TimeZoneInformation;

  OSVersionInfoA = record
    dwOSVersionInfoSize                                  : uint32;
    dwMajorVersion                                       : uint32;
    dwMinorVersion                                       : uint32;
    dwBuildNumber                                        : uint32;
    dwPlatformId                                         : uint32;
    szCSDVersion                                         : array [0..127] of AnsiChar;
  end;

  OSVersionInfoW = record
    dwOSVersionInfoSize                                  : uint32;
    dwMajorVersion                                       : uint32;
    dwMinorVersion                                       : uint32;
    dwBuildNumber                                        : uint32;
    dwPlatformId                                         : uint32;
    szCSDVersion                                         : array [0..127] of WideChar;
  end;

  MemoryStatus = record
    dwLength                                             : uint32;
    dwMemoryLoad                                         : uint32;
    dwTotalPhys                                          : nativeuint;
    dwAvailPhys                                          : nativeuint;
    dwTotalPageFile                                      : nativeuint;
    dwAvailPageFile                                      : nativeuint;
    dwTotalVirtual                                       : nativeuint;
    dwAvailVirtual                                       : nativeuint;
  end;

  HeapEntry32 = record
    dwSize                                               : nativeuint;
    hHandle                                              : winHandle;
    dwAddress                                            : nativeuint;
    dwBlockSize                                          : nativeuint;
    dwFlags                                              : uint32;
    dwLockCount                                          : uint32;
    dwResvd                                              : uint32;
    th32ProcessID                                        : uint32;
    th32HeapID                                           : nativeuint;
  end;

  HeapList32 = record
    dwSize                                               : nativeuint;
    th32ProcessID                                        : uint32;
    th32HeapID                                           : nativeuint;
    dwFlags                                              : uint32;
  end;

  ProcessHeapEntry = record
    lpData                                               : Pointer;
    cbData                                               : uint32;
    cbOverhead                                           : uint8;
    iRegionIndex                                         : uint8;
    wFlags                                               : uint16;
    case int32 of

      0 : (
        hMem                                             : winHandle;
        dwReserved                                       : array [0..2] of uint32
      );

      1: (
        dwComittedSize                                   : uint32;
        dwUnComittedSize                                 : uint32;
        lpFirstBlock                                     : pointer;
        lpLastBlock                                      : pointer
      );

  end;

  ModuleEntry32W = record
    dwSize                                               : uint32;
    th32ModuleID                                         : uint32;
    th32ProcessID                                        : uint32;
    GlblcntUsage                                         : uint32;
    ProccntUsage                                         : uint32;
    modBaseAddr                                          : ^uint8;
    modBaseSize                                          : uint32;
    hModule                                              : HMODULE;
    szModule                                             : array [0..MAX_MODULE_NAME32] of WideChar;
    szExePath                                            : array [0..MAX_PATH - 1] of WideChar;
  end;

  ModuleEntry32A = record
    dwSize                                               : uint32;
    th32ModuleID                                         : uint32;
    th32ProcessID                                        : uint32;
    GlblcntUsage                                         : uint32;
    ProccntUsage                                         : uint32;
    modBaseAddr                                          : ^uint8;
    modBaseSize                                          : uint32;
    hModule                                              : HMODULE;
    szModule                                             : array [0..MAX_MODULE_NAME32] of AnsiChar;
    szExePath                                            : array [0..MAX_PATH - 1] of AnsiChar;
  end;

  OFStruct = record
    cBytes                                               : uint8;
    fFixedDisk                                           : uint8;
    nErrCode                                             : uint16;
    Reserved1                                            : uint16;
    Reserved2                                            : uint16;
    szPathName                                           : array [0..OFS_MAXPATHNAME - 1] of AnsiChar;
  end;

  CharUnion = record
    case int32 of

      0 : (
        UnicodeChar                                      : WideChar
      );

      1: (
        AsciiChar                                        : AnsiChar
      );

  end;

  KeyEventRecord = record
    bKeyDown                                             : Bool;
    wRepeatCount                                         : uint16;
    wVirtualKeyCode                                      : uint16;
    wVirtualScanCode                                     : uint16;
    uChar                                                : CharUnion;
    dwControlKeyState                                    : uint32;
  end;

  MouseEventRecord = record
    dwMousePosition                                      : Coord;
    dwButtonState                                        : uint32;
    dwControlKeyState                                    : uint32;
    dwEventFlags                                         : uint32;
  end;

  WindowBufferSizeEventRecord = record
    dwSize                                               : Coord;
  end;

  MenuEventRecord = record
    dwCommandId                                          : uint32;
  end;

  FocusEventRecord = record
    bSetFocus                                            : Bool;
  end;

  InputRecord = record
    EventType                                            : uint16;
    case int32 of
      0: ( KeyEvent                                      : KeyEventRecord );
      1: ( MouseEvent                                    : MouseEventRecord );
      2: ( WindowBufferSizeEvent                         : WindowBufferSizeEventRecord );
      3: ( MenuEvent                                     : MenuEventRecord );
      4: ( FocusEvent                                    : FocusEventRecord );
  end;

  ProcessEntry32W = record
    dwSize                                               : uint32;
    cntUsage                                             : uint32;
    th32ProcessID                                        : uint32;
    th32DefaultHeapID                                    : nativeuint;
    th32ModuleID                                         : uint32;
    cntThreads                                           : uint32;
    th32ParentProcessID                                  : uint32;
    pcPriClassBase                                       : int32;
    dwFlags                                              : uint32;
    szExeFile                                            : array [0..MAX_PATH - 1] of WideChar;
  end;

  ProcessEntry32A = record
    dwSize                                               : uint32;
    cntUsage                                             : uint32;
    th32ProcessID                                        : uint32;
    th32DefaultHeapID                                    : nativeuint;
    th32ModuleID                                         : uint32;
    cntThreads                                           : uint32;
    th32ParentProcessID                                  : uint32;
    pcPriClassBase                                       : int32;
    dwFlags                                              : uint32;
    szExeFile                                            : array [0..MAX_PATH - 1] of AnsiChar;
  end;

  CharInfo = record
    uChar                                                : CharUnion;
    Attributes                                           : uint16;
  end;

  CommConfigW = record
    dwSize                                               : uint32;
    wVersion                                             : uint16;
    wReserved                                            : uint16;
    dcb                                                  : DCB;
    dwProviderSubType                                    : uint32;
    dwProviderOffset                                     : uint32;
    dwProviderSize                                       : uint32;
    wcProviderData                                       : array [0..0] of WideChar;
  end;
  PCommConfigW = ^CommConfigW;

  CommConfigA = record
    dwSize                                               : uint32;
    wVersion                                             : uint16;
    wReserved                                            : uint16;
    dcb                                                  : DCB;
    dwProviderSubType                                    : uint32;
    dwProviderOffset                                     : uint32;
    dwProviderSize                                       : uint32;
    wcProviderData                                       : array [0..0] of AnsiChar;
  end;
  PCommConfigA = ^CommConfigA;

  PExceptionRecord = ^ExceptionRecord;
  ExceptionRecord = record
    ExceptionCode                                        : uint32;
    ExceptionFlags                                       : uint32;
    ExceptionRecord                                      : PExceptionRecord;
    ExceptionAddress                                     : Pointer;
    NumberParameters                                     : uint32;
    ExceptionInformation                                 : array [0..EXCEPTION_MAXIMUM_PARAMETERS - 1] of nativeuint;
  end;

  ExceptionPointers = record
    ExceptionRecord                                      : PExceptionRecord;
    ContextRecord                                        : PCONTEXT;
  end;
  PExceptionPointers = ^ExceptionPointers;
  UnhandledExceptionFilter                               = function  ( ExceptionInfo: PExceptionPointers ): int32; stdcall;

  ThreadEntry32 = record
    dwSize                                               : uint32;
    cntUsage                                             : uint32;
    th32ThreadID                                         : uint32;
    th32OwnerProcessID                                   : uint32;
    tpBasePri                                            : int32;
    tpDeltaPri                                           : int32;
    dwFlags                                              : uint32;
  end;

  MemoryBasicInformation = record
    BaseAddress                                          : Pointer;
    AllocationBase                                       : Pointer;
    AllocationProtect                                    : uint32;
    RegionSize                                           : nativeuint;
    State                                                : uint32;
    Protect                                              : uint32;
    _Type                                                : uint32;
  end;

  ExceptionDebugInfo = record
    ExceptionRecord                                      : ExceptionRecord;
    dwFirstChance                                        : uint32;
  end;

  CreateThreadDebugInfo = record
    hThread                                              : winHandle;
    lpThreadLocalBase                                    : pointer;
    lpStartAddress                                       : ThreadStartRoutine;
  end;

  CreateProcessDebugInfo = record
    hFile                                                : winHandle;
    hProcess                                             : winHandle;
    hThread                                              : winHandle;
    lpBaseOfImage                                        : pointer;
    dwDebugInfoFileOffset                                : uint32;
    nDebugInfoSize                                       : uint32;
    lpThreadLocalBase                                    : pointer;
    lpStartAddress                                       : ThreadStartRoutine;
    lpImageName                                          : pointer;
    fUnicode                                             : uint16;
  end;

  ExitThreadDebugInfo = record
    dwExitCode                                           : uint32;
  end;

  ExitProcessDebugInfo = record
    dwExitCode                                           : uint32;
  end;

  LoadDLLDebugInfo = record
    hFile                                                : winHandle;
    lpBaseOfDll                                          : pointer;
    dwDebugInfoFileOffset                                : uint32;
    nDebugInfoSize                                       : uint32;
    lpImageName                                          : pointer;
    fUnicode                                             : uint16;
  end;

  UnloadDLLDebugInfo = record
    lpBaseOfDll                                          : pointer;
  end;

  OutputDebugStringInfo = record
    lpDebugStringData                                    : LPSTR;
    fUnicode                                             : uint16;
    nDebugStringLength                                   : uint16;
  end;

  RIPDebugInfo = record
    dwError                                              : uint32;
    dwType                                               : uint32;
  end;

  DebugEvent = record
    dwDebugEventCode                                     : uint32;
    dwProcessId                                          : uint32;
    dwThreadId                                           : uint32;
    case int32 of
      0: ( Exception                                     : ExceptionDebugInfo );
      1: ( CreateThread                                  : CreateThreadDebugInfo );
      2: ( CreateProcessInfo                             : CreateProcessDebugInfo );
      3: ( ExitThread                                    : ExitThreadDebugInfo );
      4: ( ExitProcess                                   : ExitProcessDebugInfo );
      5: ( LoadDll                                       : LoadDLLDebugInfo );
      6: ( UnloadDll                                     : UnloadDLLDebugInfo );
      7: ( DebugString                                   : OutputDebugStringInfo );
      8: ( RipInfo                                       : RIPDebugInfo );

  end;

  DisplayDeviceA = record
    cb                                                   : uint32;
    DeviceName                                           : array [0..32 - 1] of AnsiChar;
    DeviceString                                         : array [0..128 - 1] of AnsiChar;
    StateFlags                                           : uint32;
    DeviceID                                             : array [0..128 - 1] of AnsiChar;
    DeviceKey                                            : array [0..128 - 1] of AnsiChar;
  end;

  DisplayDeviceW = record
    cb                                                   : uint32;
    DeviceName                                           : array [0..32 - 1] of WideChar;
    DeviceString                                         : array [0..128 - 1] of WideChar;
    StateFlags                                           : uint32;
    DeviceID                                             : array [0..128 - 1] of WideChar;
    DeviceKey                                            : array [0..128 - 1] of WideChar;
  end;

  DisplayDevice = record
    cb                                                   : uint32;
    DeviceName                                           : array[0..31] of uint16;
    DeviceString                                         : array[0..127] of uint16;
    StateFlags                                           : uint32;
    DeviceID                                             : array[0..127] of uint16;
    DeviceKey                                            : array[0..127] of uint16;
  end;
  pDisplayDevice = ^DisplayDevice;

  FlashWInfo = record
    cbSize                                               : uint32;
    hwnd                                                 : HWND;
    dwFlags                                              : uint32;
    uCount                                               : uint32;
    dwTimeout                                            : uint32;
  end;

  AltTabInfo = record
    cbSize                                               : uint32;
    cItems                                               : int32;
    cColumns                                             : int32;
    cRows                                                : int32;
    iColFocus                                            : int32;
    iRowFocus                                            : int32;
    cxItem                                               : int32;
    cyItem                                               : int32;
    ptStart                                              : Point;
  end;

  CursorInfo = record
    cbSize                                               : uint32;
    flags                                                : uint32;
    hCursor                                              : HCURSOR;
    ptScreenPos                                          : Point;
  end;

  GUIThreadInfo = record
    cbSize                                               : uint32;
    flags                                                : uint32;
    hwndActive                                           : Hwnd;
    hwndFocus                                            : Hwnd;
    hwndCapture                                          : Hwnd;
    hwndMenuOwner                                        : Hwnd;
    hwndMoveSize                                         : Hwnd;
    hwndCaret                                            : Hwnd;
    rcCaret                                              : Rect;
  end;

  LastInputInfo = record
    cbSize                                               : uint32;
    dwTime                                               : uint32;
  end;

  MenuBarInfo = record
    cbSize                                               : uint32;
    rcBar                                                : RECT;
    hMenu                                                : HMENU;
    hwndMenu                                             : HWND;
    Flags                                                : uint32;
  end;

  MenuInfo = record
    cbSize                                               : uint32;
    fMask                                                : uint32;
    dwStyle                                              : uint32;
    cyMax                                                : uint32;
    hbrBack                                              : HBRUSH;
    dwContextHelpID                                      : uint32;
    dwMenuData                                           : nativeuint;
  end;

  MenuItemInfoA = record
    cbSize                                               : uint32;
    fMask                                                : uint32;
    fType                                                : uint32;
    fState                                               : uint32;
    wID                                                  : uint32;
    hSubMenu                                             : HMENU;
    hbmpChecked                                          : HBITMAP;
    hbmpUnchecked                                        : HBITMAP;
    dwItemData                                           : nativeuint;
    dwTypeData                                           : LPSTR;
    cch                                                  : uint32;
    hbmpItem                                             : HBITMAP;
  end;

  MenuItemInfoW = record
    cbSize                                               : uint32;
    fMask                                                : uint32;
    fType                                                : uint32;
    fState                                               : uint32;
    wID                                                  : uint32;
    hSubMenu                                             : HMENU;
    hbmpChecked                                          : HBITMAP;
    hbmpUnchecked                                        : HBITMAP;
    dwItemData                                           : nativeuint;
    dwTypeData                                           : LPWSTR;
    cch                                                  : uint32;
    hbmpItem                                             : HBITMAP;
  end;

  ScrollBarInfo = record
    cbSize                                               : uint32;
    rcScrollBar                                          : RECT;
    dxyLineButton                                        : int32;
    xyThumbTop                                           : int32;
    xyThumbBottom                                        : int32;
    reserved                                             : int32;
    rgstate                                              : array [0..CCHILDREN_SCROLLBAR] of uint32;
  end;

  ScrollInfo = record
    cbSize                                               : uint32;
    fMask                                                : uint32;
    nMin                                                 : int32;
    nMax                                                 : int32;
    nPage                                                : uint32;
    nPos                                                 : int32;
    nTrackPos                                            : int32;
  end;

  WindowInfo = record
    cbSize                                               : uint32;
    rcWindow                                             : RECT;
    rcClient                                             : RECT;
    dwStyle                                              : uint32;
    dwExStyle                                            : uint32;
    dwWindowStatus                                       : uint32;
    cxWindowBorders                                      : uint32;
    cyWindowBorders                                      : uint32;
    atomWindowType                                       : ATOM;
    wCreatorVersion                                      : uint16;
  end;

  WindowPlacement = record
    length                                               : uint32;
    flags                                                : uint32;
    showCmd                                              : uint32;
    ptMinPosition                                        : POINT;
    ptMaxPosition                                        : POINT;
    rcNormalPosition                                     : RECT;
  end;
  PWindowPlacement = ^WindowPlacement;

  HelpInfo = record
    cbSize                                               : uint32;
    iContextType                                         : int32;
    iCtrlId                                              : int32;
    hItemHandle                                          : winHandle;
    dwContextId                                          : nativeuint;
    MousePos                                             : Point;
  end;
  MsgBoxCallback                                         = procedure ( var lpHelpInfo: HelpInfo ); stdcall;

  MsgBoxParamsA = record
    cbSize                                               : uint32;
    hwndOwner                                            : HWND;
    hInstance                                            : HInstance;
    lpszText                                             : LPCSTR;
    lpszCaption                                          : LPCSTR;
    dwStyle                                              : uint32;
    lpszIcon                                             : LPCSTR;
    dwContextHelpId                                      : nativeuint;
    lpfnMsgBoxCallback                                   : MsgBoxCallback;
    dwLanguageId                                         : uint32;
  end;

  MsgBoxParamsW = record
    cbSize                                               : uint32;
    hwndOwner                                            : HWND;
    hInstance                                            : HInstance;
    lpszText                                             : LPCWSTR;
    lpszCaption                                          : LPCWSTR;
    dwStyle                                              : uint32;
    lpszIcon                                             : LPCWSTR;
    dwContextHelpId                                      : nativeuint;
    lpfnMsgBoxCallback                                   : MsgBoxCallback;
    dwLanguageId                                         : uint32;
  end;

  MouseInput = record
    dx                                                   : int32;
    dy                                                   : int32;
    mouseData                                            : uint32;
    dwFlags                                              : uint32;
    time                                                 : uint32;
    dwExtraInfo                                          : nativeuint;
  end;

  KeyBdInput = record
    wVk                                                  : uint16;
    wScan                                                : uint16;
    dwFlags                                              : uint32;
    time                                                 : uint32;
    dwExtraInfo                                          : nativeuint;
  end;

  HardwareInput = record
    uMsg                                                 : uint32;
    wParamL                                              : uint16;
    wParamH                                              : uint16;
  end;

  Input = record
    type_                                                : uint32;
    case int32 of
      0: ( mi                                            : MouseInput );
      1: ( ki                                            : KeyBdInput );
      2: ( hi                                            : HardwareInput );
  end;

  _TrackMouseEvent = record
    cbSize                                               : uint32;
    dwFlags                                              : uint32;
    hwndTrack                                            : HWND;
    dwHoverTime                                          : uint32;
  end;

  TPMParams = record
    cbSize                                               : uint32;
    rcExclude                                            : Rect;
  end;
  PTPMParams = ^TPMParams;

  PaletteEntry = record
    peRed                                                : uint8;
    peGreen                                              : uint8;
    peBlue                                               : uint8;
    peFlags                                              : uint8;
  end;
  PPaletteEntry = ^PaletteEntry;

  XForm = record
    eM11                                                 : single;
    eM12                                                 : single;
    eM21                                                 : single;
    eM22                                                 : single;
    eDx                                                  : single;
    eDy                                                  : single;
  end;
  PXForm = ^XForm;

  Bitmap = record
    bmType                                               : int32;
    bmWidth                                              : int32;
    bmHeight                                             : int32;
    bmWidthBytes                                         : int32;
    bmPlanes                                             : uint16;
    bmBitsPixel                                          : uint16;
    bmBits                                               : pointer;
  end;

  LogBrush = record
    lbStyle                                              : uint32;
    lbColor                                              : COLORREF;
    lbHatch                                              : nativeuint;
  end;

  CIEXYZ = record
    ciexyzX                                              : FXPT2DOT30;
    ciexyzY                                              : FXPT2DOT30;
    ciexyzZ                                              : FXPT2DOT30;
  end;

  CIEXYZTriple = record
    ciexyzRed                                            : CIEXYZ;
    ciexyzGreen                                          : CIEXYZ;
    ciexyzBlue                                           : CIEXYZ;
  end;

  LogColorSpaceA = record
    lcsSignature                                         : uint32;
    lcsVersion                                           : uint32;
    lcsSize                                              : uint32;
    lcsCSType                                            : LCSCSTYPE;
    lcsIntent                                            : LCSGAMUTMATCH;
    lcsEndpoints                                         : CIEXYZTriple;
    lcsGammaRed                                          : uint32;
    lcsGammaGreen                                        : uint32;
    lcsGammaBlue                                         : uint32;
    lcsFilename                                          : array [0..MAX_PATH - 1] of AnsiChar;
  end;

  LogColorSpaceW = record
    lcsSignature                                         : uint32;
    lcsVersion                                           : uint32;
    lcsSize                                              : uint32;
    lcsCSType                                            : LCSCSTYPE;
    lcsIntent                                            : LCSGAMUTMATCH;
    lcsEndpoints                                         : CIEXYZTriple;
    lcsGammaRed                                          : uint32;
    lcsGammaGreen                                        : uint32;
    lcsGammaBlue                                         : uint32;
    lcsFilename                                          : array [0..MAX_PATH - 1] of WideChar;
  end;

  BitmapInfoHeader = record
    biSize                                               : uint32;
    biWidth                                              : int32;
    biHeight                                             : int32;
    biPlanes                                             : uint16;
    biBitCount                                           : uint16;
    biCompression                                        : uint32;
    biSizeImage                                          : uint32;
    biXPelsPerMeter                                      : int32;
    biYPelsPerMeter                                      : int32;
    biClrUsed                                            : uint32;
    biClrImportant                                       : uint32;
  end;

  RGBQuad = record
    rgbBlue                                              : uint8;
    rgbGreen                                             : uint8;
    rgbRed                                               : uint8;
    rgbReserved                                          : uint8;
  end;

  BitmapInfo = record
    bmiHeader                                            : BitmapInfoHeader;
    bmiColors                                            : array [0..0] of RGBQuad;
  end;

  LogFontA = record
    lfHeight                                             : int32;
    lfWidth                                              : int32;
    lfEscapement                                         : int32;
    lfOrientation                                        : int32;
    lfWeight                                             : int32;
    lfItalic                                             : uint8;
    lfUnderline                                          : uint8;
    lfStrikeOut                                          : uint8;
    lfCharSet                                            : uint8;
    lfOutPrecision                                       : uint8;
    lfClipPrecision                                      : uint8;
    lfQuality                                            : uint8;
    lfPitchAndFamily                                     : uint8;
    lfFaceName                                           : array [0..LF_FACESIZE - 1] of AnsiChar;
  end;
  PLogFontA = ^LogFontA;

  LogFontW = record
    lfHeight                                             : int32;
    lfWidth                                              : int32;
    lfEscapement                                         : int32;
    lfOrientation                                        : int32;
    lfWeight                                             : int32;
    lfItalic                                             : uint8;
    lfUnderline                                          : uint8;
    lfStrikeOut                                          : uint8;
    lfCharSet                                            : uint8;
    lfOutPrecision                                       : uint8;
    lfClipPrecision                                      : uint8;
    lfQuality                                            : uint8;
    lfPitchAndFamily                                     : uint8;
    lfFaceName                                           : array [0..LF_FACESIZE - 1] of WideChar;
  end;
  PLogFontW = ^LogFontW;

  DesignVector = record
    dvReserved                                           : uint32;
    dvNumAxes                                            : uint32;
    dvValues                                             : array [0..MM_MAX_NUMAXES - 1] of int32;
  end;

  EnumLogFontExA = record
    elfLogFont                                           : LogFontA;
    elfFullName                                          : array [0..LF_FULLFACESIZE - 1] of uint8;
    elfStyle                                             : array [0..LF_FACESIZE - 1] of uint8;
    elfScript                                            : array [0..LF_FACESIZE - 1] of uint8;
  end;

  EnumLogFontExW = record
    elfLogFont                                           : LogFontW;
    elfFullName                                          : array [0..LF_FULLFACESIZE - 1] of WideChar;
    elfStyle                                             : array [0..LF_FACESIZE - 1] of WideChar;
    elfScript                                            : array [0..LF_FACESIZE - 1] of WideChar;
  end;

  EnumLogFontExDvA = record
    elfEnumLogfontEx                                     : EnumLogFontExA;
    elfDesignVector                                      : DesignVector;
  end;
  PEnumLogFontExDvA = ^EnumLogFontExDvA;

  EnumLogFontExDvW = record
    elfEnumLogfontEx                                     : EnumLogFontExW;
    elfDesignVector                                      : DesignVector;
  end;
  PEnumLogFontExDvW = ^EnumLogFontExDvW;

  LogPalette = record
    palVersion                                           : uint16;
    palNumEntries                                        : uint16;
    palPalEntry                                          : array [0..0] of PaletteEntry;
  end;

  LogPen = record
    lopnStyle                                            : uint32;
    lopnWidth                                            : POINT;
    lopnColor                                            : COLORREF;
  end;

  HandleTable = record
    objecHandle                                          : array [0..0] of HGDIOBJ;
  end;
  PHandleTable = ^HandleTable;

  ENHMetaRecord = record
    iType                                                : uint32;
    nSize                                                : uint32;
    dParm                                                : array [0..0] of uint32;
  end;
  PENHMetaRecord = ^ENHMetaRecord;
  EnhMetaFileProc                                        = function  ( hdc: HDC; lpHTable: PHandleTable; lpEMFR: PENHMetaRecord; nObj: int32; lpData: LPARAM ): int32; stdcall;

  TextMetricA = record
    tmHeight                                             : int32;
    tmAscent                                             : int32;
    tmDescent                                            : int32;
    tmInternalLeading                                    : int32;
    tmExternalLeading                                    : int32;
    tmAveCharWidth                                       : int32;
    tmMaxCharWidth                                       : int32;
    tmWeight                                             : int32;
    tmOverhang                                           : int32;
    tmDigitizedAspectX                                   : int32;
    tmDigitizedAspectY                                   : int32;
    tmFirstChar                                          : uint8;
    tmLastChar                                           : uint8;
    tmDefaultChar                                        : uint8;
    tmBreakChar                                          : uint8;
    tmItalic                                             : uint8;
    tmUnderlined                                         : uint8;
    tmStruckOut                                          : uint8;
    tmPitchAndFamily                                     : uint8;
    tmCharSet                                            : uint8;
  end;
  PTextMetricA = ^TextMetricA;
  EnumFontsProcA                                          = function  ( lpelf: PLogFontA; lpntm: PTextMetricA; FontType: uint32; lParam: LPARAM ): int32; stdcall;

  TextMetricW = record
    tmHeight                                              : int32;
    tmAscent                                              : int32;
    tmDescent                                             : int32;
    tmInternalLeading                                     : int32;
    tmExternalLeading                                     : int32;
    tmAveCharWidth                                        : int32;
    tmMaxCharWidth                                        : int32;
    tmWeight                                              : int32;
    tmOverhang                                            : int32;
    tmDigitizedAspectX                                    : int32;
    tmDigitizedAspectY                                    : int32;
    tmFirstChar                                           : WideChar;
    tmLastChar                                            : WideChar;
    tmDefaultChar                                         : WideChar;
    tmBreakChar                                           : WideChar;
    tmItalic                                              : uint8;
    tmUnderlined                                          : uint8;
    tmStruckOut                                           : uint8;
    tmPitchAndFamily                                      : uint8;
    tmCharSet                                             : uint8;
  end;
  PTextMetricW = ^TextMetricW;
  EnumFontsProcW                                          = function  ( lpelf: PLogFontW; lpntm: PTextMetricW; FontType: uint32; lParam: LPARAM ): int32; stdcall;

  MetaRecord = record
    rdSize                                                : uint32;
    rdFunction                                            : uint16;
    rdParm                                                : array [0..0] of uint16;
  end;
  PMetaRecord = ^MetaRecord;
  EnumMetaFileProc                                        = function  ( hdc: HDC; lpHTable: PHandleTable; lpMFR: PMetaRecord; nObj: int32; lpClientData: LPARAM ): int32; stdcall;

  RGNDataHeader = record
    dwSize                                                : uint32;
    iType                                                 : uint32;
    nCount                                                : uint32;
    nRgnSize                                              : uint32;
    rcBound                                               : Rect;
  end;

  RGNData = record
    rdh                                                   : RGNDataHeader;
    Buffer                                                : array [0..0] of AnsiChar;
  end;
  PRGNData = ^RGNData;

  Size = record
    cx                                                    : int32;
    cy                                                    : int32;
  end;
  PSize = ^Size;

  GCP_ResultsA = record
    lStructSize                                           : uint32;
    lpOutString                                           : LPSTR;
    lpOrder                                               : ^uint32;
    lpDx                                                  : ^int32;
    lpCaretPos                                            : ^int32;
    lpClass                                               : LPSTR;
    lpGlyphs                                              : LPWSTR;
    nGlyphs                                               : uint32;
    nMaxFit                                               : int32;
  end;

  GCP_ResultsW = record
    lStructSize                                           : uint32;
    lpOutString                                           : LPWSTR;
    lpOrder                                               : ^uint32;
    lpDx                                                  : ^int32;
    lpCaretPos                                            : ^int32;
    lpClass                                               : LPSTR;
    lpGlyphs                                              : LPWSTR;
    nGlyphs                                               : uint32;
    nMaxFit                                               : int32;
  end;

  ColorAdjustment = record
    caSize                                                : uint16;
    caFlags                                               : uint16;
    caIlluminantIndex                                     : uint16;
    caRedGamma                                            : uint16;
    caGreenGamma                                          : uint16;
    caBlueGamma                                           : uint16;
    caReferenceBlack                                      : uint16;
    caReferenceWhite                                      : uint16;
    caContrast                                            : int16;
    caBrightness                                          : int16;
    caColorfulness                                        : int16;
    caRedGreenTint                                        : int16;
  end;

  EnhMetaHeader = record
    iType                                                 : uint32;
    nSize                                                 : uint32;
    rclBounds                                             : Rect;
    rclFrame                                              : Rect;
    dSignature                                            : uint32;
    nVersion                                              : uint32;
    nBytes                                                : uint32;
    nRecords                                              : uint32;
    nHandles                                              : uint16;
    sReserved                                             : uint16;
    nDescription                                          : uint32;
    offDescription                                        : uint32;
    nPalEntries                                           : uint32;
    szlDevice                                             : Size;
    szlMillimeters                                        : Size;
    cbPixelFormat                                         : uint32;
    offPixelFormat                                        : uint32;
    bOpenGL                                               : uint32;
    szlMicrometers                                        : Size;
  end;
  PEnhMetaHeader = ^EnhMetaHeader;

  WCRange = record
    wcLow                                                 : Widechar;
    cGlyphs                                               : uint16;
  end;

  GlyphSet = record
    cbThis                                                : uint32;
    flAccel                                               : uint32;
    cGlyphsSupported                                      : uint32;
    cRanges                                               : uint32;
    ranges                                                : array [0..0] of WCRange;
  end;
  PGlyphSet = ^GlyphSet;

  GlyphMetrics = record
    gmBlackBoxX                                           : uint32;
    gmBlackBoxY                                           : uint32;
    gmptGlyphOrigin                                       : Point;
    gmCellIncX                                            : int16;
    gmCellIncY                                            : int16;
  end;

  Fixed = record
    fract                                                 : uint16;
    value                                                 : int16;
  end;

  MAT2 = record
    eM11                                                  : Fixed;
    eM12                                                  : Fixed;
    eM21                                                  : Fixed;
    eM22                                                  : Fixed;
  end;

  RasterizerStatus = record
    nSize                                                 : int16;
    wFlags                                                : int16;
    nLanguageID                                           : int16;
  end;

  FontSignature = record
    fsUsb                                                 : array [0..3] of uint32;
    fsCsb                                                 : array [0..1] of uint32;
  end;
  PFontSignature = ^FontSignature;

  PolyTextA = record
    x                                                     : uint32;
    y                                                     : uint32;
    n                                                     : uint32;
    lpstr                                                 : LPCSTR;
    uiFlags                                               : uint32;
    rcl                                                   : Rect;
    pdx                                                   : ^int32;
  end;
  PPolyTextA = ^PolyTextA;

  PolyTextW = record
    x                                                     : uint32;
    y                                                     : uint32;
    n                                                     : uint32;
    lpstr                                                 : LPCWSTR;
    uiFlags                                               : uint32;
    rcl                                                   : Rect;
    pdx                                                   : ^int32;
  end;
  PPolyTextW = ^PolyTextW;

  MetaFilePicT = record
    mm                                                    : int32;
    xExt                                                  : int32;
    yExt                                                  : int32;
    hMF                                                   : HMETAFILE;
  end;

  DocInfoA = record
    cbSize                                                : int32;
    lpszDocName                                           : LPCSTR;
    lpszOutput                                            : LPCSTR;
    lpszDatatype                                          : LPCSTR;
    fwType                                                : uint32;
  end;

  DocInfoW = record
    cbSize                                                : int32;
    lpszDocName                                           : LPCWSTR;
    lpszOutput                                            : LPCWSTR;
    lpszDatatype                                          : LPCWSTR;
    fwType                                                : uint32;
  end;

  CharsetInfo = record
    ciCharset                                             : uint32;
    ciACP                                                 : uint32;
    fs                                                    : FontSignature;
  end;

  SRWLOCK = record
    ptr                                                   : pointer;
  end;

  CONDITION_VARIABLE = SRWLOCK;

  MonitorInfo = record
    cbSize                                                : uint32;
    rcMonitor                                             : Rect;
    rcWork                                                : Rect;
    dwFlags                                               : uint32;
  end;

  MonitorInfoEx = record
    cbSize                                                : uint32;
    rcMonitor                                             : Rect;
    rcWork                                                : Rect;
    dwFlags                                               : uint32;
    szDevice                                              : array[ 0..pred(CCHDEVICENAME) ] of widechar;
  end;
  pMonitorInfoEx = ^MonitorInfoEx;

  LAYERPLANEDESCRIPTOR = record
    nSize                                                 : uint16;
    nVersion                                              : uint16;
    dwFlags                                               : uint32;
    iPixelType                                            : uint8;
    cColorBits                                            : uint8;
    cRedBits                                              : uint8;
    cRedShift                                             : uint8;
    cGreenBits                                            : uint8;
    cGreenShift                                           : uint8;
    cBlueBits                                             : uint8;
    cBlueShift                                            : uint8;
    cAlphaBits                                            : uint8;
    cAlphaShift                                           : uint8;
    cAccumBits                                            : uint8;
    cAccumRedBits                                         : uint8;
    cAccumGreenBits                                       : uint8;
    cAccumBlueBits                                        : uint8;
    cAccumAlphaBits                                       : uint8;
    cDepthBits                                            : uint8;
    cStencilBits                                          : uint8;
    cAuxBuffers                                           : uint8;
    iLayerPlane                                           : uint8;
    bReserved                                             : uint8;
    crTransparent                                         : COLORREF;
  end;
  PLAYERPLANEDESCRIPTOR = ^LAYERPLANEDESCRIPTOR;

  PointFloat = record
    x                                                     : single;
    y                                                     : single;
  end;

  GLYPHMETRICSFLOAT = record
    gmfBlackBoxX                                          : single;
    gmfBlackBoxY                                          : single;
    gmfptGlyphOrigin                                      : PointFloat;
    gmfCellIncX                                           : single;
    gmfCellIncY                                           : single;
  end;
  PGLYPHMETRICSFLOAT = ^GLYPHMETRICSFLOAT;

  TSockLen = int32;
  TIntAddr = uint32;

  TSockAddr = record
    sa_family: uint16;
    sa_data: array [0..13] of uint8;
    padding: array[0..15] of uint8;
  end;
  pTSockAddr = ^TSockAddr;

  TInAddr = record
    b1: uint8;
    b2: uint8;
    b3: uint8;
    b4: uint8;
  end;

  TSockAddrIn = record
    sin_family: int16;
      sin_port: uint16;
      sin_addr: TInAddr;
      sin_zero: array [0..7] of uint8; // ansichars
  end;

  TInAddr6 = record
    case integer of
      1: ( addr8: array [0..15] of uint8);
      2: (addr16: array [0..7]  of uint16);
      3: (addr32: array [0..3]  of int32);
  end;

  TSockAddrIn6 = record
      sin_family: int16;
        sin_port: uint16;
    sin_flowinfo: uint16;
        sin_addr: TInAddr6;
    sin_scope_id: uint32;
  end;

    function  GetMonitorInfoW                             ( hMonitor: HMonitor; mi: pMonitorInfoEx ): LongBool; stdcall; external cLibName name 'GetMonitorInfoW';
    function  EnumDisplayMonitors                         ( hdc: HDC; lprcClip: pRect; lpfnEnum: MonitorEnumProc; dwParam: LPARAM ): longbool; stdcall; external cLibName name 'EnumDisplayMonitors';
    function  ActivateKeyboardLayout                      ( hkl: HKL; Flags: uint32 ): HKL; stdcall; external cLibName name 'ActivateKeyboardLayout';
    function  AdjustWindowRect                            ( var lpRect: Rect; dwStyle: uint32; bMenu: Bool ): Bool; stdcall; external cLibName name 'AdjustWindowRect';
    function  AdjustWindowRectEx                          ( var lpRect: Rect; dwStyle: uint32; bMenu: Bool; dwExStyle: uint32 ): Bool; stdcall; external cLibName name 'AdjustWindowRectEx';
    function  AnimateWindow                               ( hWnd: HWND; dwTime: uint32; dwFlags: uint32 ): Bool; stdcall; external cLibName name 'AnimateWindow';
    function  AnyPopup                                    ( ): Bool; stdcall; external cLibName name 'AnyPopup';
    function  AppendMenuA                                 ( hMenu: HMENU; uFlags, uIDNewItem: uint32; lpNewItem: PAnsiChar ): Bool; stdcall; external cLibName name 'AppendMenuA';
    function  AppendMenuW                                 ( hMenu: HMENU; uFlags, uIDNewItem: uint32; lpNewItem: PWideChar ): Bool; stdcall; external cLibName name 'AppendMenuW';
    function  ArrangeIconicWindows                        ( hWnd: HWND ): uint32; stdcall; external cLibName name 'ArrangeIconicWindows';
    function  AttachThreadInput                           ( idAttach, idAttachTo: uint32; fAttach: Bool ): Bool; stdcall; external cLibName name 'AttachThreadInput';
    function  BeginDeferWindowPos                         ( nNumWindows: int32 ): HDWP; stdcall; external cLibName name 'BeginDeferWindowPos';
    function  BeginPaint                                  ( hWindow: HWND; out Paint: PaintStruct ): HDC; stdcall; external cLibName name 'BeginPaint';
    function  BringWindowToTop                            ( hWnd: HWND ): Bool; stdcall; external cLibName name 'BringWindowToTop';
    function  BroadcastSystemMessageA                     ( Flags: uint32; out Info: uint32; message: uint32; wParam: WPARAM; lParam: LPARAM ): int32; stdcall; external cLibName name 'BroadcastSystemMessageA';
    function  BroadcastSystemMessageW                     ( Flags: uint32; out Info: uint32; message: uint32; wParam: WPARAM; lParam: LPARAM ): int32; stdcall; external cLibName name 'BroadcastSystemMessageW';
    function  CallMsgFilterA                              ( var lpMsg: Msg; nCode: int32 ): Bool; stdcall; external cLibName name 'CallMsgFilterA';
    function  CallMsgFilterW                              ( var lpMsg: Msg; nCode: int32 ): Bool; stdcall; external cLibName name 'CallMsgFilterW';
    function  CallNextHookEx                              ( hhk: HHOOK; nCode: int32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'CallNextHookEx';
    function  CallWindowProcA                             ( lpPrevWndFunc: WndProc; hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'CallWindowProcA';
    function  CallWindowProcW                             ( lpPrevWndFunc: WndProc; hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'CallWindowProcW';
    function  CascadeWindows                              ( hwndParent: HWND; wHow: uint32; lpRect: PRect; cKids: uint32; lpKids: Pointer ): uint16; stdcall; external cLibName name 'CascadeWindows';
    function  ChangeClipboardChain                        ( hWndRemove, hWndNewNext: HWND ): Bool; stdcall; external cLibName name 'ChangeClipboardChain';
    function  ChangeDisplaySettingsA                      ( var lpDevMode: DeviceModeA; dwFlags: uint32 ): int32; stdcall; external cLibName name 'ChangeDisplaySettingsA';
    function  ChangeDisplaySettingsW                      ( var lpDevMode: DeviceModeW; dwFlags: uint32 ): int32; stdcall; external cLibName name 'ChangeDisplaySettingsW';
    function  ChangeDisplaySettingsExA                    ( lpszDeviceName: PAnsiChar; var lpDevMode: DeviceModeA; wnd: HWND; dwFlags: uint32; lParam: Pointer ): int32; stdcall; external cLibName name 'ChangeDisplaySettingsExA';
    function  ChangeDisplaySettingsExW                    ( lpszDeviceName: PWideChar; var lpDevMode: DeviceModeW; wnd: HWND; dwFlags: uint32; lParam: Pointer ): int32; stdcall; external cLibName name 'ChangeDisplaySettingsExW';
    function  ChangeMenuA                                 ( hMenu: HMENU; cmd: uint32; lpszNewItem: PAnsiChar; cmdInsert: uint32; flags: uint32 ): Bool; stdcall; external cLibName name 'ChangeMenuA';
    function  ChangeMenuW                                 ( hMenu: HMENU; cmd: uint32; lpszNewItem: PWideChar; cmdInsert: uint32; flags: uint32 ): Bool; stdcall; external cLibName name 'ChangeMenuW';
    function  CharLowerA                                  ( lpsz: PAnsiChar ): PAnsiChar; stdcall; external cLibName name 'CharLowerA';
    function  CharLowerW                                  ( lpsz: PWideChar ): PWideChar; stdcall; external cLibName name 'CharLowerW';
    function  CharLowerBuffA                              ( lpsz: PAnsiChar; cchLength: uint32 ): uint32; stdcall; external cLibName name 'CharLowerBuffA';
    function  CharLowerBuffW                              ( lpsz: PWideChar; cchLength: uint32 ): uint32; stdcall; external cLibName name 'CharLowerBuffW';
    function  CharNextA                                   ( lpsz: PAnsiChar ): PAnsiChar; stdcall; external cLibName name 'CharNextA';
    function  CharNextW                                   ( lpsz: PWideChar ): PWideChar; stdcall; external cLibName name 'CharNextW';
    function  CharNextExA                                 ( CodePage: uint16; lpCurrentChar: LPCSTR; dwFlags: uint32 ): LPSTR; stdcall; external cLibName name 'CharNextExA';
    function  CharPrevA                                   ( lpszStart: PAnsiChar; lpszCurrent: PAnsiChar ): PAnsiChar; stdcall; external cLibName name 'CharPrevA';
    function  CharPrevW                                   ( lpszStart: PWideChar; lpszCurrent: PWideChar ): PWideChar; stdcall; external cLibName name 'CharPrevW';
    function  CharPrevExA                                 ( CodePage: uint16; lpStart, lpCurrentChar: LPCSTR; dwFlags: uint32 ): LPSTR; stdcall; external cLibName name 'CharPrevExA';
    function  CharToOem                                   ( lpszSrc: PAnsiChar; lpszDst: PAnsiChar ): Bool; stdcall; external cLibName name 'CharToOemA';
    function  CharToOemBuffA                              ( lpszSrc: PAnsiChar; lpszDst: PAnsiChar; cchDstLength: uint32 ): Bool; stdcall; external cLibName name 'CharToOemBuffA';
    function  CharToOemBuffW                              ( lpszSrc: PWideChar; lpszDst: PWideChar; cchDstLength: uint32 ): Bool; stdcall; external cLibName name 'CharToOemBuffW';
    function  CharToOemW                                  ( lpszSrc: PWideChar; lpszDst: PWideChar ): Bool; stdcall; external cLibName name 'CharToOemW';
    function  CharUpperA                                  ( lpsz: PAnsiChar ): PAnsiChar; stdcall; external cLibName name 'CharUpperA';
    function  CharUpperBuffA                              ( lpsz: PAnsiChar; cchLength: uint32 ): uint32; stdcall; external cLibName name 'CharUpperBuffA';
    function  CharUpperBuffW                              ( lpsz: PWideChar; cchLength: uint32 ): uint32; stdcall; external cLibName name 'CharUpperBuffW';
    function  CharUpperW                                  ( lpsz: PWideChar ): PWideChar; stdcall; external cLibName name 'CharUpperW';
    function  CheckDlgButton                              ( hDlg: HWND; nIDButton: int32; uCheck: uint32 ): Bool; stdcall; external cLibName name 'CheckDlgButton';
    function  CheckMenuItem                               ( hMenu: HMENU; uIDCheckItem, uCheck: uint32 ): uint32; stdcall; external cLibName name 'CheckMenuItem';
    function  CheckMenuRadioItem                          ( hMenu: HMENU; First, Last, Check, Flags: uint32 ): Bool; stdcall; external cLibName name 'CheckMenuRadioItem';
    function  CheckRadioButton                            ( hDlg: HWND; nIDFirstButton, nIDLastButton, nIDCheckButton: int32 ): Bool; stdcall; external cLibName name 'CheckRadioButton';
    function  ChildWindowFromPoint                        ( hWndParent: HWND; Point: Point ): HWND; stdcall; external cLibName name 'ChildWindowFromPoint';
    function  ChildWindowFromPointEx                      ( hWnd: HWND; Point: Point; Flags: uint32 ): HWND; stdcall; external cLibName name 'ChildWindowFromPointEx';
    function  ClientToScreen                              ( hWnd: HWND; var lpPoint: Point ): Bool; stdcall; external cLibName name 'ClientToScreen';
    function  ClipCursor                                  ( lpRect: PRect ): Bool; stdcall; external cLibName name 'ClipCursor';
    function  CloseClipboard                              ( ): Bool; stdcall; external cLibName name 'CloseClipboard';
    function  CloseDesktop                                ( hDesktop: HDESK ): Bool; stdcall; external cLibName name 'CloseDesktop';
    function  CloseWindow                                 ( hWnd: HWND ): Bool; stdcall; external cLibName name 'CloseWindow';
    function  CloseWindowStation                          ( hWinSta: HWINSTA ): Bool; stdcall; external cLibName name 'CloseWindowStation';
    function  CopyAcceleratorTableA                       ( hAccelSrc: HACCEL; var lpAccelDst; cAccelEntries: int32 ): int32; stdcall; external cLibName name 'CopyAcceleratorTableA';
    function  CopyAcceleratorTableW                       ( hAccelSrc: HACCEL; var lpAccelDst; cAccelEntries: int32 ): int32; stdcall; external cLibName name 'CopyAcceleratorTableW';
    function  CopyIcon                                    ( hIcon: HICON ): HICON; stdcall; external cLibName name 'CopyIcon';
    function  CopyImage                                   ( hImage: winHandle; ImageType: uint32; X, Y: int32; Flags: uint32 ): winHandle; stdcall; external cLibName name 'CopyImage';
    function  CopyRect                                    ( var lprcDst: Rect; const lprcSrc: Rect ): Bool; stdcall; external cLibName name 'CopyRect';
    function  CountClipboardFormats                       ( ):int32; stdcall; external cLibName name 'CountClipboardFormats';
    function  CreateAcceleratorTableA                     ( var Accel; Count: int32 ): HACCEL; stdcall; external cLibName name 'CreateAcceleratorTableA';
    function  CreateAcceleratorTableW                     ( var Accel; Count: int32 ): HACCEL; stdcall; external cLibName name 'CreateAcceleratorTableW';
    function  CreateCaret                                 ( hWnd: HWND; hBitmap: HBITMAP; nWidth, nHeight: int32 ): Bool; stdcall; external cLibName name 'CreateCaret';
    function  CreateCursor                                ( hInst: HINST; xHotSpot, yHotSpot, nWidth, nHeight: int32; pvANDPlaneter, pvXORPlane: Pointer ): HCURSOR; stdcall; external cLibName name 'CreateCursor';
    function  CreateDesktopA                              ( lpszDesktop, lpszDevice: PAnsiChar; pDevmode: PDeviceModeA; dwFlags: uint32; dwDesiredAccess: uint32; lpsa: PSecurityAttributes ): HDESK; stdcall; external cLibName name 'CreateDesktopA';
    function  CreateDesktopW                              ( lpszDesktop, lpszDevice: PWideChar; pDevmode: PDeviceModeW; dwFlags: uint32; dwDesiredAccess: uint32; lpsa: PSecurityAttributes ): HDESK; stdcall; external cLibName name 'CreateDesktopW';
    function  CreateDialogIndirectParamA                  ( hInstance: HINST; const lpTemplate: DlgTemplate; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateDialogIndirectParamA';
    function  CreateDialogIndirectParamW                  ( hInstance: HINST; const lpTemplate: DlgTemplate; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateDialogIndirectParamW';
    function  CreateDialogParamA                          ( hInstance: HINST; lpTemplateName: PAnsiChar; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateDialogParamA';
    function  CreateDialogParamW                          ( hInstance: HINST; lpTemplateName: PWideChar; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateDialogParamW';
    function  CreateIcon                                  ( hInstance: HINST; nWidth, nHeight: int32; cPlanes, cBitsPixel: uint8; lpbANDbits, lpbXORbits: Pointer): HICON; stdcall; external cLibName name 'CreateIcon';
    function  CreateIconFromResource                      ( presbits: puint8; dwResSize: uint32; fIcon: Bool; dwVer: uint32 ): HICON; stdcall; external cLibName name 'CreateIconFromResource';
    function  CreateIconFromResourceEx                    ( presbits: puint8; dwResSize: uint32; fIcon: Bool; dwVer: uint32; cxDesired, cyDesired: int32; Flags: uint32 ): HICON; stdcall; external cLibName name 'CreateIconFromResourceEx';
    function  CreateIconIndirect                          ( var piconinfo: IconInfo ): HICON; stdcall; external cLibName name 'CreateIconIndirect';
    function  CreateMDIWindowA                            ( lpClassName, lpWindowName: PAnsiChar; dwStyle: uint32; X, Y, nWidth, nHeight: int32; hWndParent: HWND; hInstance: HINST; lParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateMDIWindowA';
    function  CreateMDIWindowW                            ( lpClassName, lpWindowName: PWideChar; dwStyle: uint32; X, Y, nWidth, nHeight: int32; hWndParent: HWND; hInstance: HINST; lParam: LPARAM ): HWND; stdcall; external cLibName name 'CreateMDIWindowW';
    function  CreateMenu                                  (  ): HMENU; stdcall; external cLibName name 'CreateMenu';
    function  CreatePopupMenu                             (  ): HMENU; stdcall; external cLibName name 'CreatePopupMenu';
    function  CreateWindowExA                             ( dwExStyle: uint32; lpClassName: PAnsiChar; lpWindowName: PAnsiChar; dwStyle: uint32; X, Y, nWidth, nHeight: int32; hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer ): HWND; stdcall; external cLibName name 'CreateWindowExA';
    function  CreateWindowExW                             ( dwExStyle: uint32; lpClassName: PWideChar; lpWindowName: PWideChar; dwStyle: uint32; X, Y, nWidth, nHeight: int32; hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer ): HWND; stdcall; external cLibName name 'CreateWindowExW';
    function  CreateWindowStationA                        ( lpwinsta: PAnsiChar; dwReserved, dwDesiredAccess: uint32; lpsa: PSecurityAttributes ): HWINSTA; stdcall; external cLibName name 'CreateWindowStationA';
    function  CreateWindowStationW                        ( lpwinsta: PWideChar; dwReserved, dwDesiredAccess: uint32; lpsa: PSecurityAttributes ): HWINSTA; stdcall; external cLibName name 'CreateWindowStationW';
    function  DdeAbandonTransaction                       ( Inst: uint32; Conv: HConv; Transaction: uint32 ): Bool; stdcall; external cLibName name 'DdeAbandonTransaction';
    function  DdeAccessData                               ( Data: HDDEData; var DataSize: uint32 ): Pointer; stdcall; external cLibName name 'DdeAccessData';
    function  DdeAddData                                  ( Data: HDDEData; Src: Pointer; cb, Off: uint32 ): HDDEData; stdcall; external cLibName name 'DdeAddData';
    function  DdeClientTransaction                        ( Data: Pointer; DataLen: uint32; Conv: HConv; Item: HSZ; Fmt, DataType: uint32; Timeout: uint32; var Result: uint32 ): HDDEData; stdcall; external cLibName name 'DdeClientTransaction';
    function  DdeCmpStringHandles                         ( hsz1, hsz2: HSZ ): int32; stdcall; external cLibName name 'DdeCmpStringHandles';
    function  DdeConnect                                  ( Inst: uint32; Service, Topic: HSZ; CC: PConvContext ): HConv; stdcall; external cLibName name 'DdeConnect';
    function  DdeConnectList                              ( Inst: uint32; Service, Topic: HSZ; ConvList: HConvList; CC: PConvContext ): HConvList; stdcall; external cLibName name 'DdeConnectList';
    function  DdeCreateDataHandle                         ( Inst: uint32; Src: Pointer; cb, Off: uint32; Item: HSZ; Fmt, Cmd: uint32 ): HDDEData; stdcall; external cLibName name 'DdeCreateDataHandle';
    function  DdeCreateStringHandleA                      ( Inst: uint32; psz: PAnsiChar; CodePage: int32 ): HSZ; stdcall; external cLibName name 'DdeCreateStringHandleA';
    function  DdeCreateStringHandleW                      ( Inst: uint32; psz: PWideChar; CodePage: int32 ): HSZ; stdcall; external cLibName name 'DdeCreateStringHandleW';
    function  DdeDisconnect                               ( Conv: HConv ): Bool; stdcall; external cLibName name 'DdeDisconnect';
    function  DdeDisconnectList                           ( ConvList: HConvList ): Bool; stdcall; external cLibName name 'DdeDisconnectList';
    function  DdeEnableCallback                           ( Inst: uint32; Conv: HConv; Cmd: uint32 ): Bool; stdcall; external cLibName name 'DdeEnableCallback';
    function  DdeFreeDataHandle                           ( Data: HDDEData ): Bool; stdcall; external cLibName name 'DdeFreeDataHandle';
    function  DdeFreeStringHandle                         ( Inst: uint32; HSZ: HSZ ): Bool; stdcall; external cLibName name 'DdeFreeStringHandle';
    function  DdeGetData                                  ( Data: HDDEData; Dst: Pointer; Max, Off: uint32 ): uint32; stdcall; external cLibName name 'DdeGetData';
    function  DdeGetLastError                             ( Inst: uint32 ): uint32; stdcall; external cLibName name 'DdeGetLastError';
    function  DdeInitializeA                              ( var Inst: int32; Callback: DDECallback; Cmd, Res: int32 ): int32; stdcall; external cLibName name 'DdeInitializeA';
    function  DdeInitializeW                              ( var Inst: int32; Callback: DDECallback; Cmd, Res: int32 ): int32; stdcall; external cLibName name 'DdeInitializeW';
    function  DdeKeepStringHandle                         ( Inst: uint32; HSZ: HSZ ): Bool; stdcall; external cLibName name 'DdeKeepStringHandle';
    function  DdeNameService                              ( Inst: uint32; hsz1, hsz2: HSZ; Cmd: uint32 ): HDDEData; stdcall; external cLibName name 'DdeNameService';
    function  DdePostAdvise                               ( Inst: uint32; Topic, Item: HSZ ): Bool; stdcall; external cLibName name 'DdePostAdvise';
    function  DdeQueryConvInfo                            ( Conv: HConv; Transaction: uint32; ConvInfo: PConvInfo ): uint32; stdcall; external cLibName name 'DdeQueryConvInfo';
    function  DdeQueryNextServer                          ( ConvList: HConvList; ConvPrev: HConv ): HConv; stdcall; external cLibName name 'DdeQueryNextServer';
    function  DdeQueryStringA                             ( Inst: uint32; HSZ: HSZ; psz: PAnsiChar; Max: uint32; CodePage: int32 ): uint32; stdcall; external cLibName name 'DdeQueryStringA';
    function  DdeQueryStringW                             ( Inst: uint32; HSZ: HSZ; psz: PWideChar; Max: uint32; CodePage: int32 ): uint32; stdcall; external cLibName name 'DdeQueryStringW';
    function  DdeReconnect                                ( Conv: HConv ): HConv; stdcall; external cLibName name 'DdeReconnect';
    function  DdeSetQualityOfService                      ( hWndClient: HWnd; const pqosNew: SECURITY_QUALITY_OF_SERVICE; pqosPrev: PSECURITY_QUALITY_OF_SERVICE ): Bool; stdcall; external cLibName name 'DdeSetQualityOfService';
    function  DdeSetUserHandle                            ( Conv: HConv; ID, User: uint32 ): Bool; stdcall; external cLibName name 'DdeSetUserHandle';
    function  DdeUnaccessData                             ( Data: HDDEData ): Bool; stdcall; external cLibName name 'DdeUnaccessData';
    function  DdeUninitialize                             ( Inst: uint32 ): Bool; stdcall; external cLibName name 'DdeUninitialize';
    function  DefDlgProcA                                 ( hDlg: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefDlgProcA';
    function  DefDlgProcW                                 ( hDlg: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefDlgProcW';
    function  DefFrameProcA                               ( hWnd, hWndMDIClient: HWND; uMsg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefFrameProcA';
    function  DefFrameProcW                               ( hWnd, hWndMDIClient: HWND; uMsg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefFrameProcW';
    function  DefMDIChildProcA                            ( hWnd: HWND; uMsg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefMDIChildProcA';
    function  DefMDIChildProcW                            ( hWnd: HWND; uMsg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefMDIChildProcW';
    function  DefWindowProcA                              ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefWindowProcA';
    function  DefWindowProcW                              ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'DefWindowProcW';
    function  DeferWindowPos                              ( hWinPosInfo: HDWP; hWnd: HWND; hWndInsertAfter: HWND; x, y, cx, cy: int32; uFlags: uint32 ): HDWP; stdcall; external cLibName name 'DeferWindowPos';
    function  DeleteMenu                                  ( hMenu: HMENU; uPosition, uFlags: uint32 ): Bool; stdcall; external cLibName name 'DeleteMenu';
    function  DestroyAcceleratorTable                     ( hAccel: HACCEL ): Bool; stdcall; external cLibName name 'DestroyAcceleratorTable';
    function  DestroyCaret                                (  ): Bool; stdcall; external cLibName name 'DestroyCaret';
    function  DestroyCursor                               ( hCursor: HICON ): Bool; stdcall; external cLibName name 'DestroyCursor';
    function  DestroyIcon                                 ( hIcon: HICON ): Bool; stdcall; external cLibName name 'DestroyIcon';
    function  DestroyMenu                                 ( hMenu: HMENU ): Bool; stdcall; external cLibName name 'DestroyMenu';
    function  DestroyWindow                               ( hWnd: HWND ): Bool; stdcall; external cLibName name 'DestroyWindow';
    function  DialogBoxIndirectParamA                     ( hInstance: HINST; const lpDialogTemplate: DlgTemplate; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): int32; stdcall; external cLibName name 'DialogBoxIndirectParamA';
    function  DialogBoxIndirectParamW                     ( hInstance: HINST; const lpDialogTemplate: DlgTemplate; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): int32; stdcall; external cLibName name 'DialogBoxIndirectParamW';
    function  DialogBoxParamA                             ( hInstance: HINST; lpTemplateName: PAnsiChar; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): int32; stdcall; external cLibName name 'DialogBoxParamA';
    function  DialogBoxParamW                             ( hInstance: HINST; lpTemplateName: PWideChar; hWndParent: HWND; lpDialogFunc: DlgProc; dwInitParam: LPARAM ): int32; stdcall; external cLibName name 'DialogBoxParamW';
    function  DispatchMessageA                            ( const lpMsg: Msg ): int32; stdcall; external cLibName name 'DispatchMessageA';
    function  DispatchMessageW                            ( const lpMsg: Msg ): int32; stdcall; external cLibName name 'DispatchMessageW';
    function  DlgDirListA                                 ( hDlg: HWND; lpPathSpec: PAnsiChar; nIDListBox, nIDStaticPath: int32; uFileType: uint32 ): int32; stdcall; external cLibName name 'DlgDirListA';
    function  DlgDirListW                                 ( hDlg: HWND; lpPathSpec: PWideChar; nIDListBox, nIDStaticPath: int32; uFileType: uint32 ): int32; stdcall; external cLibName name 'DlgDirListW';
    function  DlgDirListComboBoxA                         ( hDlg: HWND; lpPathSpec: PAnsiChar; nIDComboBox, nIDStaticPath: int32; uFiletype: uint32 ): int32; stdcall; external cLibName name 'DlgDirListComboBoxA';
    function  DlgDirListComboBoxW                         ( hDlg: HWND; lpPathSpec: PWideChar; nIDComboBox, nIDStaticPath: int32; uFiletype: uint32 ): int32; stdcall; external cLibName name 'DlgDirListComboBoxW';
    function  DlgDirSelectComboBoxExA                     ( hDlg: HWND; lpString: PAnsiChar; nCount, nIDComboBox: int32 ): Bool; stdcall; external cLibName name 'DlgDirSelectComboBoxExA';
    function  DlgDirSelectComboBoxExW                     ( hDlg: HWND; lpString: PWideChar; nCount, nIDComboBox: int32 ): Bool; stdcall; external cLibName name 'DlgDirSelectComboBoxExW';
    function  DlgDirSelectExA                             ( hDlg: HWND; lpString: PAnsiChar; nCount, nIDListBox: int32 ): Bool; stdcall; external cLibName name 'DlgDirSelectExA';
    function  DlgDirSelectExW                             ( hDlg: HWND; lpString: PWideChar; nCount, nIDListBox: int32 ): Bool; stdcall; external cLibName name 'DlgDirSelectExW';
    function  DragDetect                                  ( p1: HWND; p2: Point ): Bool; stdcall; external cLibName name 'DragDetect';
    function  DragObject                                  ( p1, p2: HWND; p3: uint32; p4: uint32; p5: HICON ): uint32; stdcall; external cLibName name 'DragObject';
    function  DrawAnimatedRects                           ( hwnd: HWND; idAni: int32; const lprcFrom, lprcTo: Rect ): Bool; stdcall; external cLibName name 'DrawAnimatedRects';
    function  DrawCaption                                 ( p1: HWND; p2: HDC; const p3: Rect; p4: uint32 ): Bool; stdcall; external cLibName name 'DrawCaption';
    function  DrawEdge                                    ( hdc: HDC; var qrc: Rect; edge: uint32; grfFlags: uint32 ): Bool; stdcall; external cLibName name 'DrawEdge';
    function  DrawFocusRect                               ( hDC: HDC; const lprc: Rect ): Bool; stdcall; external cLibName name 'DrawFocusRect';
    function  DrawFrameControl                            ( DC: HDC; const Rect: Rect; uType, uState: uint32 ): Bool; stdcall; external cLibName name 'DrawFrameControl';
    function  DrawIcon                                    ( hDC: HDC; X, Y: int32; hIcon: HICON ): Bool; stdcall; external cLibName name 'DrawIcon';
    function  DrawIconEx                                  ( hdc: HDC; xLeft, yTop: int32; hIcon: HICON; cxWidth, cyWidth: int32; istepIfAniCur: uint32; hbrFlickerFreeDraw: HBRUSH; diFlags: uint32 ): Bool; stdcall; external cLibName name 'DrawIconEx';
    function  DrawMenuBar                                 ( hWnd: HWND ): Bool; stdcall; external cLibName name 'DrawMenuBar';
    function  DrawStateA                                  ( DC: HDC; p2: HBRUSH; p3: DrawStateProc; p4: LPARAM; p5: WPARAM; p6, p7, p8, p9: int32; p10: uint32 ): Bool; stdcall; external cLibName name 'DrawStateA';
    function  DrawStateW                                  ( DC: HDC; p2: HBRUSH; p3: DrawStateProc; p4: LPARAM; p5: WPARAM; p6, p7, p8, p9: int32; p10: uint32 ): Bool; stdcall; external cLibName name 'DrawStateW';
    function  DrawTextA                                   ( hDC: HDC; lpString: PAnsiChar; nCount: int32; var lpRect: Rect; uFormat: uint32 ): int32; stdcall; external cLibName name 'DrawTextA';
    function  DrawTextW                                   ( hDC: HDC; lpString: PWideChar; nCount: int32; var lpRect: Rect; uFormat: uint32 ): int32; stdcall; external cLibName name 'DrawTextW';
    function  DrawTextExA                                 ( DC: HDC; lpchText: PAnsiChar; cchText: int32; var p4: Rect; dwDTFormat: uint32; DTParams: PDrawTextParams ): int32; stdcall; external cLibName name 'DrawTextExA';
    function  DrawTextExW                                 ( DC: HDC; lpchText: PWideChar; cchText: int32; var p4: Rect; dwDTFormat: uint32; DTParams: PDrawTextParams ): int32; stdcall; external cLibName name 'DrawTextExW';
    function  EmptyClipboard                              ( ): Bool; stdcall; external cLibName name 'EmptyClipboard';
    function  EnableMenuItem                              ( hMenu: HMENU; uIDEnableItem, uEnable: uint32 ): Bool; stdcall; external cLibName name 'EnableMenuItem';
    function  EnableScrollBar                             ( hWnd: HWND; wSBflags, wArrows: uint32 ): Bool; stdcall; external cLibName name 'EnableScrollBar';
    function  EnableWindow                                ( hWnd: HWND; bEnable: Bool ): Bool; stdcall; external cLibName name 'EnableWindow';
    function  EndDeferWindowPos                           ( hWinPosInfo: HDWP ): Bool; stdcall; external cLibName name 'EndDeferWindowPos';
    function  EndDialog                                   ( hDlg: HWND; nResult: int32 ): Bool; stdcall; external cLibName name 'EndDialog';
    function  EndMenu                                     (  ): Bool; stdcall; external cLibName name 'EndMenu';
    function  EndPaint                                    ( hWnd: HWND; var Paint: PaintStruct ): Bool; stdcall; external cLibName name 'EndPaint';
    function  EnumChildWindows                            ( hWndParent: HWND; lpEnumFunc: WndEnumProc; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumChildWindows';
    function  EnumClipboardFormats                        ( format: uint32 ): uint32; stdcall; external cLibName name 'EnumClipboardFormats';
    function  EnumDesktopWindows                          ( hDesktop: HDESK; lpfn: WndEnumProc; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumDesktopWindows';
    function  EnumDesktopsA                               ( hwinsta: HWINSTA; lpEnumFunc: DeskTopEnumProcA; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumDesktopsA';
    function  EnumDesktopsW                               ( hwinsta: HWINSTA; lpEnumFunc: DeskTopEnumProcW; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumDesktopsW';
    function  EnumDisplayDevicesA                         ( Unused: Pointer; iDevNum: uint32; var lpDisplayDevice: DisplayDeviceA; dwFlags: uint32 ): Bool; stdcall; external cLibName name 'EnumDisplayDevicesA';
    function  EnumDisplayDevicesW                         ( Unused: Pointer; iDevNum: uint32; var lpDisplayDevice: DisplayDeviceW; dwFlags: uint32 ): Bool; stdcall; external cLibName name 'EnumDisplayDevicesW';
    function  EnumDisplaySettingsA                        ( lpszDeviceName: PAnsiChar; iModeNum: int32; var lpDevMode: DeviceModeA ): Bool; stdcall; external cLibName name 'EnumDisplaySettingsA';
    function  EnumDisplaySettingsW                        ( lpszDeviceName: PWideChar; iModeNum: int32; var lpDevMode: DeviceModeW ): Bool; stdcall; external cLibName name 'EnumDisplaySettingsW';
    function  EnumPropsA                                  ( hWnd: HWND; lpEnumFunc: PropEnumProcA ): int32; stdcall; external cLibName name 'EnumPropsA';
    function  EnumPropsW                                  ( hWnd: HWND; lpEnumFunc: PropEnumProcW ): int32; stdcall; external cLibName name 'EnumPropsW';
    function  EnumPropsExA                                ( hWnd: HWND; lpEnumFunc: PropEnumProcExA; lParam: LPARAM ): int32; stdcall; external cLibName name 'EnumPropsExA';
    function  EnumPropsExW                                ( hWnd: HWND; lpEnumFunc: PropEnumProcExW; lParam: LPARAM ): int32; stdcall; external cLibName name 'EnumPropsExW';
    function  EnumThreadWindows                           ( dwThreadId: uint32; lpfn: WndEnumProc; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumThreadWindows';
    function  EnumWindowStationsA                         ( lpEnumFunc: EnumWinStatProcA; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumWindowStationsA';
    function  EnumWindowStationsW                         ( lpEnumFunc: EnumWinStatProcW; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumWindowStationsW';
    function  EnumWindows                                 ( lpEnumFunc: WndEnumProc; lParam: LPARAM ): Bool; stdcall; external cLibName name 'EnumWindows';
    function  EqualRect                                   ( const lprc1, lprc2: Rect ): Bool; stdcall; external cLibName name 'EqualRect';
    function  ExcludeUpdateRgn                            ( hDC: HDC; hWnd: HWND ): int32; stdcall; external cLibName name 'ExcludeUpdateRgn';
    function  ExitWindowsEx                               ( uFlags: uint32; dwReserved: uint32 ): Bool; stdcall; external cLibName name 'ExitWindowsEx';
    function  FillRect                                    ( hDC: HDC; const lprc: Rect; hbr: HBRUSH ): int32; stdcall; external cLibName name 'FillRect';
    function  FindWindowA                                 ( lpClassName, lpWindowName: PAnsiChar ): HWND; stdcall; external cLibName name 'FindWindowA';
    function  FindWindowW                                 ( lpClassName, lpWindowName: PWideChar ): HWND; stdcall; external cLibName name 'FindWindowW';
    function  FindWindowExA                               ( Parent, Child: HWND; ClassName, WindowName: PAnsiChar ): HWND; stdcall; external cLibName name 'FindWindowExA';
    function  FindWindowExW                               ( Parent, Child: HWND; ClassName, WindowName: PWideChar ): HWND; stdcall; external cLibName name 'FindWindowExW';
    function  FlashWindow                                 ( hWnd: HWND; bInvert: Bool ): Bool; stdcall; external cLibName name 'FlashWindow';
    function  FlashWindowEx                               ( var pfwi: FlashWInfo ): Bool; stdcall; external cLibName name 'FlashWindowEx';
    function  FrameRect                                   ( hDC: HDC; const lprc: Rect; hbr: HBRUSH ): int32; stdcall; external cLibName name 'FrameRect';
    function  FreeDDElParam                               ( msg: uint32; lParam: int32 ): Bool; stdcall; external cLibName name 'FreeDDElParam';
    function  GetActiveWindow                             ( ): HWND; stdcall; external cLibName name 'GetActiveWindow';
    function  GetAltTabInfoA                              ( hwnd: HWND; iItem: int32; var pati: AltTabInfo; pszItemText: PAnsiChar; cchItemText: uint32 ): Bool; stdcall; external cLibName name 'GetAltTabInfoA';
    function  GetAltTabInfoW                              ( hwnd: HWND; iItem: int32; var pati: AltTabInfo; pszItemText: PWideChar; cchItemText: uint32 ): Bool; stdcall; external cLibName name 'GetAltTabInfoW';
    function  GetAncestor                                 ( hwnd: HWND; gaFlags: uint32): HWND; stdcall; external cLibName name 'GetAncestor';
    function  GetAsyncKeyState                            ( vKey: int32 ): int16; stdcall; external cLibName name 'GetAsyncKeyState';
    function  GetCapture                                  (  ): HWND; stdcall; external cLibName name 'GetCapture';
    function  GetCaretBlinkTime                           (  ): uint32; stdcall; external cLibName name 'GetCaretBlinkTime';
    function  GetCaretPos                                 ( var lpPoint: Point ): Bool; stdcall; external cLibName name 'GetCaretPos';
    function  GetClassInfoA                               ( hInstance: HINST; lpClassName: PAnsiChar; var lpWndClass: WndClassA ): Bool; stdcall; external cLibName name 'GetClassInfoA';
    function  GetClassInfoEx                              ( Instance: HINST; Classname: PAnsiChar; var WndClass: WndClassExA ): Bool; stdcall; external cLibName name 'GetClassInfoExA';
    function  GetClassInfoExW                             ( Instance: HINST; Classname: PWideChar; var WndClass: WndClassExW ): Bool; stdcall; external cLibName name 'GetClassInfoExW';
    function  GetClassInfoW                               ( hInstance: HINST; lpClassName: PWideChar; var lpWndClass: WndClassW ): Bool; stdcall; external cLibName name 'GetClassInfoW';
    function  GetClassLong                                ( hWnd: HWND; nIndex: int32 ): uint32; stdcall; external cLibName name 'GetClassLongA';
    function  GetClassLongW                               ( hWnd: HWND; nIndex: int32 ): uint32; stdcall; external cLibName name 'GetClassLongW';
    function  GetClassNameA                               ( hWnd: HWND; lpClassName: PAnsiChar; nMaxCount: int32 ): int32; stdcall; external cLibName name 'GetClassNameA';
    function  GetClassNameW                               ( hWnd: HWND; lpClassName: PWideChar; nMaxCount: int32 ): int32; stdcall; external cLibName name 'GetClassNameW';
    function  GetClassWord                                ( hWnd: HWND; nIndex: int32 ): uint16; stdcall; external cLibName name 'GetClassWord';
    function  GetClientRect                               ( hWnd: HWND; var lpRect: Rect ): Bool; stdcall; external cLibName name 'GetClientRect';
    function  GetClipCursor                               ( var lpRect: Rect ): Bool; stdcall; external cLibName name 'GetClipCursor';
    function  GetClipboardData                            ( uFormat: uint32 ): winHandle; stdcall; external cLibName name 'GetClipboardData';
    function  GetClipboardFormatNameA                     ( format: uint32; lpszFormatName: PAnsiChar; cchMaxCount: int32 ): int32; stdcall; external cLibName name 'GetClipboardFormatNameA';
    function  GetClipboardFormatNameW                     ( format: uint32; lpszFormatName: PWideChar; cchMaxCount: int32 ): int32; stdcall; external cLibName name 'GetClipboardFormatNameW';
    function  GetClipboardOwner                           ( ): HWND; stdcall; external cLibName name 'GetClipboardOwner';
    function  GetClipboardSequenceNumber                  ( ): uint32; stdcall; external cLibName name 'GetClipboardSequenceNumber';
    function  GetClipboardViewer                          ( ): HWND; stdcall; external cLibName name 'GetClipboardViewer';
    function  GetComboBoxInfo                             ( hwndCombo: HWND; var pcbi: ComboBoxInfo ): Bool; stdcall; external cLibName name 'GetComboBoxInfo';
    function  GetCursor                                   ( ): HCURSOR; stdcall; external cLibName name 'GetCursor';
    function  GetCursorInfo                               ( var pci: CursorInfo ): Bool; stdcall; external cLibName name 'GetCursorInfo';
    function  GetCursorPos                                ( var lpPoint: Point ): Bool; stdcall; external cLibName name 'GetCursorPos';
    function  GetDC                                       ( hWnd: HWND ): HDC; stdcall; external cLibName name 'GetDC';
    function  GetDCEx                                     ( hWnd: HWND; hrgnClip: HRGN; flags: uint32 ): HDC; stdcall; external cLibName name 'GetDCEx';
    function  GetDesktopWindow                            ( ): HWND; stdcall; external cLibName name 'GetDesktopWindow';
    function  GetDialogBaseUnits                          ( ): int32; stdcall; external cLibName name 'GetDialogBaseUnits';
    function  GetDlgCtrlID                                ( hWnd: HWND ): int32; stdcall; external cLibName name 'GetDlgCtrlID';
    function  GetDlgItem                                  ( hDlg: HWND; nIDDlgItem: int32 ): HWND; stdcall; external cLibName name 'GetDlgItem';
    function  GetDlgItemInt                               ( hDlg: HWND; nIDDlgItem: int32; var lpTranslated: Bool; bSigned: Bool ): uint32; stdcall; external cLibName name 'GetDlgItemInt';
    function  GetDlgItemTextA                             ( hDlg: HWND; nIDDlgItem: int32; lpString: PAnsiChar; nMaxCount: int32 ): uint32; stdcall; external cLibName name 'GetDlgItemTextA';
    function  GetDlgItemTextW                             ( hDlg: HWND; nIDDlgItem: int32; lpString: PWideChar; nMaxCount: int32 ): uint32; stdcall; external cLibName name 'GetDlgItemTextW';
    function  GetDoubleClickTime                          ( ): uint32; stdcall; external cLibName name 'GetDoubleClickTime';
    function  GetFocus                                    ( ): HWND; stdcall; external cLibName name 'GetFocus';
    function  GetForegroundWindow                         ( ): HWND; stdcall; external cLibName name 'GetForegroundWindow';
    function  GetGUIThreadInfo                            ( idThread: uint32; var pgui: GUIThreadinfo ): Bool; stdcall; external cLibName name 'GetGUIThreadInfo';
    function  GetGuiResources                             ( hProcess: winHandle; uiFlags: uint32 ): uint32; stdcall; external cLibName name 'GetGuiResources';
    function  GetIconInfo                                 ( hIcon: HICON; var piconinfo: IconInfo ): Bool; stdcall; external cLibName name 'GetIconInfo';
    function  GetInputState                               ( ): Bool; stdcall; external cLibName name 'GetInputState';
    function  GetKBCodePage                               ( ): uint32; stdcall; external cLibName name 'GetKBCodePage';
    function  GetKeyNameTextA                             ( lParam: int32; lpString: PAnsiChar; nSize: int32 ): int32; stdcall; external cLibName name 'GetKeyNameTextA';
    function  GetKeyNameTextW                             ( lParam: int32; lpString: PWideChar; nSize: int32 ): int32; stdcall; external cLibName name 'GetKeyNameTextW';
    function  GetKeyState                                 ( nVirtKey: int32 ): int16; stdcall; external cLibName name 'GetKeyState';
    function  GetKeyboardLayout                           ( dwLayout: uint32 ): HKL; stdcall; external cLibName name 'GetKeyboardLayout';
    function  GetKeyboardLayoutList                       ( nBuff: int32; var List ): uint32; stdcall; external cLibName name 'GetKeyboardLayoutList';
    function  GetKeyboardLayoutNameA                      ( pwszKLID: PAnsiChar ): Bool; stdcall; external cLibName name 'GetKeyboardLayoutNameA';
    function  GetKeyboardLayoutNameW                      ( pwszKLID: PWideChar ): Bool; stdcall; external cLibName name 'GetKeyboardLayoutNameW';
    function  GetKeyboardState                            ( var KeyState: uint8 ): Bool; stdcall; external cLibName name 'GetKeyboardState';
    function  GetKeyboardType                             ( nTypeFlag: int32 ): int32; stdcall; external cLibName name 'GetKeyboardType';
    function  GetLastActivePopup                          ( hWnd: HWND ): HWND; stdcall; external cLibName name 'GetLastActivePopup';
    function  GetLastInputInfo                            ( var plii: LastInputInfo ): Bool; stdcall; external cLibName name 'GetLastInputInfo';
    function  GetListBoxInfo                              ( hwnd: HWND ): uint32; stdcall; external cLibName name 'GetListBoxInfo';
    function  GetMenu                                     ( hWnd: HWND ): HMENU; stdcall; external cLibName name 'GetMenu';
    function  GetMenuBarInfo                              ( hend: HWND; idObject, idItem: int32; var pmbi: MenuBarInfo ): Bool; stdcall; external cLibName name 'GetMenuBarInfo';
    function  GetMenuCheckMarkDimensions                  ( ): int32; stdcall; external cLibName name 'GetMenuCheckMarkDimensions';
    function  GetMenuContextHelpId                        ( hMenu: HMENU ): uint32; stdcall; external cLibName name 'GetMenuContextHelpId';
    function  GetMenuDefaultItem                          ( hMenu: HMENU; fByPos, gmdiFlags: uint32 ): uint32; stdcall; external cLibName name 'GetMenuDefaultItem';
    function  GetMenuInfo                                 ( hMenu: HMENU; var lpmi: MenuInfo ): Bool; stdcall; external cLibName name 'GetMenuInfo';
    function  GetMenuItemCount                            ( hMenu: HMENU ): int32; stdcall; external cLibName name 'GetMenuItemCount';
    function  GetMenuItemID                               ( hMenu: HMENU; nPos: int32 ): uint32; stdcall; external cLibName name 'GetMenuItemID';
    function  GetMenuItemInfoA                            ( p1: HMENU; p2: uint32; p3: Bool; var p4: MenuItemInfoA ): Bool; stdcall; external cLibName name 'GetMenuItemInfoA';
    function  GetMenuItemInfoW                            ( p1: HMENU; p2: uint32; p3: Bool; var p4: MenuItemInfoW ): Bool; stdcall; external cLibName name 'GetMenuItemInfoW';
    function  GetMenuItemRect                             ( hWnd: HWND; hMenu: HMENU; uItem: uint32; var lprcItem: Rect ): Bool; stdcall; external cLibName name 'GetMenuItemRect';
    function  GetMenuState                                ( hMenu: HMENU; uId, uFlags: uint32 ): uint32; stdcall; external cLibName name 'GetMenuState';
    function  GetMenuString                               ( hMenu: HMENU; uIDItem: uint32; lpString: PAnsiChar; nMaxCount: int32; uFlag: uint32 ): int32; stdcall; external cLibName name 'GetMenuStringA';
    function  GetMenuStringW                              ( hMenu: HMENU; uIDItem: uint32; lpString: PWideChar; nMaxCount: int32; uFlag: uint32 ): int32; stdcall; external cLibName name 'GetMenuStringW';
    function  GetMessageA                                 ( var lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax: uint32 ): Bool; stdcall; external cLibName name 'GetMessageA';
    function  GetMessageW                                 ( var lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax: uint32 ): Bool; stdcall; external cLibName name 'GetMessageW';
    function  GetMessageExtraInfo                         ( ): int32; stdcall; external cLibName name 'GetMessageExtraInfo';
    function  GetMessagePos                               ( ): uint32; stdcall; external cLibName name 'GetMessagePos';
    function  GetMessageTime                              ( ): int32; stdcall; external cLibName name 'GetMessageTime';
    function  GetNextDlgGroupItem                         ( hDlg: HWND; hCtl: HWND; bPrevious: Bool ): HWND; stdcall; external cLibName name 'GetNextDlgGroupItem';
    function  GetNextDlgTabItem                           ( hDlg: HWND; hCtl: HWND; bPrevious: Bool ): HWND; stdcall; external cLibName name 'GetNextDlgTabItem';
    function  GetOpenClipboardWindow                      ( ): HWND; stdcall; external cLibName name 'GetOpenClipboardWindow';
    function  GetParent                                   ( hWnd: HWND ): HWND; stdcall; external cLibName name 'GetParent';
    function  GetPriorityClipboardFormat                  ( var paFormatPriorityList; cFormats: int32 ): int32; stdcall; external cLibName name 'GetPriorityClipboardFormat';
    function  GetProcessWindowStation                     ( ): HWINSTA; stdcall; external cLibName name 'GetProcessWindowStation';
    function  GetPropA                                    ( hWnd: HWND; lpString: PAnsiChar ): winHandle; stdcall; external cLibName name 'GetPropA';
    function  GetPropW                                    ( hWnd: HWND; lpString: PWideChar ): winHandle; stdcall; external cLibName name 'GetPropW';
    function  GetQueueStatus                              ( flags: uint32): uint32; stdcall; external cLibName name 'GetQueueStatus';
    function  GetScrollBarInfo                            ( hwnd: HWND; idObject: int32; var psbi: ScrollBarInfo ): Bool; stdcall; external cLibName name 'GetScrollBarInfo';
    function  GetScrollInfo                               ( hWnd: HWND; BarFlag: int32; var ScrollInfo: ScrollInfo ): Bool; stdcall; external cLibName name 'GetScrollInfo';
    function  GetScrollPos                                ( hWnd: HWND; nBar: int32 ): int32; stdcall; external cLibName name 'GetScrollPos';
    function  GetScrollRange                              ( hWnd: HWND; nBar: int32; var lpMinPos, lpMaxPos: int32 ): Bool; stdcall; external cLibName name 'GetScrollRange';
    function  GetSubMenu                                  ( hMenu: HMENU; nPos: int32 ): HMENU; stdcall; external cLibName name 'GetSubMenu';
    function  GetSysColor                                 ( nIndex: int32 ): uint32; stdcall; external cLibName name 'GetSysColor';
    function  GetSysColorBrush                            ( nIndex: int32 ): HBRUSH; stdcall; external cLibName name 'GetSysColorBrush';
    function  GetSystemMenu                               ( hWnd: HWND; bRevert: Bool ): HMENU; stdcall; external cLibName name 'GetSystemMenu';
    function  GetSystemMetrics                            ( nIndex: int32 ): int32; stdcall; external cLibName name 'GetSystemMetrics';
    function  GetTabbedTextExtentA                        ( hDC: HDC; lpString: PAnsiChar; nCount, nTabPositions: int32; var lpnTabStopPositions ): uint32; stdcall; external cLibName name 'GetTabbedTextExtentA';
    function  GetTabbedTextExtentW                        ( hDC: HDC; lpString: PWideChar; nCount, nTabPositions: int32; var lpnTabStopPositions ): uint32; stdcall; external cLibName name 'GetTabbedTextExtentW';
    function  GetThreadDesktop                            ( dwThreadId: uint32 ): HDESK; stdcall; external cLibName name 'GetThreadDesktop';
    function  GetTopWindow                                ( hWnd: HWND ): HWND; stdcall; external cLibName name 'GetTopWindow';
    function  GetUpdateRect                               ( hWnd: HWND; var lpRect: Rect; bErase: Bool ): Bool; stdcall; external cLibName name 'GetUpdateRect';
    function  GetUpdateRgn                                ( hWnd: HWND; hRgn: HRGN; bErase: Bool ): int32; stdcall; external cLibName name 'GetUpdateRgn';
    function  GetUserObjectInformation                    ( hObj: winHandle; nIndex: int32; pvInfo: Pointer; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetUserObjectInformationA';
    function  GetUserObjectInformationW                   ( hObj: winHandle; nIndex: int32; pvInfo: Pointer; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetUserObjectInformationW';
    function  GetUserObjectSecurity                       ( hObj: winHandle; var pSIRequested: uint32; pSID: PSecurityDescriptor; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetUserObjectSecurity';
    function  GetWindow                                   ( hWnd: HWND; uCmd: uint32 ): HWND; stdcall; external cLibName name 'GetWindow';
    function  GetWindowContextHelpId                      ( hWnd: HWND ): uint32; stdcall; external cLibName name 'GetWindowContextHelpId';
    function  GetWindowDC                                 ( hWnd: HWND ): HDC; stdcall; external cLibName name 'GetWindowDC';
    function  GetWindowInfo                               ( hwnd: HWND; var pwi: WindowInfo ): Bool; stdcall; external cLibName name 'GetWindowInfo';
    function  GetWindowLongA                              ( hWnd: HWND; nIndex: int32 ): int32; stdcall; external cLibName name 'GetWindowLongA';
    function  GetWindowLongW                              ( hWnd: HWND; nIndex: int32 ): int32; stdcall; external cLibName name 'GetWindowLongW';
    function  GetWindowModuleFileNameA                    ( hwnd: HWND; pszFileName: PAnsiChar; cchFileNameMax: uint32 ): uint32; stdcall; external cLibName name 'GetWindowModuleFileNameA';
    function  GetWindowModuleFileNameW                    ( hwnd: HWND; pszFileName: PAnsiChar; cchFileNameMax: uint32 ): uint32; stdcall; external cLibName name 'GetWindowModuleFileNameW';
    function  GetWindowPlacement                          ( hWnd: HWND; WindowPlacement: PWindowPlacement ): Bool; stdcall; external cLibName name 'GetWindowPlacement';
    function  GetWindowRect                               ( hWnd: HWND; var lpRect: Rect ): Bool; stdcall; external cLibName name 'GetWindowRect';
    function  GetWindowRgn                                ( hWnd: HWND; hRgn: HRGN ): int32; stdcall; external cLibName name 'GetWindowRgn';
    function  GetWindowTextA                              ( hWnd: HWND; lpString: PAnsiChar; nMaxCount: int32 ): int32; stdcall; external cLibName name 'GetWindowTextA';
    function  GetWindowTextW                              ( hWnd: HWND; lpString: PWideChar; nMaxCount: int32 ): int32; stdcall; external cLibName name 'GetWindowTextW';
    function  GetWindowTextLengthA                        ( hWnd: HWND ): int32; stdcall; external cLibName name 'GetWindowTextLengthA';
    function  GetWindowTextLengthW                        ( hWnd: HWND ): int32; stdcall; external cLibName name 'GetWindowTextLengthW';
    function  GetWindowThreadProcessId                    ( hWnd: HWND; lpdwProcessId: Pointer ): uint32; stdcall; external cLibName name 'GetWindowThreadProcessId';
    function  GetWindowWord                               ( hWnd: HWND; nIndex: int32 ): uint16; stdcall; external cLibName name 'GetWindowWord';
    function  GrayStringA                                 ( hDC: HDC; hBrush: HBRUSH; lpOutputFunc: OutputProc; lpData: LPARAM; nCount, X, Y, nWidth, nHeight: int32 ): Bool; stdcall; external cLibName name 'GrayStringA';
    function  GrayStringW                                 ( hDC: HDC; hBrush: HBRUSH; lpOutputFunc: OutputProc; lpData: LPARAM; nCount, X, Y, nWidth, nHeight: int32 ): Bool; stdcall; external cLibName name 'GrayStringW';
    function  HideCaret                                   ( hWnd: HWND ): Bool; stdcall; external cLibName name 'HideCaret';
    function  HiliteMenuItem                              ( hWnd: HWND; hMenu: HMENU; uIDHiliteItem: uint32; uHilite: uint32 ): Bool; stdcall; external cLibName name 'HiliteMenuItem';
    function  ImpersonateDdeClientWindow                  ( hWndClient: HWND; hWndServer: HWND ): Bool; stdcall; external cLibName name 'ImpersonateDdeClientWindow';
    function  InSendMessage                               ( ): Bool; stdcall; external cLibName name 'InSendMessage';
    function  InSendMessageeX                             ( lpReserved: Pointer ): uint32; stdcall; external cLibName name 'InSendMessageeX';
    function  InflateRect                                 ( var lprc: Rect; dx, dy: int32 ): Bool; stdcall; external cLibName name 'InflateRect';
    function  InsertMenuA                                 ( hMenu: HMENU; uPosition, uFlags, uIDNewItem: uint32; lpNewItem: PAnsiChar ): Bool; stdcall; external cLibName name 'InsertMenuA';
    function  InsertMenuW                                 ( hMenu: HMENU; uPosition, uFlags, uIDNewItem: uint32; lpNewItem: PWideChar ): Bool; stdcall; external cLibName name 'InsertMenuW';
    function  InsertMenuItemA                             ( p1: HMENU; p2: uint32; p3: Bool; const p4: MenuItemInfoA ): Bool; stdcall; external cLibName name 'InsertMenuItemA';
    function  InsertMenuItemW                             ( p1: HMENU; p2: uint32; p3: Bool; const p4: MenuItemInfoW ): Bool; stdcall; external cLibName name 'InsertMenuItemW';
    function  IntersectRect                               ( var lprcDst: Rect; const lprcSrc1, lprcSrc2: Rect ): Bool; stdcall; external cLibName name 'IntersectRect';
    function  InvalidateRect                              ( hWnd: HWND; lpRect: PRect; bErase: Bool ): Bool; stdcall; external cLibName name 'InvalidateRect';
    function  InvalidateRgn                               ( hWnd: HWND; hRgn: HRGN; bErase: Bool ): Bool; stdcall; external cLibName name 'InvalidateRgn';
    function  InvertRect                                  ( hDC: HDC; const lprc: Rect ): Bool; stdcall; external cLibName name 'InvertRect';
    function  IsCharAlphaA                                ( ch: AnsiChar ): Bool; stdcall; external cLibName name 'IsCharAlphaA';
    function  IsCharAlphaW                                ( ch: WideChar ): Bool; stdcall; external cLibName name 'IsCharAlphaW';
    function  IsCharAlphaNumericA                         ( ch: AnsiChar ): Bool; stdcall; external cLibName name 'IsCharAlphaNumericA';
    function  IsCharAlphaNumericW                         ( ch: WideChar ): Bool; stdcall; external cLibName name 'IsCharAlphaNumericW';
    function  IsCharLowerA                                ( ch: AnsiChar ): Bool; stdcall; external cLibName name 'IsCharLowerA';
    function  IsCharLowerW                                ( ch: WideChar ): Bool; stdcall; external cLibName name 'IsCharLowerW';
    function  IsCharUpperA                                ( ch: AnsiChar ): Bool; stdcall; external cLibName name 'IsCharUpperA';
    function  IsCharUpperW                                ( ch: WideChar ): Bool; stdcall; external cLibName name 'IsCharUpperW';
    function  IsChild                                     ( hWndParent, hWnd: HWND ): Bool; stdcall; external cLibName name 'IsChild';
    function  IsClipboardFormatAvailable                  ( format: uint32 ): Bool; stdcall; external cLibName name 'IsClipboardFormatAvailable';
    function  IsDialogMessageA                            ( hDlg: HWND; var lpMsg: Msg ): Bool; stdcall; external cLibName name 'IsDialogMessageA';
    function  IsDialogMessageW                            ( hDlg: HWND; var lpMsg: Msg ): Bool; stdcall; external cLibName name 'IsDialogMessageW';
    function  IsDlgButtonChecked                          ( hDlg: HWND; nIDButton: int32 ): uint32; stdcall;external cLibName name 'IsDlgButtonChecked';
    function  IsIconic                                    ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsIconic';
    function  IsMenu                                      ( hMenu: HMENU ): Bool; stdcall; external cLibName name 'IsMenu';
    function  IsRectEmpty                                 ( const lprc: Rect ): Bool; stdcall; external cLibName name 'IsRectEmpty';
    function  IsWindow                                    ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsWindow';
    function  IsWindowEnabled                             ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsWindowEnabled';
    function  IsWindowUnicode                             ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsWindowUnicode';
    function  IsWindowVisible                             ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsWindowVisible';
    function  IsZoomed                                    ( hWnd: HWND ): Bool; stdcall; external cLibName name 'IsZoomed';
    function  KillTimer                                   ( hWnd: HWND; uIDEvent: uint32 ): Bool; stdcall; external cLibName name 'KillTimer';
    function  LoadAcceleratorsA                           ( hInstance: HINST; lpTableName: PAnsiChar ): HACCEL; stdcall; external cLibName name 'LoadAcceleratorsA';
    function  LoadAcceleratorsW                           ( hInstance: HINST; lpTableName: PWideChar ): HACCEL; stdcall; external cLibName name 'LoadAcceleratorsW';
    function  LoadBitmapA                                 ( hInstance: HINST; lpBitmapName: PAnsiChar ): HBITMAP; stdcall; external cLibName name 'LoadBitmapA';
    function  LoadBitmapW                                 ( HINSTance: HINST; lpBitmapName: PAnsiChar ): HBITMAP; stdcall; external cLibName name 'LoadBitmapW';
    function  LoadCursorA                                 ( HINSTance: HINST; lpCursorName: PAnsiChar ): HCURSOR; stdcall; external cLibName name 'LoadCursorA';
    function  LoadCursorW                                 ( HINSTance: HINST; lpCursorName: PWideChar ): HCURSOR; stdcall; external cLibName name 'LoadCursorW';
    function  LoadCursorFromFile                          ( lpFileName: PAnsiChar ): HCURSOR; stdcall; external cLibName name 'LoadCursorFromFileA';
    function  LoadCursorFromFileW                         ( lpFileName: PAnsiChar ): HCURSOR; stdcall; external cLibName name 'LoadCursorFromFileW';
    function  LoadIconA                                   ( HINSTance: HINST; lpIconName: PAnsiChar ): HICON; stdcall; external cLibName name 'LoadIconA';
    function  LoadIconW                                   ( HINSTance: HINST; lpIconName: PWideChar ): HICON; stdcall; external cLibName name 'LoadIconW';
    function  LoadImageA                                  ( HINST: HINST; ImageName: PAnsiChar; ImageType: uint32; X, Y: int32; Flags: uint32 ): winHandle; stdcall; external cLibName name 'LoadImageA';
    function  LoadImageW                                  ( HINST: HINST; ImageName: PWideChar; ImageType: uint32; X, Y: int32; Flags: uint32 ): winHandle; stdcall; external cLibName name 'LoadImageW';
    function  LoadKeyboardLayoutA                         ( pwszKLID: PAnsiChar; Flags: uint32 ): HKL; stdcall; external cLibName name 'LoadKeyboardLayoutA';
    function  LoadKeyboardLayoutW                         ( pwszKLID: PWideChar; Flags: uint32 ): HKL; stdcall; external cLibName name 'LoadKeyboardLayoutW';
    function  LoadMenuA                                   ( THINSTance: HINST; lpMenuName: PAnsiChar ): HMENU; stdcall; external cLibName name 'LoadMenuA';
    function  LoadMenuW                                   ( THINSTance: HINST; lpMenuName: PAnsiChar ): HMENU; stdcall; external cLibName name 'LoadMenuW';
    function  LoadMenuIndirect                            ( lpMenuTemplate: Pointer ): HMENU; stdcall; external cLibName name 'LoadMenuIndirectA';
    function  LoadMenuIndirectW                           ( lpMenuTemplate: Pointer ): HMENU; stdcall; external cLibName name 'LoadMenuIndirectW';
    function  LoadStringA                                 ( THINSTance: HINST; uID: uint32; lpBuffer: PAnsiChar; nBufferMax: int32 ): int32; stdcall; external cLibName name 'LoadStringA';
    function  LoadStringW                                 ( THINSTance: HINST; uID: uint32; lpBuffer: PWideChar; nBufferMax: int32 ): int32; stdcall; external cLibName name 'LoadStringW';
    function  LockWindowUpdate                            ( hWndLock: HWND): Bool; stdcall; external cLibName name 'LockWindowUpdate';
    function  LockWorkStation                             ( ): Bool; stdcall; external cLibName name 'LockWorkStation';
    function  LookupIconIdFromDirectory                   ( presbits: puint8; fIcon: Bool ): int32; stdcall; external cLibName name 'LookupIconIdFromDirectory';
    function  LookupIconIdFromDirectoryEx                 ( presbits: puint8; fIcon: Bool; cxDesired, cyDesired: int32; Flags: uint32 ): int32; stdcall; external cLibName name 'LookupIconIdFromDirectoryEx';
    function  MapDialogRect                               ( hDlg: HWND; var lpRect: Rect): Bool; stdcall; external cLibName name 'MapDialogRect';
    function  MapVirtualKeyA                              ( uCode, uMapType: uint32 ): uint32; stdcall; external cLibName name 'MapVirtualKeyA';
    function  MapVirtualKeyW                              ( uCode, uMapType: uint32 ): uint32; stdcall; external cLibName name 'MapVirtualKeyW';
    function  MapVirtualKeyExA                            ( uCode, uMapType: uint32; dwhkl: HKL ): uint32; stdcall; external cLibName name 'MapVirtualKeyExA';
    function  MapVirtualKeyExW                            ( uCode, uMapType: uint32; dwhkl: HKL ): uint32; stdcall; external cLibName name 'MapVirtualKeyExW';
    function  MapWindowPoints                             ( hWndFrom, hWndTo: HWND; var lpPoints; cPoints: uint32 ): int32; stdcall; external cLibName name 'MapWindowPoints';
    function  MenuItemFromPoint                           ( hWnd: HWND; hMenu: HMENU; ptScreen: Point ): Bool; stdcall; external cLibName name 'MenuItemFromPoint';
    function  MessageBeep                                 ( uType: uint32 ): Bool; stdcall; external cLibName name 'MessageBeep';
    function  MessageBoxA                                 ( hWnd: HWND; lpText, lpCaption: PAnsiChar; uType: uint32 ): int32; stdcall; external cLibName name 'MessageBoxA';
    function  MessageBoxW                                 ( hWnd: HWND; lpText, lpCaption: PWideChar; uType: uint32 ): int32; stdcall; external cLibName name 'MessageBoxW';
    function  MessageBoxExA                               ( hWnd: HWND; lpText, lpCaption: PAnsiChar; uType: uint32; wLanguageId: uint16 ): int32; stdcall; external cLibName name 'MessageBoxExA';
    function  MessageBoxExW                               ( hWnd: HWND; lpText, lpCaption: PWideChar; uType: uint32; wLanguageId: uint16 ): int32; stdcall; external cLibName name 'MessageBoxExW';
    function  MessageBoxIndirectA                         ( const MsgBoxParams: MsgBoxParamsA ): Bool; stdcall; external cLibName name 'MessageBoxIndirectA';
    function  MessageBoxIndirectW                         ( const MsgBoxParams: MsgBoxParamsW ): Bool; stdcall; external cLibName name 'MessageBoxIndirectW';
    function  ModifyMenuA                                 ( hMnu: HMENU; uPosition, uFlags, uIDNewItem: uint32; lpNewItem: PAnsiChar ): Bool; stdcall; external cLibName name 'ModifyMenuA';
    function  ModifyMenuW                                 ( hMnu: HMENU; uPosition, uFlags, uIDNewItem: uint32; lpNewItem: PWideChar ): Bool; stdcall; external cLibName name 'ModifyMenuW';
    function  MoveWindow                                  ( hWnd: HWND; X, Y, nWidth, nHeight: int32; bRepaint: Bool ): Bool; stdcall; external cLibName name 'MoveWindow';
    function  MsgWaitForMultipleObjects                   ( nCount: uint32; var pHandles; fWaitAll: Bool; dwMilliseconds, dwWakeMask: uint32 ): uint32; stdcall; external cLibName name 'MsgWaitForMultipleObjects';
    function  MsgWaitForMultipleObjectsEx                 ( nCount: uint32; var pHandles; dwMilliseconds, dwWakeMask, dwFlags: uint32 ): uint32; stdcall; external cLibName name 'MsgWaitForMultipleObjectsEx';
    procedure NotifyWinEvente                             ( event: uint32; hwnd: HWND; idObject, idChild: int32 ); external cLibName name 'NotifyWinEvent';
    function  OemKeyScan                                  ( wOemChar: uint16 ): uint32; stdcall; external cLibName name 'OemKeyScan';
    function  OemToCharA                                  ( lpszSrc: PAnsiChar; lpszDst: PAnsiChar ): Bool; stdcall; external cLibName name 'OemToCharA';
    function  OemToCharW                                  ( lpszSrc: PWideChar; lpszDst: PWideChar ): Bool; stdcall; external cLibName name 'OemToCharW';
    function  OemToCharBuffA                              ( lpszSrc: PAnsiChar; lpszDst: PAnsiChar; cchDstLength: uint32 ): Bool; stdcall; external cLibName name 'OemToCharBuffA';
    function  OemToCharBuffW                              ( lpszSrc: PWideChar; lpszDst: PWideChar; cchDstLength: uint32 ): Bool; stdcall; external cLibName name 'OemToCharBuffW';
    function  OffsetRect                                  ( var lprc: Rect; dx, dy: int32 ): Bool; stdcall; external cLibName name 'OffsetRect';
    function  OpenClipboard                               ( hWndNewOwner: HWND ): Bool; stdcall; external cLibName name 'OpenClipboard';
    function  OpenDesktopA                                ( lpszDesktop: PAnsiChar; dwFlags: uint32; fInherit: Bool; dwDesiredAccess: uint32 ): HDESK; stdcall; external cLibName name 'OpenDesktopA';
    function  OpenDesktopW                                ( lpszDesktop: PWideChar; dwFlags: uint32; fInherit: Bool; dwDesiredAccess: uint32 ): HDESK; stdcall; external cLibName name 'OpenDesktopW';
    function  OpenIcon                                    ( hWnd: HWND ): Bool; stdcall; external cLibName name 'OpenIcon';
    function  OpenInputDesktop                            ( dwFlags: uint32; fInherit: Bool; dwDesiredAccess: uint32 ): HDESK; stdcall; external cLibName name 'OpenInputDesktop';
    function  OpenWindowStationA                          ( lpszWinSta: PAnsiChar; fInherit: Bool; dwDesiredAccess: uint32 ): HWINSTA; stdcall; external cLibName name 'OpenWindowStationA';
    function  OpenWindowStationW                          ( lpszWinSta: PWideChar; fInherit: Bool; dwDesiredAccess: uint32 ): HWINSTA; stdcall; external cLibName name 'OpenWindowStationW';
    function  PackDDElParam                               ( msg: uint32; uiLo: uint32; uiHi: uint32 ): int32; stdcall; external cLibName name 'PackDDElParam';
    function  PaintDesktop                                ( hdc: HDC ): Bool; stdcall; external cLibName name 'PaintDesktop';
    function  PeekMessageA                                ( var lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax, wRemoveMsg: uint32 ): Bool; stdcall; external cLibName name 'PeekMessageA';
    function  PeekMessageW                                ( var lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax, wRemoveMsg: uint32 ): Bool; stdcall; external cLibName name 'PeekMessageW';
    function  PostMessageA                                ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'PostMessageA';
    function  PostMessageW                                ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'PostMessageW';
    procedure PostQuitMessagee                            ( nExitCode: int32 ); stdcall; external cLibName name 'PostQuitMessage';
    function  PostThreadMessageA                          ( idThread: uint32; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'PostThreadMessageA';
    function  PostThreadMessageW                          ( idThread: uint32; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'PostThreadMessageW';
    function  PtInRect                                    ( const lprc: Rect; pt: Point ): Bool; stdcall; external cLibName name 'PtInRect';
    function  RealChildWindowFromPoint                    ( hwndParent: HWND; ptParentClientCoords: Point ): HWND; stdcall; external cLibName name 'RealChildWindowFromPoint';
    function  RealGetWindowClassA                         ( hwnd: HWND; pszType: PAnsiChar; cchType: uint32 ): uint32; stdcall; external cLibName name 'RealGetWindowClassA';
    function  RealGetWindowClassW                         ( hwnd: HWND; pszType: PWideChar; cchType: uint32 ): uint32; stdcall; external cLibName name 'RealGetWindowClassW';
    function  RedrawWindow                                ( hWnd: HWND; lprcUpdate: PRect; hrgnUpdate: HRGN; flags: uint32 ): Bool; stdcall; external cLibName name 'RedrawWindow';
    function  RegisterClassA                              ( const lpWndClass: WndClassA ): ATOM; stdcall; external cLibName name 'RegisterClassA';
    function  RegisterClassW                              ( const lpWndClass: WndClassW ): ATOM; stdcall; external cLibName name 'RegisterClassW';
    function  RegisterClassExA                            ( const WndClass: WndClassExA ): ATOM; stdcall; external cLibName name 'RegisterClassExA';
    function  RegisterClassExW                            ( const WndClass: WndClassExW ): ATOM; stdcall; external cLibName name 'RegisterClassExW';
    function  RegisterClipboardFormatA                    ( lpszFormat: PAnsiChar ): uint32; stdcall; external cLibName name 'RegisterClipboardFormatA';
    function  RegisterClipboardFormatW                    ( lpszFormat: PWideChar ): uint32; stdcall; external cLibName name 'RegisterClipboardFormatW';
    function  RegisterDeviceNotificationA                 ( hRecipient: winHandle; NotificationFilter: Pointer; Flags: uint32 ): HDEVNOTIFY; stdcall; external cLibName name 'RegisterDeviceNotificationA';
    function  RegisterDeviceNotificationW                 ( hRecipient: winHandle; NotificationFilter: Pointer; Flags: uint32 ): HDEVNOTIFY; stdcall; external cLibName name 'RegisterDeviceNotificationW';
    function  RegisterHotKey                              ( hWnd: HWND; id: int32; fsModifiers, vk: uint32 ): Bool; stdcall; external cLibName name 'RegisterHotKey';
    function  RegisterWindowMessageA                      ( lpString: PAnsiChar ): uint32; stdcall; external cLibName name 'RegisterWindowMessageA';
    function  RegisterWindowMessageW                      ( lpString: PWideChar ): uint32; stdcall; external cLibName name 'RegisterWindowMessageW';
    function  ReleaseCapture                              ( ): Bool; stdcall; external cLibName name 'ReleaseCapture';
    function  ReleaseDC                                   ( hWnd: HWND; hDC: HDC ): int32; stdcall; external cLibName name 'ReleaseDC';
    function  RemoveMenu                                  ( hMenu: HMENU; uPosition, uFlags: uint32 ): Bool; stdcall; external cLibName name 'RemoveMenu';
    function  RemovePropA                                 ( hWnd: HWND; lpString: PAnsiChar ): winHandle; stdcall; external cLibName name 'RemovePropA';
    function  RemovePropW                                 ( hWnd: HWND; lpString: PWideChar ): winHandle; stdcall; external cLibName name 'RemovePropW';
    function  ReplyMessage                                ( lResult: LRESULT ): Bool; stdcall; external cLibName name 'ReplyMessage';
    function  ReuseDDElParam                              ( lParam: int32; msgIn: uint32; msgOut: uint32; uiLo: uint32; uiHi: uint32 ): int32; stdcall; external cLibName name 'ReuseDDElParam';
    function  ScreenToClient                              ( hWnd: HWND; var lpPoint: Point ): Bool; stdcall; external cLibName name 'ScreenToClient';
    function  ScrollDC                                    ( DC: HDC; DX, DY: int32; var Scroll, Clip: Rect; Rgn: HRGN; Update: PRect ): Bool; stdcall; external cLibName name 'ScrollDC';
    function  ScrollWindow                                ( hWnd: HWND; XAmount, YAmount: int32; Rect, ClipRect: PRect ): Bool; stdcall; external cLibName name 'ScrollWindow';
    function  ScrollWindowEx                              ( hWnd: HWND; dx, dy: int32; prcScroll, prcClip: PRect; hrgnUpdate: HRGN; prcUpdate: PRect; flags: uint32 ): Bool; stdcall; external cLibName name 'ScrollWindowEx';
    function  SendDlgItemMessageA                         ( hDlg: HWND; nIDDlgItem: int32; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): int32; stdcall; external cLibName name 'SendDlgItemMessageA';
    function  SendDlgItemMessageW                         ( hDlg: HWND; nIDDlgItem: int32; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): int32; stdcall; external cLibName name 'SendDlgItemMessageW';
    function  SendInput                                   ( cInputs: uint32; var pInputs: Input; cbSize: int32 ): uint32; stdcall; external cLibName name 'SendInput';
    function  SendMessageA                                ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'SendMessageA';
    function  SendMessageW                                ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall; external cLibName name 'SendMessageW';
    function  SendMessageCallbackA                        ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM; lpResultCallBack: SendASyncProc; dwData: uint32 ): Bool; stdcall; external cLibName name 'SendMessageCallbackA';
    function  SendMessageCallbackW                        ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM; lpResultCallBack: SendASyncProc; dwData: uint32 ): Bool; stdcall; external cLibName name 'SendMessageCallbackW';
    function  SendMessageTimeoutA                         ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM; fuFlags, uTimeout: uint32; var lpdwResult: uint32 ): LRESULT; stdcall; external cLibName name 'SendMessageTimeoutA';
    function  SendMessageTimeoutW                         ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM; fuFlags, uTimeout: uint32; var lpdwResult: uint32 ): LRESULT; stdcall; external cLibName name 'SendMessageTimeoutW';
    function  SendNotifyMessageA                          ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'SendNotifyMessageA';
    function  SendNotifyMessageW                          ( hWnd: HWND; Msg: uint32; wParam: WPARAM; lParam: LPARAM ): Bool; stdcall; external cLibName name 'SendNotifyMessageW';
    function  SetActiveWindow                             ( hWnd: HWND ): HWND; stdcall; external cLibName name 'SetActiveWindow';
    function  SetCapture                                  ( hWnd: HWND ): HWND; stdcall; external cLibName name 'SetCapture';
    function  SetCaretBlinkTime                           ( uMSeconds: uint32 ): Bool; stdcall; external cLibName name 'SetCaretBlinkTime';
    function  SetCaretPos                                 ( X, Y: int32 ): Bool; stdcall; external cLibName name 'SetCaretPos';
    function  SetClassLongA                               ( hWnd: HWND; nIndex: int32; dwNewLong: int32 ): uint32; stdcall; external cLibName name 'SetClassLongA';
    function  SetClassLongW                               ( hWnd: HWND; nIndex: int32; dwNewLong: int32 ): uint32; stdcall; external cLibName name 'SetClassLongW';
    function  SetClassWord                                ( hWnd: HWND; nIndex: int32; wNewWord: uint16 ): uint16; stdcall; external cLibName name 'SetClassWord';
    function  SetClipboardData                            ( uFormat: uint32; hMem: winHandle ): winHandle; stdcall; external cLibName name 'SetClipboardData';
    function  SetClipboardViewer                          ( hWndNewViewer: HWND ): HWND; stdcall; external cLibName name 'SetClipboardViewer';
    function  SetCursor                                   ( hCursor: HICON ): HCURSOR; stdcall; external cLibName name 'SetCursor';
    function  SetCursorPos                                ( X, Y: int32 ): Bool; stdcall; external cLibName name 'SetCursorPos';
    procedure SetDebugErrorLevele                         ( dwLevel: uint32 ); stdcall; external cLibName name 'SetDebugErrorLevel';
    function  SetDlgItemInt                               ( hDlg: HWND; nIDDlgItem: int32; uValue: uint32; bSigned: Bool ): Bool; stdcall; external cLibName name 'SetDlgItemInt';
    function  SetDlgItemTextA                             ( hDlg: HWND; nIDDlgItem: int32; lpString: PAnsiChar ): Bool; stdcall; external cLibName name 'SetDlgItemTextA';
    function  SetDlgItemTextW                             ( hDlg: HWND; nIDDlgItem: int32; lpString: PWideChar ): Bool; stdcall; external cLibName name 'SetDlgItemTextW';
    function  SetDoubleClickTime                          ( Interval: uint32 ): Bool; stdcall; external cLibName name 'SetDoubleClickTime';
    function  SetFocus                                    ( hWnd: HWND ): HWND; stdcall; external cLibName name 'SetFocus';
    function  SetForegroundWindow                         ( hWnd: HWND ): Bool; stdcall; external cLibName name 'SetForegroundWindow';
    function  SetKeyboardState                            ( var KeyState: uint8 ): Bool; stdcall; external cLibName name 'SetKeyboardState';
    procedure SetLastErrorExe                             ( dwErrCode, dwType: uint32 ); stdcall; external cLibName name 'SetLastErrorEx';
    function  SetMenu                                     ( hWnd: HWND; hMenu: HMENU ): Bool; stdcall; external cLibName name 'SetMenu';
    function  SetMenuContextHelpId                        ( hMenu: HMENU; HelpID: uint32 ): Bool; stdcall; external cLibName name 'SetMenuContextHelpId';
    function  SetMenuDefaultItem                          ( hMenu: HMENU; uItem, fByPos: uint32 ): Bool; stdcall; external cLibName name 'SetMenuDefaultItem';
    function  SetMenuInfo                                 ( hMenu: HMENU; const lpcmi: MenuInfo ): Bool; stdcall; external cLibName name 'SetMenuInfo';
    function  SetMenuItemBitmaps                          ( hMenu: HMENU; uPosition, uFlags: uint32; hBitmapUnchecked: HBITMAP; hBitmapChecked: HBITMAP ): Bool; stdcall; external cLibName name 'SetMenuItemBitmaps';
    function  SetMenuItemInfoA                            ( p1: HMENU; p2: uint32; p3: Bool; const p4: MenuItemInfoA ): Bool; stdcall; external cLibName name 'SetMenuItemInfoA';
    function  SetMenuItemInfoW                            ( p1: HMENU; p2: uint32; p3: Bool; const p4: MenuItemInfoW ): Bool; stdcall; external cLibName name 'SetMenuItemInfoW';
    function  SetMessageExtraInfo                         ( lParam: LPARAM ): LPARAM; stdcall; external cLibName name 'SetMessageExtraInfo';
    function  SetMessageQueue                             ( cMessagesMax: int32 ): Bool; stdcall; external cLibName name 'SetMessageQueue';
    function  SetParent                                   ( hWndChild, hWndNewParent: HWND ): HWND; stdcall; external cLibName name 'SetParent';
    function  SetProcessWindowStation                     ( hWinSta: HWINSTA ): Bool; stdcall; external cLibName name 'SetProcessWindowStation';
    function  SetPropA                                    ( hWnd: HWND; lpString: PAnsiChar; hData: winHandle ): Bool; stdcall; external cLibName name 'SetPropA';
    function  SetPropW                                    ( hWnd: HWND; lpString: PWideChar; hData: winHandle ): Bool; stdcall; external cLibName name 'SetPropW';
    function  SetRect                                     ( var lprc: Rect; xLeft, yTop, xRight, yBottom: int32 ): Bool; stdcall; external cLibName name 'SetRect';
    function  SetRectEmpty                                ( var lprc: Rect ): Bool; stdcall; external cLibName name 'SetRectEmpty';
    function  SetScrollInfo                               ( hWnd: HWND; BarFlag: int32; const ScrollInfo: ScrollInfo; Redraw: Bool ): int32; stdcall; external cLibName name 'SetScrollInfo';
    function  SetScrollPos                                ( hWnd: HWND; nBar, nPos: int32; bRedraw: Bool ): int32; stdcall; external cLibName name 'SetScrollPos';
    function  SetScrollRange                              ( hWnd: HWND; nBar, nMinPos, nMaxPos: int32; bRedraw: Bool ): Bool; stdcall; external cLibName name 'SetScrollRange';
    function  SetSysColors                                ( cElements: int32; const lpaElements; const lpaRgbValues ): Bool; stdcall; external cLibName name 'SetSysColors';
    function  SetSystemCursor                             ( hcur: HICON; id: uint32 ): Bool; stdcall; external cLibName name 'SetSystemCursor';
    function  SetThreadDesktop                            ( hDesktop: HDESK ): Bool; stdcall; external cLibName name 'SetThreadDesktop';
    function  SetTimer                                    ( hWnd: HWND; nIDEvent, uElapse: uint32; TimerFunc: TimerProc ): uint32; stdcall; external cLibName name 'SetTimer';
    function  SetUserObjectInformationA                   ( hObj: winHandle; nIndex: int32; pvInfo: Pointer; nLength: uint32 ): Bool; stdcall; external cLibName name 'SetUserObjectInformationA';
    function  SetUserObjectInformationW                   ( hObj: winHandle; nIndex: int32; pvInfo: Pointer; nLength: uint32 ): Bool; stdcall; external cLibName name 'SetUserObjectInformationW';
    function  SetUserObjectSecurity                       ( hObj: winHandle; var pSIRequested: uint32; pSID: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'SetUserObjectSecurity';
    function  SetWinEventHook                             ( eventMin, eventMax: uint32; hmodWinEventProc: HMODULE; pfnWinEventProc: WinEventProc; idProcess, idThread, dwFlags: uint32 ): winHandle; stdcall; external cLibName name 'SetWinEventHook';
    function  SetWindowContextHelpId                      ( hWnd: HWND; HelpID: uint32 ): Bool; stdcall; external cLibName name 'SetWindowContextHelpId';
    function  SetWindowLongA                              ( hWnd: HWND; nIndex: int32; dwNewLong: int32 ): int32; stdcall; external cLibName name 'SetWindowLongA';
    function  SetWindowLongW                              ( hWnd: HWND; nIndex: int32; dwNewLong: int32 ): int32; stdcall; external cLibName name 'SetWindowLongW';
    function  SetWindowPlacement                          ( hWnd: HWND; WindowPlacement: PWindowPlacement ): Bool; stdcall; external cLibName name 'SetWindowPlacement';
    function  SetWindowPos                                ( hWnd: HWND; hWndInsertAfter: HWND; X, Y, cx, cy: int32; uFlags: uint32 ): Bool; stdcall; external cLibName name 'SetWindowPos';
    function  SetWindowRgn                                ( hWnd: HWND; hRgn: HRGN; bRedraw: Bool ): Bool; stdcall; external cLibName name 'SetWindowRgn';
    function  SetWindowTextA                              ( hWnd: HWND; lpString: PAnsiChar ): Bool; stdcall; external cLibName name 'SetWindowTextA';
    function  SetWindowTextW                              ( hWnd: HWND; lpString: PWideChar ): Bool; stdcall; external cLibName name 'SetWindowTextW';
    function  SetWindowWord                               ( hWnd: HWND; nIndex: int32; wNewWord: uint16 ): uint16; stdcall; external cLibName name 'SetWindowWord';
    function  SetWindowsHookA                             ( nFilterType: int32; pfnFilterProc: HookProc ): HHOOK; stdcall; external cLibName name 'SetWindowsHookA';
    function  SetWindowsHookW                             ( nFilterType: int32; pfnFilterProc: HookProc ): HHOOK; stdcall; external cLibName name 'SetWindowsHookW';
    function  SetWindowsHookExA                           ( idHook: int32; lpfn: HookProc; hmod: HINST; dwThreadId: uint32 ): HHOOK; stdcall; external cLibName name 'SetWindowsHookExA';
    function  SetWindowsHookExW                           ( idHook: int32; lpfn: HookProc; hmod: HINST; dwThreadId: uint32 ): HHOOK; stdcall; external cLibName name 'SetWindowsHookExW';
    function  ShowCaret                                   ( hWnd: HWND ): Bool; stdcall; external cLibName name 'ShowCaret';
    function  ShowCursor                                  ( bShow: Bool ): int32; stdcall; external cLibName name 'ShowCursor';
    function  ShowOwnedPopups                             ( hWnd: HWND; fShow: Bool ): Bool; stdcall; external cLibName name 'ShowOwnedPopups';
    function  ShowScrollBar                               ( hWnd: HWND; wBar: int32; bShow: Bool ): Bool; stdcall; external cLibName name 'ShowScrollBar';
    function  ShowWindow                                  ( hWnd: HWND; nCmdShow: int32 ): Bool; stdcall; external cLibName name 'ShowWindow';
    function  ShowWindowAsync                             ( hWnd: HWND; nCmdShow: int32 ): Bool; stdcall; external cLibName name 'ShowWindowAsync';
    function  SubtractRect                                ( var lprcDst: Rect; const lprcSrc1, lprcSrc2: Rect ): Bool; stdcall; external cLibName name 'SubtractRect';
    function  SwapMouseButton                             ( fSwap: Bool ): Bool; stdcall; external cLibName name 'SwapMouseButton';
    function  SwitchDesktop                               ( hDesktop: HDESK ): Bool; stdcall; external cLibName name 'SwitchDesktop';
    function  SystemParametersInfoA                       ( uiAction, uiParam: uint32; pvParam: Pointer; fWinIni: uint32 ): Bool; stdcall; external cLibName name 'SystemParametersInfoA';
    function  SystemParametersInfoW                       ( uiAction, uiParam: uint32; pvParam: Pointer; fWinIni: uint32 ): Bool; stdcall; external cLibName name 'SystemParametersInfoW';
    function  TabbedTextOut                               ( hDC: HDC; X, Y: int32; lpString: PAnsiChar; nCount, nTabPositions: int32; var lpnTabStopPositions; nTabOrigin: int32 ): int32; stdcall; external cLibName name 'TabbedTextOutA';
    function  TabbedTextOutW                              ( hDC: HDC; X, Y: int32; lpString: PWideChar; nCount, nTabPositions: int32; var lpnTabStopPositions; nTabOrigin: int32 ): int32; stdcall; external cLibName name 'TabbedTextOutW';
    function  TileWindows                                 ( hwndParent: HWND; wHow: uint32; lpRect: PRect; cKids: uint32; lpKids: Pointer ): uint16; stdcall; external cLibName name 'TileWindows';
    function  ToAscii                                     ( uVirtKey, uScanCode: uint32; const KeyState: uint8; lpChar: PChar; uFlags: uint32 ): int32; stdcall; external cLibName name 'ToAscii';
    function  ToAsciiEx                                   ( uVirtKey: uint32; uScanCode: uint32; const KeyState: uint8; lpChar: PChar; uFlags: uint32; dwhkl: HKL ): int32; stdcall; external cLibName name 'ToAsciiEx';
    function  ToUnicode                                   ( wVirtKey, wScanCode: uint32; const KeyState: uint8; var pwszBuff; cchBuff: int32; wFlags: uint32 ): int32; stdcall; external cLibName name 'ToUnicode';
    function  ToUnicodeEx                                 ( wVirtKey, wScanCode: uint32; lpKeyState: puint8; pwszBuff: PWideChar; cchBuff: int32; wFlags: uint32; dwhkl: HKL ): int32; stdcall; external cLibName name 'ToUnicodeEx';
    function  TrackMouseEvent                             ( var EventTrack: _TrackMouseEvent): Bool; stdcall; external cLibName name 'TrackMouseEvent';
    function  TrackPopupMenu                              ( hMenu: HMENU; uFlags: uint32; x, y, nReserved: int32; hWnd: HWND; prcRect: PRect ): Bool; stdcall; external cLibName name 'TrackPopupMenu';
    function  TrackPopupMenuEx                            ( hMenu: HMENU; Flags: uint32; x, y: int32; Wnd: HWND; TPMParams: PTPMParams ): Bool; stdcall; external cLibName name 'TrackPopupMenuEx';
    function  TranslateAcceleratorA                       ( hWnd: HWND; hAccTable: HACCEL; var lpMsg: Msg ): int32; stdcall; external cLibName name 'TranslateAcceleratorA';
    function  TranslateAcceleratorW                       ( hWnd: HWND; hAccTable: HACCEL; var lpMsg: Msg ): int32; stdcall; external cLibName name 'TranslateAcceleratorW';
    function  TranslateMDISysAccel                        ( hWndClient: HWND; const lpMsg: Msg ): Bool; stdcall; external cLibName name 'TranslateMDISysAccel';
    function  TranslateMessage                            ( const lpMsg: Msg ): Bool; stdcall; external cLibName name 'TranslateMessage';
    function  UnhookWinEvent                              ( hWinEventHook: winHandle ): Bool; stdcall; external cLibName name 'UnhookWinEvent';
    function  UnhookWindowsHook                           ( nCode: int32; pfnFilterProc: HookProc ): Bool; stdcall; external cLibName name 'UnhookWindowsHook';
    function  UnhookWindowsHookEx                         ( hhk: HHOOK ): Bool; stdcall; external cLibName name 'UnhookWindowsHookEx';
    function  UnionRect                                   ( var lprcDst: Rect; const lprcSrc1, lprcSrc2: Rect ): Bool; stdcall; external cLibName name 'UnionRect';
    function  UnloadKeyboardLayout                        ( hkl: HKL ): Bool; stdcall; external cLibName name 'UnloadKeyboardLayout';
    function  UnpackDDElParam                             ( msg: uint32; lParam: int32; puiLo: puint32; puiHi: puint32 ): Bool; stdcall; external cLibName name 'UnpackDDElParam';
    function  UnregisterClassA                            ( lpClassName: PAnsiChar; THINSTance: HINST ): Bool; stdcall; external cLibName name 'UnregisterClassA';
    function  UnregisterClassW                            ( lpClassName: PWideChar; THINSTance: HINST ): Bool; stdcall; external cLibName name 'UnregisterClassW';
    function  UnregisterDeviceNotification                ( Handle: HDEVNOTIFY ): Bool; stdcall; external cLibName name 'UnregisterDeviceNotification';
    function  UnregisterHotKey                            ( hWnd: HWND; id: int32 ): Bool; stdcall; external cLibName name 'UnregisterHotKey';
    function  UpdateWindow                                ( hWnd: HWND ): Bool; stdcall; external cLibName name 'UpdateWindow';
    function  UserHandleGrantAccess                       ( hUserHandle, hJob: winHandle ): Bool; stdcall; external cLibName name 'UserHandleGrantAccess';
    function  ValidateRect                                ( hWnd: HWND; lpRect: PRect ): Bool; stdcall; external cLibName name 'ValidateRect';
    function  ValidateRgn                                 ( hWnd: HWND; hRgn: HRGN ): Bool; stdcall; external cLibName name 'ValidateRgn';
    function  VkKeyScanA                                  ( ch: AnsiChar ): int16; stdcall; external cLibName name 'VkKeyScanA';
    function  VkKeyScanW                                  ( ch: WideChar ): int16; stdcall; external cLibName name 'VkKeyScanW';
    function  VkKeyScanEx                                 ( ch: AnsiChar; dwhkl: HKL ): int16; stdcall; external cLibName name 'VkKeyScanExA';
    function  VkKeyScanExW                                ( ch: WideChar; dwhkl: HKL ): int16; stdcall; external cLibName name 'VkKeyScanExW';
    function  WaitForInputIdle                            ( hProcess: winHandle; dwMilliseconds: uint32 ): uint32; stdcall; external cLibName name 'WaitForInputIdle';
    function  WaitMessage                                 (  ): Bool; stdcall; external cLibName name 'WaitMessage';
    function  WinHelpA                                    ( hWndMain: HWND; lpszHelp: PAnsiChar; uCommand: uint32; dwData: uint32 ): Bool; stdcall; external cLibName name 'WinHelpA';
    function  WinHelpW                                    ( hWndMain: HWND; lpszHelp: PWideChar; uCommand: uint32; dwData: uint32 ): Bool; stdcall; external cLibName name 'WinHelpW';
    function  WindowFromDC                                ( hDC: HDC ): HWND; stdcall; external cLibName name 'WindowFromDC';
    function  WindowFromPoint                             ( Point: Point ): HWND; stdcall; external cLibName name 'WindowFromPoint';
    procedure keybd_evente                                ( bVk: uint8; bScan: uint8; dwFlags, dwExtraInfo: uint32 ); stdcall; external cLibName name 'keybd_event';
    procedure mouse_evente                                ( dwFlags, dx, dy, dwData, dwExtraInfo: uint32 ); stdcall; external cLibName name 'mouse_event';
    function  wsprintfA                                   ( Output: PAnsiChar; Format: PAnsiChar ): int32; stdcall; external cLibName name 'wsprintfA';
    function  wsprintfW                                   ( Output: PWideChar; Format: PWideChar ): int32; stdcall; external cLibName name 'wsprintfW';
    function  wvsprintfA                                  ( Output: PAnsiChar; Format: PAnsiChar; arglist: va_list ): int32; stdcall; external cLibName name 'wvsprintfA';
    function  wvsprintfW                                  ( Output: PWideChar; Format: PWideChar; arglist: va_list ): int32; stdcall; external cLibName name 'wvsprintfW';

    procedure AcquireSRWLockExclusive                     ( var Lock: SRWLock ); stdcall; external cLibNameKernel name 'AcquireSRWLockExclusive';
    procedure InitializeSRWLock                           ( var Lock: SRWLock );  stdcall; external cLibNameKernel name 'InitializeSRWLock';
    procedure InitializeConditionVariable                 ( var CV: CONDITION_VARIABLE );  stdcall; external cLibNameKernel name 'InitializeConditionVariable';
    procedure ReleaseSRWLockExclusive                     ( var Lock: SRWLock ); stdcall; external cLibNameKernel name 'ReleaseSRWLockExclusive';
    function  SleepConditionVariableSRW                   ( var CV: CONDITION_VARIABLE; var SRWLock: SRWLock; dwMilliseconds: uint32; flags: uint64 ): Bool; stdcall; external cLibNameKernel name 'SleepConditionVariableSRW';
    procedure WakeConditionVariable                       ( var CV: CONDITION_VARIABLE ); stdcall; external cLibNameKernel name 'WakeConditionVariable';
    function  AddAtomA                                    ( lpString: PAnsiChar ): Atom; stdcall; external cLibNameKernel name 'AddAtomA';
    function  AddAtomW                                    ( lpString: PWideChar ): Atom; stdcall; external cLibNameKernel name 'AddAtomW';
    function  AllocConsole                                ( ): Bool; stdcall; external cLibNameKernel name 'AllocConsole';
    function  AreFileApisANSI                             ( ): Bool; stdcall; external cLibNameKernel name 'AreFileApisANSI';
    function  BackupRead                                  ( hFile: winHandle; lpBuffer: puint8; nNumberOfBytesToRead: uint32; var lpNumberOfBytesRead: uint32; bAbort: Bool; bProcessSecurity: Bool; var lpContext: Pointer ): Bool; stdcall; external cLibNameKernel name 'BackupRead';
    function  BackupSeek                                  ( hFile: winHandle; dwLowBytesToSeek, dwHighBytesToSeek: uint32; var lpdwLowByteSeeked, lpdwHighByteSeeked: uint32; lpContext: Pointer ): Bool; stdcall; external cLibNameKernel name 'BackupSeek';
    function  BackupWrite                                 ( hFile: winHandle; lpBuffer: puint8; nNumberOfBytesToWrite: uint32; var lpNumberOfBytesWritten: uint32; bAbort, bProcessSecurity: Bool; var lpContext: Pointer ): Bool; stdcall; external cLibNameKernel name 'BackupWrite';
    function  Beep                                        ( dwFreq, dwDuration: uint32 ): Bool; stdcall; external cLibNameKernel name 'Beep';
    function  BeginUpdateResourceA                        ( pFileName: PAnsiChar; bDeleteExistingResources: Bool ): winHandle; stdcall; external cLibNameKernel name 'BeginUpdateResourceA';
    function  BeginUpdateResourceW                        ( pFileName: PWideChar; bDeleteExistingResources: Bool ): winHandle; stdcall; external cLibNameKernel name 'BeginUpdateResourceW';
    function  BuildCommDCB                                ( lpDef: PAnsiChar; var lpDCB: DCB ): Bool; stdcall; external cLibNameKernel name 'BuildCommDCBA';
    function  BuildCommDCBAndTimeoutsA                    ( lpDef: PAnsiChar; var lpDCB: DCB; var lpCommTimeouts: CommTimeouts ): Bool; stdcall; external cLibNameKernel name 'BuildCommDCBAndTimeoutsA';
    function  BuildCommDCBAndTimeoutsW                    ( lpDef: PWideChar; var lpDCB: DCB; var lpCommTimeouts: CommTimeouts ): Bool; stdcall; external cLibNameKernel name 'BuildCommDCBAndTimeoutsW';
    function  BuildCommDCBW                               ( lpDef: PWideChar; var lpDCB: DCB ): Bool; stdcall; external cLibNameKernel name 'BuildCommDCBW';
    function  CallNamedPipeA                              ( lpNamedPipeName: PAnsiChar; lpInBuffer: Pointer; nInBufferSize: uint32; lpOutBuffer: Pointer; nOutBufferSize: uint32; var lpBytesRead: uint32; nTimeOut: uint32 ): Bool; stdcall; external cLibNameKernel name 'CallNamedPipeA';
    function  CallNamedPipeW                              ( lpNamedPipeName: PWideChar; lpInBuffer: Pointer; nInBufferSize: uint32; lpOutBuffer: Pointer; nOutBufferSize: uint32; var lpBytesRead: uint32; nTimeOut: uint32 ): Bool; stdcall; external cLibNameKernel name 'CallNamedPipeW';
    function  CancelIo                                    ( hFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'CancelIo';
    function  CancelWaitableTimer                         ( hTimer: winHandle ): Bool; stdcall; external cLibNameKernel name 'CancelWaitableTimer';
    function  ClearCommBreak                              ( hFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'ClearCommBreak';
    function  ClearCommError                              ( hFile: winHandle; var lpErrors: uint32; lpStat: PComStat ): Bool; stdcall; external cLibNameKernel name 'ClearCommError';
    function  CloseHandle                                 ( hObject: winHandle ): Bool; stdcall; external cLibNameKernel name 'CloseHandle';
    function  CommConfigDialogA                           ( lpszName: PAnsiChar; hWnd: HWND; var lpCC: CommConfig ): Bool; stdcall; external cLibNameKernel name 'CommConfigDialogA';
    function  CommConfigDialogW                           ( lpszName: PWideChar; hWnd: HWND; var lpCC: CommConfig ): Bool; stdcall; external cLibNameKernel name 'CommConfigDialogW';
    function  CompareFileTime                             ( const lpFileTime1, lpFileTime2: FileTime ): int32; stdcall; external cLibNameKernel name 'CompareFileTime';
    function  CompareStringA                              ( Locale: LCID; dwCmpFlags: uint32; lpString1: PAnsiChar; cchCount1: int32; lpString2: PAnsiChar; cchCount2: int32 ): int32; stdcall; external cLibNameKernel name 'CompareStringA';
    function  CompareStringW                              ( Locale: LCID; dwCmpFlags: uint32; lpString1: PWideChar; cchCount1: int32; lpString2: PWideChar; cchCount2: int32 ): int32; stdcall; external cLibNameKernel name 'CompareStringW';
    function  ConnectNamedPipe                            ( hNamedPipe: winHandle; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'ConnectNamedPipe';
    function  ContinueDebugEvent                          ( dwProcessId, dwThreadId, dwContinueStatus: uint32 ): Bool; stdcall; external cLibNameKernel name 'ContinueDebugEvent';
    function  ConvertDefaultLocale                        ( Locale: LCID ): LCID; stdcall; external cLibNameKernel name 'ConvertDefaultLocale';
    function  ConvertThreadToFiber                        ( lpParameter: Pointer ): Bool; stdcall; external cLibNameKernel name 'ConvertThreadToFiber';
    function  CopyFileA                                   ( lpExistingFileName, lpNewFileName: PAnsiChar; bFailIfExists: Bool ): Bool; stdcall; external cLibNameKernel name 'CopyFileA';
    function  CopyFileW                                   ( lpExistingFileName, lpNewFileName: PWideChar; bFailIfExists: Bool ): Bool; stdcall; external cLibNameKernel name 'CopyFileW';
    function  CopyFileExA                                 ( lpExistingFileName, lpNewFileName: PAnsiChar; lpProgressRoutine: CopyProgressRoutine; lpData: Pointer; out pbCancel: Bool; dwCopyFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'CopyFileExA';
    function  CopyFileExW                                 ( lpExistingFileName, lpNewFileName: PWideChar; lpProgressRoutine: CopyProgressRoutine; lpData: Pointer; out pbCancel: Bool; dwCopyFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'CopyFileExW';
    function  CreateConsoleScreenBuffer                   ( dwDesiredAccess, dwShareMode: uint32; lpSecurityAttributes: PSecurityAttributes; dwFlags: uint32; lpScreenBufferData: Pointer ): winHandle; stdcall; external cLibNameKernel name 'CreateConsoleScreenBuffer';
    function  CreateDirectoryA                            ( lpPathName: PAnsiChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateDirectoryA';
    function  CreateDirectoryW                            ( lpPathName: PWideChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateDirectoryW';
    function  CreateDirectoryEx                           ( lpTemplateDirectory, lpNewDirectory: PAnsiChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateDirectoryExA';
    function  CreateDirectoryExW                          ( lpTemplateDirectory, lpNewDirectory: PWideChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateDirectoryExW';
    function  CreateEventA                                ( lpEventAttributes: PSecurityAttributes; bManualReset, bInitialState: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'CreateEventA';
    function  CreateEventW                                ( lpEventAttributes: PSecurityAttributes; bManualReset, bInitialState: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'CreateEventW';
    function  CreateFiber                                 ( dwStackSize: uint32; lpStartAddress: FiberProc; lpParameter: Pointer ): Bool; stdcall; external cLibNameKernel name 'CreateFiber';
    function  CreateFileA                                 ( lpFileName: PAnsiChar; dwDesiredAccess, dwShareMode: uint32; lpSecurityAttributes: PSecurityAttributes; dwCreationDisposition, dwFlagsAndAttributes: uint32; hTemplateFile: winHandle ): winHandle; stdcall; external cLibNameKernel name 'CreateFileA';
    function  CreateFileW                                 ( lpFileName: PWideChar; dwDesiredAccess, dwShareMode: uint32; lpSecurityAttributes: PSecurityAttributes; dwCreationDisposition, dwFlagsAndAttributes: uint32; hTemplateFile: winHandle ): winHandle; stdcall; external cLibNameKernel name 'CreateFileW';
    function  CreateFileMappingA                          ( hFile: winHandle; lpFileMappingAttributes: PSecurityAttributes; flProtect, dwMaximumSizeHigh, dwMaximumSizeLow: uint32; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'CreateFileMappingA';
    function  CreateFileMappingW                          ( hFile: winHandle; lpFileMappingAttributes: PSecurityAttributes; flProtect, dwMaximumSizeHigh, dwMaximumSizeLow: uint32; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'CreateFileMappingW';
    function  CreateHardLinkA                             ( lpFileName, lpExistingFileName: PAnsiChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateHardLinkA';
    function  CreateHardLinkW                             ( lpFileName, lpExistingFileName: PWideChar; lpSecurityAttributes: PSecurityAttributes ): Bool; stdcall; external cLibNameKernel name 'CreateHardLinkW';
    function  CreateIoCompletionPort                      ( FileHandle, ExistingCompletionPort: winHandle; CompletionKey, NumberOfConcurrentThreads: uint32 ): winHandle; stdcall; external cLibNameKernel name 'CreateIoCompletionPort';
    function  CreateMailslotA                             ( lpName: PAnsiChar; nMaxMessageSize: uint32; lReadTimeout: uint32; lpSecurityAttributes: PSecurityAttributes ): winHandle; stdcall; external cLibNameKernel name 'CreateMailslotA';
    function  CreateMailslotW                             ( lpName: PWideChar; nMaxMessageSize: uint32; lReadTimeout: uint32; lpSecurityAttributes: PSecurityAttributes ): winHandle; stdcall; external cLibNameKernel name 'CreateMailslotW';
    function  CreateMutexA                                ( lpMutexAttributes: PSecurityAttributes; bInitialOwner: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'CreateMutexA';
    function  CreateMutexW                                ( lpMutexAttributes: PSecurityAttributes; bInitialOwner: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'CreateMutexW';
    function  CreateNamedPipeA                            ( lpName: PAnsiChar; dwOpenMode, dwPipeMode, nMaxInstances, nOutBufferSize, nInBufferSize, nDefaultTimeOut: uint32; lpSecurityAttributes: PSecurityAttributes ): winHandle; stdcall; external cLibNameKernel name 'CreateNamedPipeA';
    function  CreateNamedPipeW                            ( lpName: PWideChar; dwOpenMode, dwPipeMode, nMaxInstances, nOutBufferSize, nInBufferSize, nDefaultTimeOut: uint32; lpSecurityAttributes: PSecurityAttributes ): winHandle; stdcall; external cLibNameKernel name 'CreateNamedPipeW';
    function  CreatePipe                                  ( var hReadPipe, hWritePipe: winHandle; lpPipeAttributes: PSecurityAttributes; nSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'CreatePipe';
    function  CreateProcessA                              ( lpApplicationName: PAnsiChar; lpCommandLine: PAnsiChar; lpProcessAttributes, lpThreadAttributes: PSecurityAttributes; bInheritHandles: Bool; dwCreationFlags: uint32; lpEnvironment: Pointer; lpCurrentDirectory: PAnsiChar; const lpStartupInfo: StartupInfoA; var lpProcessInformation: ProcessInformation ): Bool; stdcall; external cLibNameKernel name 'CreateProcessA';
    function  CreateProcessW                              ( lpApplicationName: PWideChar; lpCommandLine: PWideChar; lpProcessAttributes, lpThreadAttributes: PSecurityAttributes; bInheritHandles: Bool; dwCreationFlags: uint32; lpEnvironment: Pointer; lpCurrentDirectory: PWideChar; const lpStartupInfo: StartupInfoW; var lpProcessInformation: ProcessInformation ): Bool; stdcall; external cLibNameKernel name 'CreateProcessW';
    function  CreateRemoteThread                          ( hProcess: winHandle; lpThreadAttributes: Pointer; dwStackSize: uint32; lpStartAddress: ThreadProc; lpParameter: Pointer; dwCreationFlags: uint32; var lpThreadId: uint32 ): winHandle; stdcall; external cLibNameKernel name 'CreateRemoteThread';
    function  CreateSemaphoreA                            ( lpSemaphoreAttributes: PSecurityAttributes; lInitialCount, lMaximumCount: int32; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'CreateSemaphoreA';
    function  CreateSemaphoreW                            ( lpSemaphoreAttributes: PSecurityAttributes; lInitialCount, lMaximumCount: int32; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'CreateSemaphoreW';
    function  CreateTapePartition                         ( hDevice: winHandle; dwPartitionMethod, dwCount, dwSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'CreateTapePartition';
    function  CreateThread                                ( lpThreadAttributes: Pointer; dwStackSize: uint32; lpStartAddress: ThreadProc; lpParameter: Pointer; dwCreationFlags: uint32; var lpThreadId: uint32 ): winHandle; stdcall; external cLibNameKernel name 'CreateThread';
    function  CreateToolhelp32Snapshot                    ( dwFlags, th32ProcessID: uint32 ): winHandle; stdcall; external cLibNameKernel name 'CreateToolhelp32Snapshot';
    function  CreateWaitableTimerA                        ( lpTimerAttributes: PSecurityAttributes; bManualReset: Bool; lpTimerName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'CreateWaitableTimerA';
    function  CreateWaitableTimerW                        ( lpTimerAttributes: PSecurityAttributes; bManualReset: Bool; lpTimerName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'CreateWaitableTimerW';
    function  DebugActiveProcess                          ( dwProcessId: uint32 ): Bool; stdcall; external cLibNameKernel name 'DebugActiveProcess';
    procedure DebugBreak                                  ( ); stdcall; external cLibNameKernel name 'DebugBreak';
    function  DefineDosDeviceA                            ( dwFlags: uint32; lpDeviceName, lpTargetPath: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'DefineDosDeviceA';
    function  DefineDosDeviceW                            ( dwFlags: uint32; lpDeviceName, lpTargetPath: PWideChar ): Bool; stdcall; external cLibNameKernel name 'DefineDosDeviceW';
    function  DeleteAtom                                  ( nAtom: ATOM ): ATOM; stdcall; external cLibNameKernel name 'DeleteAtom';
    procedure DeleteCriticalSection                       ( var lpCriticalSection: RTLCriticalSection ); stdcall; external cLibNameKernel name 'DeleteCriticalSection';
    function  DeleteFiber                                 ( lpFiber: Pointer ): Bool; stdcall; external cLibNameKernel name 'DeleteFiber';
    function  DeleteFileA                                 ( lpFileName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'DeleteFileA';
    function  DeleteFileW                                 ( lpFileName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'DeleteFileW';
    function  DeviceIoControl                             ( hDevice: winHandle; dwIoControlCode: uint32; lpInBuffer: Pointer; nInBufferSize: uint32; lpOutBuffer: Pointer; nOutBufferSize: uint32; var lpBytesReturned: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'DeviceIoControl';
    function  DisableThreadLibraryCalls                   ( hLibModule: HMODULE ): Bool; stdcall; external cLibNameKernel name 'DisableThreadLibraryCalls';
    function  DisconnectNamedPipe                         ( hNamedPipe: winHandle ): Bool; stdcall; external cLibNameKernel name 'DisconnectNamedPipe';
    function  DosDateTimeToFileTime                       ( wFatDate, wFatTime: uint16; var lpFileTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'DosDateTimeToFileTime';
    function  DuplicateHandle                             ( hSourceProcessHandle, hSourceHandle, hTargetProcessHandle: winHandle; lpTargetHandle: pWinHandle; dwDesiredAccess: uint32; bInheritHandle: Bool; dwOptions: uint32 ): Bool; stdcall; external cLibNameKernel name 'DuplicateHandle';
    function  EndUpdateResourceA                          ( hUpdate: winHandle; fDiscard: Bool ): Bool; stdcall; external cLibNameKernel name 'EndUpdateResourceA';
    function  EndUpdateResourceW                          ( hUpdate: winHandle; fDiscard: Bool ): Bool; stdcall; external cLibNameKernel name 'EndUpdateResourceW';
    procedure EnterCriticalSection                        ( var lpCriticalSection: RTLCriticalSection ); stdcall; external cLibNameKernel name 'EnterCriticalSection';
    function  EnumCalendarInfoA                           ( lpCalInfoEnumProc: CalInfoEnumProcA; Locale: LCID; Calendar: CALID; CalType: CALTYPE ): Bool; stdcall; external cLibNameKernel name 'EnumCalendarInfoA';
    function  EnumCalendarInfoW                           ( lpCalInfoEnumProc: CalInfoEnumProcW; Locale: LCID; Calendar: CALID; CalType: CALTYPE ): Bool; stdcall; external cLibNameKernel name 'EnumCalendarInfoW';
    function  EnumDateFormatsA                            ( lpDateFmtEnumProc: DateFmtEnumProcA; Locale: LCID; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumDateFormatsA';
    function  EnumDateFormatsW                            ( lpDateFmtEnumProc: DateFmtEnumProcW; Locale: LCID; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumDateFormatsW';
    function  EnumResourceLanguagesA                      ( hModule: HMODULE; lpType, lpName: PAnsiChar; lpEnumFunc: EnumResLangProcA; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceLanguagesA';
    function  EnumResourceLanguagesW                      ( hModule: HMODULE; lpType, lpName: PWideChar; lpEnumFunc: EnumResLangProcW; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceLanguagesW';
    function  EnumResourceNamesA                          ( hModule: HMODULE; lpType: PAnsiChar; lpEnumFunc: EnumResNameProcA; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceNamesA';
    function  EnumResourceNamesW                          ( hModule: HMODULE; lpType: PWideChar; lpEnumFunc: EnumResNameProcW; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceNamesW';
    function  EnumResourceTypesA                          ( hModule: HMODULE; lpEnumFunc: EnumResTypeProcA; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceTypesA';
    function  EnumResourceTypesW                          ( hModule: HMODULE; lpEnumFunc: EnumResTypeProcW; lParam: int32 ): Bool; stdcall; external cLibNameKernel name 'EnumResourceTypesW';
    function  EnumSystemCodePagesA                        ( lpCodePageEnumProc: EnumCodePageProcA; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumSystemCodePagesA';
    function  EnumSystemCodePagesW                        ( lpCodePageEnumProc: EnumCodePageProcW; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumSystemCodePagesW';
    function  EnumSystemLocalesA                          ( lpLocaleEnumProc: EnumLocaleProcA; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumSystemLocalesA';
    function  EnumSystemLocalesW                          ( lpLocaleEnumProc: EnumLocaleProcW; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumSystemLocalesW';
    function  EnumTimeFormatsA                            ( lpTimeFmtEnumProc: EnumTimeFmtProcA; Locale: LCID; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumTimeFormatsA';
    function  EnumTimeFormatsW                            ( lpTimeFmtEnumProc: EnumTimeFmtProcW; Locale: LCID; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'EnumTimeFormatsW';
    function  EraseTape                                   ( hDevice: winHandle; dwEraseType: uint32; bImmediate: Bool ): uint32; stdcall; external cLibNameKernel name 'EraseTape';
    function  EscapeCommFunction                          ( hFile: winHandle; dwFunc: uint32 ): Bool; stdcall; external cLibNameKernel name 'EscapeCommFunction';
    procedure ExitProcess                                 ( uExitCode: uint32 ); stdcall; external cLibNameKernel name 'ExitProcess';
    procedure ExitThread                                  ( dwExitCode: uint32 ); stdcall; external cLibNameKernel name 'ExitThread';
    function  ExpandEnvironmentStringsA                   ( lpSrc: PAnsiChar; lpDst: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'ExpandEnvironmentStringsA';
    function  ExpandEnvironmentStringsW                   ( lpSrc: PWideChar; lpDst: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'ExpandEnvironmentStringsW';
    procedure FatalAppExitA                               ( uAction: uint32; lpMessageText: PAnsiChar ); stdcall; external cLibNameKernel name 'FatalAppExitA';
    procedure FatalAppExitW                               ( uAction: uint32; lpMessageText: PWideChar ); stdcall; external cLibNameKernel name 'FatalAppExitW';
    procedure FatalExit                                   ( ExitCode: int32 ); stdcall; external cLibNameKernel name 'FatalExit';
    function  FileTimeToDosDateTime                       ( const lpFileTime: FileTime; var lpFatDate, lpFatTime: uint16 ): Bool; stdcall; external cLibNameKernel name 'FileTimeToDosDateTime';
    function  FileTimeToLocalFileTime                     ( const lpFileTime: FileTime; var lpLocalFileTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'FileTimeToLocalFileTime';
    function  FileTimeToSystemTime                        ( const lpFileTime: FileTime; var lpSystemTime: SystemTime ): Bool; stdcall; external cLibNameKernel name 'FileTimeToSystemTime';
    function  FillConsoleOutputAttribute                  ( hConsoleOutput: winHandle; wAttribute: uint16; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfAttrsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'FillConsoleOutputAttribute';
    function  FillConsoleOutputCharacterA                 ( hConsoleOutput: winHandle; cCharacter: AnsiChar; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfCharsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'FillConsoleOutputCharacterA';
    function  FillConsoleOutputCharacterW                 ( hConsoleOutput: winHandle; cCharacter: WideChar; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfCharsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'FillConsoleOutputCharacterW';
    function  FindAtomA                                   ( lpString: PAnsiChar ): ATOM; stdcall; external cLibNameKernel name 'FindAtomA';
    function  FindAtomW                                   ( lpString: PWideChar ): ATOM; stdcall; external cLibNameKernel name 'FindAtomW';
    function  FindClose                                   ( hFindFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'FindClose';
    function  FindCloseChangeNotification                 ( hChangeHandle: winHandle ): Bool; stdcall; external cLibNameKernel name 'FindCloseChangeNotification';
    function  FindFirstChangeNotificationA                ( lpPathName: PAnsiChar; bWatchSubtree: Bool; dwNotifyFilter: uint32 ): winHandle; stdcall; external cLibNameKernel name 'FindFirstChangeNotificationA';
    function  FindFirstChangeNotificationW                ( lpPathName: PWideChar; bWatchSubtree: Bool; dwNotifyFilter: uint32 ): winHandle; stdcall; external cLibNameKernel name 'FindFirstChangeNotificationW';
    function  FindFirstFileA                              ( lpFileName: pointer; lpFindFileData: PWIN32FindDataA ): winHandle; stdcall; external cLibNameKernel name 'FindFirstFileA';
    function  FindFirstFileW                              ( lpFileName: pointer; lpFindFileData: PWIN32FindDataW ): winHandle; stdcall; external cLibNameKernel name 'FindFirstFileW';
    function  FindFirstFileExA                            ( lpFileName: PAnsiChar; fInfoLevelId: FindexInfoLevels; lpFindFileData: Pointer; fSearchOp: FindexSearchOps; lpSearchFilter: Pointer; dwAdditionalFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'FindFirstFileExA';
    function  FindFirstFileExW                            ( lpFileName: PWideChar; fInfoLevelId: FindexInfoLevels; lpFindFileData: Pointer; fSearchOp: FindexSearchOps; lpSearchFilter: Pointer; dwAdditionalFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'FindFirstFileExW';
    function  FindNextChangeNotification                  ( hChangeHandle: winHandle ): Bool; stdcall; external cLibNameKernel name 'FindNextChangeNotification';
    function  FindNextFileA                               ( hFindFile: winHandle; lpFindFileData: PWIN32FindDataA ): Bool; stdcall; external cLibNameKernel name 'FindNextFileA';
    function  FindNextFileW                               ( hFindFile: winHandle; lpFindFileData: PWIN32FindDataW ): Bool; stdcall; external cLibNameKernel name 'FindNextFileW';
    function  FindResourceA                               ( hModule: HMODULE; lpName, lpType: PAnsiChar ): HRSRC; stdcall; external cLibNameKernel name 'FindResourceA';
    function  FindResourceW                               ( hModule: HMODULE; lpName, lpType: PWideChar ): HRSRC; stdcall; external cLibNameKernel name 'FindResourceW';
    function  FindResourceExA                             ( hModule: HMODULE; lpType, lpName: PAnsiChar; wLanguage: uint16 ): HRSRC; stdcall; external cLibNameKernel name 'FindResourceExA';
    function  FindResourceExW                             ( hModule: HMODULE; lpType, lpName: PWideChar; wLanguage: uint16 ): HRSRC; stdcall; external cLibNameKernel name 'FindResourceExW';
    function  FlushConsoleInputBuffer                     ( hConsoleInput: winHandle ): Bool; stdcall; external cLibNameKernel name 'FlushConsoleInputBuffer';
    function  FlushFileBuffers                            ( hFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'FlushFileBuffers';
    function  FlushInstructionCache                       ( hProcess: winHandle; const lpBaseAddress: Pointer; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'FlushInstructionCache';
    function  FlushViewOfFile                             ( const lpBaseAddress: Pointer; dwNumberOfBytesToFlush: uint32 ): Bool; stdcall; external cLibNameKernel name 'FlushViewOfFile';
    function  FoldStringA                                 ( dwMapFlags: uint32; lpSrcStr: PAnsiChar; cchSrc: int32; lpDestStr: PAnsiChar; cchDest: int32 ): int32; stdcall; external cLibNameKernel name 'FoldStringA';
    function  FoldStringW                                 ( dwMapFlags: uint32; lpSrcStr: PWideChar; cchSrc: int32; lpDestStr: PWideChar; cchDest: int32 ): int32; stdcall; external cLibNameKernel name 'FoldStringW';
    function  FormatMessageA                              ( dwFlags: uint32; lpSource: Pointer; dwMessageId: uint32; dwLanguageId: uint32; lpBuffer: PAnsiChar; nSize: uint32; Arguments: Pointer ): uint32; stdcall; external cLibNameKernel name 'FormatMessageA';
    function  FormatMessageW                              ( dwFlags: uint32; lpSource: Pointer; dwMessageId: uint32; dwLanguageId: uint32; lpBuffer: PWideChar; nSize: uint32; Arguments: Pointer ): uint32; stdcall; external cLibNameKernel name 'FormatMessageW';
    function  FreeConsole                                 ( ): Bool; stdcall; external cLibNameKernel name 'FreeConsole';
    function  FreeEnvironmentStringsA                     ( p1: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'FreeEnvironmentStringsA';
    function  FreeEnvironmentStringsW                     ( p1: PWideChar ): Bool; stdcall; external cLibNameKernel name 'FreeEnvironmentStringsW';
    function  FreeLibrary                                 ( hLibModule: HMODULE ): Bool; stdcall; external cLibNameKernel name 'FreeLibrary';
    procedure FreeLibraryAndExitThread                    ( hLibModule: HMODULE; dwExitCode: uint32 ); stdcall; external cLibNameKernel name 'FreeLibraryAndExitThread';
    function  FreeResource                                ( hResData: HGLOBAL ): Bool; stdcall; external cLibNameKernel name 'FreeResource';
    function  GenerateConsoleCtrlEvent                    ( dwCtrlEvent: uint32; dwProcessGroupId: uint32 ): Bool; stdcall; external cLibNameKernel name 'GenerateConsoleCtrlEvent';
    function  GetACP                                      ( ): uint32; stdcall; external cLibNameKernel name 'GetACP';
    function  GetAtomNameA                                ( nAtom: ATOM; lpBuffer: PAnsiChar; nSize: int32 ): uint32; stdcall; external cLibNameKernel name 'GetAtomNameA';
    function  GetAtomNameW                                ( nAtom: ATOM; lpBuffer: PWideChar; nSize: int32 ): uint32; stdcall; external cLibNameKernel name 'GetAtomNameW';
    function  GetBinaryTypeA                              ( lpApplicationName: PAnsiChar; var lpBinaryType: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetBinaryTypeA';
    function  GetBinaryTypeW                              ( lpApplicationName: PWideChar; var lpBinaryType: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetBinaryTypeW';
    function  GetCPInfo                                   ( CodePage: uint32; var lpCPInfo: CPInfo ): Bool; stdcall; external cLibNameKernel name 'GetCPInfo';
    function  GetCommConfig                               ( hCommDev: winHandle; var lpCC: CommConfig; var lpdwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetCommConfig';
    function  GetCommMask                                 ( hFile: winHandle; var lpEvtMask: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetCommMask';
    function  GetCommModemStatus                          ( hFile: winHandle; var lpModemStat: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetCommModemStatus';
    function  GetCommProperties                           ( hFile: winHandle; var lpCommProp: CommProp ): Bool; stdcall; external cLibNameKernel name 'GetCommProperties';
    function  GetCommState                                ( hFile: winHandle; var lpDCB: DCB ): Bool; stdcall; external cLibNameKernel name 'GetCommState';
    function  GetCommTimeouts                             ( hFile: winHandle; var lpCommTimeouts: CommTimeouts ): Bool; stdcall; external cLibNameKernel name 'GetCommTimeouts';
    function  GetCommandLineA                             ( ): PAnsiChar; stdcall; external cLibNameKernel name 'GetCommandLineA';
    function  GetCommandLineW                             ( ): PWideChar; stdcall; external cLibNameKernel name 'GetCommandLineW';
    function  GetCompressedFileSizeA                      ( lpFileName: PAnsiChar; var lpFileSizeHigh: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetCompressedFileSizeA';
    function  GetCompressedFileSizeW                      ( lpFileName: PWideChar; var lpFileSizeHigh: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetCompressedFileSizeW';
    function  GetComputerNameA                            ( lpBuffer: PAnsiChar; var nSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetComputerNameA';
    function  GetComputerNameW                            ( lpBuffer: PWideChar; var nSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetComputerNameW';
    function  GetConsoleCP                                ( ): uint32; stdcall; external cLibNameKernel name 'GetConsoleCP';
    function  GetConsoleCursorInfo                        ( hConsoleOutput: winHandle; var lpConsoleCursorInfo: ConsoleCursorInfo ): Bool; stdcall; external cLibNameKernel name 'GetConsoleCursorInfo';
    function  GetConsoleMode                              ( hConsoleHandle: winHandle; var lpMode: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetConsoleMode';
    function  GetConsoleOutputCP                          ( ): uint32; stdcall; external cLibNameKernel name 'GetConsoleOutputCP';
    function  GetConsoleScreenBufferInfo                  ( hConsoleOutput: winHandle; var lpConsoleScreenBufferInfo: ConsoleScreenBufferInfo ): Bool; stdcall; external cLibNameKernel name 'GetConsoleScreenBufferInfo';
    function  GetConsoleTitleA                            ( lpConsoleTitle: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetConsoleTitleA';
    function  GetConsoleTitleW                            ( lpConsoleTitle: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetConsoleTitleW';
    function  GetCurrencyFormatA                          ( Locale: LCID; dwFlags: uint32; lpValue: PAnsiChar; lpFormat: PCurrencyFmtA; lpCurrencyStr: PAnsiChar; cchCurrency: int32 ): int32; stdcall; external cLibNameKernel name 'GetCurrencyFormatA';
    function  GetCurrencyFormatW                          ( Locale: LCID; dwFlags: uint32; lpValue: PWideChar; lpFormat: PCurrencyFmtW; lpCurrencyStr: PWideChar; cchCurrency: int32 ): int32; stdcall; external cLibNameKernel name 'GetCurrencyFormatW';
    function  GetCurrentDirectoryA                        ( nBufferLength: uint32; lpBuffer: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetCurrentDirectoryA';
    function  GetCurrentDirectoryW                        ( nBufferLength: uint32; lpBuffer: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetCurrentDirectoryW';
    function  GetCurrentProcess                           ( ): winHandle; stdcall; external cLibNameKernel name 'GetCurrentProcess';
    function  GetCurrentProcessId                         ( ): uint32; stdcall; external cLibNameKernel name 'GetCurrentProcessId';
    function  GetCurrentThread                            ( ): winHandle; stdcall; external cLibNameKernel name 'GetCurrentThread';
    function  GetCurrentThreadId                          ( ): uint32; stdcall; external cLibNameKernel name 'GetCurrentThreadId';
    function  GetDateFormatA                              ( Locale: LCID; dwFlags: uint32; lpDate: PSystemTime; lpFormat: PAnsiChar; lpDateStr: PAnsiChar; cchDate: int32 ): int32; stdcall; external cLibNameKernel name 'GetDateFormatA';
    function  GetDateFormatW                              ( Locale: LCID; dwFlags: uint32; lpDate: PSystemTime; lpFormat: PWideChar; lpDateStr: PWideChar; cchDate: int32 ): int32; stdcall; external cLibNameKernel name 'GetDateFormatW';
    function  GetDefaultCommConfigA                       ( lpszName: PAnsiChar; var lpCC: CommConfig; var lpdwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetDefaultCommConfigA';
    function  GetDefaultCommConfigW                       ( lpszName: PWideChar; var lpCC: CommConfig; var lpdwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetDefaultCommConfigW';
    function  GetDiskFreeSpaceA                           ( lpRootPathName: PAnsiChar; var lpSectorsPerCluster, lpBytesPerSector, lpNumberOfFreeClusters, lpTotalNumberOfClusters: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetDiskFreeSpaceA';
    function  GetDiskFreeSpaceW                           ( lpRootPathName: PWideChar; var lpSectorsPerCluster, lpBytesPerSector, lpNumberOfFreeClusters, lpTotalNumberOfClusters: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetDiskFreeSpaceW';
    function  GetDiskFreeSpaceExA                         ( lpDirectoryName: PAnsiChar; out FreeBytesAvailableToCaller: int64; out TotalNumberOfBytes: int64; out TotalNumberOfFreeBytes: int64 ): Bool; stdcall; external cLibNameKernel name 'GetDiskFreeSpaceExA';
    function  GetDiskFreeSpaceExW                         ( lpDirectoryName: PWideChar; out FreeBytesAvailableToCaller: int64; out TotalNumberOfBytes: int64; out TotalNumberOfFreeBytes: int64 ): Bool; stdcall; external cLibNameKernel name 'GetDiskFreeSpaceExW';
    function  GetDriveTypeA                               ( lpRootPathName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetDriveTypeA';
    function  GetDriveTypeW                               ( lpRootPathName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetDriveTypeW';
    function  GetEnvironmentStringsA                      ( ): PAnsiChar; stdcall; external cLibNameKernel name 'GetEnvironmentStringsA';
    function  GetEnvironmentStringsW                      ( ): PWideChar; stdcall; external cLibNameKernel name 'GetEnvironmentStringsW';
    function  GetEnvironmentVariableA                     ( lpName: PAnsiChar; lpBuffer: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetEnvironmentVariableA';
    function  GetEnvironmentVariableW                     ( lpName: PWideChar; lpBuffer: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetEnvironmentVariableW';
    function  GetExitCodeProcess                          ( hProcess: winHandle; var lpExitCode: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetExitCodeProcess';
    function  GetExitCodeThread                           ( hThread: winHandle; var lpExitCode: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetExitCodeThread';
    function  GetFileAttributesA                          ( lpFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetFileAttributesA';
    function  GetFileAttributesW                          ( lpFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetFileAttributesW';
    function  GetFileAttributesExA                        ( lpFileName: PAnsiChar; fInfoLevelId: GetFileExInfoLevels; lpFileInformation: Pointer ): Bool; stdcall; external cLibNameKernel name 'GetFileAttributesExA';
    function  GetFileAttributesExW                        ( lpFileName: PWideChar; fInfoLevelId: GetFileExInfoLevels; lpFileInformation: Pointer ): Bool; stdcall; external cLibNameKernel name 'GetFileAttributesExW';
    function  GetFileInformationByHandle                  ( hFile: winHandle; var lpFileInformation: ByHandleFileInformation ): Bool; stdcall; external cLibNameKernel name 'GetFileInformationByHandle';
    function  GetFileSize                                 ( hFile: winHandle; lpFileSizeHigh: Pointer ): uint32; stdcall; external cLibNameKernel name 'GetFileSize';
    function  GetFileTime                                 ( hFile: winHandle; lpCreationTime, lpLastAccessTime, lpLastWriteTime: PFileTime ): Bool; stdcall; external cLibNameKernel name 'GetFileTime';
    function  GetFileType                                 ( hFile: winHandle ): uint32; stdcall; external cLibNameKernel name 'GetFileType';
    function  GetFullPathNameA                            ( lpFileName: PAnsiChar; nBufferLength: uint32; lpBuffer: PAnsiChar; var lpFilePart: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetFullPathNameA';
    function  GetFullPathNameW                            ( lpFileName: PWideChar; nBufferLength: uint32; lpBuffer: PWideChar; var lpFilePart: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetFullPathNameW';
    function  GetHandleInformation                        ( hObject: winHandle; var lpdwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetHandleInformation';
    function  GetLargestConsoleWindowSize                 ( hConsoleOutput: winHandle ): Coord; stdcall; external cLibNameKernel name 'GetLargestConsoleWindowSize';
    function  GetLastError                                ( ): uint32; stdcall; external cLibNameKernel name 'GetLastError';
    procedure GetLocalTime                                ( var lpSystemTime: SystemTime ); stdcall; external cLibNameKernel name 'GetLocalTime';
    function  GetLocaleInfoA                              ( Locale: LCID; LCType: LCTYPE; lpLCData: PAnsiChar; cchData: int32 ): int32; stdcall; external cLibNameKernel name 'GetLocaleInfoA';
    function  GetLocaleInfoW                              ( Locale: LCID; LCType: LCTYPE; lpLCData: PWideChar; cchData: int32 ): int32; stdcall; external cLibNameKernel name 'GetLocaleInfoW';
    function  GetLogicalDriveStringsA                     ( nBufferLength: uint32; lpBuffer: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetLogicalDriveStringsA';
    function  GetLogicalDriveStringsW                     ( nBufferLength: uint32; lpBuffer: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetLogicalDriveStringsW';
    function  GetLogicalDrives                            ( ): uint32; stdcall; external cLibNameKernel name 'GetLogicalDrives';
    function  GetMailslotInfo                             ( hMailslot: winHandle; lpMaxMessageSize: Pointer; var lpNextSize: uint32; lpMessageCount, lpReadTimeout: Pointer ): Bool; stdcall; external cLibNameKernel name 'GetMailslotInfo';
    function  GetModuleFileNameA                          ( hModule: HINST; lpFilename: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetModuleFileNameA';
    function  GetModuleFileNameW                          ( hModule: HINST; lpFilename: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetModuleFileNameW';
    function  GetModuleHandleA                            ( lpModuleName: PAnsiChar ): HMODULE; stdcall; external cLibNameKernel name 'GetModuleHandleA';
    function  GetModuleHandleW                            ( lpModuleName: PWideChar ): HMODULE; stdcall; external cLibNameKernel name 'GetModuleHandleW';
    function  GetNamedPipeHandleStateA                    ( hNamedPipe: winHandle; lpState, lpCurInstances, lpMaxCollectionCount, lpCollectDataTimeout: puint32; lpUserName: PAnsiChar; nMaxUserNameSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetNamedPipeHandleStateA';
    function  GetNamedPipeHandleStateW                    ( hNamedPipe: winHandle; lpState, lpCurInstances, lpMaxCollectionCount, lpCollectDataTimeout: puint32; lpUserName: PWideChar; nMaxUserNameSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetNamedPipeHandleStateW';
    function  GetNamedPipeInfo                            ( hNamedPipe: winHandle; var lpFlags: uint32; lpOutBufferSize, lpInBufferSize, lpMaxInstances: Pointer ): Bool; stdcall; external cLibNameKernel name 'GetNamedPipeInfo';
    function  GetNumberFormatA                            ( Locale: LCID; dwFlags: uint32; lpValue: PAnsiChar; lpFormat: PNumberFmtA; lpNumberStr: PAnsiChar; cchNumber: int32 ): int32; stdcall; external cLibNameKernel name 'GetNumberFormatA';
    function  GetNumberFormatW                            ( Locale: LCID; dwFlags: uint32; lpValue: PWideChar; lpFormat: PNumberFmtW; lpNumberStr: PWideChar; cchNumber: int32 ): int32; stdcall; external cLibNameKernel name 'GetNumberFormatW';
    function  GetNumberOfConsoleInputEvents               ( hConsoleInput: winHandle; var lpNumberOfEvents: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetNumberOfConsoleInputEvents';
    function  GetNumberOfConsoleMouseButtons              ( var lpNumberOfMouseButtons: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetNumberOfConsoleMouseButtons';
    function  GetOEMCP                                    ( ): uint32; stdcall; external cLibNameKernel name 'GetOEMCP';
    function  GetOverlappedResult                         ( hFile: winHandle; const lpOverlapped: Overlapped; var lpNumberOfBytesTransferred: uint32; bWait: Bool ): Bool; stdcall; external cLibNameKernel name 'GetOverlappedResult';
    function  GetPriorityClass                            ( hProcess: winHandle ): uint32; stdcall; external cLibNameKernel name 'GetPriorityClass';
    function  GetPrivateProfileIntA                       ( lpAppName, lpKeyName: PAnsiChar; nDefault: int32; lpFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileIntA';
    function  GetPrivateProfileIntW                       ( lpAppName, lpKeyName: PWideChar; nDefault: int32; lpFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileIntW';
    function  GetPrivateProfileSectionA                   ( lpAppName: PAnsiChar; lpReturnedString: PAnsiChar; nSize: uint32; lpFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileSectionA';
    function  GetPrivateProfileSectionW                   ( lpAppName: PWideChar; lpReturnedString: PWideChar; nSize: uint32; lpFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileSectionW';
    function  GetPrivateProfileSectionNamesA              ( lpszReturnBuffer: PAnsiChar; nSize: uint32; lpFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileSectionNamesA';
    function  GetPrivateProfileSectionNamesW              ( lpszReturnBuffer: PWideChar; nSize: uint32; lpFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileSectionNamesW';
    function  GetPrivateProfileStringA                    ( lpAppName, lpKeyName, lpDefault: PAnsiChar; lpReturnedString: PAnsiChar; nSize: uint32; lpFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileStringA';
    function  GetPrivateProfileStringW                    ( lpAppName, lpKeyName, lpDefault: PWideChar; lpReturnedString: PWideChar; nSize: uint32; lpFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetPrivateProfileStringW';
    function  GetPrivateProfileStructA                    ( lpszSection, lpszKey: PAnsiChar; lpStruct: Pointer; uSizeStruct: uint32; szFile: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'GetPrivateProfileStructA';
    function  GetPrivateProfileStructW                    ( lpszSection, lpszKey: PWideChar; lpStruct: Pointer; uSizeStruct: uint32; szFile: PWideChar ): Bool; stdcall; external cLibNameKernel name 'GetPrivateProfileStructW';
    function  GetProcAddress                              ( hModule: HMODULE; lpProcName: LPCSTR ): pointer; stdcall; external cLibNameKernel name 'GetProcAddress';
    function  GetProcessAffinityMask                      ( hProcess: winHandle; var lpProcessAffinityMask, lpSystemAffinityMask: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetProcessAffinityMask';
    function  GetProcessHeap                              ( ): winHandle; stdcall; external cLibNameKernel name 'GetProcessHeap';
    function  GetProcessHeaps                             ( NumberOfHeaps: uint32; var ProcessHeaps: winHandle ): uint32; stdcall; external cLibNameKernel name 'GetProcessHeaps';
    function  GetProcessPriorityBoost                     ( hThread: winHandle; var DisablePriorityBoost: Bool ): Bool; stdcall; external cLibNameKernel name 'GetProcessPriorityBoost';
    function  GetProcessShutdownParameters                ( var lpdwLevel, lpdwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetProcessShutdownParameters';
    function  GetProcessTimes                             ( hProcess: winHandle; var lpCreationTime, lpExitTime, lpKernelTime, lpUserTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'GetProcessTimes';
    function  GetProcessVersion                           ( ProcessId: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetProcessVersion';
    function  GetProcessWorkingSetSize                    ( hProcess: winHandle; var lpMinimumWorkingSetSize, lpMaximumWorkingSetSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetProcessWorkingSetSize';
    function  GetProfileIntA                              ( lpAppName, lpKeyName: PAnsiChar; nDefault: int32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileIntA';
    function  GetProfileIntW                              ( lpAppName, lpKeyName: PWideChar; nDefault: int32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileIntW';
    function  GetProfileSectionA                          ( lpAppName: PAnsiChar; lpReturnedString: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileSectionA';
    function  GetProfileSectionW                          ( lpAppName: PWideChar; lpReturnedString: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileSectionW';
    function  GetProfileStringA                           ( lpAppName, lpKeyName, lpDefault: PAnsiChar; lpReturnedString: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileStringA';
    function  GetProfileStringW                           ( lpAppName, lpKeyName, lpDefault: PWideChar; lpReturnedString: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetProfileStringW';
    function  GetQueuedCompletionStatus                   ( CompletionPort: winHandle; var lpNumberOfBytesTransferred, lpCompletionKey: uint32; var lpOverlapped: POverlapped; dwMilliseconds: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetQueuedCompletionStatus';
    function  GetShortPathNameA                           ( lpszLongPath: PAnsiChar; lpszShortPath: PAnsiChar; cchBuffer: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetShortPathNameA';
    function  GetShortPathNameW                           ( lpszLongPath: PWideChar; lpszShortPath: PWideChar; cchBuffer: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetShortPathNameW';
    procedure GetStartupInfoA                             ( var lpStartupInfo: StartupInfoA ); stdcall; external cLibNameKernel name 'GetStartupInfoA';
    procedure GetStartupInfoW                             ( var lpStartupInfo: StartupInfoW ); stdcall; external cLibNameKernel name 'GetStartupInfoW';
    function  GetStdHandle                                ( nStdHandle: uint32 ): winHandle; stdcall; external cLibNameKernel name 'GetStdHandle';
    function  GetStringTypeA                              ( Locale: LCID; dwInfoType: uint32; const lpSrcStr: LPCSTR; cchSrc: Bool; var lpCharType: uint16 ): Bool; external cLibNameKernel name 'GetStringTypeA';
    function  GetStringTypeW                              ( dwInfoType: uint32; const lpSrcStr: WideChar; cchSrc: Bool; var lpCharType: uint16 ): Bool; external cLibNameKernel name 'GetStringTypeW';
    function  GetStringTypeExA                            ( Locale: LCID; dwInfoType: uint32; lpSrcStr: PAnsiChar; cchSrc: int32; var lpCharType ): Bool; stdcall; external cLibNameKernel name 'GetStringTypeExA';
    function  GetStringTypeExW                            ( Locale: LCID; dwInfoType: uint32; lpSrcStr: PWideChar; cchSrc: int32; var lpCharType ): Bool; stdcall; external cLibNameKernel name 'GetStringTypeExW';
    function  GetSystemDefaultLCID                        ( ): LCID; stdcall; external cLibNameKernel name 'GetSystemDefaultLCID';
    function  GetSystemDefaultLangID                      ( ): LANGID; stdcall; external cLibNameKernel name 'GetSystemDefaultLangID';
    function  GetSystemDirectoryA                         ( lpBuffer: PAnsiChar; uSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetSystemDirectoryA';
    function  GetSystemDirectoryW                         ( lpBuffer: PWideChar; uSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetSystemDirectoryW';
    procedure GetSystemInfo                               ( var lpSystemInfo: SystemInfo ); stdcall; external cLibNameKernel name 'GetSystemInfo';
    function  GetSystemPowerStatus                        ( var lpSystemPowerStatus: SystemPowerStatus ): Bool; stdcall; external cLibNameKernel name 'GetSystemPowerStatus';
    procedure GetSystemTime                               ( var lpSystemTime: SystemTime ); stdcall; external cLibNameKernel name 'GetSystemTime';
    function  GetSystemTimeAdjustment                     ( var lpTimeAdjustment, lpTimeIncrement: uint32; var lpTimeAdjustmentDisabled: Bool ): Bool; stdcall; external cLibNameKernel name 'GetSystemTimeAdjustment';
    procedure GetSystemTimeAsFileTime                     ( var lpSystemTimeAsFileTime: FileTime ); stdcall; external cLibNameKernel name 'GetSystemTimeAsFileTime';
    function  GetTapeParameters                           ( hDevice: winHandle; dwOperation: uint32; var lpdwSize: uint32; lpTapeInformation: Pointer ): uint32; stdcall; external cLibNameKernel name 'GetTapeParameters';
    function  GetTapePosition                             ( hDevice: winHandle; dwPositionType: uint32; var lpdwPartition, lpdwOffsetLow: uint32; lpdwOffsetHigh: Pointer ): uint32; stdcall; external cLibNameKernel name 'GetTapePosition';
    function  GetTapeStatus                               ( hDevice: winHandle ): uint32; stdcall; external cLibNameKernel name 'GetTapeStatus';
    function  GetTempFileNameA                            ( lpPathName, lpPrefixString: PAnsiChar; uUnique: uint32; lpTempFileName: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetTempFileNameA';
    function  GetTempFileNameW                            ( lpPathName, lpPrefixString: PWideChar; uUnique: uint32; lpTempFileName: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetTempFileNameW';
    function  GetTempPathA                                ( nBufferLength: uint32; lpBuffer: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'GetTempPathA';
    function  GetTempPathW                                ( nBufferLength: uint32; lpBuffer: PWideChar ): uint32; stdcall; external cLibNameKernel name 'GetTempPathW';
    function  GetThreadContext                            ( hThread: winHandle; var lpContext: Context ): Bool; stdcall; external cLibNameKernel name 'GetThreadContext';
    function  GetThreadLocale                             ( ): LCID; stdcall; external cLibNameKernel name 'GetThreadLocale';
    function  GetThreadPriority                           ( hThread: winHandle ): int32; stdcall; external cLibNameKernel name 'GetThreadPriority';
    function  GetThreadPriorityBoost                      ( hThread: winHandle; var DisablePriorityBoost: Bool ): Bool; stdcall; external cLibNameKernel name 'GetThreadPriorityBoost';
    function  GetThreadSelectorEntry                      ( hThread: winHandle; dwSelector: uint32; var lpSelectorEntry: LDTEntry ): Bool; stdcall; external cLibNameKernel name 'GetThreadSelectorEntry';
    function  GetThreadTimes                              ( hThread: winHandle; var lpCreationTime, lpExitTime, lpKernelTime, lpUserTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'GetThreadTimes';
    function  GetTickCount                                ( ): uint32; stdcall; external cLibNameKernel name 'GetTickCount';
    function  GetTimeFormatA                              ( Locale: LCID; dwFlags: uint32; lpTime: PSystemTime; lpFormat: PAnsiChar; lpTimeStr: PAnsiChar; cchTime: int32 ): int32; stdcall; external cLibNameKernel name 'GetTimeFormatA';
    function  GetTimeFormatW                              ( Locale: LCID; dwFlags: uint32; lpTime: PSystemTime; lpFormat: PWideChar; lpTimeStr: PWideChar; cchTime: int32 ): int32; stdcall; external cLibNameKernel name 'GetTimeFormatW';
    function  GetTimeZoneInformation                      ( var lpTimeZoneInformation: TimeZoneInformation ): uint32; stdcall; external cLibNameKernel name 'GetTimeZoneInformation';
    function  GetUserDefaultLCID                          ( ): LCID; stdcall; external cLibNameKernel name 'GetUserDefaultLCID';
    function  GetUserDefaultLangID                        ( ): LANGID; stdcall; external cLibNameKernel name 'GetUserDefaultLangID';
    function  GetVersionA                                 ( ): uint32; stdcall; external cLibNameKernel name 'GetVersion';
    function  GetVersionExA                               ( var lpVersionInformation: OSVersionInfoA ): Bool; stdcall; external cLibNameKernel name 'GetVersionExA';
    function  GetVersionExW                               ( var lpVersionInformation: OSVersionInfoW ): Bool; stdcall; external cLibNameKernel name 'GetVersionExW';
    function  GetVolumeInformationA                       ( lpRootPathName: PAnsiChar; lpVolumeNameBuffer: PAnsiChar; nVolumeNameSize: uint32; lpVolumeSerialNumber: pointer; var lpMaximumComponentLength, lpFileSystemFlags: uint32; lpFileSystemNameBuffer: PAnsiChar; nFileSystemNameSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetVolumeInformationA';
    function  GetVolumeInformationW                       ( lpRootPathName: PWideChar; lpVolumeNameBuffer: PWideChar; nVolumeNameSize: uint32; lpVolumeSerialNumber: pointer; var lpMaximumComponentLength, lpFileSystemFlags: uint32; lpFileSystemNameBuffer: PWideChar; nFileSystemNameSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetVolumeInformationW';
    function  GetWindowsDirectoryA                        ( lpBuffer: PAnsiChar; uSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetWindowsDirectoryA';
    function  GetWindowsDirectoryW                        ( lpBuffer: PWideChar; uSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'GetWindowsDirectoryW';
    function  GlobalAddAtomA                              ( lpString: PAnsiChar ): ATOM; stdcall; external cLibNameKernel name 'GlobalAddAtomA';
    function  GlobalAddAtomW                              ( lpString: PWideChar ): ATOM; stdcall; external cLibNameKernel name 'GlobalAddAtomW';
    function  GlobalAlloc                                 ( uFlags: uint32; dwBytes: uint32 ): HGLOBAL; stdcall; external cLibNameKernel name 'GlobalAlloc';
    function  GlobalCompact                               ( dwMinFree: uint32 ): uint32; stdcall; external cLibNameKernel name 'GlobalCompact';
    function  GlobalDeleteAtom                            ( nAtom: ATOM ): ATOM; stdcall; external cLibNameKernel name 'GlobalDeleteAtom';
    function  GlobalFindAtomA                             ( lpString: PAnsiChar ): ATOM; stdcall; external cLibNameKernel name 'GlobalFindAtomA';
    function  GlobalFindAtomW                             ( lpString: PWideChar ): ATOM; stdcall; external cLibNameKernel name 'GlobalFindAtomW';
    procedure GlobalFix                                   ( hMem: HGLOBAL ); stdcall; external cLibNameKernel name 'GlobalFix';
    function  GlobalFlags                                 ( hMem: HGLOBAL ): uint32; stdcall; external cLibNameKernel name 'GlobalFlags';
    function  GlobalFree                                  ( hMem: HGLOBAL ): HGLOBAL; stdcall; external cLibNameKernel name 'GlobalFree';
    function  GlobalGetAtomNameA                          ( nAtom: ATOM; lpBuffer: PAnsiChar; nSize: int32 ): uint32; stdcall; external cLibNameKernel name 'GlobalGetAtomNameA';
    function  GlobalGetAtomNameW                          ( nAtom: ATOM; lpBuffer: PWideChar; nSize: int32 ): uint32; stdcall; external cLibNameKernel name 'GlobalGetAtomNameW';
    function  GlobalHandle                                ( Mem: Pointer ): HGLOBAL; stdcall; external cLibNameKernel name 'GlobalHandle';
    function  GlobalLock                                  ( hMem: HGLOBAL ): Pointer; stdcall; external cLibNameKernel name 'GlobalLock';
    procedure GlobalMemoryStatus                          ( var lpBuffer: MemoryStatus ); stdcall; external cLibNameKernel name 'GlobalMemoryStatus';
    function  GlobalReAlloc                               ( hMem: HGLOBAL; dwBytes: uint32; uFlags: uint32 ): HGLOBAL; stdcall; external cLibNameKernel name 'GlobalReAlloc';
    function  GlobalSize                                  ( hMem: HGLOBAL ): uint32; stdcall; external cLibNameKernel name 'GlobalSize';
    function  GlobalUnWire                                ( hMem: HGLOBAL ): Bool; stdcall; external cLibNameKernel name 'GlobalUnWire';
    procedure GlobalUnfix                                 ( hMem: HGLOBAL ); stdcall; external cLibNameKernel name 'GlobalUnfix';
    function  GlobalUnlock                                ( hMem: HGLOBAL ): Bool; stdcall; external cLibNameKernel name 'GlobalUnlock';
    function  GlobalWire                                  ( hMem: HGLOBAL ): Pointer; stdcall; external cLibNameKernel name 'GlobalWire';
    function  Heap32First                                 ( var lphe: HeapEntry32; th32ProcessID, th32HeapID: uint32 ): Bool; stdcall; external cLibNameKernel name 'Heap32First';
    function  Heap32ListFirst                             ( hSnapshot: winHandle; var lphl: HeapList32 ): Bool; stdcall; external cLibNameKernel name 'Heap32ListFirst';
    function  Heap32ListNext                              ( hSnapshot: winHandle; var lphl: HeapList32 ): Bool; stdcall; external cLibNameKernel name 'Heap32ListNext';
    function  Heap32Next                                  ( var lphe: HeapEntry32 ): Bool; stdcall; external cLibNameKernel name 'Heap32Next';
    function  HeapAlloc                                   ( hHeap: winHandle; dwFlags, dwBytes: uint32 ): Pointer; stdcall; external cLibNameKernel name 'HeapAlloc';
    function  HeapCompact                                 ( hHeap: winHandle; dwFlags: uint32 ): uint32; stdcall; external cLibNameKernel name 'HeapCompact';
    function  HeapCreate                                  ( flOptions, dwInitialSize, dwMaximumSize: uint32 ): winHandle; stdcall; external cLibNameKernel name 'HeapCreate';
    function  HeapDestroy                                 ( hHeap: winHandle ): Bool; stdcall; external cLibNameKernel name 'HeapDestroy';
    function  HeapFree                                    ( hHeap: winHandle; dwFlags: uint32; lpMem: Pointer ): Bool; stdcall; external cLibNameKernel name 'HeapFree';
    function  HeapLock                                    ( hHeap: winHandle ): Bool; stdcall; external cLibNameKernel name 'HeapLock';
    function  HeapReAlloc                                 ( hHeap: winHandle; dwFlags: uint32; lpMem: Pointer; dwBytes: uint32 ): Pointer; stdcall; external cLibNameKernel name 'HeapReAlloc';
    function  HeapSize                                    ( hHeap: winHandle; dwFlags: uint32; lpMem: Pointer ): uint32; stdcall; external cLibNameKernel name 'HeapSize';
    function  HeapUnlock                                  ( hHeap: winHandle ): Bool; stdcall; external cLibNameKernel name 'HeapUnlock';
    function  HeapValidate                                ( hHeap: winHandle; dwFlags: uint32; lpMem: Pointer ): Bool; stdcall; external cLibNameKernel name 'HeapValidate';
    function  HeapWalk                                    ( hHeap: winHandle; var lpEntry: ProcessHeapEntry ): Bool; stdcall; external cLibNameKernel name 'HeapWalk';
    function  InitAtomTable                               ( nSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'InitAtomTable';
    procedure InitializeCriticalSection                   ( var lpCriticalSection: RTLCriticalSection ); stdcall; external cLibNameKernel name 'InitializeCriticalSection';
    function  InitializeCriticalSectionAndSpinCount       (var lpCriticalSection: RTLCriticalSection; dwSpinCount: uint32 ): Bool; stdcall; external cLibNameKernel name 'InitializeCriticalSectionAndSpinCount';
    function  InterlockedCompareExchange                  ( var Destination: Pointer; Exchange: Pointer; Comperand: Pointer ): Pointer; stdcall; external cLibNameKernel name 'InterlockedCompareExchange';
    function  InterlockedDecrement                        ( var Addend: int32 ): int32; stdcall; external cLibNameKernel name 'InterlockedDecrement';
    function  InterlockedExchange                         ( var Target: int32; Value: int32 ): int32; stdcall; external cLibNameKernel name 'InterlockedExchange';
    function  InterlockedExchangeAdd                      ( Addend: Pint32; Value: int32 ): int32; stdcall; external cLibNameKernel name 'InterlockedExchangeAdd';
    function  InterlockedIncrement                        ( var Addend: int32 ): int32; stdcall; external cLibNameKernel name 'InterlockedIncrement';
    function  IsBadCodePtr                                ( lpfn: Pointer ): Bool; stdcall; external cLibNameKernel name 'IsBadCodePtr';
    function  IsBadHugeReadPtr                            ( lp: Pointer; ucb: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadHugeReadPtr';
    function  IsBadHugeWritePtr                           ( lp: Pointer; ucb: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadHugeWritePtr';
    function  IsBadReadPtr                                ( lp: Pointer; ucb: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadReadPtr';
    function  IsBadStringPtrA                             ( lpsz: PAnsiChar; ucchMax: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadStringPtrA';
    function  IsBadStringPtrW                             ( lpsz: PWideChar; ucchMax: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadStringPtrW';
    function  IsBadWritePtr                               ( lp: Pointer; ucb: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsBadWritePtr';
    function  IsDBCSLeadByte                              ( TestChar: uint8 ): Bool; stdcall; external cLibNameKernel name 'IsDBCSLeadByte';
    function  IsDBCSLeadByteEx                            ( CodePage: uint32; TestChar: uint8 ): Bool; stdcall; external cLibNameKernel name 'IsDBCSLeadByteEx';
    function  IsProcessorFeaturePresent                   ( ProcessorFeature: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsProcessorFeaturePresent';
    function  IsValidCodePage                             ( CodePage: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsValidCodePage';
    function  IsValidLocale                               ( Locale: LCID; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'IsValidLocale';
    function  LCMapStringA                                ( Locale: LCID; dwMapFlags: uint32; lpSrcStr: PAnsiChar; cchSrc: int32; lpDestStr: PAnsiChar; cchDest: int32 ): int32; stdcall; external cLibNameKernel name 'LCMapStringA';
    function  LCMapStringW                                ( Locale: LCID; dwMapFlags: uint32; lpSrcStr: PWideChar; cchSrc: int32; lpDestStr: PWideChar; cchDest: int32 ): int32; stdcall; external cLibNameKernel name 'LCMapStringW';
    function  LCMapStringEx                               ( lpLocaleName: pWideChar; dwMapFlags: uint32; lpSrcStr: pWideChar; cchSrc: int32; lpDestStr: pWideChar; cchDest: int32; pVersionInformation: pointer; lpReserved: pointer; sortHandle: nativeuint ): int32;  stdcall; external cLibNameKernel name 'LCMapStringEx';
    procedure LeaveCriticalSection                        ( var lpCriticalSection: RTLCriticalSection ); stdcall; external cLibNameKernel name 'LeaveCriticalSection';
    function  LoadLibraryA                                ( lpLibFileName: PAnsiChar ): HModule; stdcall; external cLibNameKernel name 'LoadLibraryA';
    function  LoadLibraryW                                ( lpLibFileName: PWideChar ): HModule; stdcall; external cLibNameKernel name 'LoadLibraryW';
    function  LoadLibraryEx                               ( lpLibFileName: PAnsiChar; hFile: winHandle; dwFlags: uint32 ): HModule; stdcall; external cLibNameKernel name 'LoadLibraryExA';
    function  LoadLibraryExW                              ( lpLibFileName: PWideChar; hFile: winHandle; dwFlags: uint32 ): HModule; stdcall; external cLibNameKernel name 'LoadLibraryExW';
    function  LoadModule                                  ( lpModuleName: LPCSTR; lpParameterBlock: Pointer ): uint32; stdcall; external cLibNameKernel name 'LoadModule';
    function  LoadResource                                ( hModule: HINST; hResInfo: HRSRC ): HGLOBAL; stdcall; external cLibNameKernel name 'LoadResource';
    function  LocalAlloc                                  ( uFlags, uBytes: uint32 ): HLOCAL; stdcall; external cLibNameKernel name 'LocalAlloc';
    function  LocalCompact                                ( uMinFree: uint32 ): uint32; stdcall; external cLibNameKernel name 'LocalCompact';
    function  LocalFileTimeToFileTime                     ( const lpLocalFileTime: FileTime; var lpFileTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'LocalFileTimeToFileTime';
    function  LocalFlags                                  ( hMem: HLOCAL ): uint32; stdcall; external cLibNameKernel name 'LocalFlags';
    function  LocalFree                                   ( hMem: HLOCAL ): HLOCAL; stdcall; external cLibNameKernel name 'LocalFree';
    function  LocalLock                                   ( hMem: HLOCAL ): Pointer; stdcall; external cLibNameKernel name 'LocalLock';
    function  LocalReAlloc                                ( hMem: HLOCAL; uBytes, uFlags: uint32 ): HLOCAL; stdcall; external cLibNameKernel name 'LocalReAlloc';
    function  LocalShrink                                 ( hMem: HLOCAL; cbNewSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'LocalShrink';
    function  LocalSize                                   ( hMem: HLOCAL ): uint32; stdcall; external cLibNameKernel name 'LocalSize';
    function  LocalUnlock                                 ( hMem: HLOCAL ): Bool; stdcall; external cLibNameKernel name 'LocalUnlock';
    function  LockFile                                    ( hFile: winHandle; dwFileOffsetLow, dwFileOffsetHigh: uint32; nNumberOfBytesToLockLow, nNumberOfBytesToLockHigh: uint32 ): Bool; stdcall; external cLibNameKernel name 'LockFile';
    function  LockFileEx                                  ( hFile: winHandle; dwFlags, dwReserved: uint32; nNumberOfBytesToLockLow, nNumberOfBytesToLockHigh: uint32; const lpOverlapped: Overlapped ): Bool; stdcall; external cLibNameKernel name 'LockFileEx';
    function  LockResource                                ( hResData: HGLOBAL ): Pointer; stdcall; external cLibNameKernel name 'LockResource';
    function  MapViewOfFile                               ( hFileMappingObject: winHandle; dwDesiredAccess: uint32; dwFileOffsetHigh, dwFileOffsetLow, dwNumberOfBytesToMap: uint32 ): Pointer; stdcall; external cLibNameKernel name 'MapViewOfFile';
    function  MapViewOfFileEx                             ( hFileMappingObject: winHandle; dwDesiredAccess, dwFileOffsetHigh, dwFileOffsetLow, dwNumberOfBytesToMap: uint32; lpBaseAddress: Pointer ): Pointer; stdcall; external cLibNameKernel name 'MapViewOfFileEx';
    function  Module32First                               ( hSnapshot: winHandle; var lpme: ModuleEntry32A ): Bool; stdcall; external cLibNameKernel name 'Module32First';
    function  Module32Next                                ( hSnapshot: winHandle; var lpme: ModuleEntry32W ): Bool; stdcall; external cLibNameKernel name 'Module32Next';
    function  MoveFileA                                   ( lpExistingFileName, lpNewFileName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'MoveFileA';
    function  MoveFileW                                   ( lpExistingFileName, lpNewFileName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'MoveFileW';
    function  MoveFileExA                                 ( lpExistingFileName, lpNewFileName: PAnsiChar; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'MoveFileExA';
    function  MoveFileExW                                 ( lpExistingFileName, lpNewFileName: PWideChar; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'MoveFileExW';
    function  MoveFileWithProgressA                       ( lpExistingFileName, lpNewFileName: PAnsiChar; lpProgressRoutine: CopyProgressRoutine; lpData: Pointer; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'MoveFileWithProgressA';
    function  MoveFileWithProgressW                       ( lpExistingFileName, lpNewFileName: PWideChar; lpProgressRoutine: CopyProgressRoutine; lpData: Pointer; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'MoveFileWithProgressW';
    function  MulDiv                                      ( nNumber, nNumerator, nDenominator: int32 ): int32; stdcall; external cLibNameKernel name 'MulDiv';
    function  MultiByteToWideChar                         ( CodePage: uint32; dwFlags: uint32; const lpMultiByteStr: LPCSTR; cchMultiByte: int32; lpWideCharStr: LPWSTR; cchWideChar: int32 ): int32; stdcall; external cLibNameKernel name 'MultiByteToWideChar';
    function  OpenEventA                                  ( dwDesiredAccess: uint32; bInheriHandle: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'OpenEventA';
    function  OpenEventW                                  ( dwDesiredAccess: uint32; bInheriHandle: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'OpenEventW';
    function  OpenFile                                    ( const lpFileName: LPCSTR; var lpReOpenBuff: OFStruct; uStyle: uint32 ): HFILE; stdcall; external cLibNameKernel name 'OpenFile';
    function  OpenFileMappingA                            ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'OpenFileMappingA';
    function  OpenFileMappingW                            ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'OpenFileMappingW';
    function  OpenMutexA                                  ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'OpenMutexA';
    function  OpenMutexW                                  ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'OpenMutexW';
    function  OpenProcess                                 ( dwDesiredAccess: uint32; bInheritHandle: Bool; dwProcessId: uint32 ): winHandle; stdcall; external cLibNameKernel name 'OpenProcess';
    function  OpenSemaphoreA                              ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'OpenSemaphoreA';
    function  OpenSemaphoreW                              ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'OpenSemaphoreW';
    function  OpenWaitableTimerA                          ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpTimerName: PAnsiChar ): winHandle; stdcall; external cLibNameKernel name 'OpenWaitableTimerA';
    function  OpenWaitableTimerW                          ( dwDesiredAccess: uint32; bInheritHandle: Bool; lpTimerName: PWideChar ): winHandle; stdcall; external cLibNameKernel name 'OpenWaitableTimerW';
    procedure OutputDebugStringA                          ( lpOutputString: PAnsiChar ); stdcall; external cLibNameKernel name 'OutputDebugStringA';
    procedure OutputDebugStringW                          ( lpOutputString: PWideChar ); stdcall; external cLibNameKernel name 'OutputDebugStringW';
    function  PeekConsoleInputA                           ( hConsoleInput: winHandle; var lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'PeekConsoleInputA';
    function  PeekConsoleInputW                           ( hConsoleInput: winHandle; var lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'PeekConsoleInputW';
    function  PeekNamedPipe                               ( hNamedPipe: winHandle; lpBuffer: Pointer; nBufferSize: uint32; lpBytesRead, lpTotalBytesAvail, lpBytesLeftThisMessage: Pointer ): Bool; stdcall; external cLibNameKernel name 'PeekNamedPipe';
    function  PostQueuedCompletionStatus                  ( CompletionPort: winHandle; dwNumberOfBytesTransferred: uint32; dwCompletionKey: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'PostQueuedCompletionStatus';
    function  PrepareTape                                 ( hDevice: winHandle; dwOperation: uint32; bImmediate: Bool ): uint32; stdcall; external cLibNameKernel name 'PrepareTape';
    function  Process32First                              ( hSnapshot: winHandle; var lppe: ProcessEntry32W ): Bool; stdcall; external cLibNameKernel name 'Process32First';
    function  Process32Next                               ( hSnapshot: winHandle; var lppe: ProcessEntry32W ): Bool; stdcall; external cLibNameKernel name 'Process32Next';
    function  PulseEvent                                  ( hEvent: winHandle ): Bool; stdcall; external cLibNameKernel name 'PulseEvent';
    function  PurgeComm                                   ( hFile: winHandle; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'PurgeComm';
    function  QueryDosDeviceA                             ( lpDeviceName: PAnsiChar; lpTargetPath: PAnsiChar; ucchMax: uint32 ): uint32; stdcall; external cLibNameKernel name 'QueryDosDeviceA';
    function  QueryDosDeviceW                             ( lpDeviceName: PWideChar; lpTargetPath: PWideChar; ucchMax: uint32 ): uint32; stdcall; external cLibNameKernel name 'QueryDosDeviceW';
    function  QueryPerformanceCounter                     ( var lpPerformanceCount: int64 ): Bool; stdcall; external cLibNameKernel name 'QueryPerformanceCounter';
    function  QueryPerformanceFrequency                   ( var lpFrequency: int64 ): Bool; stdcall; external cLibNameKernel name 'QueryPerformanceFrequency';
    function  QueueUserAPC                                ( pfnAPC: APCProc; hThread: winHandle; dwData: uint32 ): Bool; stdcall; external cLibNameKernel name 'QueueUserAPC';
    procedure RaiseException                              ( dwExceptionCode, dwExceptionFlags, nNumberOfArguments: uint32; lpArguments: pointer ); stdcall; external cLibNameKernel name 'RaiseException';
    function  ReadConsoleA                                ( hConsoleInput: winHandle; lpBuffer: Pointer; nNumberOfCharsToRead: uint32; var lpNumberOfCharsRead: uint32; lpReserved: Pointer ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleA';
    function  ReadConsoleW                                ( hConsoleInput: winHandle; lpBuffer: Pointer; nNumberOfCharsToRead: uint32; var lpNumberOfCharsRead: uint32; lpReserved: Pointer ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleW';
    function  ReadConsoleInputA                           ( hConsoleInput: winHandle; var lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleInputA';
    function  ReadConsoleInputW                           ( hConsoleInput: winHandle; var lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleInputW';
    function  ReadConsoleOutputA                          ( hConsoleOutput: winHandle; lpBuffer: Pointer; dwBufferSize, dwBufferCoord: Coord; var lpReadRegion: SmallRect ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleOutputA';
    function  ReadConsoleOutputW                          ( hConsoleOutput: winHandle; lpBuffer: Pointer; dwBufferSize, dwBufferCoord: Coord; var lpReadRegion: SmallRect ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleOutputW';
    function  ReadConsoleOutputAttribute                  ( hConsoleOutput: winHandle; lpAttribute: Pointer; nLength: uint32; dwReadCoord: Coord; var lpNumberOfAttrsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleOutputAttribute';
    function  ReadConsoleOutputCharacterA                 ( hConsoleOutput: winHandle; lpCharacter: PAnsiChar; nLength: uint32; dwReadCoord: Coord; var lpNumberOfCharsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleOutputCharacterA';
    function  ReadConsoleOutputCharacterW                 ( hConsoleOutput: winHandle; lpCharacter: PAnsiChar; nLength: uint32; dwReadCoord: Coord; var lpNumberOfCharsRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadConsoleOutputCharacterW';
    function  ReadDirectoryChangesW                       ( hDirectory: winHandle; lpBuffer: Pointer; nBufferLength: uint32; bWatchSubtree: Bool; dwNotifyFilter: uint32; var lpBytesReturned: uint32; lpOverlapped: POverlapped; lpCompletionRoutine: pointer ): Bool; stdcall; external cLibNameKernel name 'ReadDirectoryChangesW';
    function  ReadFile                                    ( hFile: winHandle; var Buffer; nNumberOfBytesToRead: uint32; var lpNumberOfBytesRead: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'ReadFile';
    function  ReadFileEx                                  ( hFile: winHandle; lpBuffer: Pointer; nNumberOfBytesToRead: uint32; lpOverlapped: POverlapped; lpCompletionRoutine: FileIOCompletionRoutine ): Bool; stdcall; external cLibNameKernel name 'ReadFileEx';
    function  ReadProcessMemory                           ( hProcess: winHandle; const lpBaseAddress: Pointer; lpBuffer: Pointer; nSize: uint32; var lpNumberOfBytesRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'ReadProcessMemory';
    function  ReleaseMutex                                ( hMutex: winHandle ): Bool; stdcall; external cLibNameKernel name 'ReleaseMutex';
    function  ReleaseSemaphore                            ( hSemaphore: winHandle; lReleaseCount: int32; lpPreviousCount: Pointer ): Bool; stdcall; external cLibNameKernel name 'ReleaseSemaphore';
    function  RemoveDirectoryA                            ( lpPathName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'RemoveDirectoryA';
    function  RemoveDirectoryW                            ( lpPathName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'RemoveDirectoryW';
    function  ResetEvent                                  ( hEvent: winHandle ): Bool; stdcall; external cLibNameKernel name 'ResetEvent';
    function  ResumeThread                                ( hThread: winHandle ): uint32; stdcall; external cLibNameKernel name 'ResumeThread';
    function  ScrollConsoleScreenBufferA                  ( hConsoleOutput: winHandle; const lpScrollRectangle: SmallRect; lpClipRectangle: PSmallRect; dwDestinationOrigin: Coord; var lpFill: CharInfo ): Bool; stdcall; external cLibNameKernel name 'ScrollConsoleScreenBufferA';
    function  ScrollConsoleScreenBufferW                  ( hConsoleOutput: winHandle; const lpScrollRectangle: SmallRect; lpClipRectangle: PSmallRect; dwDestinationOrigin: Coord; var lpFill: CharInfo ): Bool; stdcall; external cLibNameKernel name 'ScrollConsoleScreenBufferW';
    function  SearchPathA                                 ( lpPath, lpFileName, lpExtension: PAnsiChar; nBufferLength: uint32; lpBuffer: PAnsiChar; var lpFilePart: PAnsiChar ): uint32; stdcall; external cLibNameKernel name 'SearchPathA';
    function  SearchPathW                                 ( lpPath, lpFileName, lpExtension: PWideChar; nBufferLength: uint32; lpBuffer: PWideChar; var lpFilePart: PWideChar ): uint32; stdcall; external cLibNameKernel name 'SearchPathW';
    function  SetCommBreak                                ( hFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'SetCommBreak';
    function  SetCommConfig                               ( hCommDev: winHandle; const lpCC: CommConfig; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetCommConfig';
    function  SetCommMask                                 ( hFile: winHandle; dwEvtMask: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetCommMask';
    function  SetCommState                                ( hFile: winHandle; const lpDCB: DCB ): Bool; stdcall; external cLibNameKernel name 'SetCommState';
    function  SetCommTimeouts                             ( hFile: winHandle; const lpCommTimeouts: CommTimeouts ): Bool; stdcall; external cLibNameKernel name 'SetCommTimeouts';
    function  SetComputerNameA                            ( lpComputerName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetComputerNameA';
    function  SetComputerNameW                            ( lpComputerName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'SetComputerNameW';
    function  SetConsoleActiveScreenBuffer                ( hConsoleOutput: winHandle ): Bool; stdcall; external cLibNameKernel name 'SetConsoleActiveScreenBuffer';
    function  SetConsoleCP                                ( wCodePageID: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetConsoleCP';
    function  SetConsoleCtrlHandler                       ( HandlerRoutine: HandlerRoutine; Add: Bool ): Bool; stdcall; external cLibNameKernel name 'SetConsoleCtrlHandler';
    function  SetConsoleCursorInfo                        ( hConsoleOutput: winHandle; const lpConsoleCursorInfo: ConsoleCursorInfo ): Bool; stdcall; external cLibNameKernel name 'SetConsoleCursorInfo';
    function  SetConsoleCursorPosition                    ( hConsoleOutput: winHandle; dwCursorPosition: Coord ): Bool; stdcall; external cLibNameKernel name 'SetConsoleCursorPosition';
    function  SetConsoleMode                              ( hConsoleHandle: winHandle; dwMode: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetConsoleMode';
    function  SetConsoleOutputCP                          ( wCodePageID: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetConsoleOutputCP';
    function  SetConsoleScreenBufferSize                  ( hConsoleOutput: winHandle; dwSize: Coord ): Bool; stdcall; external cLibNameKernel name 'SetConsoleScreenBufferSize';
    function  SetConsoleTextAttribute                     ( hConsoleOutput: winHandle; wAttributes: uint16 ): Bool; stdcall; external cLibNameKernel name 'SetConsoleTextAttribute';
    function  SetConsoleTitleA                            ( lpConsoleTitle: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetConsoleTitleA';
    function  SetConsoleTitleW                            ( lpConsoleTitle: PWideChar ): Bool; stdcall; external cLibNameKernel name 'SetConsoleTitleW';
    function  SetConsoleWindowInfo                        ( hConsoleOutput: winHandle; bAbsolute: Bool; const lpConsoleWindow: SmallRect ): Bool; stdcall; external cLibNameKernel name 'SetConsoleWindowInfo';
    function  SetCriticalSectionSpinCount                 ( var lpCriticalSection: RTLCriticalSection; dwSpinCount: uint32 ): uint32; stdcall; external cLibNameKernel name 'SetCriticalSectionSpinCount';
    function  SetCurrentDirectoryA                        ( lpPathName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetCurrentDirectoryA';
    function  SetCurrentDirectoryW                        ( lpPathName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'SetCurrentDirectoryW';
    function  SetDefaultCommConfigA                       ( lpszName: PAnsiChar; lpCC: PCommConfigA; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetDefaultCommConfigA';
    function  SetDefaultCommConfigW                       ( lpszName: PWideChar; lpCC: PCommConfigW; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetDefaultCommConfigW';
    function  SetEndOfFile                                ( hFile: winHandle ): Bool; stdcall; external cLibNameKernel name 'SetEndOfFile';
    function  SetEnvironmentVariableA                     ( lpName, lpValue: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetEnvironmentVariableA';
    function  SetEnvironmentVariableW                     ( lpName, lpValue: PWideChar ): Bool; stdcall; external cLibNameKernel name 'SetEnvironmentVariableW';
    function  SetErrorMode                                ( uMode: uint32 ): uint32; stdcall; external cLibNameKernel name 'SetErrorMode';
    function  SetEvent                                    ( hEvent: winHandle ): Bool; stdcall; external cLibNameKernel name 'SetEvent';
    procedure SetFileApisToANSI                           ( ); stdcall; external cLibNameKernel name 'SetFileApisToANSI';
    procedure SetFileApisToOEM                            ( ); stdcall; external cLibNameKernel name 'SetFileApisToOEM';
    function  SetFileAttributesA                          ( lpFileName: PAnsiChar; dwFileAttributes: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetFileAttributesA';
    function  SetFileAttributesW                          ( lpFileName: PWideChar; dwFileAttributes: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetFileAttributesW';
    function  SetFilePointer                              ( hFile: winHandle; lDistanceToMove: int32; lpDistanceToMoveHigh: Pointer; dwMoveMethod: uint32 ): uint32; stdcall; external cLibNameKernel name 'SetFilePointer';
    function  SetFileTime                                 ( hFile: winHandle; lpCreationTime, lpLastAccessTime, lpLastWriteTime: PFileTime ): Bool; stdcall; external cLibNameKernel name 'SetFileTime';
    function  SetHandleCount                              ( uNumber: uint32 ): uint32; stdcall; external cLibNameKernel name 'SetHandleCount';
    function  SetHandleInformation                        ( hObject: winHandle; dwMask: uint32; dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetHandleInformation';
    procedure SetLastError                                ( dwErrCode: uint32 ); stdcall; external cLibNameKernel name 'SetLastError';
    function  SetLocalTime                                ( const lpSystemTime: SystemTime ): Bool; stdcall; external cLibNameKernel name 'SetLocalTime';
    function  SetLocaleInfoA                              ( Locale: LCID; LCType: LCTYPE; lpLCData: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetLocaleInfoA';
    function  SetLocaleInfoW                              ( Locale: LCID; LCType: LCTYPE; lpLCData: PWideChar ): Bool; stdcall; external cLibNameKernel name 'SetLocaleInfoW';
    function  SetMailslotInfo                             ( hMailslot: winHandle; lReadTimeout: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetMailslotInfo';
    function  SetNamedPipeHandleState                     ( hNamedPipe: winHandle; var lpMode: uint32; lpMaxCollectionCount, lpCollectDataTimeout: Pointer ): Bool; stdcall; external cLibNameKernel name 'SetNamedPipeHandleState';
    function  SetPriorityClass                            ( hProcess: winHandle; dwPriorityClass: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetPriorityClass';
    function  SetProcessAffinityMask                      ( hProcess: winHandle; dwProcessAffinityMask: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetProcessAffinityMask';
    function  SetProcessPriorityBoost                     ( hThread: winHandle; DisablePriorityBoost: Bool ): Bool; stdcall; external cLibNameKernel name 'SetProcessPriorityBoost';
    function  SetProcessShutdownParameters                ( dwLevel, dwFlags: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetProcessShutdownParameters';
    function  SetProcessWorkingSetSize                    ( hProcess: winHandle; dwMinimumWorkingSetSize, dwMaximumWorkingSetSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetProcessWorkingSetSize';
    function  SetStdHandle                                ( nStdHandle: uint32; hHandle: winHandle ): Bool; stdcall; external cLibNameKernel name 'SetStdHandle';
    function  SetSystemPowerState                         ( fSuspend, fForce: Bool ): Bool; stdcall; external cLibNameKernel name 'SetSystemPowerState';
    function  SetSystemTime                               ( const lpSystemTime: SystemTime ): Bool; stdcall; external cLibNameKernel name 'SetSystemTime';
    function  SetSystemTimeAdjustment                     ( dwTimeAdjustment: uint32; bTimeAdjustmentDisabled: Bool ): Bool; stdcall; external cLibNameKernel name 'SetSystemTimeAdjustment';
    function  SetTapeParameters                           ( hDevice: winHandle; dwOperation: uint32; lpTapeInformation: Pointer ): uint32; stdcall; external cLibNameKernel name 'SetTapeParameters';
    function  SetTapePosition                             ( hDevice: winHandle; dwPositionMethod, dwPartition: uint32; dwOffsetLow, dwOffsetHigh: uint32; bImmediate: Bool ): uint32; stdcall; external cLibNameKernel name 'SetTapePosition';
    function  SetThreadAffinityMask                       ( hThread: winHandle; dwThreadAffinityMask: uint32 ): uint32; stdcall; external cLibNameKernel name 'SetThreadAffinityMask';
    function  SetThreadContext                            ( hThread: winHandle; const lpContext: Context ): Bool; stdcall; external cLibNameKernel name 'SetThreadContext';
    function  SetThreadIdealProcessor                     ( hThread: winHandle; dwIdealProcessor: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetThreadIdealProcessor';
    function  SetThreadLocale                             ( Locale: LCID ): Bool; stdcall; external cLibNameKernel name 'SetThreadLocale';
    function  SetThreadPriority                           ( hThread: winHandle; nPriority: int32 ): Bool; stdcall; external cLibNameKernel name 'SetThreadPriority';
    function  SetThreadPriorityBoost                      ( hThread: winHandle; DisablePriorityBoost: Bool ): Bool; stdcall; external cLibNameKernel name 'SetThreadPriorityBoost';
    function  SetTimeZoneInformation                      ( const lpTimeZoneInformation: TimeZoneInformation ): Bool; stdcall; external cLibNameKernel name 'SetTimeZoneInformation';
    function  SetUnhandledExceptionFilter                 ( lpTopLevelExceptionFilter: UnhandledExceptionFilter ): UnhandledExceptionFilter; stdcall; external cLibNameKernel name 'SetUnhandledExceptionFilter';
    function  SetVolumeLabelA                             ( lpRootPathName: PAnsiChar; lpVolumeName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetVolumeLabelA';
    function  SetVolumeLabelW                             ( lpRootPathName: PWideChar; lpVolumeName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'SetVolumeLabelW';
    function  SetWaitableTimer                            ( hTimer: winHandle; var lpDueTime: int64; lPeriod: int32; pfnCompletionRoutine: TimerAPCProc; lpArgToCompletionRoutine: Pointer; fResume: Bool ): Bool; stdcall; external cLibNameKernel name 'SetWaitableTimer';
    function  SetupComm                                   ( hFile: winHandle; dwInQueue, dwOutQueue: uint32 ): Bool; stdcall; external cLibNameKernel name 'SetupComm';
    function  SignalObjectAndWait                         ( hObjectToSignal: winHandle; hObjectToWaitOn: winHandle; dwMilliseconds: uint32; bAlertable: Bool ): Bool; stdcall; external cLibNameKernel name 'SignalObjectAndWait';
    function  SizeofResource                              ( hModule: HINST; hResInfo: HRSRC ): uint32; stdcall; external cLibNameKernel name 'SizeofResource';
    procedure Sleep                                       ( dwMilliseconds: uint32 ); stdcall; external cLibNameKernel name 'Sleep';
    function  SleepEx                                     ( dwMilliseconds: uint32; bAlertable: Bool ): uint32; stdcall; external cLibNameKernel name 'SleepEx';
    function  SuspendThread                               ( hThread: winHandle ): uint32; stdcall; external cLibNameKernel name 'SuspendThread';
    function  SwitchToFiber                               ( lpFiber: Pointer ): Bool; stdcall; external cLibNameKernel name 'SwitchToFiber';
    function  SwitchToThread                              ( ): Bool; stdcall; external cLibNameKernel name 'SwitchToThread';
    function  SystemTimeToFileTime                        ( const lpSystemTime: SystemTime; var lpFileTime: FileTime ): Bool; stdcall; external cLibNameKernel name 'SystemTimeToFileTime';
    function  SystemTimeToTzSpecificLocalTime             ( lpTimeZoneInformation: PTimeZoneInformation; var lpUniversalTime, lpLocalTime: SystemTime ): Bool; stdcall; external cLibNameKernel name 'SystemTimeToTzSpecificLocalTime';
    function  TerminateProcess                            ( hProcess: winHandle; uExitCode: uint32 ): Bool; stdcall; external cLibNameKernel name 'TerminateProcess';
    function  TerminateThread                             ( hThread: winHandle; dwExitCode: uint32 ): Bool; stdcall; external cLibNameKernel name 'TerminateThread';
    function  Thread32First                               ( hSnapshot: winHandle; var lpte: ThreadEntry32 ): Bool; stdcall; external cLibNameKernel name 'Thread32First';
    function  Thread32Next                                ( hSnapshot: winHandle; var lpte: ThreadENtry32 ): Bool; stdcall; external cLibNameKernel name 'Thread32Next';
    function  TlsAlloc                                    ( ): uint32; stdcall; external cLibNameKernel name 'TlsAlloc';
    function  TlsFree                                     ( dwTlsIndex: uint32 ): Bool; stdcall; external cLibNameKernel name 'TlsFree';
    function  TlsGetValue                                 ( dwTlsIndex: uint32 ): Pointer; stdcall; external cLibNameKernel name 'TlsGetValue';
    function  TlsSetValue                                 ( dwTlsIndex: uint32; lpTlsValue: Pointer ): Bool; stdcall; external cLibNameKernel name 'TlsSetValue';
    function  Toolhelp32ReadProcessMemory                 ( th32ProcessID: uint32; lpBaseAddress: Pointer; var lpBuffer; cbRead: uint32; var lpNumberOfBytesRead: uint32 ): Bool; stdcall; external cLibNameKernel name 'Toolhelp32ReadProcessMemory';
    function  TransactNamedPipe                           ( hNamedPipe: winHandle; lpInBuffer: Pointer; nInBufferSize: uint32; lpOutBuffer: Pointer; nOutBufferSize: uint32; var lpBytesRead: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'TransactNamedPipe';
    function  TransmitCommChar                            ( hFile: winHandle; cChar: char ): Bool; stdcall; external cLibNameKernel name 'TransmitCommChar';
    function  TryEnterCriticalSection                     ( var lpCriticalSection: RTLCriticalSection ): Bool; stdcall; external cLibNameKernel name 'TryEnterCriticalSection';
    function  nhandledExceptionFilter                     ( const ExceptionInfo: ExceptionPointers ): int32; stdcall; external cLibNameKernel name 'UnhandledExceptionFilter';
    function  UnlockFile                                  ( hFile: winHandle; dwFileOffsetLow, dwFileOffsetHigh: uint32; nNumberOfBytesToUnlockLow, nNumberOfBytesToUnlockHigh: uint32 ): Bool; stdcall; external cLibNameKernel name 'UnlockFile';
    function  UnlockFileEx                                ( hFile: winHandle; dwReserved, nNumberOfBytesToUnlockLow: uint32; nNumberOfBytesToUnlockHigh: uint32; const lpOverlapped: Overlapped ): Bool; stdcall; external cLibNameKernel name 'UnlockFileEx';
    function  UnmapViewOfFile                             ( lpBaseAddress: Pointer ): Bool; stdcall; external cLibNameKernel name 'UnmapViewOfFile';
    function  UpdateResourceA                             ( hUpdate: winHandle; lpType, lpName: PAnsiChar; wLanguage: uint16; lpData: Pointer; cbData: uint32 ): Bool; stdcall; external cLibNameKernel name 'UpdateResourceA';
    function  UpdateResourceW                             ( hUpdate: winHandle; lpType, lpName: PWideChar; wLanguage: uint16; lpData: Pointer; cbData: uint32 ): Bool; stdcall; external cLibNameKernel name 'UpdateResourceW';
    function  VerLanguageNameA                            ( wLang: uint32; szLang: PAnsiChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'VerLanguageNameA';
    function  VerLanguageNameW                            ( wLang: uint32; szLang: PWideChar; nSize: uint32 ): uint32; stdcall; external cLibNameKernel name 'VerLanguageNameW';
    function  VirtualAlloc                                ( lpvAddress: Pointer; dwSize, flAllocationType, flProtect: uint32 ): Pointer; stdcall; external cLibNameKernel name 'VirtualAlloc';
    function  VirtualAllocEx                              ( hProcess: winHandle; lpAddress: Pointer; dwSize, flAllocationType: uint32; flProtect: uint32 ): Pointer; stdcall; external cLibNameKernel name 'VirtualAllocEx';
    function  VirtualFree                                 ( lpAddress: Pointer; dwSize, dwFreeType: uint32 ): Bool; stdcall; external cLibNameKernel name 'VirtualFree';
    function  VirtualFreeEx                               ( hProcess: winHandle; lpAddress: Pointer; dwSize, dwFreeType: uint32 ): Pointer; stdcall; external cLibNameKernel name 'VirtualFreeEx';
    function  VirtualLock                                 ( lpAddress: Pointer; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'VirtualLock';
    function  VirtualProtect                              ( lpAddress: Pointer; dwSize, flNewProtect: uint32; lpflOldProtect: Pointer ): Bool; stdcall; external cLibNameKernel name 'VirtualProtect';
    function  VirtualProtectEx                            ( hProcess: winHandle; lpAddress: Pointer; dwSize, flNewProtect: uint32; lpflOldProtect: Pointer ): Bool; stdcall; external cLibNameKernel name 'VirtualProtectEx';
    function  VirtualQuery                                ( lpAddress: Pointer; var lpBuffer: MemoryBasicInformation; dwLength: uint32 ): uint32; stdcall; external cLibNameKernel name 'VirtualQuery';
    function  VirtualQueryEx                              ( hProcess: winHandle; lpAddress: Pointer; var lpBuffer: MemoryBasicInformation; dwLength: uint32 ): uint32; stdcall; external cLibNameKernel name 'VirtualQueryEx';
    function  VirtualUnlock                               ( lpAddress: Pointer; dwSize: uint32 ): Bool; stdcall; external cLibNameKernel name 'VirtualUnlock';
    function  WaitCommEvent                               ( hFile: winHandle; var lpEvtMask: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'WaitCommEvent';
    function  WaitForDebugEvent                           ( var lpDebugEvent: DebugEvent; dwMilliseconds: uint32 ): Bool; stdcall; external cLibNameKernel name 'WaitForDebugEvent';
    function  WaitForMultipleObjects                      ( nCount: uint32; lpHandles: PHandleArray; bWaitAll: Bool; dwMilliseconds: uint32 ): uint32; stdcall; external cLibNameKernel name 'WaitForMultipleObjects';
    function  WaitForMultipleObjectsEx                    ( nCount: uint32; lpHandles: PHandleArray; bWaitAll: Bool; dwMilliseconds: uint32; bAlertable: Bool ): uint32; stdcall; external cLibNameKernel name 'WaitForMultipleObjectsEx';
    function  WaitForSingleObject                         ( hHandle: winHandle; dwMilliseconds: uint32 ): uint32; stdcall; external cLibNameKernel name 'WaitForSingleObject';
    function  WaitForSingleObjectEx                       ( hHandle: winHandle; dwMilliseconds: uint32; bAlertable: Bool ): uint32; stdcall; external cLibNameKernel name 'WaitForSingleObjectEx';
    function  WaitNamedPipeA                              ( lpNamedPipeName: PAnsiChar; nTimeOut: uint32 ): Bool; stdcall; external cLibNameKernel name 'WaitNamedPipeA';
    function  WaitNamedPipeW                              ( lpNamedPipeName: PWideChar; nTimeOut: uint32 ): Bool; stdcall; external cLibNameKernel name 'WaitNamedPipeW';
    function  WideCharToMultiByte                         ( CodePage: uint32; dwFlags: uint32; lpWideCharStr: LPWSTR; cchWideChar: int32; lpMultiByteStr: LPSTR; cchMultiByte: int32; lpDefaultChar: LPCSTR; out lpUsedDefaultChar: Bool ): int32; stdcall; external cLibNameKernel name 'WideCharToMultiByte';
    function  WinExec                                     ( lpCmdLine: LPCSTR; uCmdShow: uint32 ): uint32; stdcall; external cLibNameKernel name 'WinExec';
    function  WriteConsoleA                               ( hConsoleOutput: winHandle; const lpBuffer: Pointer; nNumberOfCharsToWrite: uint32; var lpNumberOfCharsWritten: uint32; lpReserved: Pointer ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleA';
    function  WriteConsoleW                               ( hConsoleOutput: winHandle; const lpBuffer: Pointer; nNumberOfCharsToWrite: uint32; var lpNumberOfCharsWritten: uint32; lpReserved: Pointer ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleW';
    function  WriteConsoleInputA                          ( hConsoleInput: winHandle; const lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleInputA';
    function  WriteConsoleInputW                          ( hConsoleInput: winHandle; const lpBuffer: InputRecord; nLength: uint32; var lpNumberOfEventsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleInputW';
    function  WriteConsoleOutputA                         ( hConsoleOutput: winHandle; lpBuffer: Pointer; dwBufferSize, dwBufferCoord: Coord; var lpWriteRegion: SmallRect ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleOutputA';
    function  WriteConsoleOutputW                         ( hConsoleOutput: winHandle; lpBuffer: Pointer; dwBufferSize, dwBufferCoord: Coord; var lpWriteRegion: SmallRect ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleOutputW';
    function  WriteConsoleOutputAttribute                 ( hConsoleOutput: winHandle; lpAttribute: Pointer; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfAttrsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleOutputAttribute';
    function  WriteConsoleOutputCharacterA                ( hConsoleOutput: winHandle; lpCharacter: PAnsiChar; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfCharsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleOutputCharacterA';
    function  WriteConsoleOutputCharacterW                ( hConsoleOutput: winHandle; lpCharacter: PWideChar; nLength: uint32; dwWriteCoord: Coord; var lpNumberOfCharsWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteConsoleOutputCharacterW';
    function  WriteFile                                   ( hFile: winHandle; const Buffer; nNumberOfBytesToWrite: uint32; var lpNumberOfBytesWritten: uint32; lpOverlapped: POverlapped ): Bool; stdcall; external cLibNameKernel name 'WriteFile';
    function  WriteFileEx                                 ( hFile: winHandle; lpBuffer: Pointer; nNumberOfBytesToWrite: uint32; const lpOverlapped: Overlapped; lpCompletionRoutine: pointer ): Bool; stdcall; external cLibNameKernel name 'WriteFileEx';
    function  WritePrivateProfileSectionA                 ( lpAppName, lpString, lpFileName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileSectionA';
    function  WritePrivateProfileSectionW                 ( lpAppName, lpString, lpFileName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileSectionW';
    function  WritePrivateProfileStringA                  ( lpAppName, lpKeyName, lpString, lpFileName: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileStringA';
    function  WritePrivateProfileStringW                  ( lpAppName, lpKeyName, lpString, lpFileName: PWideChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileStringW';
    function  WritePrivateProfileStructA                  ( lpszSection, lpszKey: PAnsiChar; lpStruct: Pointer; uSizeStruct: uint32; szFile: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileStructA';
    function  WritePrivateProfileStructW                  ( lpszSection, lpszKey: PWideChar; lpStruct: Pointer; uSizeStruct: uint32; szFile: PWideChar ): Bool; stdcall; external cLibNameKernel name 'WritePrivateProfileStructW';
    function  WriteProcessMemory                          ( hProcess: winHandle; const lpBaseAddress: Pointer; lpBuffer: Pointer; nSize: uint32; var lpNumberOfBytesWritten: uint32 ): Bool; stdcall; external cLibNameKernel name 'WriteProcessMemory';
    function  WriteProfileSectionA                        ( lpAppName, lpString: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'WriteProfileSectionA';
    function  WriteProfileSectionW                        ( lpAppName, lpString: PWideChar ): Bool; stdcall; external cLibNameKernel name 'WriteProfileSectionW';
    function  WriteProfileStringA                         ( lpAppName, lpKeyName, lpString: PAnsiChar ): Bool; stdcall; external cLibNameKernel name 'WriteProfileStringA';
    function  WriteProfileStringW                         ( lpAppName, lpKeyName, lpString: PWideChar ): Bool; stdcall; external cLibNameKernel name 'WriteProfileStringW';
    function  WriteTapemark                               ( hDevice: winHandle; dwTapemarkType, dwTapemarkCount: uint32; bImmediate: Bool ): uint32; stdcall; external cLibNameKernel name 'WriteTapemark';
    function  _hread                                      ( hFile: HFILE; lpBuffer: Pointer; lBytes: int32 ): int32; stdcall; external cLibNameKernel name '_hread';
    function  _hwrite                                     ( hFile: HFILE; lpBuffer: LPCSTR; lBytes: int32 ): int32; stdcall; external cLibNameKernel name '_hwrite';
    function  _lclose                                     ( hFile: HFILE ): HFILE; stdcall; external cLibNameKernel name '_lclose';
    function  _lcreat                                     ( const lpPathName: LPCSTR; iAttribute: int32 ): HFILE; stdcall; external cLibNameKernel name '_lcreat';
    function  _llseek                                     ( hFile: HFILE; lOffset: int32; iOrigin: int32 ): int32; stdcall; external cLibNameKernel name '_llseek';
    function  _lopen                                      ( const lpPathName: LPCSTR; iReadWrite: int32 ): HFILE; stdcall; external cLibNameKernel name '_lopen';
    function  _lread                                      ( hFile: HFILE; lpBuffer: Pointer; uBytes: uint32 ): uint32; stdcall; external cLibNameKernel name '_lread';
    function  _lwrite                                     ( hFile: HFILE; const lpBuffer: LPCSTR; uBytes: uint32 ): uint32; stdcall; external cLibNameKernel name '_lwrite';
    function  lstrcat                                     ( lpString1, lpString2: PAnsiChar ): PAnsiChar; stdcall; external cLibNameKernel name 'lstrcatA';
    function  lstrcatW                                    ( lpString1, lpString2: PWideChar ): PWideChar; stdcall; external cLibNameKernel name 'lstrcatW';
    function  lstrcmp                                     ( lpString1, lpString2: PAnsiChar ): int32; stdcall; external cLibNameKernel name 'lstrcmpA';
    function  lstrcmpW                                    ( lpString1, lpString2: PWideChar ): int32; stdcall; external cLibNameKernel name 'lstrcmpW';
    function  lstrcmpi                                    ( lpString1, lpString2: PAnsiChar ): int32; stdcall; external cLibNameKernel name 'lstrcmpiA';
    function  lstrcmpiW                                   ( lpString1, lpString2: PWideChar ): int32; stdcall; external cLibNameKernel name 'lstrcmpiW';
    function  lstrcpy                                     ( lpString1, lpString2: PAnsiChar ): PAnsiChar; stdcall; external cLibNameKernel name 'lstrcpyA';
    function  lstrcpyW                                    ( lpString1, lpString2: PWideChar ): PWideChar; stdcall; external cLibNameKernel name 'lstrcpyW';
    function  lstrcpyn                                    ( lpString1, lpString2: PAnsiChar; iMaxLength: int32 ): PAnsiChar; stdcall; external cLibNameKernel name 'lstrcpynA';
    function  lstrcpynW                                   ( lpString1, lpString2: PWideChar; iMaxLength: int32 ): PWideChar; stdcall; external cLibNameKernel name 'lstrcpynW';
    function  lstrlen                                     ( lpString: PAnsiChar ): int32; stdcall; external cLibNameKernel name 'lstrlenA';
    function  lstrlenW                                    ( lpString: PWideChar ): int32; stdcall; external cLibNameKernel name 'lstrlenW';
    function  FindFirstVolume                             ( lpszVolumeName: pointer; cchBufferLength: uint32 ): winHandle; stdcall; external cLibNameKernel name 'FindFirstVolumeW';
    function  FindNextVolume                              ( hFindVolume: winHandle; lptstrVolumeName: pointer; cchBufferLength: uint32 ): Bool; stdcall; external cLibNameKernel name 'FindNextVolumeW';
    function  FindVolumeClose                             ( hFindVolume: winHandle ): Bool; stdcall; external cLibNameKernel name 'FindVolumeClose';
    function  GetVolumePathNamesForVolumeName             ( lpszVolumeName: pointer; lpszVolumePathNames: pointer; cchBufferLength: uint32; var lpcchReturnLength: uint32 ): Bool; stdcall; external cLibNameKernel name 'GetVolumePathNamesForVolumeNameW';

    function  AbortSystemShutdownA                        (lpMachineName: LPSTR ): Bool; stdcall; external cLibName name 'AbortSystemShutdownA';
    function  AbortSystemShutdownW                        ( lpMachineName: LPWSTR ): Bool; stdcall; external cLibName name 'AbortSystemShutdownW';
    function  AccessCheck                                 ( pSecurityDescriptor: PSecurityDescriptor; ClientToken: winHandle; DesiredAccess: uint32; const GenericMapping: TGenericMapping; var PrivilegeSet: PrivilegeSet; var PrivilegeSetLength: uint32; var GrantedAccess: uint32; var AccessStatus: Bool ): Bool; stdcall; external cLibName name 'AccessCheck';
    function  AccessCheckAndAuditAlarmA                   ( SubsystemName: LPSTR; HandleId: Pointer; ObjectTypeName, ObjectName: PAnsiChar; SecurityDescriptor: PSecurityDescriptor; DesiredAccess: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatus, pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckAndAuditAlarmA';
    function  AccessCheckAndAuditAlarmW                   ( SubsystemName: LPWSTR; HandleId: Pointer; ObjectTypeName, ObjectName: PWideChar; SecurityDescriptor: PSecurityDescriptor; DesiredAccess: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatus, pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckAndAuditAlarmW';
    function  AccessCheckByType                           ( pSecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; ClientToken: winHandle; DesiredAccess: uint32; ObjectTypeList: PObjectTypeList; const GenericMapping: TGenericMapping; ObjectTypeListLength: uint32; var PrivilegeSet: PrivilegeSet; var PrivilegeSetLength: uint32; var GrantedAccess: uint32; var AccessStatus: Bool ): Bool; stdcall; external cLibName name 'AccessCheckByType';
    function  AccessCheckByTypeAndAuditAlarmA             ( SubsystemName: LPSTR; HandleId: Pointer; ObjectTypeName, ObjectName: PAnsiChar; SecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; DesiredAccess: uint32; AuditType: AUDIT_EVENT_TYPE; Flags: uint32; ObjectTypeList: PObjectTypeList; ObjectTypeListLength: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatus, pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckByTypeAndAuditAlarmA';
    function  AccessCheckByTypeAndAuditAlarmW             ( SubsystemName: LPWSTR; HandleId: Pointer; ObjectTypeName, ObjectName: PWideChar; SecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; DesiredAccess: uint32; AuditType: AUDIT_EVENT_TYPE; Flags: uint32; ObjectTypeList: PObjectTypeList; ObjectTypeListLength: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatus, pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckByTypeAndAuditAlarmW';
    function  AccessCheckByTypeResultList                 ( pSecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; ClientToken: winHandle; DesiredAccess: uint32; ObjectTypeList: PObjectTypeList; const GenericMapping: TGenericMapping; ObjectTypeListLength: uint32; var PrivilegeSet: PrivilegeSet; var PrivilegeSetLength: uint32; var GrantedAccess: uint32; var AccessStatusList: uint32 ): Bool; stdcall; external cLibName name 'AccessCheckByTypeResultList';
    function  AccessCheckByTypeResultListAndAuditAlarmA   ( SubsystemName: PAnsiChar; HandleId: Pointer; ObjectTypeName, ObjectName: PAnsiChar; SecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; DesiredAccess: uint32; AuditType: AUDIT_EVENT_TYPE; Flags: uint32; ObjectTypeList: PObjectTypeList; ObjectTypeListLength: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatusList: uint32; var pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckByTypeResultListAndAuditAlarmA';
    function  AccessCheckByTypeResultListAndAuditAlarmW   ( SubsystemName: PWideChar; HandleId: Pointer; ObjectTypeName, ObjectName: PWideChar; SecurityDescriptor: PSecurityDescriptor; PrincipalSelfSid: PSID; DesiredAccess: uint32; AuditType: AUDIT_EVENT_TYPE; Flags: uint32; ObjectTypeList: PObjectTypeList; ObjectTypeListLength: uint32; const GenericMapping: TGenericMapping;  ObjectCreation: Bool; var GrantedAccess: uint32; var AccessStatusList: uint32; var pfGenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'AccessCheckByTypeResultListAndAuditAlarmW';
    function  AddAccessAllowedAce                         ( var pAcl: ACL; dwAceRevision: uint32; AccessMask: uint32; pSid: PSID ): Bool; stdcall; external cLibName name 'AddAccessAllowedAce';
    function  AddAccessAllowedAceEx                       ( var pAcl: ACL; dwAceRevision: uint32; AceFlags: uint32; AccessMask: uint32; pSid: PSID ): Bool; stdcall; external cLibName name 'AddAccessAllowedAceEx';
    function  AddAccessAllowedObjectAce                   ( var pAcl: ACL; dwAceRevision: uint32; AceFlags: uint32; AccessMask: uint32; ObjectTypeGuid, InheritedObjectTypeGuid: PGuid; pSid: Pointer ): Bool; stdcall; external cLibName name 'AddAccessAllowedObjectAce';
    function  AddAccessDeniedAce                          ( var pAcl: ACL; dwAceRevision: uint32; AccessMask: uint32; pSid: PSID ): Bool; stdcall; external cLibName name 'AddAccessDeniedAce';
    function  AddAccessDeniedAceEx                        ( var pAcl: ACL; dwAceRevision: uint32; ACEFlags: uint32; AccessMask: uint32; pSid: PSID ): Bool; stdcall; external cLibName name 'AddAccessDeniedAceEx';
    function  AddAccessDeniedObjectAce                    ( var pAcl: ACL; dwAceRevision: uint32; AceFlags: uint32; AccessMask: uint32; ObjectTypeGuid, InheritedObjectTypeGuid: PGuid; pSid: Pointer ): Bool; stdcall; external cLibName name 'AddAccessDeniedObjectAce';
    function  AddAce                                      ( var pAcl: ACL; dwAceRevision, dwStartingAceIndex: uint32; pAceList: Pointer; nAceListLength: uint32 ): Bool; stdcall; external cLibName name 'AddAce';
    function  AddAuditAccessAce                           ( var pAcl: ACL; dwAceRevision: uint32; dwAccessMask: uint32; pSid: Pointer; bAuditSuccess, bAuditFailure: Bool ): Bool; stdcall; external cLibName name 'AddAuditAccessAce';
    function  AddAuditAccessAceEx                         ( var pAcl: ACL; dwAceRevision: uint32; AceFlags: uint32; dwAccessMask: uint32; pSid: Pointer; bAuditSuccess, bAuditFailure: Bool ): Bool; stdcall; external cLibName name 'AddAuditAccessAceEx';
    function  AddAuditAccessObjectAce                     ( var pAcl: ACL; dwAceRevision: uint32; AceFlags: uint32; AccessMask: uint32; ObjectTypeGuid, InheritedObjectTypeGuid: PGuid; pSid: Pointer; bAuditSuccess, bAuditFailure: Bool ): Bool; stdcall; external cLibName name 'AddAuditAccessObjectAce';
    function  AdjustTokenGroups                           ( TokenHandle: winHandle; ResetToDefault: Bool; const NewState: Token_Groups; BufferLength: uint32; var PreviousState: Token_Groups; var ReturnLength: uint32 ): Bool; stdcall; external cLibName name 'AdjustTokenGroups';
    function  AdjustTokenPrivileges                       ( TokenHandle: winHandle; DisableAllPrivileges: Bool; const NewState: Token_Privileges; BufferLength: uint32; var PreviousState: Token_Privileges; var ReturnLength: uint32 ): Bool; stdcall; external cLibName name 'AdjustTokenPrivileges';
    function  AllocateAndInitializeSid                    ( const pIdentifierAuthority: SIDIdentifierAuthority; nSubAuthorityCount: uint8; nSubAuthority0, nSubAuthority1: uint32; nSubAuthority2, nSubAuthority3, nSubAuthority4: uint32; nSubAuthority5, nSubAuthority6, nSubAuthority7: uint32; var pSid: Pointer ): Bool; stdcall; external cLibName name 'AllocateAndInitializeSid';
    function  AllocateLocallyUniqueId                     ( var Luid: int64 ): Bool; stdcall; external cLibName name 'AllocateLocallyUniqueId';
    function  AreAllAccessesGranted                       ( GrantedAccess, DesiredAccess: uint32 ): Bool; stdcall; external cLibName name 'AreAllAccessesGranted';
    function  AreAnyAccessesGranted                       ( GrantedAccess, DesiredAccess: uint32 ): Bool; stdcall; external cLibName name 'AreAnyAccessesGranted';
    function  BackupEventLogA                             ( hEventLog: winHandle; lpBackupFileName: PAnsiChar ): Bool; stdcall; external cLibName name 'BackupEventLogA';
    function  BackupEventLogW                             ( hEventLog: winHandle; lpBackupFileName: PWideChar ): Bool; stdcall; external cLibName name 'BackupEventLogW';
    function  ChangeServiceConfigA                        ( hService: SC_HANDLE; dwServiceType, dwStartType, dwErrorControl: uint32; lpBinaryPathName, lpLoadOrderGroup: PAnsiChar; lpdwTagId: puint32; lpDependencies, lpServiceStartName, lpPassword, lpDisplayName: PAnsiChar ): Bool; stdcall; external cLibName name 'ChangeServiceConfigA';
    function  ChangeServiceConfigW                        ( hService: SC_HANDLE; dwServiceType, dwStartType, dwErrorControl: uint32; lpBinaryPathName, lpLoadOrderGroup: PWideChar; lpdwTagId: puint32; lpDependencies, lpServiceStartName, lpPassword, lpDisplayName: PWideChar ): Bool; stdcall; external cLibName name 'ChangeServiceConfigW';
    function  ClearEventLogA                              ( hEventLog: winHandle; lpBackupFileName: PAnsiChar ): Bool; stdcall; external cLibName name 'ClearEventLogA';
    function  ClearEventLogW                              ( hEventLog: winHandle; lpBackupFileName: PWideChar ): Bool; stdcall; external cLibName name 'ClearEventLogW';
    function  CloseEventLog                               ( hEventLog: winHandle ): Bool; stdcall; external cLibName name 'CloseEventLog';
    function  CloseServiceHandle                          ( hSCObject: SC_HANDLE ): Bool; stdcall; external cLibName name 'CloseServiceHandle';
    function  ControlService                              ( hService: SC_HANDLE; dwControl: uint32; var lpServiceStatus: ServiceStatus ): Bool; stdcall; external cLibName name 'ControlService';
    function  ConvertToAutoInheritPrivateObjectSecurity   ( ParentDescriptor, CurrentSecurityDescriptor: PSecurityDescriptor; var NewDescriptor: PSecurityDescriptor; ObjectType: PGUID; IsDirectoryObject: Bool; const GenericMapping: TGenericMapping ): Bool; stdcall; external cLibName name 'ConvertToAutoInheritPrivateObjectSecurity';
    function  CopySid                                     ( nDestinationSidLength: uint32; pDestinationSid, pSourceSid: Pointer ): Bool; stdcall; external cLibName name 'CopySid';
    function  CreatePrivateObjectSecurity                 ( ParentDescriptor, CreatorDescriptor: PSecurityDescriptor; var NewDescriptor: PSecurityDescriptor; IsDirectoryObject: Bool; Token: winHandle; const GenericMapping: TGenericMapping ): Bool; stdcall; external cLibName name 'CreatePrivateObjectSecurity';
    function  CreatePrivateObjectSecurityEx               ( ParentDescriptor, CreatorDescriptor: PSecurityDescriptor; var NewDescriptor: PSecurityDescriptor; ObjectType: PGUID; IsContainerObject: Bool; AutoInheritFlags: uint32; Token: winHandle; const GenericMapping: TGenericMapping ): Bool; stdcall; external cLibName name 'CreatePrivateObjectSecurityEx';
    function  CreateProcessAsUserA                        ( hToken: winHandle; lpApplicationName: PAnsiChar; lpCommandLine: PAnsiChar; lpProcessAttributes: PSecurityAttributes; lpThreadAttributes: PSecurityAttributes; bInheritHandles: Bool; dwCreationFlags: uint32; lpEnvironment: Pointer; lpCurrentDirectory: PAnsiChar; const lpStartupInfo: StartupInfoA; var lpProcessInformation: ProcessInformation ): Bool; stdcall; external cLibName name 'CreateProcessAsUserA';
    function  CreateProcessAsUserW                        ( hToken: winHandle; lpApplicationName: PWideChar; lpCommandLine: PWideChar; lpProcessAttributes: PSecurityAttributes; lpThreadAttributes: PSecurityAttributes; bInheritHandles: Bool; dwCreationFlags: uint32; lpEnvironment: Pointer; lpCurrentDirectory: PWideChar; const lpStartupInfo: StartupInfoW; var lpProcessInformation: ProcessInformation ): Bool; stdcall; external cLibName name 'CreateProcessAsUserW';
    function  CreateServiceA                              ( hSCManager: SC_HANDLE; lpServiceName, lpDisplayName: PAnsiChar; dwDesiredAccess, dwServiceType, dwStartType, dwErrorControl: uint32; lpBinaryPathName, lpLoadOrderGroup: PAnsiChar; lpdwTagId: puint32; lpDependencies, lpServiceStartName, lpPassword: PAnsiChar ): SC_HANDLE; stdcall; external cLibName name 'CreateServiceA';
    function  CreateServiceW                              ( hSCManager: SC_HANDLE; lpServiceName, lpDisplayName: PWideChar; dwDesiredAccess, dwServiceType, dwStartType, dwErrorControl: uint32; lpBinaryPathName, lpLoadOrderGroup: PWideChar; lpdwTagId: puint32; lpDependencies, lpServiceStartName, lpPassword: PWideChar ): SC_HANDLE; stdcall; external cLibName name 'CreateServiceW';
    function  DeleteAce                                   ( var pAcl: ACL; dwAceIndex: uint32 ): Bool; stdcall; external cLibName name 'DeleteAce';
    function  DeleteService                               ( hService: SC_HANDLE ): Bool; stdcall; external cLibName name 'DeleteService';
    function  DeregisterEventSource                       ( hEventLog: winHandle ): Bool; stdcall; external cLibName name 'DeregisterEventSource';
    function  DestroyPrivateObjectSecurity                ( var ObjectDescriptor: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'DestroyPrivateObjectSecurity';
    function  DuplicateToken                              ( ExistingTokenHandle: winHandle; ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL; DuplicateTokenHandle: pWinHandle ): Bool; stdcall; external cLibName name 'DuplicateToken';
    function  DuplicateTokenEx                            ( hExistingToken: winHandle; dwDesiredAccess: uint32; lpTokenAttributes: PSecurityAttributes; ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL; TokenType: Token_Type; var phNewToken: winHandle): Bool; stdcall; external cLibName name 'DuplicateTokenEx';
    function  EnumDependentServicesA                      ( hService: SC_HANDLE; dwServiceState: uint32; var lpServices: EnumServiceStatusA; cbBufSize: uint32; var pcbBytesNeeded, lpServicesReturned : uint32 ): Bool; stdcall; external cLibName name 'EnumDependentServicesA';
    function  EnumDependentServicesW                      ( hService: SC_HANDLE; dwServiceState: uint32; var lpServices: EnumServiceStatusW; cbBufSize: uint32; var pcbBytesNeeded, lpServicesReturned : uint32 ): Bool; stdcall; external cLibName name 'EnumDependentServicesW';
    function  EnumServicesStatusA                         ( hSCManager: SC_HANDLE; dwServiceType, dwServiceState: uint32; var lpServices: EnumServiceStatusA; cbBufSize: uint32; var pcbBytesNeeded, lpServicesReturned, lpResumeHandle: uint32 ): Bool; stdcall; external cLibName name 'EnumServicesStatusA';
    function  EnumServicesStatusW                         ( hSCManager: SC_HANDLE; dwServiceType, dwServiceState: uint32; var lpServices: EnumServiceStatusW; cbBufSize: uint32; var pcbBytesNeeded, lpServicesReturned, lpResumeHandle: uint32 ): Bool; stdcall; external cLibName name 'EnumServicesStatusW';
    function  EqualPrefixSid                              ( pSid1, pSid2: Pointer ): Bool; stdcall; external cLibName name 'EqualPrefixSid';
    function  EqualSid                                    ( pSid1, pSid2: Pointer ): Bool; stdcall; external cLibName name 'EqualSid';
    function  FindFirstFreeAce                            ( var pAcl: ACL; var pAce: Pointer ): Bool; stdcall; external cLibName name 'FindFirstFreeAce';
    function  FreeSid                                     ( pSid: Pointer ): Pointer; stdcall; external cLibName name 'FreeSid';
    function  GetAce                                      ( const pAcl: ACL; dwAceIndex: uint32; var pAce: Pointer ): Bool; stdcall; external cLibName name 'GetAce';
    function  GetAclInformation                           ( const pAcl: ACL; pAclInformation: Pointer; nAclInformationLength: uint32; dwAclInformationClass: AclInformationClass ): Bool; stdcall; external cLibName name 'GetAclInformation';
    function  GetCurrentHwProfileA                        ( var lpHwProfileInfo: HWProfileInfoA ): Bool; stdcall; external cLibName name 'GetCurrentHwProfileA';
    function  GetCurrentHwProfileW                        ( var lpHwProfileInfo: HWProfileInfoW ): Bool; stdcall; external cLibName name 'GetCurrentHwProfileW';
    function  GetFileSecurityA                            ( lpFileName: PAnsiChar; RequestedInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetFileSecurityA';
    function  GetFileSecurityW                            ( lpFileName: PWideChar; RequestedInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetFileSecurityW';
    function  GetKernelObjectSecurity                     ( Handle: winHandle; RequestedInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor; nLength: uint32; var lpnLengthNeeded: uint32 ): Bool; stdcall; external cLibName name 'GetKernelObjectSecurity';
    function  GetLengthSid                                ( pSid: Pointer ): uint32; stdcall; external cLibName name 'GetLengthSid';
    function  GetNumberOfEventLogRecords                  ( hEventLog: winHandle; var NumberOfRecords: uint32 ): Bool; stdcall; external cLibName name 'GetNumberOfEventLogRecords';
    function  GetOldestEventLogRecord                     ( hEventLog: winHandle; var OldestRecord: uint32 ): Bool; stdcall; external cLibName name 'GetOldestEventLogRecord';
    function  GetPrivateObjectSecurity                    ( ObjectDescriptor: PSecurityDescriptor; SecurityInformation: TSECURITY_INFORMATION; ResultantDescriptor: PSecurityDescriptor; DescriptorLength: uint32; var ReturnLength: uint32 ): Bool; stdcall; external cLibName name 'GetPrivateObjectSecurity';
    function  GetSecurityDescriptorControl                ( pSecurityDescriptor: PSecurityDescriptor; var pControl: SECURITY_DESCRIPTOR_CONTROL; var lpdwRevision: uint32 ): Bool; stdcall; external cLibName name 'GetSecurityDescriptorControl';
    function  GetSecurityDescriptorDacl                   ( pSecurityDescriptor: PSecurityDescriptor; var lpbDaclPresent: Bool; var pDacl: PACL; var lpbDaclDefaulted: Bool ): Bool; stdcall; external cLibName name 'GetSecurityDescriptorDacl';
    function  GetSecurityDescriptorGroup                  ( pSecurityDescriptor: PSecurityDescriptor; var pGroup: PSID; var lpbGroupDefaulted: Bool ): Bool; stdcall; external cLibName name 'GetSecurityDescriptorGroup';
    function  GetSecurityDescriptorLength                 ( pSecurityDescriptor: PSecurityDescriptor ): uint32; stdcall; external cLibName name 'GetSecurityDescriptorLength';
    function  GetSecurityDescriptorOwner                  ( pSecurityDescriptor: PSecurityDescriptor; var pOwner: PSID; var lpbOwnerDefaulted: Bool ): Bool; stdcall; external cLibName name 'GetSecurityDescriptorOwner';
    function  GetSecurityDescriptorSacl                   ( pSecurityDescriptor: PSecurityDescriptor; var lpbSaclPresent: Bool; var pSacl: PACL; var lpbSaclDefaulted: Bool ): Bool; stdcall; external cLibName name 'GetSecurityDescriptorSacl';
    function  GetServiceDisplayNameA                      ( hSCManager: SC_HANDLE; lpServiceName, lpDisplayName: PAnsiChar; var lpcchBuffer: uint32 ): Bool; stdcall; external cLibName name 'GetServiceDisplayNameA';
    function  GetServiceDisplayNameW                      ( hSCManager: SC_HANDLE; lpServiceName, lpDisplayName: PWideChar; var lpcchBuffer: uint32 ): Bool; stdcall; external cLibName name 'GetServiceDisplayNameW';
    function  GetServiceKeyNameA                          ( hSCManager: SC_HANDLE; lpDisplayName, lpServiceName: PAnsiChar; var lpcchBuffer: uint32 ): Bool; stdcall; external cLibName name 'GetServiceKeyNameA';
    function  GetServiceKeyNameW                          ( hSCManager: SC_HANDLE; lpDisplayName, lpServiceName: PWideChar; var lpcchBuffer: uint32 ): Bool; stdcall; external cLibName name 'GetServiceKeyNameW';
    function  GetSidIdentifierAuthority                   ( pSid: Pointer ): PSIDIdentifierAuthority; stdcall; external cLibName name 'GetSidIdentifierAuthority';
    function  GetSidLengthRequired                        ( nSubAuthorityCount: uint8 ): uint32; stdcall; external cLibName name 'GetSidLengthRequired';
    function  GetSidSubAuthority                          ( pSid: Pointer; nSubAuthority: uint32 ): puint32; stdcall; external cLibName name 'GetSidSubAuthority';
    function  GetSidSubAuthorityCount                     ( pSid: Pointer ): puint8; stdcall; external cLibName name 'GetSidSubAuthorityCount';
    function  GetTokenInformation                         ( TokenHandle: winHandle; TokenInformationClass: Token_Information_Class; TokenInformation: Pointer; TokenInformationLength: uint32; var ReturnLength: uint32 ): Bool; stdcall; external cLibName name 'GetTokenInformation';
    function  GetUserNameA                                ( lpBuffer: PAnsiChar; var nSize: uint32 ): Bool; stdcall; external cLibName name 'GetUserNameA';
    function  GetUserNameW                                ( lpBuffer: PWideChar; var nSize: uint32 ): Bool; stdcall; external cLibName name 'GetUserNameW';
    function  ImpersonateLoggedOnUser                     ( hToken: winHandle ): Bool; stdcall; external cLibName name 'ImpersonateLoggedOnUser';
    function  ImpersonateNamedPipeClient                  ( hNamedPipe: winHandle ): Bool; stdcall; external cLibName name 'ImpersonateNamedPipeClient';
    function  ImpersonateSelf                             ( ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL ): Bool; stdcall; external cLibName name 'ImpersonateSelf';
    function  InitializeAcl                               ( var pAcl: ACL; nAclLength, dwAclRevision: uint32 ): Bool; stdcall; external cLibName name 'InitializeAcl';
    function  InitializeSecurityDescriptor                ( pSecurityDescriptor: PSecurityDescriptor; dwRevision: uint32 ): Bool; stdcall; external cLibName name 'InitializeSecurityDescriptor';
    function  InitializeSid                               ( Sid: Pointer; const pIdentifierAuthority: SIDIdentifierAuthority; nSubAuthorityCount: uint8 ): Bool; stdcall; external cLibName name 'InitializeSid';
    function  InitiateSystemShutdownA                     ( lpMachineName, lpMessage: PAnsiChar; dwTimeout: uint32; bForceAppsClosed, bRebootAfterShutdown: Bool ): Bool; stdcall; external cLibName name 'InitiateSystemShutdownA';
    function  InitiateSystemShutdownW                     ( lpMachineName, lpMessage: PWideChar; dwTimeout: uint32; bForceAppsClosed, bRebootAfterShutdown: Bool ): Bool; stdcall; external cLibName name 'InitiateSystemShutdownW';
    function  IsTextUnicode                               ( lpBuffer: Pointer; cb: int32; lpi: pint32 ): Bool; stdcall; external cLibName name 'IsTextUnicode';
    function  IsValidAcl                                  ( const pAcl: ACL ): Bool; stdcall; external cLibName name 'IsValidAcl';
    function  IsValidSecurityDescriptor                   ( pSecurityDescriptor: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'IsValidSecurityDescriptor';
    function  IsValidSid                                  ( pSid: Pointer ): Bool; stdcall; external cLibName name 'IsValidSid';
    function  LockServiceDatabase                         ( hSCManager: SC_HANDLE ): SC_LOCK; stdcall; external cLibName name 'LockServiceDatabase';
    function  LogonUser                                   ( lpszUsername, lpszDomain, lpszPassword: PAnsiChar; dwLogonType, dwLogonProvider: uint32; var phToken: winHandle ): Bool; stdcall; external cLibName name 'LogonUserA';
    function  LogonUserW                                  ( lpszUsername, lpszDomain, lpszPassword: PWideChar; dwLogonType, dwLogonProvider: uint32; var phToken: winHandle ): Bool; stdcall; external cLibName name 'LogonUserW';
    function  LookupAccountNameA                          ( lpSystemName, lpAccountName: PAnsiChar; Sid: PSID; var cbSid: uint32; ReferencedDomainName: PAnsiChar; var cbReferencedDomainName: uint32; var peUse: SID_NAME_USE ): Bool; stdcall; external cLibName name 'LookupAccountNameA';
    function  LookupAccountNameW                          ( lpSystemName, lpAccountName: PWideChar; Sid: PSID; var cbSid: uint32; ReferencedDomainName: PWideChar; var cbReferencedDomainName: uint32; var peUse: SID_NAME_USE ): Bool; stdcall; external cLibName name 'LookupAccountNameW';
    function  LookupAccountSidA                           ( lpSystemName: PAnsiChar; Sid: PSID; Name: PAnsiChar; var cbName: uint32; ReferencedDomainName: PAnsiChar; var cbReferencedDomainName: uint32; var peUse: SID_NAME_USE ): Bool; stdcall; external cLibName name 'LookupAccountSidA';
    function  LookupAccountSidW                           ( lpSystemName: PWideChar; Sid: PSID; Name: PWideChar; var cbName: uint32; ReferencedDomainName: PWideChar; var cbReferencedDomainName: uint32; var peUse: SID_NAME_USE ): Bool; stdcall; external cLibName name 'LookupAccountSidW';
    function  LookupPrivilegeDisplayNameA                 ( lpSystemName, lpName: PAnsiChar; lpDisplayName: PAnsiChar; var cbDisplayName, lpLanguageId: uint32 ): Bool; stdcall; external cLibName name 'LookupPrivilegeDisplayNameA';
    function  LookupPrivilegeDisplayNameW                 ( lpSystemName, lpName: PAnsiChar; lpDisplayName: PWideChar; var cbDisplayName, lpLanguageId: uint32 ): Bool; stdcall; external cLibName name 'LookupPrivilegeDisplayNameW';
    function  LookupPrivilegeNameA                        ( lpSystemName: PAnsiChar; var lpLuid: int64; lpName: PAnsiChar; var cbName: uint32 ): Bool; stdcall; external cLibName name 'LookupPrivilegeNameA';
    function  LookupPrivilegeNameW                        ( lpSystemName: PWideChar; var lpLuid: int64; lpName: PWideChar; var cbName: uint32 ): Bool; stdcall; external cLibName name 'LookupPrivilegeNameW';
    function  LookupPrivilegeValueA                       ( lpSystemName, lpName: PAnsiChar; var lpLuid: int64 ): Bool; stdcall; external cLibName name 'LookupPrivilegeValueA';
    function  LookupPrivilegeValueW                       ( lpSystemName, lpName: PWideChar; var lpLuid: int64 ): Bool; stdcall; external cLibName name 'LookupPrivilegeValueW';
    function  MakeAbsoluteSD                              ( pSelfRelativeSecurityDescriptor: PSecurityDescriptor; pAbsoluteSecurityDescriptor: PSecurityDescriptor; var lpdwAbsoluteSecurityDescriptorSi: uint32; var pDacl: ACL; var lpdwDaclSize: uint32; var pSacl: ACL; var lpdwSaclSize: uint32; pOwner: PSID; var lpdwOwnerSize: uint32; pPrimaryGroup: Pointer; var lpdwPrimaryGroupSize: uint32 ): Bool; stdcall; external cLibName name 'MakeAbsoluteSD';
    function  MakeSelfRelativeSD                          ( pAbsoluteSecurityDescriptor: PSecurityDescriptor; pSelfRelativeSecurityDescriptor: PSecurityDescriptor; var lpdwBufferLength: uint32 ): Bool; stdcall; external cLibName name 'MakeSelfRelativeSD';
    procedure MapGenericMask                              ( var AccessMask: uint32; const GenericMapping: TGenericMapping ); stdcall; external cLibName name 'MapGenericMask';
    function  NotifyBootConfigStatus                      ( BootAcceptable: Bool ): Bool; stdcall; external cLibName name 'NotifyBootConfigStatus';
    function  NotifyChangeEventLog                        ( hEventLog, hEvent: winHandle ): Bool; stdcall; external cLibName name 'NotifyChangeEventLog';
    function  ObjectCloseAuditAlarmA                      ( SubsystemName: PAnsiChar; HandleId: Pointer; GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectCloseAuditAlarmA';
    function  ObjectCloseAuditAlarmW                      ( SubsystemName: PWideChar; HandleId: Pointer; GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectCloseAuditAlarmW';
    function  ObjectDeleteAuditAlarmA                     ( SubsystemName: PAnsiChar; HandleId: Pointer; GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectDeleteAuditAlarmA';
    function  ObjectDeleteAuditAlarmW                     ( SubsystemName: PWideChar; HandleId: Pointer; GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectDeleteAuditAlarmW';
    function  ObjectOpenAuditAlarmA                       ( SubsystemName: PAnsiChar; HandleId: Pointer; ObjectTypeName: PAnsiChar; ObjectName: PAnsiChar; pSecurityDescriptor: PSecurityDescriptor; ClientToken: winHandle; DesiredAccess, GrantedAccess: uint32; var Privileges: PrivilegeSet; ObjectCreation, AccessGranted: Bool; var GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectOpenAuditAlarmA';
    function  ObjectOpenAuditAlarmW                       ( SubsystemName: PWideChar; HandleId: Pointer; ObjectTypeName: PWideChar; ObjectName: PWideChar; pSecurityDescriptor: PSecurityDescriptor; ClientToken: winHandle; DesiredAccess, GrantedAccess: uint32; var Privileges: PrivilegeSet; ObjectCreation, AccessGranted: Bool; var GenerateOnClose: Bool ): Bool; stdcall; external cLibName name 'ObjectOpenAuditAlarmW';
    function  ObjectPrivilegeAuditAlarmA                  ( SubsystemName: PAnsiChar; HandleId: Pointer; ClientToken: winHandle; DesiredAccess: uint32; var Privileges: PrivilegeSet; AccessGranted: Bool ): Bool; stdcall; external cLibName name 'ObjectPrivilegeAuditAlarmA';
    function  ObjectPrivilegeAuditAlarmW                  ( SubsystemName: PWideChar; HandleId: Pointer; ClientToken: winHandle; DesiredAccess: uint32; var Privileges: PrivilegeSet; AccessGranted: Bool ): Bool; stdcall; external cLibName name 'ObjectPrivilegeAuditAlarmW';
    function  OpenBackupEventLogA                         ( lpUNCServerName, lpFileName: PAnsiChar ): winHandle; stdcall; external cLibName name 'OpenBackupEventLogA';
    function  OpenBackupEventLogW                         ( lpUNCServerName, lpFileName: PWideChar ): winHandle; stdcall; external cLibName name 'OpenBackupEventLogW';
    function  OpenEventLogA                               ( lpUNCServerName, lpSourceName: PAnsiChar ): winHandle; stdcall; external cLibName name 'OpenEventLogA';
    function  OpenEventLogW                               ( lpUNCServerName, lpSourceName: PWideChar ): winHandle; stdcall; external cLibName name 'OpenEventLogW';
    function  OpenProcessToken                            ( ProcessHandle: winHandle; DesiredAccess: uint32; var TokenHandle: winHandle ): Bool; stdcall; external cLibName name 'OpenProcessToken';
    function  OpenSCManagerA                              ( lpMachineName, lpDatabaseName: PAnsiChar; dwDesiredAccess: uint32 ): SC_HANDLE; stdcall; external cLibName name 'OpenSCManagerA';
    function  OpenSCManagerW                              ( lpMachineName, lpDatabaseName: PWideChar; dwDesiredAccess: uint32 ): SC_HANDLE; stdcall; external cLibName name 'OpenSCManagerW';
    function  OpenServiceA                                ( hSCManager: SC_HANDLE; lpServiceName: PAnsiChar; dwDesiredAccess: uint32 ): SC_HANDLE; stdcall; external cLibName name 'OpenServiceA';
    function  OpenServiceW                                ( hSCManager: SC_HANDLE; lpServiceName: PWideChar; dwDesiredAccess: uint32 ): SC_HANDLE; stdcall; external cLibName name 'OpenServiceW';
    function  OpenThreadToken                             ( ThreadHandle: winHandle; DesiredAccess: uint32; OpenAsSelf: Bool; var TokenHandle: winHandle ): Bool; stdcall; external cLibName name 'OpenThreadToken';
    function  PrivilegeCheck                              ( ClientToken: winHandle; const RequiredPrivileges: PrivilegeSet; var pfResult: Bool ): Bool; stdcall; external cLibName name 'PrivilegeCheck';
    function  PrivilegedServiceAuditAlarmA                ( SubsystemName, ServiceName: PAnsiChar; ClientToken: winHandle; var Privileges: PrivilegeSet; AccessGranted: Bool ): Bool; stdcall; external cLibName name 'PrivilegedServiceAuditAlarmA';
    function  PrivilegedServiceAuditAlarmW                ( SubsystemName, ServiceName: PWideChar; ClientToken: winHandle; var Privileges: PrivilegeSet; AccessGranted: Bool ): Bool; stdcall; external cLibName name 'PrivilegedServiceAuditAlarmW';
    function  QueryServiceConfigA                         ( hService: SC_HANDLE; lpServiceConfig: PQuery_Service_ConfigA; cbBufSize: uint32; var pcbBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'QueryServiceConfigA';
    function  QueryServiceConfigW                         ( hService: SC_HANDLE; lpServiceConfig: PQuery_Service_ConfigW; cbBufSize: uint32; var pcbBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'QueryServiceConfigW';
    function  QueryServiceLockStatusA                     ( hSCManager: SC_HANDLE; var lpLockStatus: Query_Service_Lock_StatusA; cbBufSize: uint32; var pcbBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'QueryServiceLockStatusA';
    function  QueryServiceLockStatusW                     ( hSCManager: SC_HANDLE; var lpLockStatus: Query_Service_Lock_StatusW; cbBufSize: uint32; var pcbBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'QueryServiceLockStatusW';
    function  QueryServiceObjectSecurity                  ( hService: SC_HANDLE; dwSecurityInformation: TSECURITY_INFORMATION; lpSecurityDescriptor: PSECURITY_DESCRIPTOR; cbBufSize: uint32; var pcbBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'QueryServiceObjectSecurity';
    function  QueryServiceStatus                          ( hService: SC_HANDLE; var lpServiceStatus: ServiceStatus ): Bool; stdcall; external cLibName name 'QueryServiceStatus';
    function  ReadEventLogA                               ( hEventLog: winHandle; dwReadFlags, dwRecordOffset: uint32; lpBuffer: Pointer; nNumberOfBytesToRead: uint32; var pnBytesRead, pnMinNumberOfBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'ReadEventLogA';
    function  ReadEventLogW                               ( hEventLog: winHandle; dwReadFlags, dwRecordOffset: uint32; lpBuffer: Pointer; nNumberOfBytesToRead: uint32; var pnBytesRead, pnMinNumberOfBytesNeeded: uint32 ): Bool; stdcall; external cLibName name 'ReadEventLogW';
    function  RegCloseKey                                 ( hKey: HKEY ): int32; stdcall; external cLibName name 'RegCloseKey';
    function  RegConnectRegistryA                         ( lpMachineName: PAnsiChar; hKey: HKEY; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegConnectRegistryA';
    function  RegConnectRegistryW                         ( lpMachineName: PWideChar; hKey: HKEY; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegConnectRegistryW';
    function  RegCreateKeyA                               ( hKey: HKEY; lpSubKey: PAnsiChar; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegCreateKeyA';
    function  RegCreateKeyW                               ( hKey: HKEY; lpSubKey: PWideChar; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegCreateKeyW';
    function  RegCreateKeyExA                             ( hKey: HKEY; lpSubKey: PAnsiChar; Reserved: uint32; lpClass: PAnsiChar; dwOptions: uint32; samDesired: REGSAM; lpSecurityAttributes: PSecurityAttributes; var phkResult: HKEY; lpdwDisposition: Puint32 ): int32; stdcall; external cLibName name 'RegCreateKeyExA';
    function  RegCreateKeyExW                             ( hKey: HKEY; lpSubKey: PWideChar; Reserved: uint32; lpClass: PWideChar; dwOptions: uint32; samDesired: REGSAM; lpSecurityAttributes: PSecurityAttributes; var phkResult: HKEY; lpdwDisposition: Puint32 ): int32; stdcall; external cLibName name 'RegCreateKeyExW';
    function  RegDeleteKeyA                               ( hKey: HKEY; lpSubKey: PAnsiChar ): int32; stdcall; external cLibName name 'RegDeleteKeyA';
    function  RegDeleteKeyW                               ( hKey: HKEY; lpSubKey: PWideChar ): int32; stdcall; external cLibName name 'RegDeleteKeyW';
    function  RegDeleteValueA                             ( hKey: HKEY; lpValueName: PAnsiChar ): int32; stdcall; external cLibName name 'RegDeleteValueA';
    function  RegDeleteValueW                             ( hKey: HKEY; lpValueName: PWideChar ): int32; stdcall; external cLibName name 'RegDeleteValueW';
    function  RegEnumKeyA                                 ( hKey: HKEY; dwIndex: uint32; lpName: PAnsiChar; cbName: uint32 ): int32; stdcall; external cLibName name 'RegEnumKeyA';
    function  RegEnumKeyW                                 ( hKey: HKEY; dwIndex: uint32; lpName: PWideChar; cbName: uint32 ): int32; stdcall; external cLibName name 'RegEnumKeyW';
    function  RegEnumKeyExA                               ( hKey: HKEY; dwIndex: uint32; lpName: PAnsiChar; var lpcbName: uint32; lpReserved: Pointer; lpClass: PAnsiChar; lpcbClass: Puint32; lpftLastWriteTime: PFileTime ): int32; stdcall; external cLibName name 'RegEnumKeyExA';
    function  RegEnumKeyExW                               ( hKey: HKEY; dwIndex: uint32; lpName: PWideChar; var lpcbName: uint32; lpReserved: Pointer; lpClass: PWideChar; lpcbClass: Puint32; lpftLastWriteTime: PFileTime ): int32; stdcall; external cLibName name 'RegEnumKeyExW';
    function  RegEnumValueA                               ( hKey: HKEY; dwIndex: uint32; lpValueName: LPWStr; var lpcbValueName: uint32; lpReserved: Pointer; lpType: Puint32; lpData: puint8; lpcbData: Puint32 ): int32; stdcall; external cLibName name 'RegEnumValueA';
    function  RegEnumValueW                               ( hKey: HKEY; dwIndex: uint32; lpValueName: LPWStr; var lpcbValueName: uint32; lpReserved: Pointer; lpType: Puint32; lpData: puint8; lpcbData: Puint32 ): int32; stdcall; external cLibName name 'RegEnumValueW';
    function  RegFlushKey                                 ( hKey: HKEY ): int32; stdcall; external cLibName name 'RegFlushKey';
    function  RegGetKeySecurity                           ( hKey: HKEY; SecurityInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor; var lpcbSecurityDescriptor: uint32 ): int32; stdcall; external cLibName name 'RegGetKeySecurity';
    function  RegLoadKeyA                                 ( hKey: HKEY; lpSubKey, lpFile: PAnsiChar ): int32; stdcall; external cLibName name 'RegLoadKeyA';
    function  RegLoadKeyW                                 ( hKey: HKEY; lpSubKey, lpFile: PWideChar ): int32; stdcall; external cLibName name 'RegLoadKeyW';
    function  RegNotifyChangeKeyValue                     ( hKey: HKEY; bWatchSubtree: Bool; dwNotifyFilter: uint32; hEvent: winHandle; fAsynchronus: Bool ): int32; stdcall; external cLibName name 'RegNotifyChangeKeyValue';
    function  RegOpenKeyA                                 ( hKey: HKEY; lpSubKey: PAnsiChar; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegOpenKeyA';
    function  RegOpenKeyW                                 ( hKey: HKEY; lpSubKey: PWideChar; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegOpenKeyW';
    function  RegOpenKeyExA                               ( hKey: HKEY; lpSubKey: PAnsiChar; ulOptions: uint32; samDesired: REGSAM; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegOpenKeyExA';
    function  RegOpenKeyExW                               ( hKey: HKEY; lpSubKey: PWideChar; ulOptions: uint32; samDesired: REGSAM; var phkResult: HKEY ): int32; stdcall; external cLibName name 'RegOpenKeyExW';
    function  RegQueryInfoKeyA                            ( hKey: HKEY; lpClass: LPWStr; lpcbClass: Puint32; lpReserved: Pointer; lpcSubKeys, lpcbMaxSubKeyLen, lpcbMaxClassLen, lpcValues, lpcbMaxValueNameLen, lpcbMaxValueLen, lpcbSecurityDescriptor: Puint32; lpftLastWriteTime: PFileTime ): int32; stdcall; external cLibName name 'RegQueryInfoKeyA';
    function  RegQueryInfoKeyW                            ( hKey: HKEY; lpClass: LPWStr; lpcbClass: Puint32; lpReserved: Pointer; lpcSubKeys, lpcbMaxSubKeyLen, lpcbMaxClassLen, lpcValues, lpcbMaxValueNameLen, lpcbMaxValueLen, lpcbSecurityDescriptor: Puint32; lpftLastWriteTime: PFileTime ): int32; stdcall; external cLibName name 'RegQueryInfoKeyW';
    function  RegQueryMultipleValuesA                     ( hKey: HKEY; var ValList; NumVals: uint32; lpValueBuf: PAnsiChar; var ldwTotsize: uint32 ): int32; stdcall; external cLibName name 'RegQueryMultipleValuesA';
    function  RegQueryMultipleValuesW                     ( hKey: HKEY; var ValList; NumVals: uint32; lpValueBuf: PWideChar; var ldwTotsize: uint32 ): int32; stdcall; external cLibName name 'RegQueryMultipleValuesW';
    function  RegQueryValueA                              ( hKey: HKEY; lpSubKey: PAnsiChar; lpValue: PAnsiChar; var lpcbValue: int32 ): int32; stdcall; external cLibName name 'RegQueryValueA';
    function  RegQueryValueExW                            ( hKey: HKEY; lpValueName: PWideChar; lpReserved: Pointer; lpType: Puint32; lpData: puint8; lpcbData: Puint32 ): int32; stdcall; external cLibName name 'RegQueryValueExW';
    function  RegQueryValueEx                             ( hKey: HKEY; lpValueName: PAnsiChar; lpReserved: Pointer; lpType: Puint32; lpData: puint8; lpcbData: Puint32 ): int32; stdcall; external cLibName name 'RegQueryValueExA';
    function  RegQueryValueW                              ( hKey: HKEY; lpSubKey: PWideChar; lpValue: PWideChar; var lpcbValue: int32 ): int32; stdcall; external cLibName name 'RegQueryValueW';
    function  RegReplaceKeyA                              ( hKey: HKEY; lpSubKey: PAnsiChar; lpNewFile: PAnsiChar; lpOldFile: PAnsiChar ): int32; stdcall; external cLibName name 'RegReplaceKeyA';
    function  RegReplaceKeyW                              ( hKey: HKEY; lpSubKey: PWideChar; lpNewFile: PWideChar; lpOldFile: PWideChar ): int32; stdcall; external cLibName name 'RegReplaceKeyW';
    function  RegRestoreKeyA                              ( hKey: HKEY; lpFile: PAnsiChar; dwFlags: uint32 ): int32; stdcall; external cLibName name 'RegRestoreKeyA';
    function  RegRestoreKeyW                              ( hKey: HKEY; lpFile: PWideChar; dwFlags: uint32 ): int32; stdcall; external cLibName name 'RegRestoreKeyW';
    function  RegSaveKeyA                                 ( hKey: HKEY; lpFile: PAnsiChar; lpSecurityAttributes: PSecurityAttributes ): int32; stdcall; external cLibName name 'RegSaveKeyA';
    function  RegSaveKeyW                                 ( hKey: HKEY; lpFile: PWideChar; lpSecurityAttributes: PSecurityAttributes ): int32; stdcall; external cLibName name 'RegSaveKeyW';
    function  RegSetKeySecurity                           ( hKey: HKEY; SecurityInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSECURITY_DESCRIPTOR ): int32; stdcall; external cLibName name 'RegSetKeySecurity';
    function  RegSetValueA                                ( hKey: HKEY; lpSubKey: PAnsiChar; dwType: uint32; lpData: PAnsiChar; cbData: uint32 ): int32; stdcall; external cLibName name 'RegSetValueA';
    function  RegSetValueW                                ( hKey: HKEY; lpSubKey: PWideChar; dwType: uint32; lpData: PWideChar; cbData: uint32 ): int32; stdcall; external cLibName name 'RegSetValueW';
    function  RegSetValueEx                               ( hKey: HKEY; lpValueName: PAnsiChar; Reserved: uint32; dwType: uint32; lpData: Pointer; cbData: uint32 ): int32; stdcall; external cLibName name 'RegSetValueExA';
    function  RegSetValueExW                              ( hKey: HKEY; lpValueName: PWideChar; Reserved: uint32; dwType: uint32; lpData: Pointer; cbData: uint32 ): int32; stdcall; external cLibName name 'RegSetValueExW';
    function  RegUnLoadKeyA                               ( hKey: HKEY; lpSubKey: PAnsiChar ): int32; stdcall; external cLibName name 'RegUnLoadKeyA';
    function  RegUnLoadKeyW                               ( hKey: HKEY; lpSubKey: PWideChar ): int32; stdcall; external cLibName name 'RegUnLoadKeyW';
    function  RegisterEventSourceA                        ( lpUNCServerName, lpSourceName: PAnsiChar ): winHandle; stdcall; external cLibName name 'RegisterEventSourceA';
    function  RegisterEventSourceW                        ( lpUNCServerName, lpSourceName: PWideChar ): winHandle; stdcall; external cLibName name 'RegisterEventSourceW';
    function  RegisterServiceCtrlHandlerA                 ( lpServiceName: PAnsiChar; lpHandlerProc: HandlerFunction ): SERVICE_STATUS_HANDLE; stdcall; external cLibName name 'RegisterServiceCtrlHandlerA';
    function  RegisterServiceCtrlHandlerW                 ( lpServiceName: PWideChar; lpHandlerProc: HandlerFunction ): SERVICE_STATUS_HANDLE; stdcall; external cLibName name 'RegisterServiceCtrlHandlerW';
    function  ReportEventA                                (  hEventLog: winHandle; wType, wCategory: uint16; dwEventID: uint32; lpUserSid: Pointer; wNumStrings: uint16; dwDataSize: uint32; lpStrings, lpRawData: Pointer ): Bool; stdcall; external cLibName name 'ReportEventA';
    function  ReportEventW                                ( hEventLog: winHandle; wType, wCategory: uint16; dwEventID: uint32; lpUserSid: Pointer; wNumStrings: uint16; dwDataSize: uint32; lpStrings, lpRawData: Pointer ): Bool; stdcall; external cLibName name 'ReportEventW';
    function  RevertToSelf                                ( ): Bool; stdcall; external cLibName name 'RevertToSelf';
    function  SetAclInformation                           ( var pAcl: ACL; pAclInformation: Pointer; nAclInformationLength: uint32; dwAclInformationClass: AclInformationClass ): Bool; stdcall; external cLibName name 'SetAclInformation';
    function  SetFileSecurityA                            ( lpFileName: PAnsiChar; SecurityInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'SetFileSecurityA';
    function  SetFileSecurityW                            ( lpFileName: PWideChar; SecurityInformation: TSECURITY_INFORMATION; pSecurityDescriptor: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'SetFileSecurityW';
    function  SetKernelObjectSecurity                     ( Handle: winHandle; SecurityInformation: TSECURITY_INFORMATION; SecurityDescriptor: PSecurityDescriptor ): Bool; stdcall; external cLibName name 'SetKernelObjectSecurity';
    function  SetPrivateObjectSecurity                    ( SecurityInformation: TSECURITY_INFORMATION; ModificationDescriptor: PSecurityDescriptor; var ObjectsSecurityDescriptor: PSecurityDescriptor; const GenericMapping: TGenericMapping; Token: winHandle ): Bool; stdcall; external cLibName name 'SetPrivateObjectSecurity';
    function  SetPrivateObjectSecurityEx                  ( SecurityInformation: TSECURITY_INFORMATION; ModificationDescriptor: PSecurityDescriptor; var ObjectsSecurityDescriptor: PSecurityDescriptor; AutoInheritFlags: uint32; const GenericMapping: TGenericMapping; Token: winHandle ): Bool; stdcall; external cLibName name 'SetPrivateObjectSecurityEx';
    function  SetSecurityDescriptorControl                ( pSecurityDescriptor: PSecurityDescriptor; ControlBitsOfInterest, ControlBitsToSet: SECURITY_DESCRIPTOR_CONTROL ): Bool; stdcall; external cLibName name 'SetSecurityDescriptorControl';
    function  SetSecurityDescriptorDacl                   ( pSecurityDescriptor: PSecurityDescriptor; bDaclPresent: Bool; pDacl: PACL; bDaclDefaulted: Bool ): Bool; stdcall; external cLibName name 'SetSecurityDescriptorDacl';
    function  SetSecurityDescriptorGroup                  ( pSecurityDescriptor: PSecurityDescriptor; pGroup: PSID; bGroupDefaulted: Bool ): Bool; stdcall; external cLibName name 'SetSecurityDescriptorGroup';
    function  SetSecurityDescriptorOwner                  ( pSecurityDescriptor: PSecurityDescriptor; pOwner: PSID; bOwnerDefaulted: Bool ): Bool; stdcall; external cLibName name 'SetSecurityDescriptorOwner';
    function  SetSecurityDescriptorSacl                   ( pSecurityDescriptor: PSecurityDescriptor; bSaclPresent: Bool; pSacl: PACL; bSaclDefaulted: Bool ): Bool; stdcall; external cLibName name 'SetSecurityDescriptorSacl';
    function  SetServiceObjectSecurity                    ( hService: SC_HANDLE; dwSecurityInformation: TSECURITY_INFORMATION; lpSecurityDescriptor: PSECURITY_DESCRIPTOR ): Bool; stdcall; external cLibName name 'SetServiceObjectSecurity';
    function  SetServiceStatus                            ( hServiceStatus: SERVICE_STATUS_HANDLE; var ServiceStatus: Service_Status ): Bool; stdcall; external cLibName name 'SetServiceStatus';
    function  SetThreadToken                              ( Thread: pWinHandle; Token: winHandle ): Bool; stdcall; external cLibName name 'SetThreadToken';
    function  SetTokenInformation                         ( TokenHandle: winHandle; TokenInformationClass: Token_Information_Class; TokenInformation: Pointer; TokenInformationLength: uint32 ): Bool; stdcall; external cLibName name 'SetTokenInformation';
    function  StartServiceA                               ( hService: SC_HANDLE; dwNumServiceArgs: uint32; var lpServiceArgVectors: PAnsiChar ): Bool; stdcall; external cLibName name 'StartServiceA';
    function  StartServiceW                               ( hService: SC_HANDLE; dwNumServiceArgs: uint32; var lpServiceArgVectors: PWideChar ): Bool; stdcall; external cLibName name 'StartServiceW';
    function  StartServiceCtrlDispatcherA                 ( var ServiceStartTable: Service_Table_EntryA ): Bool; stdcall; external cLibName name 'StartServiceCtrlDispatcherA';
    function  StartServiceCtrlDispatcherW                 ( var ServiceStartTable: Service_Table_EntryW ): Bool; stdcall; external cLibName name 'StartServiceCtrlDispatcherW';
    function  UnlockServiceDatabase                       ( ScLock: SC_LOCK ): Bool; stdcall; external cLibName name 'UnlockServiceDatabase';
    function  RegisterServiceCtrlHandlerExA               ( lpServiceName: LPCSTR; lpHandlerProc: HandlerEx; lpContext: pointer ): SERVICE_STATUS_HANDLE; stdcall; external cLibName name 'RegisterServiceCtrlHandlerExA';
    function  RegisterServiceCtrlHandlerExW               ( lpServiceName: LPCWSTR; lpHandlerProc: HandlerEx; lpContext: pointer ): SERVICE_STATUS_HANDLE; stdcall; external cLibName name 'RegisterServiceCtrlHandlerExW';

    function  AbortDoc                                    ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'AbortDoc';
    function  AbortPath                                   ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'AbortPath';
    function  AddFontMemResourceEx                        ( p1: Pointer; p2: uint32; p3: PDesignVector; var p4: uint32 ): winHandle; stdcall; external cLibNameGDI name 'AddFontMemResourceEx';
    function  AddFontResourceA                            ( p1: PAnsiChar ): int32; stdcall; external cLibNameGDI name 'AddFontResourceA';
    function  AddFontResourceW                            ( p1: PWideChar ): int32; stdcall; external cLibNameGDI name 'AddFontResourceW';
    function  AddFontResourceExA                          ( p1: PAnsiChar; p2: uint32; p3: PDesignVector ): int32; stdcall; external cLibNameGDI name 'AddFontResourceExA';
    function  AddFontResourceExW                          ( p1: PAnsiChar; p2: uint32; p3: PDesignVector ): int32; stdcall; external cLibNameGDI name 'AddFontResourceExW';
    function  AngleArc                                    ( DC: HDC; p2, p3: int32; p4: uint32; p5, p6: Single ): Bool; stdcall; external cLibNameGDI name 'AngleArc';
    function  AnimatePalette                              ( p1: HPALETTE; p2, p3: uint32; p4: PPaletteEntry ): Bool; stdcall; external cLibNameGDI name 'AnimatePalette';
    function  Arc                                         ( hDC: HDC; left, top, right, bottom, startX, startY, endX, endY: int32 ): Bool; stdcall; external cLibNameGDI name 'Arc';
    function  ArcTo                                       ( DC: HDC; RLeft, RTop, RRight, RBottom: int32; X1, Y1, X2, Y2: int32 ): Bool; stdcall; external cLibNameGDI name 'ArcTo';
    function  BeginPath                                   ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'BeginPath';
    function  BitBlt                                      ( DestDC: HDC; X, Y, Width, Height: int32; SrcDC: HDC; XSrc, YSrc: int32; Rop: uint32 ): Bool; stdcall; external cLibNameGDI name 'BitBlt';
    function  CancelDC                                    ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'CancelDC';
    function  CheckColorsInGamut                          ( DC: HDC; var RGBQuads, Results; Count: uint32 ): Bool; stdcall; external cLibNameGDI name 'CheckColorsInGamut';
    function  ChoosePixelFormat                           ( DC: HDC; p2: PPixelFormatDescriptor ): int32; stdcall; external cLibNameGDI name 'ChoosePixelFormat';
    function  Chord                                       ( DC: HDC; X1, Y1, X2, Y2, X3, Y3, X4, Y4: int32 ): Bool; stdcall; external cLibNameGDI name 'Chord';
    function  CloseEnhMetaFile                            ( DC: HDC ): HENHMETAFILE; stdcall; external cLibNameGDI name 'CloseEnhMetaFile';
    function  CloseFigure                                 ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'CloseFigure';
    function  CloseMetaFile                               ( DC: HDC ): HMETAFILE; stdcall; external cLibNameGDI name 'CloseMetaFile';
    function  ColorCorrectPalette                         ( DC: HDC; p2: HPALETTE; p3, p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'ColorCorrectPalette';
    function  ColorMatchToTarget                          ( DC: HDC; Target: HDC; Action: uint32 ): Bool; stdcall; external cLibNameGDI name 'ColorMatchToTarget';
    function  CombineRgn                                  ( p1, p2, p3: HRGN; p4: int32 ): int32; stdcall; external cLibNameGDI name 'CombineRgn';
    function  CombineTransform                            ( var p1: XForm; const p2, p3: XForm ): Bool; stdcall; external cLibNameGDI name 'CombineTransform';
    function  CopyEnhMetaFileA                            ( p1: HENHMETAFILE; p2: PAnsiChar ): HENHMETAFILE; stdcall; external cLibNameGDI name 'CopyEnhMetaFileA';
    function  CopyEnhMetaFileW                            ( p1: HENHMETAFILE; p2: PWideChar ): HENHMETAFILE; stdcall; external cLibNameGDI name 'CopyEnhMetaFileW';
    function  CopyMetaFileA                               ( p1: HMETAFILE; p2: PAnsiChar ): HMETAFILE; stdcall; external cLibNameGDI name 'CopyMetaFileA';
    function  CopyMetaFileW                               ( p1: HMETAFILE; p2: PWideChar ): HMETAFILE; stdcall; external cLibNameGDI name 'CopyMetaFileW';
    function  CreateBitmap                                ( Width, Height: int32; Planes, BitCount: int32; Bits: Pointer ): HBITMAP; stdcall; external cLibNameGDI name 'CreateBitmap';
    function  CreateBitmapIndirect                        ( const p1: Bitmap ): HBITMAP; stdcall; external cLibNameGDI name 'CreateBitmapIndirect';
    function  CreateBrushIndirect                         ( const p1: LogBrush ): HBRUSH; stdcall; external cLibNameGDI name 'CreateBrushIndirect';
    function  CreateColorSpaceA                           ( var ColorSpace: LogColorSpaceA ): HCOLORSPACE; stdcall; external cLibNameGDI name 'CreateColorSpaceA';
    function  CreateColorSpaceW                           ( var ColorSpace: LogColorSpaceW ): HCOLORSPACE; stdcall; external cLibNameGDI name 'CreateColorSpaceW';
    function  CreateCompatibleBitmap                      ( DC: HDC; Width, Height: int32 ): HBITMAP; stdcall; external cLibNameGDI name 'CreateCompatibleBitmap';
    function  CreateCompatibleDC                          ( DC: HDC ): HDC; stdcall; external cLibNameGDI name 'CreateCompatibleDC';
    function  CreateDCA                                   ( lpszDriver, lpszDevice, lpszOutput: PAnsiChar; lpdvmInit: PDeviceModeA ): HDC; stdcall; external cLibNameGDI name 'CreateDCA';
    function  CreateDCW                                   ( lpszDriver, lpszDevice, lpszOutput: PWideChar; lpdvmInit: PDeviceModeW ): HDC; stdcall; external cLibNameGDI name 'CreateDCW';
    function  CreateDIBPatternBrush                       ( p1: HGLOBAL; p2: uint32 ): HBRUSH; stdcall; external cLibNameGDI name 'CreateDIBPatternBrush';
    function  CreateDIBPatternBrushPt                     ( const p1: Pointer; p2: uint32 ): HBRUSH; stdcall; external cLibNameGDI name 'CreateDIBPatternBrushPt';
    function  CreateDIBSection                            ( DC: HDC; const p2: BitmapInfo; p3: uint32; var p4: Pointer; p5: winHandle; p6: uint32 ): HBITMAP; stdcall; external cLibNameGDI name 'CreateDIBSection';
    function  CreateDIBitmap                              ( DC: HDC; var InfoHeader: BitmapInfoHeader; dwUsage: uint32; InitBits: PChar; var InitInfo: BitmapInfo; wUsage: uint32 ): HBITMAP; stdcall; external cLibNameGDI name 'CreateDIBitmap';
    function  CreateDiscardableBitmap                     ( DC: HDC; p2, p3: int32 ): HBITMAP; stdcall; external cLibNameGDI name 'CreateDiscardableBitmap';
    function  CreateEllipticRgn                           ( p1, p2, p3, p4: int32 ): HRGN; stdcall; external cLibNameGDI name 'CreateEllipticRgn';
    function  CreateEllipticRgnIndirect                   ( const p1: Rect ): HRGN; stdcall; external cLibNameGDI name 'CreateEllipticRgnIndirect';
    function  CreateEnhMetaFileA                          ( DC: HDC; p2: PAnsiChar; p3: PRect; p4: PAnsiChar ): HDC; stdcall; external cLibNameGDI name 'CreateEnhMetaFileA';
    function  CreateEnhMetaFileW                          ( DC: HDC; p2: PWideChar; p3: PRect; p4: PWideChar ): HDC; stdcall; external cLibNameGDI name 'CreateEnhMetaFileW';
    function  CreateFont                                  ( nHeight, nWidth, nEscapement, nOrientaion, fnWeight: int32; fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily: uint32; lpszFace: PAnsiChar ): HFONT; stdcall; external cLibNameGDI name 'CreateFontA';
    function  CreateFontIndirectA                         ( const p1: LogFontA ): HFONT; stdcall; external cLibNameGDI name 'CreateFontIndirectA';
    function  CreateFontIndirectW                         ( const p1: LogFontW ): HFONT; stdcall; external cLibNameGDI name 'CreateFontIndirectW';
    function  CreateFontIndirectExA                       ( const p1: PEnumLogFontExDVA ): HFONT; stdcall; external cLibNameGDI name 'CreateFontIndirectExA';
    function  CreateFontIndirectExW                       ( const p1: PEnumLogFontExDVW ): HFONT; stdcall; external cLibNameGDI name 'CreateFontIndirectExW';
    function  CreateFontW                                 ( nHeight, nWidth, nEscapement, nOrientaion, fnWeight: int32; fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily: uint32; lpszFace: PWideChar ): HFONT; stdcall; external cLibNameGDI name 'CreateFontW';
    function  CreateHalftonePalette                       ( DC: HDC ): HPALETTE; stdcall; external cLibNameGDI name 'CreateHalftonePalette';
    function  CreateHatchBrush                            ( p1: int32; p2: COLORREF ): HBRUSH; stdcall; external cLibNameGDI name 'CreateHatchBrush';
    function  CreateICA                                   ( lpszDriver, lpszDevice, lpszOutput: PAnsiChar; lpdvmInit: PDeviceModeA ): HDC; stdcall; external cLibNameGDI name 'CreateICA';
    function  CreateICW                                   ( lpszDriver, lpszDevice, lpszOutput: PWideChar; lpdvmInit: PDeviceModeW ): HDC; stdcall; external cLibNameGDI name 'CreateICW';
    function  CreateMetaFileA                             ( p1: PAnsiChar ): HDC; stdcall; external cLibNameGDI name 'CreateMetaFileA';
    function  CreateMetaFileW                             ( p1: PWideChar ): HDC; stdcall; external cLibNameGDI name 'CreateMetaFileW';
    function  CreatePalette                               ( const LogPalette: LogPalette ): HPALETTE; stdcall; external cLibNameGDI name 'CreatePalette';
    function  CreatePatternBrush                          ( Bitmap: HBITMAP ): HBRUSH; stdcall; external cLibNameGDI name 'CreatePatternBrush';
    function  CreatePen                                   ( Style, Width: int32; Color: COLORREF ): HPEN; stdcall; external cLibNameGDI name 'CreatePen';
    function  CreatePenIndirect                           ( const LogPen: LogPen ): HPEN; stdcall; external cLibNameGDI name 'CreatePenIndirect';
    function  CreatePolyPolygonRgn                        ( const pPtStructs; const pIntArray; p3, p4: int32 ): HRGN; stdcall; external cLibNameGDI name 'CreatePolyPolygonRgn';
    function  CreatePolygonRgn                            ( const Points; Count, FillMode: int32 ): HRGN; stdcall; external cLibNameGDI name 'CreatePolygonRgn';
    function  CreateRectRgn                               ( p1, p2, p3, p4: int32 ): HRGN; stdcall; external cLibNameGDI name 'CreateRectRgn';
    function  CreateRectRgnIndirect                       ( const p1: Rect ): HRGN; stdcall; external cLibNameGDI name 'CreateRectRgnIndirect';
    function  CreateRoundRectRgn                          ( p1, p2, p3, p4, p5, p6: int32 ): HRGN; stdcall; external cLibNameGDI name 'CreateRoundRectRgn';
    function  CreateScalableFontResourceA                 ( p1: uint32; p2, p3, p4: PAnsiChar ): Bool; stdcall; external cLibNameGDI name 'CreateScalableFontResourceA';
    function  CreateScalableFontResourceW                 ( p1: uint32; p2, p3, p4: PWideChar ): Bool; stdcall; external cLibNameGDI name 'CreateScalableFontResourceW';
    function  CreateSolidBrush                            ( p1: COLORREF ): HBRUSH; stdcall; external cLibNameGDI name 'CreateSolidBrush';
    function  DPtoLP                                      ( DC: HDC; var Points; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'DPtoLP';
    function  DeleteColorSpace                            ( ColorSpace: HCOLORSPACE ): Bool; stdcall; external cLibNameGDI name 'DeleteColorSpace';
    function  DeleteDC                                    ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'DeleteDC';
    function  DeleteEnhMetaFile                           ( p1: HENHMETAFILE ): Bool; stdcall; external cLibNameGDI name 'DeleteEnhMetaFile';
    function  DeleteMetaFile                              ( p1: HMETAFILE ): Bool; stdcall; external cLibNameGDI name 'DeleteMetaFile';
    function  DeleteObject                                ( p1: HGDIOBJ ): Bool; stdcall; external cLibNameGDI name 'DeleteObject';
    function  DescribePixelFormat                         ( DC: HDC; p2: int32; p3: uint32; var p4: PixelFormatDescriptor ): Bool; stdcall; external cLibNameGDI name 'DescribePixelFormat';
    function  DrawEscape                                  ( DC: HDC; p2, p3: int32; p4: LPCSTR ): Bool; stdcall; external cLibNameGDI name 'DrawEscape';
    function  Ellipse                                     ( DC: HDC; X1, Y1, X2, Y2: int32 ): Bool; stdcall; external cLibNameGDI name 'Ellipse';
    function  EndDoc                                      ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'EndDoc';
    function  EndPage                                     ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'EndPage';
    function  EndPath                                     ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'EndPath';
    function  EnumEnhMetaFile                             ( DC: HDC; p2: HENHMETAFILE; p3: EnhMetaFileProc; p4: Pointer; const p5: Rect ): Bool; stdcall; external cLibNameGDI name 'EnumEnhMetaFile';
    function  EnumFontFamiliesA                           ( DC: HDC; p2: PAnsiChar; p3: EnumFontsProcA; p4: LPARAM ): Bool; stdcall; external cLibNameGDI name 'EnumFontFamiliesA';
    function  EnumFontFamiliesW                           ( DC: HDC; p2: PWideChar; p3: EnumFontsProcW; p4: LPARAM ): Bool; stdcall; external cLibNameGDI name 'EnumFontFamiliesW';
    function  EnumFontFamiliesExA                         ( DC: HDC; var p2: LogFontA; p3: EnumFontsProcA; p4: LPARAM; p5: uint32 ): Bool; stdcall; external cLibNameGDI name 'EnumFontFamiliesExA';
    function  EnumFontFamiliesExW                         ( DC: HDC; var p2: LogFontW; p3: EnumFontsProcW; p4: LPARAM; p5: uint32 ): Bool; stdcall; external cLibNameGDI name 'EnumFontFamiliesExW';
    function  EnumFontsA                                  ( DC: HDC; lpszFace: PAnsiChar; fntenmprc: EnumFontsProcA; lpszData: PChar ): int32; stdcall; external cLibNameGDI name 'EnumFontsA';
    function  EnumFontsW                                  ( DC: HDC; lpszFace: PWideChar; fntenmprc: EnumFontsProcW; lpszData: PChar ): int32; stdcall; external cLibNameGDI name 'EnumFontsW';
    function  EnumICMProfilesA                            ( DC: HDC; ICMProc: ICMEnumProcA; p3: LPARAM ): int32; stdcall; external cLibNameGDI name 'EnumICMProfilesA';
    function  EnumICMProfilesW                            ( DC: HDC; ICMProc: ICMEnumProcW; p3: LPARAM ): int32; stdcall; external cLibNameGDI name 'EnumICMProfilesW';
    function  EnumMetaFile                                ( DC: HDC; p2: HMETAFILE; p3: EnumMetaFileProc; p4: LPARAM ): Bool; stdcall; external cLibNameGDI name 'EnumMetaFile';
    function  EnumObjects                                 ( DC: HDC; p2: int32; p3: EnumObjectsProc; p4: LPARAM ): int32; stdcall; external cLibNameGDI name 'EnumObjects';
    function  EqualRgn                                    ( p1, p2: HRGN ): Bool; stdcall; external cLibNameGDI name 'EqualRgn';
    function  Escape                                      ( DC: HDC; p2, p3: int32; p4: LPCSTR; p5: Pointer ): int32; stdcall; external cLibNameGDI name 'Escape';
    function  ExcludeClipRect                             ( DC: HDC; p2, p3, p4, p5: int32 ): int32; stdcall; external cLibNameGDI name 'ExcludeClipRect';
    function  ExtCreatePen                                ( PenStyle, Width: uint32; const Brush: LogBrush; StyleCount: uint32; Style: Pointer ): HPEN; stdcall; external cLibNameGDI name 'ExtCreatePen';
    function  ExtCreateRegion                             ( p1: PXForm; p2: uint32; const p3: RgnData ): HRGN; stdcall; external cLibNameGDI name 'ExtCreateRegion';
    function  ExtEscape                                   ( DC: HDC; p2, p3: int32; const p4: LPCSTR; p5: int32; p6: LPSTR ): int32; stdcall; external cLibNameGDI name 'ExtEscape';
    function  ExtFloodFill                                ( DC: HDC; X, Y: int32; Color: COLORREF; FillType: uint32 ): Bool; stdcall; external cLibNameGDI name 'ExtFloodFill';
    function  ExtSelectClipRgn                            ( DC: HDC; p2: HRGN; p3: int32 ): int32; stdcall; external cLibNameGDI name 'ExtSelectClipRgn';
    function  ExtTextOutA                                 ( DC: HDC; X, Y: int32; Options: int32; Rect: PRect; Str: PAnsiChar; Count: int32; Dx: Pint32 ): Bool; stdcall; external cLibNameGDI name 'ExtTextOutA';
    function  ExtTextOutW                                 ( DC: HDC; X, Y: int32; Options: int32; Rect: PRect; Str: PWideChar; Count: int32; Dx: Pint32 ): Bool; stdcall; external cLibNameGDI name 'ExtTextOutW';
    function  FillPath                                    ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'FillPath';
    function  FillRgn                                     ( DC: HDC; p2: HRGN; p3: HBRUSH ): Bool; stdcall; external cLibNameGDI name 'FillRgn';
    function  FlattenPath                                 ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'FlattenPath';
    function  FloodFill                                   ( DC: HDC; nXStart, nYStart: int32; crFill: COLORREF ): Bool; stdcall; external cLibNameGDI name 'FloodFill';
    function  FrameRgn                                    ( DC: HDC; p2: HRGN; p3: HBRUSH; p4, p5: int32 ): Bool; stdcall; external cLibNameGDI name 'FrameRgn';
    function  GdiComment                                  ( DC: HDC; p2: uint32; p3: PChar ): Bool; stdcall; external cLibNameGDI name 'GdiComment';
    function  GdiFlush                                    ( ): Bool; stdcall; external cLibNameGDI name 'GdiFlush';
    function  GdiGetBatchLimit                            ( ): uint32; stdcall; external cLibNameGDI name 'GdiGetBatchLimit';
    function  GdiSetBatchLimit                            (  Limit: uint32 ): uint32; stdcall; external cLibNameGDI name 'GdiSetBatchLimit';
    function  GetArcDirection                             ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetArcDirection';
    function  GetAspectRatioFilterEx                      ( DC: HDC; var p2: Size ): Bool; stdcall; external cLibNameGDI name 'GetAspectRatioFilterEx';
    function  GetBitmapBits                               ( Bitmap: HBITMAP; Count: int32; Bits: Pointer ): int32; stdcall; external cLibNameGDI name 'GetBitmapBits';
    function  GetBitmapDimensionEx                        ( p1: HBITMAP; var p2: Size ): Bool; stdcall; external cLibNameGDI name 'GetBitmapDimensionEx';
    function  GetBkColor                                  ( hDC: HDC ): COLORREF; stdcall; external cLibNameGDI name 'GetBkColor';
    function  GetBkMode                                   ( hDC: HDC ): int32; stdcall; external cLibNameGDI name 'GetBkMode';
    function  GetBoundsRect                               ( DC: HDC; var p2: Rect; p3: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetBoundsRect';
    function  GetBrushOrgEx                               ( DC: HDC; var p2: Point ): Bool; stdcall; external cLibNameGDI name 'GetBrushOrgEx';
    function  GetCharABCWidthsA                           ( DC: HDC; p2, p3: uint32; const ABCStructs ): Bool; stdcall; external cLibNameGDI name 'GetCharABCWidthsA';
    function  GetCharABCWidthsI                           ( DC: HDC; p2, p3: uint32; p4: puint16; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharABCWidthsI';
    function  GetCharABCWidthsW                           ( DC: HDC; p2, p3: uint32; const ABCStructs ): Bool; stdcall; external cLibNameGDI name 'GetCharABCWidthsW';
    function  GetCharABCWidthsFloatA                      ( DC: HDC; p2, p3: uint32; const ABCFloatSturcts ): Bool; stdcall; external cLibNameGDI name 'GetCharABCWidthsFloatA';
    function  GetCharABCWidthsFloatW                      ( DC: HDC; p2, p3: uint32; const ABCFloatSturcts ): Bool; stdcall; external cLibNameGDI name 'GetCharABCWidthsFloatW';
    function  GetCharWidth32A                             ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidth32A';
    function  GetCharWidth32W                             ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidth32W';
    function  GetCharWidthA                               ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidthA';
    function  GetCharWidthI                               ( DC: HDC; p2, p3: uint32; p4: pUint16; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidthI';
    function  GetCharWidthW                               ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidthW';
    function  GetCharWidthFloatA                          ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidthFloatA';
    function  GetCharWidthFloatW                          ( DC: HDC; p2, p3: uint32; const Widths ): Bool; stdcall; external cLibNameGDI name 'GetCharWidthFloatW';
    function  GetCharacterPlacement                       ( DC: HDC; p2: PAnsiChar; p3, p4: Bool; var p5: GCP_ResultsA; p6: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetCharacterPlacementA';
    function  GetCharacterPlacementW                      ( DC: HDC; p2: PWideChar; p3, p4: Bool; var p5: GCP_ResultsW; p6: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetCharacterPlacementW';
    function  GetClipBox                                  ( DC: HDC; var Rect: Rect ): int32; stdcall; external cLibNameGDI name 'GetClipBox';
    function  GetClipRgn                                  ( DC: HDC; rgn: HRGN ): int32; stdcall; external cLibNameGDI name 'GetClipRgn';
    function  GetColorAdjustment                          ( DC: HDC; var p2: ColorAdjustment ): Bool; stdcall; external cLibNameGDI name 'GetColorAdjustment';
    function  GetColorSpace                               ( DC: HDC ): winHandle; stdcall; external cLibNameGDI name 'GetColorSpace';
    function  GetCurrentObject                            ( DC: HDC; p2: uint32 ): HGDIOBJ; stdcall; external cLibNameGDI name 'GetCurrentObject';
    function  GetCurrentPositionEx                        ( DC: HDC; Point: PPoint ): Bool; stdcall; external cLibNameGDI name 'GetCurrentPositionEx';
    function  GetDCBrushColor                             ( DC: HDC ): COLORREF; stdcall; external cLibNameGDI name 'GetDCBrushColor';
    function  GetDCOrgEx                                  ( DC: HDC; var Origin: Point ): Bool; stdcall; external cLibNameGDI name 'GetDCOrgEx';
    function  GetDCPenColor                               ( DC: HDC ): COLORREF; stdcall; external cLibNameGDI name 'GetDCPenColor';
    function  GetDIBColorTable                            ( DC: HDC; p2, p3: uint32; var RGBQuadStructs ): uint32; stdcall; external cLibNameGDI name 'GetDIBColorTable';
    function  GetDIBits                                   ( DC: HDC; Bitmap: HBITMAP; StartScan, NumScans: uint32; Bits: Pointer; var BitInfo: BitmapInfo; Usage: uint32 ): int32; stdcall; external cLibNameGDI name 'GetDIBits';
    function  GetDeviceCaps                               ( DC: HDC; Index: int32 ): int32; stdcall; external cLibNameGDI name 'GetDeviceCaps';
    function  GetDeviceGammaRamp                          ( DC: HDC; var Ramp ): Bool; stdcall; external cLibNameGDI name 'GetDeviceGammaRamp';
    function  GetEnhMetaFileA                             ( p1: PAnsiChar ): HENHMETAFILE; stdcall; external cLibNameGDI name 'GetEnhMetaFileA';
    function  GetEnhMetaFileW                             ( p1: PWideChar ): HENHMETAFILE; stdcall; external cLibNameGDI name 'GetEnhMetaFileW';
    function  GetEnhMetaFileBits                          ( p1: HENHMETAFILE; p2: uint32; p3: puint8 ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFileBits';
    function  GetEnhMetaFileDescriptionA                  ( p1: HENHMETAFILE; p2: uint32; p3: PAnsiChar ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFileDescriptionA';
    function  GetEnhMetaFileDescriptionW                  ( p1: HENHMETAFILE; p2: uint32; p3: PWideChar ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFileDescriptionW';
    function  GetEnhMetaFileHeader                        ( p1: HENHMETAFILE; p2: uint32; p3: PEnhMetaHeader ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFileHeader';
    function  GetEnhMetaFilePaletteEntries                ( p1: HENHMETAFILE; p2: uint32; p3: Pointer ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFilePaletteEntries';
    function  GetEnhMetaFilePixelFormat                   ( p1: HENHMETAFILE; p2: Cardinal; var p3: PixelFormatDescriptor ): uint32; stdcall; external cLibNameGDI name 'GetEnhMetaFilePixelFormat';
    function  GetFontData                                 ( DC: HDC; p2, p3: uint32; p4: Pointer; p5: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetFontData';
    function  GetFontLanguageInfo                         ( DC: HDC ): uint32; stdcall; external cLibNameGDI name 'GetFontLanguageInfo';
    function  GetFontUnicodeRanges                        ( DC: HDC; lpgs: PGlyphSet ): uint32; stdcall; external cLibNameGDI name 'GetFontUnicodeRanges';
    function  GetGlyphIndicesA                            ( DC: HDC; p2: PAnsiChar; p3: int32; p4: puint16; p5: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetGlyphIndicesA';
    function  GetGlyphIndicesW                            ( DC: HDC; p2: PAnsiChar; p3: int32; p4: puint16; p5: uint32 ): uint32; stdcall; external cLibNameGDI name 'GetGlyphIndicesW';
    function  GetGlyphOutlineA                            ( DC: HDC; p2, p3: uint32; const p4: GlyphMetrics; p5: uint32; p6: Pointer; const p7: Mat2 ): uint32; stdcall; external cLibNameGDI name 'GetGlyphOutlineA';
    function  GetGlyphOutlineW                            ( DC: HDC; p2, p3: uint32; const p4: GlyphMetrics; p5: uint32; p6: Pointer; const p7: Mat2 ): uint32; stdcall; external cLibNameGDI name 'GetGlyphOutlineW';
    function  GetGraphicsMode                             ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetGraphicsMode';
    function  GetICMProfileA                              ( DC: HDC; var Size: uint32; Name: PAnsiChar ): Bool; stdcall; external cLibNameGDI name 'GetICMProfileA';
    function  GetICMProfileW                              ( DC: HDC; var Size: uint32; Name: PWideChar ): Bool; stdcall; external cLibNameGDI name 'GetICMProfileW';
    function  GetKerningPairs                             ( DC: HDC; Count: uint32; var KerningPairs ): uint32; stdcall; external cLibNameGDI name 'GetKerningPairs';
    function  GetLogColorSpaceA                           ( p1: HCOLORSPACE; var ColorSpace: LogColorSpaceA; Size: uint32 ): Bool; stdcall; external cLibNameGDI name 'GetLogColorSpaceA';
    function  GetLogColorSpaceW                           ( p1: HCOLORSPACE; var ColorSpace: LogColorSpaceW; Size: uint32 ): Bool; stdcall; external cLibNameGDI name 'GetLogColorSpaceW';
    function  GetMapMode                                  ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetMapMode';
    function  GetMetaFileA                                ( p1: PAnsiChar ): HMETAFILE; stdcall; external cLibNameGDI name 'GetMetaFileA';
    function  GetMetaFileW                                ( p1: PWideChar ): HMETAFILE; stdcall; external cLibNameGDI name 'GetMetaFileW';
    function  GetMetaFileBitsEx                           ( p1: HMETAFILE; p2: uint32; p3: Pointer ): uint32; stdcall; external cLibNameGDI name 'GetMetaFileBitsEx';
    function  GetMetaRgn                                  ( DC: HDC; rgn: HRGN ): int32; stdcall; external cLibNameGDI name 'GetMetaRgn';
    function  GetMiterLimit                               ( DC: HDC; var Limit: Single ): Bool; stdcall; external cLibNameGDI name 'GetMiterLimit';
    function  GetNearestColor                             ( DC: HDC; p2: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'GetNearestColor';
    function  GetNearestPaletteIndex                      ( p1: HPALETTE; p2: COLORREF ): uint32; stdcall; external cLibNameGDI name 'GetNearestPaletteIndex';
    function  GetObjectA                                  ( p1: HGDIOBJ; p2: int32; p3: Pointer ): int32; stdcall; external cLibNameGDI name 'GetObjectA';
    function  GetObjectW                                  ( p1: HGDIOBJ; p2: int32; p3: Pointer ): int32; stdcall; external cLibNameGDI name 'GetObjectW';
    function  GetObjectType                               ( h: HGDIOBJ ): uint32; stdcall; external cLibNameGDI name 'GetObjectType';
    function  GetOutlineTextMetricsA                      ( DC: HDC; p2: uint32; OTMetricStructs: Pointer ): uint32; stdcall; external cLibNameGDI name 'GetOutlineTextMetricsA';
    function  GetOutlineTextMetricsW                      ( DC: HDC; p2: uint32; OTMetricStructs: Pointer ): uint32; stdcall; external cLibNameGDI name 'GetOutlineTextMetricsW';
    function  GetPaletteEntries                           ( Palette: HPALETTE; StartIndex, NumEntries: uint32; var PaletteEntries): uint32; stdcall; external cLibNameGDI name 'GetPaletteEntries';
    function  GetPath                                     ( DC: HDC; var Points, Types; nSize: int32 ): int32; stdcall; external cLibNameGDI name 'GetPath';
    function  GetPixel                                    ( DC: HDC; X, Y: int32 ): COLORREF; stdcall; external cLibNameGDI name 'GetPixel';
    function  GetPixelFormat                              ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetPixelFormat';
    function  GetPolyFillMode                             ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetPolyFillMode';
    function  GetROP2                                     ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetROP2';
    function  GetRasterizerCaps                           ( var p1: RasterizerStatus; p2: uint32 ): Bool; stdcall; external cLibNameGDI name 'GetRasterizerCaps';
    function  GetRegionData                               ( RGN: HRGN; p2: uint32; p3: PRgnData ): uint32; stdcall; external cLibNameGDI name 'GetRegionData';
    function  GetRgnBox                                   ( RGN: HRGN; var p2: Rect ): int32; stdcall; external cLibNameGDI name 'GetRgnBox';
    function  GetStockObject                              ( Index: int32 ): HGDIOBJ; stdcall; external cLibNameGDI name 'GetStockObject';
    function  GetStretchBltMode                           ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetStretchBltMode';
    function  GetSystemPaletteEntries                     ( DC: HDC; StartIndex, NumEntries: uint32; var PaletteEntries): uint32; stdcall; external cLibNameGDI name 'GetSystemPaletteEntries';
    function  GetSystemPaletteUse                         ( DC: HDC ): uint32; stdcall; external cLibNameGDI name 'GetSystemPaletteUse';
    function  GetTextAlign                                ( DC: HDC ): uint32; stdcall; external cLibNameGDI name 'GetTextAlign';
    function  GetTextCharacterExtra                       ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'GetTextCharacterExtra';
    function  GetTextCharset                              ( hdc: HDC ): int32; stdcall; external cLibNameGDI name 'GetTextCharset';
    function  GetTextCharsetInfo                          ( hdc: HDC; lpSig: PFontSignature; dwFlags: uint32 ): Bool; stdcall; external cLibNameGDI name 'GetTextCharsetInfo';
    function  GetTextColor                                ( DC: HDC ): COLORREF; stdcall; external cLibNameGDI name 'GetTextColor';
    function  GetTextExtentExPointA                       ( DC: HDC; p2: PAnsiChar; p3, p4: int32; p5, p6: Pint32; var p7: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentExPointA';
    function  GetTextExtentExPointI                       ( DC: HDC; p2: puint16; p3, p4: int32; p5, p6: pint32; var p7: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentExPointI';
    function  GetTextExtentExPointW                       ( DC: HDC; p2: PWideChar; p3, p4: int32; p5, p6: Pint32; var p7: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentExPointW';
    function  GetTextExtentPoint32A                       ( DC: HDC; Str: PAnsiChar; Count: int32; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentPoint32A';
    function  GetTextExtentPoint32W                       ( DC: HDC; Str: PWideChar; Count: int32; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentPoint32W';
    function  GetTextExtentPointA                         ( DC: HDC; Str: PAnsiChar; Count: int32; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentPointA';
    function  GetTextExtentPointI                         ( DC: HDC; p2: puint16; p3: int32; var p4: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentPointI';
    function  GetTextExtentPointW                         ( DC: HDC; Str: PWideChar; Count: int32; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetTextExtentPointW';
    function  GetTextFaceA                                ( DC: HDC; Count: int32; Buffer: PAnsiChar ): int32; stdcall; external cLibNameGDI name 'GetTextFaceA';
    function  GetTextFaceW                                ( DC: HDC; Count: int32; Buffer: PWideChar ): int32; stdcall; external cLibNameGDI name 'GetTextFaceW';
    function  GetTextMetricsA                             ( DC: HDC; var TM: TextMetricA ): Bool; stdcall; external cLibNameGDI name 'GetTextMetricsA';
    function  GetTextMetricsW                             ( DC: HDC; var TM: TextMetricW ): Bool; stdcall; external cLibNameGDI name 'GetTextMetricsW';
    function  GetViewportExtEx                            ( DC: HDC; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetViewportExtEx';
    function  GetViewportOrgEx                            ( DC: HDC; var Point: Point ): Bool; stdcall; external cLibNameGDI name 'GetViewportOrgEx';
    function  GetWinMetaFileBits                          ( p1: HENHMETAFILE; p2: uint32; p3: puint8; p4: int32; p5: HDC ): uint32; stdcall; external cLibNameGDI name 'GetWinMetaFileBits';
    function  GetWindowExtEx                              ( DC: HDC; var Size: Size ): Bool; stdcall; external cLibNameGDI name 'GetWindowExtEx';
    function  GetWindowOrgEx                              ( DC: HDC; var Point: Point ): Bool; stdcall; external cLibNameGDI name 'GetWindowOrgEx';
    function  GetWorldTransform                           ( DC: HDC; var p2: XForm ): Bool; stdcall; external cLibNameGDI name 'GetWorldTransform';
    function  IntersectClipRect                           ( DC: HDC; X1, Y1, X2, Y2: int32 ): int32; stdcall; external cLibNameGDI name 'IntersectClipRect';
    function  InvertRgn                                   ( DC: HDC; p2: HRGN ): Bool; stdcall; external cLibNameGDI name 'InvertRgn';
    function  LPtoDP                                      ( DC: HDC; var Points; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'LPtoDP';
    function  LineDDA                                     ( p1, p2, p3, p4: int32; p5: LineDDAProc; p6: LPARAM ): Bool; stdcall; external cLibNameGDI name 'LineDDA';
    function  LineTo                                      ( DC: HDC; X, Y: int32 ): Bool; stdcall; external cLibNameGDI name 'LineTo';
    function  MaskBlt                                     ( DC: HDC; p2, p3, p4, p5: int32; p6: HDC; p7, p8: int32; p9: HBITMAP; p10, p11: int32; p12: uint32 ): Bool; stdcall; external cLibNameGDI name 'MaskBlt';
    function  ModifyWorldTransform                        ( DC: HDC; const p2: XForm; p3: uint32 ): Bool; stdcall; external cLibNameGDI name 'ModifyWorldTransform';
    function  MoveToEx                                    ( DC: HDC; p2, p3: int32; p4: PPoint ): Bool; stdcall; external cLibNameGDI name 'MoveToEx';
    function  OffsetClipRgn                               ( DC: HDC; p2, p3: int32 ): int32; stdcall; external cLibNameGDI name 'OffsetClipRgn';
    function  OffsetRgn                                   ( RGN: HRGN; p2, p3: int32 ): int32; stdcall; external cLibNameGDI name 'OffsetRgn';
    function  OffsetViewportOrgEx                         ( DC: HDC; X, Y: int32; var Points ): Bool; stdcall; external cLibNameGDI name 'OffsetViewportOrgEx';
    function  OffsetWindowOrgEx                           ( DC: HDC; X, Y: int32; var Points ): Bool; stdcall; external cLibNameGDI name 'OffsetWindowOrgEx';
    function  PaintRgn                                    ( DC: HDC; RGN: HRGN ): Bool; stdcall; external cLibNameGDI name 'PaintRgn';
    function  PatBlt                                      ( DC: HDC; X, Y, Width, Height: int32; Rop: uint32 ): Bool; stdcall; external cLibNameGDI name 'PatBlt';
    function  PathToRegion                                ( DC: HDC ): HRGN; stdcall; external cLibNameGDI name 'PathToRegion';
    function  Pie                                         ( DC: HDC; X1, Y1, X2, Y2, X3, Y3, X4, Y4: int32 ): Bool; stdcall; external cLibNameGDI name 'Pie';
    function  PlayEnhMetaFile                             ( DC: HDC; p2: HENHMETAFILE; const p3: Rect ): Bool; stdcall; external cLibNameGDI name 'PlayEnhMetaFile';
    function  PlayEnhMetaFileRecord                       ( DC: HDC; var p2: HandleTable; const p3: EnhMetaRecord; p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'PlayEnhMetaFileRecord';
    function  PlayMetaFile                                ( DC: HDC; MF: HMETAFILE ): Bool; stdcall; external cLibNameGDI name 'PlayMetaFile';
    function  PlayMetaFileRecord                          ( DC: HDC; const p2: HandleTable; const p3: MetaRecord; p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'PlayMetaFileRecord';
    function  PlgBlt                                      ( DC: HDC; const PointsArray; p3: HDC; p4, p5, p6, p7: int32; p8: HBITMAP; p9, p10: int32 ): Bool; stdcall; external cLibNameGDI name 'PlgBlt';
    function  PolyBezier                                  ( DC: HDC; const Points; Count: uint32 ): Bool; stdcall; external cLibNameGDI name 'PolyBezier';
    function  PolyBezierTo                                ( DC: HDC; const Points; Count: uint32 ): Bool; stdcall; external cLibNameGDI name 'PolyBezierTo';
    function  PolyDraw                                    ( DC: HDC; const Points, Types; cCount: int32 ): Bool; stdcall; external cLibNameGDI name 'PolyDraw';
    function  PolyPolygon                                 ( DC: HDC; var Points; var nPoints; p4: int32 ): Bool; stdcall; external cLibNameGDI name 'PolyPolygon';
    function  PolyPolyline                                ( DC: HDC; const PointStructs; const Points; p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'PolyPolyline';
    function  PolyTextOutA                                ( DC: HDC; const PolyTextArray: PPolyTextA; Strings: int32 ): Bool; stdcall; external cLibNameGDI name 'PolyTextOutA';
    function  PolyTextOutW                                ( DC: HDC; const PolyTextArray: PPolyTextW; Strings: int32 ): Bool; stdcall; external cLibNameGDI name 'PolyTextOutW';
    function  Polygon                                     ( DC: HDC; var Points; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'Polygon';
    function  Polyline                                    ( DC: HDC; var Points; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'Polyline';
    function  PolylineTo                                  ( DC: HDC; const Points; Count: uint32 ): Bool; stdcall; external cLibNameGDI name 'PolylineTo';
    function  PtInRegion                                  ( RGN: HRGN; p2, p3: int32 ): Bool; stdcall; external cLibNameGDI name 'PtInRegion';
    function  PtVisible                                   ( DC: HDC; p2, p3: int32 ): Bool; stdcall; external cLibNameGDI name 'PtVisible';
    function  RealizePalette                              ( DC: HDC ): uint32; stdcall; external cLibNameGDI name 'RealizePalette';
    function  RectInRegion                                ( RGN: HRGN; const p2: Rect ): Bool; stdcall; external cLibNameGDI name 'RectInRegion';
    function  RectVisible                                 ( DC: HDC; const Rect: Rect ): Bool; stdcall; external cLibNameGDI name 'RectVisible';
    function  Rectangle                                   ( DC: HDC; X1, Y1, X2, Y2: int32 ): Bool; stdcall; external cLibNameGDI name 'Rectangle';
    function  RemoveFontMemResourceEx                     ( p1: winHandle ): Bool; stdcall; external cLibNameGDI name 'RemoveFontMemResourceEx';
    function  RemoveFontResourceA                         ( p1: PAnsiChar ): Bool; stdcall; external cLibNameGDI name 'RemoveFontResourceA';
    function  RemoveFontResourceW                         ( p1: PWideChar ): Bool; stdcall; external cLibNameGDI name 'RemoveFontResourceW';
    function  RemoveFontResourceExA                       ( p1: PAnsiChar; p2: uint32; p3: PDesignVector ): Bool; stdcall; external cLibNameGDI name 'RemoveFontResourceExA';
    function  RemoveFontResourceExW                       ( p1: PAnsiChar; p2: uint32; p3: PDesignVector ): Bool; stdcall; external cLibNameGDI name 'RemoveFontResourceExW';
    function  ResetDC                                     ( DC: HDC; const p2: DeviceModeA ): HDC; stdcall; external cLibNameGDI name 'ResetDCA';
    function  ResetDCW                                    ( DC: HDC; const p2: DeviceModeW ): HDC; stdcall; external cLibNameGDI name 'ResetDCW';
    function  ResizePalette                               ( p1: HPALETTE; p2: uint32 ): Bool; stdcall; external cLibNameGDI name 'ResizePalette';
    function  RestoreDC                                   ( DC: HDC; SavedDC: int32 ): Bool; stdcall; external cLibNameGDI name 'RestoreDC';
    function  RoundRect                                   ( DC: HDC; X1, Y1, X2, Y2, X3, Y3: int32 ): Bool; stdcall; external cLibNameGDI name 'RoundRect';
    function  SaveDC                                      ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'SaveDC';
    function  ScaleViewportExtEx                          ( DC: HDC; XM, XD, YM, YD: int32; Size: PSize ): Bool; stdcall; external cLibNameGDI name 'ScaleViewportExtEx';
    function  ScaleWindowExtEx                            ( DC: HDC; XM, XD, YM, YD: int32; Size: PSize ): Bool; stdcall; external cLibNameGDI name 'ScaleWindowExtEx';
    function  SelectClipPath                              ( DC: HDC; Mode: int32 ): Bool; stdcall; external cLibNameGDI name 'SelectClipPath';
    function  SelectClipRgn                               ( DC: HDC; p2: HRGN ): int32; stdcall; external cLibNameGDI name 'SelectClipRgn';
    function  SelectObject                                ( DC: HDC; p2: HGDIOBJ ): HGDIOBJ; stdcall; external cLibNameGDI name 'SelectObject';
    function  SelectPalette                               ( DC: HDC; Palette: HPALETTE; ForceBackground: Bool ): HPALETTE; stdcall; external cLibNameGDI name 'SelectPalette';
    function  SetAbortProc                                ( DC: HDC; lpAbortProc: AbortProc ): int32; stdcall; external cLibNameGDI name 'SetAbortProc';
    function  SetArcDirection                             ( DC: HDC; Direction: int32 ): int32; stdcall; external cLibNameGDI name 'SetArcDirection';
    function  SetBitmapBits                               ( p1: HBITMAP; p2: uint32; bits: Pointer ): int32; stdcall; external cLibNameGDI name 'SetBitmapBits';
    function  SetBitmapDimensionEx                        ( hBitmap: HBITMAP; Width, Height: int32; Size: PSize ): Bool; stdcall; external cLibNameGDI name 'SetBitmapDimensionEx';
    function  SetBkColor                                  ( DC: HDC; Color: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'SetBkColor';
    function  SetBkMode                                   ( DC: HDC; BkMode: int32 ): int32; stdcall; external cLibNameGDI name 'SetBkMode';
    function  SetBoundsRect                               ( DC: HDC; p2: PRect; p3: uint32 ): uint32; stdcall; external cLibNameGDI name 'SetBoundsRect';
    function  SetBrushOrgEx                               ( DC: HDC; X, Y: int32; PrevPt: PPoint ): Bool; stdcall; external cLibNameGDI name 'SetBrushOrgEx';
    function  SetColorAdjustment                          ( DC: HDC; const p2: ColorAdjustment ): Bool; stdcall; external cLibNameGDI name 'SetColorAdjustment';
    function  SetColorSpace                               ( DC: HDC; ColorSpace: HCOLORSPACE ): Bool; stdcall; external cLibNameGDI name 'SetColorSpace';
    function  SetDCBrushColor                             ( DC: HDC; Color: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'SetDCBrushColor';
    function  SetDCPenColor                               ( DC: HDC; Color: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'SetDCPenColor';
    function  SetDIBColorTable                            ( DC: HDC; p2, p3: uint32; var RGBQuadSTructs ): uint32; stdcall; external cLibNameGDI name 'SetDIBColorTable';
    function  SetDIBits                                   ( DC: HDC; Bitmap: HBITMAP; StartScan, NumScans: uint32; Bits: Pointer; var BitsInfo: BitmapInfo; Usage: uint32 ): int32; stdcall; external cLibNameGDI name 'SetDIBits';
    function  SetDIBitsToDevice                           ( DC: HDC; DestX, DestY: int32; Width, Height: uint32; SrcX, SrcY: int32; nStartScan, NumScans: uint32; Bits: Pointer; var BitsInfo: BitmapInfo; Usage: uint32 ): int32; stdcall; external cLibNameGDI name 'SetDIBitsToDevice';
    function  SetDeviceGammaRamp                          ( DC: HDC; var Ramp ): Bool; stdcall; external cLibNameGDI name 'SetDeviceGammaRamp';
    function  SetEnhMetaFileBits                          ( p1: uint32; p2: PChar ): HENHMETAFILE; stdcall; external cLibNameGDI name 'SetEnhMetaFileBits';
    function  SetGraphicsMode                             ( hdc: HDC; iMode: int32 ): int32; stdcall; external cLibNameGDI name 'SetGraphicsMode';
    function  SetICMMode                                  ( DC: HDC; Mode: int32 ): int32; stdcall; external cLibNameGDI name 'SetICMMode';
    function  SetICMProfileA                              ( DC: HDC; Name: PAnsiChar ): Bool; stdcall; external cLibNameGDI name 'SetICMProfileA';
    function  SetICMProfileW                              ( DC: HDC; Name: PWideChar ): Bool; stdcall; external cLibNameGDI name 'SetICMProfileW';
    function  SetMapMode                                  ( DC: HDC; p2: int32): int32; stdcall; external cLibNameGDI name 'SetMapMode';
    function  SetMapperFlags                              ( DC: HDC; Flag: uint32 ): uint32; stdcall; external cLibNameGDI name 'SetMapperFlags';
    function  SetMetaFileBitsEx                           ( p1: uint32; const p2: PChar ): HMETAFILE; stdcall; external cLibNameGDI name 'SetMetaFileBitsEx';
    function  SetMetaRgn                                  ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'SetMetaRgn';
    function  SetMiterLimit                               ( DC: HDC; NewLimit: Single; OldLimit: PSingle ): Bool; stdcall; external cLibNameGDI name 'SetMiterLimit';
    function  SetPaletteEntries                           ( Palette: HPALETTE; StartIndex, NumEntries: uint32; var PaletteEntries ): uint32; stdcall; external cLibNameGDI name 'SetPaletteEntries';
    function  SetPixel                                    ( DC: HDC; X, Y: int32; Color: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'SetPixel';
    function  SetPixelFormat                              ( DC: HDC; p2: int32; p3: PPixelFormatDescriptor ): Bool; stdcall; external cLibNameGDI name 'SetPixelFormat';
    function  SetPixelV                                   ( DC: HDC; X, Y: int32; Color: COLORREF ): Bool; stdcall; external cLibNameGDI name 'SetPixelV';
    function  SetPolyFillMode                             ( DC: HDC; PolyFillMode: int32 ): int32; stdcall; external cLibNameGDI name 'SetPolyFillMode';
    function  SetROP2                                     ( DC: HDC; p2: int32 ): int32; stdcall; external cLibNameGDI name 'SetROP2';
    function  SetRectRgn                                  ( Rgn: HRGN; X1, Y1, X2, Y2: int32 ): Bool; stdcall; external cLibNameGDI name 'SetRectRgn';
    function  SetStretchBltMode                           ( DC: HDC; p2: int32 ): int32; stdcall; external cLibNameGDI name 'SetStretchBltMode';
    function  SetSystemPaletteUse                         ( DC: HDC; p2: uint32 ): uint32; stdcall; external cLibNameGDI name 'SetSystemPaletteUse';
    function  SetTextAlign                                ( DC: HDC; Flags: uint32 ): uint32; stdcall; external cLibNameGDI name 'SetTextAlign';
    function  SetTextCharacterExtra                       ( DC: HDC; CharExtra: int32 ): int32; stdcall; external cLibNameGDI name 'SetTextCharacterExtra';
    function  SetTextColor                                ( DC: HDC; Color: COLORREF ): COLORREF; stdcall; external cLibNameGDI name 'SetTextColor';
    function  SetTextJustification                        ( DC: HDC; BreakExtra, BreakCount: int32 ): int32; stdcall; external cLibNameGDI name 'SetTextJustification';
    function  SetViewportExtEx                            ( DC: HDC; XExt, YExt: int32; Size: PSize ): Bool; stdcall; external cLibNameGDI name 'SetViewportExtEx';
    function  SetViewportOrgEx                            ( DC: HDC; X, Y: int32; Point: PPoint ): Bool; stdcall; external cLibNameGDI name 'SetViewportOrgEx';
    function  SetWinMetaFileBits                          ( p1: uint32; p2: PChar; p3: HDC; const p4: MetaFilePict ): HENHMETAFILE; stdcall; external cLibNameGDI name 'SetWinMetaFileBits';
    function  SetWindowExtEx                              ( DC: HDC; XExt, YExt: int32; Size: PSize ): Bool; stdcall; external cLibNameGDI name 'SetWindowExtEx';
    function  SetWindowOrgEx                              ( DC: HDC; X, Y: int32; Point: PPoint ): Bool; stdcall; external cLibNameGDI name 'SetWindowOrgEx';
    function  SetWorldTransform                           ( DC: HDC; const p2: XForm ): Bool; stdcall; external cLibNameGDI name 'SetWorldTransform';
    function  StartDocA                                   ( DC: HDC; const p2: DocInfoA ): int32; stdcall; external cLibNameGDI name 'StartDocA';
    function  StartDocW                                   ( DC: HDC; const p2: DocInfoW ): int32; stdcall; external cLibNameGDI name 'StartDocW';
    function  StartPage                                   ( DC: HDC ): int32; stdcall; external cLibNameGDI name 'StartPage';
    function  StretchBlt                                  ( DestDC: HDC; X, Y, Width, Height: int32; SrcDC: HDC; XSrc, YSrc, SrcWidth, SrcHeight: int32; Rop: uint32): Bool; stdcall; external cLibNameGDI name 'StretchBlt';
    function  StretchDIBits                               ( DC: HDC; DestX, DestY, DestWidth, DestHegiht, SrcX, SrcY, SrcWidth, SrcHeight: int32; Bits: Pointer; var BitsInfo: BitmapInfo; Usage: uint32; Rop: uint32 ): int32; stdcall; external cLibNameGDI name 'StretchDIBits';
    function  StrokeAndFillPath                           ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'StrokeAndFillPath';
    function  StrokePath                                  ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'StrokePath';
    function  SwapBuffers                                 ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'SwapBuffers';
    function  TextOutA                                    ( DC: HDC; X, Y: int32; Str: PAnsiChar; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'TextOutA';
    function  TextOutW                                    ( DC: HDC; X, Y: int32; Str: PWideChar; Count: int32 ): Bool; stdcall; external cLibNameGDI name 'TextOutW';
    function  TranslateCharsetInfo                        ( var lpSrc: uint32; var lpCs: CharsetInfo; dwFlags: uint32 ): Bool; stdcall; external cLibNameGDI name 'TranslateCharsetInfo';
    function  UnrealizeObject                             ( hGDIObj: HGDIOBJ ): Bool; stdcall; external cLibNameGDI name 'UnrealizeObject';
    function  UpdateColors                                ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'UpdateColors';
    function  UpdateICMRegKeyA                            ( p1: uint32; p2, p3: PAnsiChar; p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'UpdateICMRegKeyA';
    function  UpdateICMRegKeyW                            ( p1: uint32; p2, p3: PWideChar; p4: uint32 ): Bool; stdcall; external cLibNameGDI name 'UpdateICMRegKeyW';
    function  WidenPath                                   ( DC: HDC ): Bool; stdcall; external cLibNameGDI name 'WidenPath';

const
  cDescriptionLen                                               = 256;
  cSysStatusLen                                                 = 128;

type
  TWSAData = record
    wVersion: uint16;
    wHighVersoin: uint16;
    szDescription: array[0..cDescriptionLen] of uint8;
    szSystemStatus: array[0..cSysStatusLen] of uint8;
    iMaxSockets: uint16;
    iMaxUdpDg: uint16;
    lpVendorInfo: pansichar;
  end;
  pTWSAData = ^TWSAData;

function Socket      ( const Domain: int32;         const kind: int32;        const protocol: int32                 ): TSocketHandle; stdcall; external cLibNameWinsock name 'socket';
function Bind        ( const Socket: TSocketHandle; const Addr: pointer;      const Addrlen: TSockLen               ): int32;         stdcall; external cLibNameWinsock name 'bind';
function InetAddr    ( const lpszAddress: pointer                                                                   ): TIntAddr;      stdcall; external cLibNameWinsock name 'inet_addr';
function HtoNS       ( const Host: uint16                                                                           ): uint16;        stdcall; external cLibNameWinsock name 'htons';
function Listen      ( const Socket: TSocketHandle; const BackLog: int32                                            ): int32;         stdcall; external cLibNameWinsock name 'listen';
function Accept      ( const Socket: TSocketHandle; const lpAddr: pTSockAddr; var AddrLen: int32                    ): TSocketHandle; stdcall; external cLibNameWinsock name 'accept';
function Connect     ( const Socket: TSocketHandle; const lpAddr: pTSockAddr; const AddrLen: int32                  ): int32;         stdcall; external cLibNameWinsock name 'connect';
function CloseSocket ( const Socket: TSocketHandle                                                                  ): int32;         stdcall; external cLibNameWinsock name 'closesocket';
function Send        ( const Socket: TSocketHandle; const lpData: pointer;    const len: int32;  const flags: int32 ): int32;         stdcall; external cLibNameWinsock name 'send';
function Recv        ( const Socket: TSocketHandle; const lpData: pointer;    const len: int32;  const flags: int32 ): int32;         stdcall; external cLibNameWinsock name 'recv';
function Shutdown    ( const Socket: TSocketHandle; const Method: uint32                                            ): int32;         stdcall; external cLibNameWinsock name 'shutdown';
function ioctlSocket ( Socket: TSocketHandle;       const cmd: int32;         var argp: uint32                      ): int32;         stdcall; external cLibNameWinsock name 'ioctlsocket';

function Startup     ( wVersionRequested: uint16;   lpWSAData: pTWSAData                                            ): int32;         stdcall; external cLibNameWinsock name 'WSAStartup';
function Cleanup     (                                                                                              ): int32;         stdcall; external cLibNameWinsock name 'WSACleanup';

 (* not a translation of Ole32, just a required export or two.. *)

 function CoCreateGuid( ptrGUID: pointer ): HRESULT;  stdcall; external cLibNameOle name 'CoCreateGuid';

{$endif}
implementation
{$ifdef MSWINDOWS}

var
  wsdata: TWSAData;

{$endif}
initialization
{$ifdef MSWINDOWS}
  //- Initialization for winsock.
  Startup($0002 {version 2}, @wsdata);
{$endif}

finalization
{$ifdef MSWINDOWS}
  //- Finalization for winsock.
  Cleanup;
{$endif}

end.
